#include <bits/stdc++.h>
using namespace std;

using ll = long long;

#define all(v) v.begin(), v.end()

const int MAXMEM = 25e7;

int mempos = 0;

char mem[MAXMEM];

inline void * operator new(size_t n) {
    char *res = mem + mempos;
    mempos += n;
    assert(mempos <= MAXMEM);
    return (void*)res;
}

inline void operator delete(void*) {}

struct edge {
    int from;
    int to;
    int f;
    int c;
    int p;
    edge(int par, int v, int c1, int cost) : from(par), to(v), f(0), c(c1), p(cost) {};
};

vector<edge> e;
vector<vector<int> > g;
const int inf = (int)1e9 + 7;

inline void add_edge(int u, int v, int c, int p) {
    g[u].emplace_back(e.size());
    e.emplace_back(edge(u, v, c, p));
    g[v].emplace_back(e.size());
    e.emplace_back(edge(v, u, 0, -p));
}

vector<int> min_e;
vector<int> d;
vector<int> par;

bool FB(int s, int t, int N) {
    fill(all(min_e), inf);
    fill(all(d), -inf);
    fill(all(par), -1);
    queue<int> q;
    vector<bool> in(N, 0);
    in[s] = 1;
    d[s] = 0;
    q.push(s);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        in[v] = 0;
        for (int i : g[v]) {
            int to = e[i].to;
            int cap = e[i].c - e[i].f;
            if (cap <= 0)
                continue;
            int cost = e[i].p;
            if (d[to] < d[v] + cost) {
                d[to] = d[v] + cost;
                min_e[to] = min(cap, min_e[v]);
                par[to] = i;
                if (!in[to]) {
                    in[to] = 1;
                    q.push(to);
                }
            }
        }
    }
    ///cout << "mmm" << endl;
    return d[t] != -inf;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector<int> st(n);
    vector<int> mx(n);
    for (int &x : st)
        cin >> x;
    for (int &x : mx)
        cin >> x;
    g.resize(n + 2); ///S = n, T = n + 1
    min_e.resize(n + 2);
    d.resize(n + 2);
    par.resize(n + 2);
    for (int i = 1; i < n; ++i) {
        int p, w;
        cin >> p >> w;
        --p;
        add_edge(p, i, inf, w);
    }
    for (int i = 0; i < n; ++i) {
        add_edge(n, i, st[i], 0);
        add_edge(i, n + 1, mx[i], 0);
    }
    ll ans = 0;
    ll mx_ans = 0;
    int s = n, t = n + 1;
    while (FB(s, t, n + 2)) {
        ///cout << "mmm" << endl;
        int v = t;
        int df = min_e[t];
        ll delta = 0;
        while (v != s) {
            ///cout << v + 1 << ' ';
            int i = par[v];
            e[i].f += df;
            e[i ^ 1].f -= df;
            delta += (ll)df * (ll)e[i].p;
            v = e[i].from;
        }
        ///cout << endl;
        if (delta < 0)
            break;
        ans += delta;
        mx_ans = max(mx_ans, ans);
    }
    cout << mx_ans;
    return 0;
}
