#include <bits/stdc++.h>
using namespace std;

vector<vector<int> > g;
vector<int> tin;
vector<int> tout;
vector<int> a;
vector<int> h;
vector<vector<int> > tour;
vector<int> euler;
vector<int> tree;
vector<int> mod;
int timer = 0;

void dfs(int v) {
    tin[v] = timer++;
    euler.emplace_back(v);
    for (int u : g[v]) {
        h[u] = h[v] + 1;
        dfs(u);
    }
    tout[v] = timer++;
    tour[h[v]].emplace_back(v);
    euler.emplace_back(v);
}

void build(int v, int tl, int tr) {
    if (tl == tr) {
        tree[v] = a[euler[tl]];
        mod[v] = -1;
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v << 1, tl, tm);
    build(1 + (v << 1), tm + 1, tr);
    tree[v] = tree[v << 1] + tree[1 + (v << 1)];
    mod[v] = -1;
}

void push(int v, int tl, int tr) {
    if (mod[v] == -1)
        return;
    if (tl == tr) {
        mod[v] = -1;
        tree[v] = 1;
        return;
    }
    ///int tm = (tl + tr) >> 1;
    mod[v << 1] = mod[1 + (v << 1)] = mod[v];
    tree[v] = (tr - tl + 1);
    mod[v] = -1;
}

void update(int v, int tl, int tr, int l, int r) {
    push(v, tl, tr);
    l = max(l, tl);
    r = min(r, tr);
    if (l > tr || r < tl || l > r)
        return;
    if (l == tl && r == tr) {
        mod[v] = 1;
        push(v, tl, tr);
        return;
    }
    int tm = (tl + tr) >> 1;
    update(v << 1, tl, tm, l, r);
    update(1 + (v << 1), tm + 1, tr, l, r);
    tree[v] = tree[v << 1] + tree[1 + (v << 1)];
}

int get(int v, int tl, int tr, int l, int r) {
    push(v, tl, tr);
    l = max(l, tl);
    r = min(r, tr);
    if (l > tr || r < tl || l > r)
        return 0;
    if (l == tl && r == tr) {
        return tree[v];
    }
    int tm = (tl + tr) >> 1;
    return get(v << 1, tl, tm, l, r) + get(1 + (v << 1), tm + 1, tr, l, r);
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        int p, v;
        cin >> p >> v;
        --p;
        --v;
        g[p].emplace_back(v);
    }
    a.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    tin.resize(n);
    tout.resize(n);
    h.assign(n, 0);
    tour.resize(n + 1);
    dfs(0);
    tree.resize(4 * euler.size());
    mod.resize(tree.size());
    ///for (int v : euler)
    ///    cout << v << ' ';
    ///cout << endl;
    build(1, 0, (int)euler.size() - 1);
    int q;
    cin >> q;
    if (q <= 10000 && n <= 10000) {
    ///if (0) {
        while (q--) {
            int type;
            cin >> type;
            if (type == 1) {
                int v, k;
                cin >> v >> k;
                --v;
                for (int i = h[v]; i <= min(n, h[v] + k); ++i) {
                    for (int &u : tour[i]) {
                        if (tin[u] >= tin[v] && tout[u] <= tout[v])
                            a[u] = 1;
                    }
                }
            } else {
                int v, k;
                cin >> v >> k;
                --v;
                int sum = 0;
                for (int i = h[v]; i <= min(n, h[v] + k); ++i) {
                    for (int &u : tour[i]) {
                        if (tin[u] >= tin[v] && tout[u] <= tout[v])
                            sum += a[u];
                    }
                }
                cout << sum << '\n';
            }
        }
        return 0;
    } else {
        vector<pair<int, pair<int, int> > > qs(q);
        int cnt = 0;
        for (int i = 0; i < q; ++i) {
            cin >> qs[i].first >> qs[i].second.first >> qs[i].second.second;
            if (qs[i].second.second == n)
                ++cnt;
        }
        if (cnt == q) {
            for (int i = 0; i < q; ++i) {
                int type = qs[i].first;
                int v = qs[i].second.first - 1;
                if (type == 1) {
                    update(1, 0, (int)euler.size() - 1, tin[v], tout[v]);
                } else {
                    cout << get(1, 0, (int)euler.size() - 1, tin[v], tout[v]) / 2 << '\n';
                }
            }
            return 0;
        }
    }
    return 0;
}
