#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>

#define upmin(a, b) a = min(a, b)
#define upmax(a, b) a = max(a, b)
#define pr(x) cout << x << endl
#define wpr(x) cout << #x << ": " << x << endl
#define wprv(x) cout << #x << ": " << endl; for(auto it : x) cout << it << " "; cout << endl;
#define wprvv(x) cout << #x << ": " << endl; for(auto it : x) {for(auto it2 : it) cout << it2<< " "; cout << endl;}
#define rep(i, s, e) for(ll i = s; i < e; i++)

using namespace std;
using ll = long long;
using vll = vector<ll>;
using vll = vector<ll>;
using vvll = vector<vll>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
using vvpll = vector<vpll>;
using pq = priority_queue<pll, vpll>;
/*

Solution:
for each one, the answer is pref[end] - pref[start]
So we can assign for each one the best node in his subtree that is free
We can use set for that.

The question is what to do when we are now only negative.
I guess that for now we will just pop those nodes back.

I should look at it from the end:
For each end we assign best start -> take smallest start.
BUT start calculating the answer from the bottom.

0 - based indexes

dp[i][j] = max number when we used j ppl for it

*/

ll n;
vll s, e, pref;

vpll par;
vvpll tree;
ll res;

void make_pref(ll cur, ll sum)
{
	//wpr(cur);
	pref[cur] = sum;
	for (auto& nei : tree[cur]) {
		if (nei.first == par[cur].first) continue;
		make_pref(nei.first, sum + nei.second);
	}
}



void get_sons(ll cur, vll& have)
{
	have.push_back(cur);

	for (auto& nei : tree[cur]) {
		if (nei.first == par[cur].first) continue;
		get_sons(nei.first, have);
	}

}


void calc(ll cur) {
	
	for (auto& nei : tree[cur]) {
		if (nei.first == par[cur].first) continue;
		calc(nei.first);
	}
	vll sons;
	get_sons(cur, sons);

}

void brute()
{
	/*
	vector<pair<ll, pll>> got;
	rep(start, 0, n) {
		vll have;
		get_sons(start, have);
		for (auto& end : have) {
			got.push_back({ pref[end] - pref[start], {start, end } });
		}
	}
	sort(got.rbegin(), got.rend());

	rep(i, 0, got.size()) {
		ll start = got[i].second.first;
		ll end = got[i].second.second;
		ll v = got[i].first;

		if (v <= 0) continue;

		ll add = min(s[start], e[end]);
		//cout << add << " ppl are going from " << start + 1 << " to " << end + 1 << endl;

		res += add * v;
		s[start] -= add, e[end] -= add;
	}
	*/
	res = 0;
	for (ll i = n - 2; i >= 0; i--) {
		ll v = pref[i + 1] - pref[i];
		if (v >= 0) res += v;
	}


}

void solve()
{
	cin >> n;
	s.resize(n), e.resize(n);
	rep(i, 0, n) cin >> s[i];
	rep(i, 0, n) cin >> e[i];
	par.resize(n, { -1, -1 });
	tree.resize(n);
	rep(i, 0, n - (ll)1) {
		ll papa, curw;
		cin >> papa >> curw;
		papa--;
		par[i + 1].first = papa, par[i + 1].second = curw;
		tree[i + 1].push_back({ papa, curw });
		tree[papa].push_back({ i + 1, curw });
	}

	pref.resize(n, 0);
	make_pref(0, 0);
	//wprv(pref);
	res = 0;
	pq have;
	//dfs_solve(0, have);
	brute();
	pr(res);
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	solve();
}


/*

5
5 1 0 0 0
100 1 1 2 4
1 6
1 1
2 2
2 -1


*/