#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>

#define upmin(a, b) a = min(a, b)
#define upmax(a, b) a = max(a, b)
#define pr(x) cout << x << endl
#define wpr(x) cout << #x << ": " << x << endl
#define wprv(x) cout << #x << ": " << endl; for(auto it : x) cout << it << " "; cout << endl;
#define wprvv(x) cout << #x << ": " << endl; for(auto it : x) {for(auto it2 : it) cout << it2<< " "; cout << endl;}
#define rep(i, s, e) for(ll i = s; i < e; i++)

using namespace std;
using ll = long long;
using vll = vector<ll>;
using vll = vector<ll>;
using vvll = vector<vll>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
using vvpll = vector<vpll>;
using vb = vector<bool>;


/*

I think the solution might be as follows:

Find for each one the first time he knows the news
Then, for query, find the number of nodes that know the news before the current time.
This can be done by using euler tour to flatten the tree to an array, and then make a persistent segtree.

*/

ll n, q;
vvll tree;
vll par;
vb know;

void spread(ll cur, ll x)
{
	if (x < 0) return;
	know[cur] = true;
	for (auto& nei : tree[cur]) {
		if (nei == par[cur]) continue;
		spread(nei, x - 1);
	}
}


ll calc(ll cur, ll x) {
	if (x < 0) return 0;
	ll sum = 0;
	if (know[cur]) sum = 1;
	for (auto& nei : tree[cur]) {
		if (nei == par[cur]) continue;
		sum += calc(nei, x - 1);
	}
	return sum;
}
void solve()
{
	cin >> n;
	tree.resize(n);
	know.resize(n, 0);
	par.resize(n, -1);
	rep(i, 0, n - (ll)1) {
		ll pap, son;
		cin >> pap >> son;
		pap--, son--;
		par[son] = pap;
		tree[pap].push_back(son);
	}
	rep(i, 0, n) {
		ll b; cin >> b;
		know[i] = b;
	}

	cin >> q;
	while (q--) {
		ll opt, x, k;
		cin >> opt >> x >> k;
		x--;
		if (opt == 1) {
			spread(x, k);
		}
		else {
			ll res = calc(x, k);
			pr(res);
		}
	}
	
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	solve();
}

/*


10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0
1 0 1 0 1
9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2



1
3
0
6
3
4
6

*/