#include <bits/stdc++.h>

using namespace std;

constexpr int NMAX = 2e5 + 5;

int N, Q;
vector <int> G[NMAX];
int Dad[NMAX];
int B[NMAX];

void Dfs (int Node, int dad = 0) {
    Dad[Node] = dad;

    for (auto it : G[Node]) {
        if (it == dad) continue;

        Dfs(it, Node);
    }
}

void Complete (int Node, int Lvl) {
    if (Lvl < 0) return;
    B[Node] = 1;

    for (auto it : G[Node]) {
        if (it == Dad[Node]) continue;

        Complete(it, Lvl-1);
    }
}

int FindAnswer (int Node, int Lvl) {
    if (Lvl == 0) return B[Node];

    int sum = B[Node];
    for (auto it : G[Node]) {
        if (it == Dad[Node]) continue;

        sum += FindAnswer(it, Lvl-1);
    }

    return sum;
}
void Read () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for (int i = 1; i < N; ++ i ) {
        int x,y;
        cin >> x >> y;

        G[x].push_back(y);
    }

    Dfs(1);

    for (int i = 1; i <= N; ++ i )
        cin >> B[i];
}

void Solve () {
    cin >> Q;
    for (int i = 1; i <= Q; ++ i ) {
        int tip, x, k;
        cin >> tip >> x >> k;

        if (tip == 1) {
            Complete(x, k);
        }
        else {
            cout << FindAnswer(x, k) << '\n';
        }
    }
}

int main () {
    Read();
    Solve();
    return 0;
}
