#include <bits/stdc++.h>

using namespace std;

constexpr int NMAX = 2e5 + 5;

struct Node {
    int lazy;
    int cnt;
};

Node arb[4*NMAX];

void Propag (int nod, int a, int b) {
    if (arb[nod].lazy == 0) return;
    if (a == b) return;

    int mij = (a + b) / 2;

    arb[2*nod].lazy = arb[2*nod+1].lazy = arb[nod].lazy;
    arb[nod].lazy = 0;

    arb[2*nod].cnt = (mij - a + 1);
    arb[2*nod+1].cnt = b - mij;
}

void Update (int nod, int a, int b, int ua, int ub) {
    if (ua <= a && b <= ub) {
        arb[nod].cnt = (b - a + 1);
        arb[nod].lazy = 1;
        return;
    }

    Propag(nod, a, b);

    int mij = (a + b) / 2;

    if (ua <= mij) Update(2*nod, a, mij, ua, ub);
    if (mij < ub) Update(2*nod+1, mij+1, b, ua, ub);

    arb[nod].cnt = (arb[2*nod].cnt + arb[2*nod+1].cnt);
}

int Query (int nod, int a, int b, int qa, int qb) {
    if (qa <= a && b <= qb) return arb[nod].cnt;

    Propag(nod, a, b);
    int mij = (a + b) / 2;
    int ans_1 = 0, ans_2 = 0;
    if (qa <= mij) ans_1 = Query(2*nod, a, mij, qa, qb);
    if (mij < qb) ans_2 = Query(2*nod+1, mij+1, b, qa, qb);

    return ans_1 + ans_2;
}

int N, Q;
vector <int> G[NMAX];
int Dad[NMAX];

int poz[NMAX];
vector <int> Euler;
int Sz[NMAX];

void Dfs (int Node, int dad = 0) {
    Euler.push_back(Node);
    poz[Node] = Euler.size();
    Sz[Node] = 1;
    Dad[Node] = dad;

    for (auto it : G[Node]) {
        if (it == dad) continue;

        Dfs(it, Node);
        Sz[Node] += Sz[it];
    }
}

void Read () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for (int i = 1; i < N; ++ i ) {
        int x,y;
        cin >> x >> y;

        G[x].push_back(y);
    }

    Dfs(1);

    for (int i = 1; i <= N; ++ i ) {
        int x;
        cin >> x;

        if (x == 1)
            Update(1, 1, N, poz[i], poz[i]);
    }
}

void Solve () {
    cin >> Q;
    for (int i = 1; i <= Q; ++ i ) {
        int tip, x, k;
        cin >> tip >> x >> k;

        if (tip == 1) {
            Update(1, 1, N, poz[x], poz[x] + Sz[x] - 1);
        }
        else {
            cout << Query(1, 1, N, poz[x], poz[x] + Sz[x] - 1) << '\n';
        }
    }
}

int main () {
    Read();
    Solve();
    return 0;
}
