#include <bits/stdc++.h>

using namespace std;

constexpr int NMAX = 2e5 + 5;

vector <int> G[NMAX];

struct Node {
    int lazy;
    multiset <int> Know, NotKnow;
};

Node arb[4*NMAX];

int N;
int B[NMAX];
vector <int> Euler;
int poz[NMAX];
int Sz[NMAX];
int Level[NMAX];

void Init (int nod, int a, int b) {
    if (a == b) {
        if (B[Euler[a-1]] == 1)
            arb[nod].Know.insert(Level[Euler[a-1]]);
        else arb[nod].NotKnow.insert(Level[Euler[a-1]]);
        return;
    }

    int mij = (a + b) / 2;

    Init(2*nod, a, mij);
    Init(2*nod+1, mij+1, b);

    for (auto it : arb[2*nod].Know)
        arb[nod].Know.insert(it);
    for (auto it : arb[2*nod+1].Know)
        arb[nod].Know.insert(it);

    for (auto it : arb[2*nod].NotKnow)
        arb[nod].NotKnow.insert(it);
    for (auto it : arb[2*nod+1].NotKnow)
        arb[nod].NotKnow.insert(it);
}

void Propag (int nod, int a, int b) {
    if (arb[nod].lazy == 0) return;
    if (a == b) return;

    int aux = arb[nod].lazy;
    arb[nod].lazy = 0;
    arb[2*nod].lazy = max(arb[2*nod].lazy, aux);
    arb[2*nod+1].lazy = max(arb[2*nod+1].lazy, aux);

    aux = arb[2*nod].lazy;
    for (auto it : arb[2*nod].NotKnow)
        if (it <= aux)
            arb[2*nod].Know.insert(it);
    multiset <int> :: iterator it = upper_bound(arb[2*nod].NotKnow.begin(), arb[2*nod].NotKnow.end(), aux);
    if (it != arb[2*nod].NotKnow.begin()) {
        it = prev(it);
        arb[2*nod].NotKnow.erase(arb[2*nod].NotKnow.begin(), it);
    }

    aux = arb[2*nod+1].lazy;
    for (auto it : arb[2*nod+1].NotKnow)
        if (it <= aux)
            arb[2*nod+1].Know.insert(it);
    it = upper_bound(arb[2*nod+1].NotKnow.begin(), arb[2*nod+1].NotKnow.end(), aux);
    if (it != arb[2*nod+1].NotKnow.begin()) {
        it = prev(it);
        arb[2*nod+1].NotKnow.erase(arb[2*nod+1].NotKnow.begin(), it);
    }
}

void Update (int nod, int a, int b, int ua, int ub, int lvl) {
    if (ua <= a && b <= ub) {
        arb[nod].lazy = lvl;
        for (auto it : arb[nod].NotKnow)
            if (it <= lvl)
                arb[nod].Know.insert(it);
            else break;
        multiset <int> :: iterator it = upper_bound(arb[nod].NotKnow.begin(), arb[nod].NotKnow.end(), lvl);
        if (it != arb[nod].NotKnow.begin()) {
            it = prev(it);
            arb[nod].NotKnow.erase(arb[nod].NotKnow.begin(), it);
        }

        return;
    }

    Propag(nod, a, b);
    int mij = (a + b) / 2;

    if (ua <= mij) Update(2*nod, a, mij, ua, ub, lvl);
    if (mij < ub) Update(2*nod+1, mij+1, b, ua, ub, lvl);

    if (arb[2*nod].Know.size() > arb[2*nod+1].Know.size()) {
        arb[nod].Know = arb[2*nod].Know;

        for (auto it : arb[2*nod+1].Know)
            arb[nod].Know.insert(it);
    }
    else {
        arb[nod].Know = arb[2*nod+1].Know;

        for (auto it : arb[2*nod].Know)
            arb[nod].Know.insert(it);
    }

    if (arb[2*nod].NotKnow.size() > arb[2*nod+1].NotKnow.size()) {
        arb[nod].NotKnow = arb[2*nod].NotKnow;

        for (auto it : arb[2*nod+1].NotKnow)
            arb[nod].NotKnow.insert(it);
    }
    else {
        arb[nod].NotKnow = arb[2*nod+1].NotKnow;

        for (auto it : arb[2*nod].NotKnow)
            arb[nod].NotKnow.insert(it);
    }
}

int Query (int nod, int a, int b, int qa, int qb, int lvl) {
    if (qa <= a && b <= qb) {
        multiset <int> :: iterator it = upper_bound(arb[nod].Know.begin(), arb[nod].Know.end(), lvl);
        int cnt = 0;

        for (multiset <int> :: iterator i = arb[nod].Know.begin(); i != it; ++ i, ++ cnt);
        return cnt;
    }

    Propag(nod, a, b);
    int mij = (a + b) / 2;
    int ans_left = 0, ans_right = 0;
    if (qa <= mij) ans_left = Query(2*nod, a, mij, qa, qb, lvl);
    if (mij < qb) ans_right = Query(2*nod+1, mij+1, b, qa, qb, lvl);

    return (ans_left + ans_right);
}
void Dfs (int Node, int dad = 0) {
    Euler.push_back(Node);
    poz[Node] = Euler.size();
    Level[Node] = Level[dad] + 1;
    Sz[Node] = 1;

    for (auto it : G[Node]) {
        if (it == dad) continue;

        Dfs(it, Node);
        Sz[Node] += Sz[it];
    }
}

void Read () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for (int i = 1; i < N; ++ i ) {
        int x, y;
        cin >> x >> y;

        G[x].push_back(y);
    }
}

void Precalculation () {
    for (int i = 1; i <= N; ++ i )
        cin >> B[i];

    Dfs(1);

    Init(1, 1, N);
}

void Solve () {
    int Q;
    cin >> Q;
    for (; Q; -- Q ) {
        int tip, x, k;
        cin >> tip >> x >> k;

        if (tip == 1) {
            Update(1, 1, N, poz[x], poz[x] + Sz[x] - 1, Level[x] + k);
        }
        else cout << Query(1, 1, N, poz[x], poz[x] + Sz[x] - 1, Level[x] + k) << '\n';
    }
}

int main () {
    Read();
    Precalculation();

    Solve();

    return 0;
}
