#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <vector>

struct Node {
	int Flag;
	int Parent;
	std::vector<int> Child;
} A [ 200'005 ];

void Update ( int root , int levels ) {
	A [ root ].Flag = 1;
	if ( levels ) {
		for ( int i = 0 ; i < A [ root ].Child.size ( ) ; i++ ) {
				Update ( A [ root ].Child[ i ] , levels - 1 ) ;
		}
	}
}

int Query ( int root , int levels ) {
	int Answer = A [ root ].Flag ;
	if ( levels ) {
		for ( int i = 0 ; i < A [ root ].Child.size ( ) ; i++ ) {
				Answer += Query ( A [ root ].Child[ i ] , levels - 1 ) ;
		}
	}
	return Answer;
}

int main ( void ) {
	int N ;
	scanf ( "%d" , &N ) ;
	for ( int i = 0 ; i < N - 1 ; i++ ) {
		int x , y ;
		scanf ( " %d %d" , &x , &y ) ;
		A [ y ].Parent = x;
		A [ x ].Child.push_back ( y ) ;
	}
	for ( int i = 1 ; i <= N ; i++ ) {
		scanf ( " %d" , &A [ i ].Flag ) ;
	}
	int Q ;
	scanf ( " %d" , &Q ) ;
	for ( int i = 0 ; i < Q ; i++ ) {
		int c , x , k ;
		scanf ( " %d %d %d" , &c , &x , &k ) ;
		if ( c == 1 ) Update ( x , k ) ;
		else if ( c == 2 ) printf ( "%d\n" , Query ( x , k )) ;
	}
	return 0 ;
}
