#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define int ll

const int INF = 1e18 + 228;

struct edge {
    int to, cap, cost, rev;
};

vector<vector<edge>> g;

vector<int> dist;
vector<int> p;
vector<int> inq;

void spfa() {
    dist.assign(g.size(), INF);
    p.assign(g.size(), -1);
    inq.assign(g.size(), 0);
    dist[0] = 0;
    deque<int> q;
    q.push_back(0);
    inq[0] = 1;
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        inq[v] = 0;
        for (auto e : g[v]) {
            if (e.cap != 0) {
                if (dist[e.to] > dist[v] + e.cost) {
                    dist[e.to] = dist[v] + e.cost;
                    p[e.to] = v;
                    if (!inq[e.to]) {
                        inq[e.to] = 1;
                        q.push_back(e.to);
                    }
                }
            }
        }
    }
}

void addEdge(int a, int b, int c, int d=0) {
    int asz = g[a].size();
    int bsz = g[b].size();
    g[a].push_back({b, c, d, bsz});
    g[b].push_back({a, 0, -d, asz});
}

void solve() {
    int n;
    cin >> n;
    g.resize(n + 2);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if (x)
            addEdge(0, i + 2, x);
    }
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if (x)
            addEdge(i + 2, 1, x);
    }
    for (int i = 1; i < n; i++) {
        int from, w;
        cin >> from >> w;
        from--;
        addEdge(from + 2, i + 2, INF, -w);
    }
    int ans = 0;
    while (true) {
        spfa();
        if (dist[1] >= 0) {
            break;
        }
        vector<int> path;
        {
            int curv = 1;
            while (curv != -1) {
                path.push_back(curv);
                curv = p[curv];
            }
        }
        reverse(path.begin(), path.end());
        vector<int> inds(path.size() - 1);
        int mincap = INF;
        for (int i = 0; i < (int) inds.size(); i++) {
            while (g[path[i]][inds[i]].to != path[i + 1]) {
                inds[i]++;
            }
            mincap = min(mincap, g[path[i]][inds[i]].cap);
        }
        ans += dist[1] * mincap;
        for (int i = 0; i < (int) inds.size(); i++) {
            g[path[i]][inds[i]].cap -= mincap;
            int to = g[path[i]][inds[i]].to;
            g[to][g[path[i]][inds[i]].rev].cap += mincap;
        }
    }
    cout << -ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
