#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

const int MAXN = 2e5 + 228;
const int INF = 1e9 + 228;

int n;
vector<int> ch[MAXN];
int tin[MAXN];
int tout[MAXN];
int depth[MAXN];
int cur_time = 0;

void dfs(int v) {
    tin[v] = cur_time++;
    for (int u : ch[v]) {
        depth[cur_time] = depth[tin[v]] + 1;
        dfs(u);
    }
    tout[v] = cur_time;
}

int arr2[MAXN];
int tree2[4 * MAXN];
int arr[MAXN];

int merge2(int a, int b) {
    if (a == -1)
        return b;
    if (b == -1)
        return a;
    if (arr2[a] < arr2[b]) {
        return a;
    }
    return b;
}

void build2(int v, int l, int r) {
    if (l + 1 == r) {
        tree2[v] = l;
    } else {
        int m = (l + r) / 2;
        build2(2 * v + 1, l, m);
        build2(2 * v + 2, m, r);
        tree2[v] = merge2(tree2[2 * v + 1], tree2[2 * v + 2]);
    }
}

void update2(int v, int l, int r, int i) {
    if (i < l || i >= r)
        return;
    if (l + 1 == r) {
        return;
    }
    int m = (l + r) / 2;
    update2(2 * v + 1, l, m, i);
    update2(2 * v + 2, m, r, i);
    tree2[v] = merge2(tree2[2 * v + 1], tree2[2 * v  + 2]);
}

int getMinD(int v, int l, int r, int ql, int qr) {
    if (l >= qr || ql >= r) {
        return -1;
    }
    if (ql <= l && r <= qr) {
        return tree2[v];
    }
    int m = (l + r) / 2;
    return merge2(getMinD(2 * v + 1, l, m, ql, qr), getMinD(2 * v + 2, m, r, ql, qr));
}

int getMinD(int l, int r) {
    return getMinD(0, 0, n, l, r);
    return (int) (min_element(arr2 + l, arr2 + r) - arr2);
}

vector<int> tree[4 * MAXN]; //fwt?
vector<int> inds[4 * MAXN];

unordered_map<int, int> mapa[MAXN];

void build(int v, int l, int r) {
    tree[v].resize(r - l + 1);
    inds[v].resize(r - l);
    iota(inds[v].begin(), inds[v].end(), l);
    sort(inds[v].begin(), inds[v].end(), [&](int i, int j) { return depth[i] < depth[j]; });
    for (int i = 0; i < r - l; i++) {
        mapa[v][inds[v][i]] = i;
    }
    if (l + 1 == r) {
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    // TODO: merge sort for inds if I get TL
}

int get(int v, int l, int r, int ql, int qr, int d) {
    if (l >= qr || ql >= r) 
        return 0;
    if (ql <= l && r <= qr) {
        int n = (int) (upper_bound(inds[v].begin(), inds[v].end(), -1, [&](int i, int j) {
            assert(i == -1);
            if (depth[j] > d) {
                return true;
            }
            return false;
        }) - inds[v].begin());
        int ans = 0;
        while (n > 0) {
            ans += tree[v][n];
            n -= n & (-n);
        }
        return ans;
    }
    int m = (l + r) / 2;
    return get(2 * v + 1, l, m, ql, qr, d) + get(2 * v + 2, m, r, ql, qr, d);
}

int get(int l, int r, int d) {
    return get(0, 0, n, l, r, d);
    int ans = 0;
    for  (int i = l; i < r; i++) {
        if (depth[i] <= d) {
            ans += arr[i];
        }
    }
    return ans;
}

void update(int v, int l, int r, int i) {
    if (i < l || i >= r)
        return;
    {
        int n = mapa[v][i] + 1;
        while (n < (int) tree[v].size()) {
            tree[v][n] += 1;
            n += n & (-n);
        }
    }
    if (l + 1 == r)
        return;
    int m = (l + r) / 2;
    update(2 * v + 1, l, m, i);
    update(2 * v + 2, m, r, i);
}

void update(int i) {
    arr[i] = 1;
    arr2[i] = INF;
    update2(0, 0, n, i);
    update(0, 0, n, i);
}

void solve() {
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        ch[a].push_back(b);
    }
    dfs(0);
    for (int i = 0; i < n; i++) {
        arr2[i] = depth[i];
    }
    build2(0, 0, n);
    build(0, 0, n);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if (x) {
            update(tin[i]);
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t, v, d;
        cin >> t >> v >> d;
        v--;
        if (t == 1) {
            while (true) {
                int i = getMinD(tin[v], tout[v]);
                if (arr2[i] - depth[tin[v]] > d)
                    break;
                update(i);
            } 
        } else {
            int ans = 0;
            ans = get(tin[v], tout[v], depth[tin[v]] + d);
            cout << ans << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
