#include <algorithm>
#include <iostream>
#include <cstring>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>

#define pii pair<long long, long long>
#define ppiii pair<pii, long long>
#define ll long long
#define MOD (int)1e9 + 7

using namespace std;

bool cmp(ppiii x, ppiii y) {
	return x.second > y.second;
}

int miners[(int)1e5];
int spaceLeft[(int)1e5];
vector<vector<pii> > graph;
int n;

bool visited[(int)1e5];
vector<ppiii> paths;

vector<pii> dfs(int curr) {
	visited[curr] = true;

	vector<pii> myPaths;
	myPaths.push_back(pii(curr, 0));
	for (pii x : graph[curr]) {
		if (visited[x.first])
			continue;
		vector<pii> c = dfs(x.first);
		for (pii i : c) {
			myPaths.push_back(pii(i.first, i.second + x.second));
			paths.push_back(ppiii(pii(curr, i.first), i.second + x.second));
		}
	}

	return myPaths;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	cin >> n;
	graph.resize(n + 1, vector<pii>());
	for (int i = 0; i < n; i++)
		cin >> miners[i + 1];
	for (int i = 0; i < n; i++)
		cin >> spaceLeft[i + 1];
	
	for (int i = 2; i <= n; i++) {
		pii s;
		cin >> s.first >> s.second;
		graph[s.first].push_back(pii(i, s.second));
		graph[i].push_back(pii(s.first, s.second));
	}

	dfs(1);
	sort(paths.begin(), paths.end(), cmp);

	ll out = 0;
	for (ppiii x : paths) {
		if (x.second <= 0)
			break;
		ll miner = min(miners[x.first.first], spaceLeft[(int)x.first.second]);
		out += miner * x.second;
		miners[x.first.first] -= miner;
		spaceLeft[x.first.second] -= miner;
	}

	cout << out << endl;
}
