#include <algorithm>
#include <iostream>
#include <cstring>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>

#define pii pair<long long, long long>
#define ppiii pair<pii, long long>
#define ll long long
#define MOD (int)1e9 + 7

using namespace std;

bool cmp(ppiii x, ppiii y) {
	if (x.second > y.second)
		return true;
	return false;
}

int miners[(int)5e5];
int spaceLeft[(int)5e5];
vector<bool> visited;
vector<ppiii> paths;
vector<vector<pii> > graph;

vector<pii> dfs(int curr) {
	visited[curr] = true;

	vector<pii> myPaths(1, pii(curr, 0));
	
	for (pii x : graph[curr]) {
		if (visited[x.first])
			continue;

		vector<pii> currPaths = dfs(x.first);
		for (pii p : currPaths) {
			myPaths.push_back(pii(p.first, p.second + x.second));
			paths.push_back(ppiii(pii(curr, p.first), p.second + x.second));
		}
	}

	return myPaths;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n;
	cin >> n;
	visited.resize(n + 1, false);
	graph.resize(n + 1);
	for (int i = 1; i <= n; i++)
		cin >> miners[i];
	for (int i = 1; i <= n; i++)
		cin >> spaceLeft[i];

	for (int i = 2; i <= n; i++) {
		int a, b;
		cin >> a >> b;
		graph[i].push_back(pii(a, b));
		graph[a].push_back(pii(i, b));
	}

	dfs(1);
	sort(paths.begin(), paths.end(), cmp);

	ll out = 0;
	for (ppiii path : paths) {
		if (path.second <= 0)
			break;

		ll sent = min(miners[path.first.first], spaceLeft[path.first.second]);
		miners[path.first.first] -= sent;
		spaceLeft[path.first.second] -= sent;
		out += sent * path.second;
	}

	cout << out << endl;
}
