#include <algorithm>
#include <iostream>
#include <cstring>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>

#define pii pair<long long, long long>
#define ppiii pair<pii, long long>
#define ll long long
#define MOD (int)1e9 + 7

using namespace std;

bool cmp(ppiii x, ppiii y) {
	if (x.second > y.second)
		return true;
	return false;
}

struct Path {
	int f, t; ll cost;

	Path(int F, int T, ll Cost) { f = F, t = T, cost = Cost; }

	bool operator<(const Path& b) const {
		return cost > b.cost;
	}
};

int miners[(int)5e5];
int spaceLeft[(int)5e5];
int par[(int)5e5];
vector<Path> paths;
vector<vector<pii> > graph;

void getPars(int curr) {

	for (pii x : graph[curr]) {
		if (x.first != par[curr]) {
			par[x.first] = curr;
			getPars(x.first);
		}
	}
}

void getPaths(int start, int curr, ll cost) {
	
	if (start != curr)
		paths.push_back(Path(start, curr, cost));
	for (pii x : graph[curr])
		if (x.first != par[curr])
			getPaths(start, x.first, cost + x.second);
	
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n;
	cin >> n;
	graph.resize(n + 1);
	for (int i = 1; i <= n; i++)
		cin >> miners[i];
	for (int i = 1; i <= n; i++)
		cin >> spaceLeft[i];

	for (int i = 2; i <= n; i++) {
		int a, b;
		cin >> a >> b;
		graph[i].push_back(pii(a, b));
		graph[a].push_back(pii(i, b));
	}

	getPars(1);
	for (int i = 1; i <= n; i++) {
		getPaths(i, i, 0);
	}
	sort(paths.begin(), paths.end());

	ll out = 0;
	for (Path path : paths) {
		if (path.cost <= 0)
			break;

		ll sent = min(miners[path.f], spaceLeft[path.t]);
		miners[path.f] -= sent;
		spaceLeft[path.t] -= sent;
		out += sent * path.cost;
	}

	cout << out << endl;
}
