#include <algorithm>
#include <iostream>
#include <cstring>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>

#define pii pair<int, int>
#define ll long long
#define MOD (int)1e9 + 7

using namespace std;

struct path {
	int f, t, c;

	path(int F, int T, int C) { f = F, t = T, c = C; }

	bool operator<(const path& b) const {
		return c > b.c;
	}
};

int parent[(int)5e5];
vector<path> paths;
vector<vector<pii> > graph;

int miners[(int)5e5];
int leftt[(int)1e5];

void getParent(int curr) {
	for (pii x : graph[curr])
	{
		if (x.first == parent[curr])
			continue;
		parent[x.first] = curr;
		getParent(x.first);
	}
}

void goDown(int start, int curr, int cost) {
	if (start != curr)
		paths.push_back(path(start, curr, cost));
	for (pii x : graph[curr]) {
		if (x.first == parent[curr])
			continue;
		goDown(start, x.first, cost + x.second);
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n;
	cin >> n;
	graph.resize(n + 1);

	for (int i = 1; i <= n; i++)
		cin >> miners[i];
	for (int i = 1; i <= n; i++)
		cin >> leftt[i];

	for (int i = 2; i <= n; i++) {
		int b, w;
		cin >> b >> w;

		graph[i].push_back(pii(b, w));
		graph[b].push_back(pii(i, w));
	}

	getParent(1);
	for (int i = 1; i <= n; i++)
		goDown(i, i, 0);
	sort(paths.begin(), paths.end());
	
	int out = 0;
	for (path x : paths) {
		if (x.c <= 0)
			break;

		int toMove = min(miners[x.f], leftt[x.t]);
		out += toMove * x.c;
		miners[x.f] -= toMove;
		leftt[x.t] -= toMove;
	}

	cout << out << endl;
}
