#include <algorithm>
#include <iostream>
#include <cstring>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>

#define pii pair<long long, long long>
#define ll long long
#define MOD (int)1e9 + 7

using namespace std;

struct seggy {
	vector<int> tree;
	int n;

	seggy() {
		n = 0;
	}
	seggy(int _size) {
		n = _size;
		tree.resize(n * 2);
	}

	void set(int idx, int val) {
		idx += n;
		tree[idx] = val;
		for (idx /= 2; idx > 0; idx /= 2)
			tree[idx] = tree[idx * 2] + tree[idx * 2 + 1];
	}

	int query(int l, int r) {
		int out = 0;
		for (l += n, r += n; l < r; l /= 2, r /= 2) {
			if (l & 1)
				out += tree[l++];
			if (r & 1)
				out += tree[--r];
		}

		return out;
	}
};

vector<vector<int> > graph;

int numChildren[(int)5e5];
int par[(int)5e5];
bool set2[(int)5e5];
map<int, int> wher;
seggy dfsArr;

int pnt = 0;
int dfs1(int curr) {
	wher[curr] = pnt, pnt++;
	
	numChildren[curr] = 1;
	for (int x : graph[curr])
	{
		if (x != par[curr]) {
			par[x] = curr;
			numChildren[curr] += dfs1(x);
		}
	}

	return numChildren[curr];
}

void dfs2(int curr) {
	dfsArr.set(wher[curr], 1);
	if (set2[curr])
		return;
	set2[curr] = true;

	for (int x : graph[curr]) {
		if (x == par[curr])
			continue;

		dfs2(x);
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n;
	cin >> n;
	dfsArr = seggy(n + 1);
	graph.resize(n + 1);

	for (int i = 1; i < n; i++) {
		int a, b;
		cin >> a >> b;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}

	dfs1(1);
	for (int i = 1; i <= n; i++) {
		int k;
		cin >> k;
		dfsArr.set(wher[i], k);
	}

	int q;
	cin >> q;
	while (q--) {
		int type;
		cin >> type;
		if (type == 2) {
			int x, k;
			cin >> x >> k;

			cout << dfsArr.query(wher[x], wher[x] + numChildren[x]) << endl;
		}
		else
		{
			int x, k;
			cin >> x >> k;
			dfs2(x);
		}
	}
}
