
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt")
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/rope>
//
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;
using namespace std;
//using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 2e5 + 10;
int d[N], tin[N], tout[N];
int globalT;
vector<int> tinInDist[N];
vector<int> soloScoreInDist[N];
bool alreadyKnows[N];
int MAXDIST = 0;

struct fenwick {
    vector<int> t;

    void add(int i, int val) {
        ++i;
        for (; i < t.size(); i += i & -i) {
            t[i] += val;
        }
    }

    void build(vector<int>& a) {
        t.assign(a.size() + 1, 0);
        for (int i = 0; i < a.size(); ++i) {
            add(i, a[i]);
        }
    }

    int get(int l) {
        int res = 0;
        for (int i = l; i > 0; i -= i & -i) {
            res += t[i];
        }
        return res;
    }

    int get(int l, int r) {
        return get(r + 1) - get(l);
    }
};

struct level {
    fenwick st;
    set<int> s; // zerosIndexes

    void build(vector<int>& a) {
        st.build(a);
        for (int i = 0; i < a.size(); ++i) {
            if (!a[i]) {
                s.insert(i);
            }
        }
    }

    void modify(int l, int r) {
        while (true) {
            auto it = s.lower_bound(l);
            if (it == s.end() || *it > r) {
                break;
            }
            st.add(*it, 1);
            s.erase(it);
        }
    }

    int get(int l, int r) {
        return st.get(l, r);
    }
};

void dfs(int i, vector<vector<int>>& g, int currD = 0) {
    MAXDIST = max(MAXDIST, currD);
    tin[i] = globalT;
    ++globalT;
    d[i] = currD;
    tinInDist[currD].push_back(tin[i]);
    soloScoreInDist[currD].push_back(alreadyKnows[i]);
    for (int j : g[i]) {
        dfs(j, g, currD + 1);
    }
    tout[i] = globalT;
    ++globalT;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    long long root = (long long)(n) * ((long long)(n) - 1LL) / 2LL;
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        root -= y;
        g[x].push_back(y);
    }
    for (int i = 0; i < n; ++i) {
        int tmp;
        cin >> tmp;
        alreadyKnows[i] = tmp;
    }
    globalT = 0;
    dfs(root, g);
    vector<level> stInDist(MAXDIST + 1);
    for (int i = 0; !soloScoreInDist[i].empty(); ++i) {
        stInDist[i].build(soloScoreInDist[i]);
    }
    int q;
    cin >> q;
    while (q--) {
        int type, x , k;
        cin >> type >> x >> k;
        --x;
        if (type == 1) {
            for (int i = d[x]; i <= d[x] + k && i < N && !tinInDist[i].empty(); ++i) {
                int l = lower_bound(tinInDist[i].begin(),  tinInDist[i].end(), tin[x]) - tinInDist[i].begin();
                if (l < tinInDist[i].size()) {
                    int r = upper_bound(tinInDist[i].begin(),  tinInDist[i].end(), tout[x]) - tinInDist[i].begin();
                    --r;
                    stInDist[i].modify(l, r);
                }
            }
        } else {
            int res = 0;
            for (int i = d[x]; i <= d[x] + k && i < N && !tinInDist[i].empty(); ++i) {
                int l = lower_bound(tinInDist[i].begin(),  tinInDist[i].end(), tin[x]) - tinInDist[i].begin();
                if (l < tinInDist[i].size()) {
                    int r = upper_bound(tinInDist[i].begin(),  tinInDist[i].end(), tout[x]) - tinInDist[i].begin();
                    --r;
                    res += stInDist[i].get(l, r);
                }
            }
            cout << res << '\n';
        }
    }
    return 0;
}
