#include <bits/stdc++.h>

using namespace std;

///#define int long long

typedef long long ll;

struct edge{
  int to;
  ll cap;
  int cost;
};

vector<edge> edges;

const int N=(int)5e5+7;
const ll INF=(ll)1e18;
int n;
vector<int> g[N];

void add(int a,int b,ll cap,int cost){

  edges.push_back({b,cap,cost});
  edges.push_back({a,0,-cost});

  g[a].push_back(edges.size()-2);
  g[b].push_back(edges.size()-1);
}

ll best[N];
int parind[N];


void algo(){
  for (int i=1;i<=n;i++)best[i]=-INF;
  best[1]=0;

  priority_queue<pair<ll,int>> q;
  q.push({best[1],1});

  while (!q.empty()) {
    auto it=q.top();
    q.pop();
    if (best[it.second]!=it.first)continue;
    int a=it.second;
    //cout << " = " << a << " : " << best[a] << "\n";

    for (auto &i:g[a]){
      if (edges[i].cap){
        ll nw=best[a]+edges[i].cost;

        int b=edges[i].to;

        if (nw>best[b]){
          parind[b]=i;
          best[b]=nw;
          q.push({best[b],b});
        }
      }
    }
  }
}

signed main() {
  ios::sync_with_stdio(0); cin.tie(0);

  //freopen ("input","r",stdin);

  cin>>n;
  for (int i=1;i<=n;i++){
    int s;
    cin>>s;
    add(1,i+1,s,0);
  }
  for (int i=1;i<=n;i++){
    int t;
    cin>>t;
    add(i+1,n+2,t,0);
  }

  for (int i=2;i<=n;i++){
    int par,gt;
    cin>>par>>gt;
    add(par+1,i+1,INF,gt);
  }

  algo();

  n+=2;
  ll sol=0;

  while (1){
    /// find the best path

    algo();

    if (best[n]<=0)break;

    //cout << " done \n";

    vector<int> inds;

    int node=n;

    while (node!=1){
      inds.push_back(parind[node]);
      assert(edges[parind[node]].to==node);
      node=edges[parind[node]^1].to;
    }
    reverse(inds.begin(),inds.end());

    ll mn=INF;
    for (auto &i:inds){
      mn=min(mn,edges[i].cap);
    }

    //cout << mn << " and " << best[n] << "\n";
    sol+=mn*best[n];

    for (auto &i:inds){
      edges[i].cap-=mn;
      edges[i^1].cap+=mn;
    }
  }

  cout<<sol<<"\n";


  return 0;
}
