#include <iostream>
#include <vector>

using namespace std;

int n;
vector<int> g[201010];
int know[201010];
int q;
void dfsMark(int v, int depth, int mx) {
    know[v] = true;
    if (depth >= mx)return;
    for (auto to : g[v]) {
        dfsMark(to, depth + 1, mx);
    }
}
void mark(int x, int k) {
    dfsMark(x, 0, k);
}

int ans = 0;
void dfsGet(int v, int depth, int mx) {
    ans += know[v];
    if (depth >= mx)return;
    for (auto to : g[v]) {
        dfsGet(to, depth + 1, mx);
    }
}
int get(int x, int k) {
    ans = 0;
    dfsGet(x, 0, k);
    return ans;
}



int tIN[401010];
int tOUT[401010];
vector<int> sv;
int T = 1;
int tAll[401010];
int Depth[201010];
void dfs(int v) {
    tAll[T] = v;
    tIN[v] = T++;
    sv.push_back(v);
    for (auto to : g[v]) {
        Depth[to] = Depth[v] + 1;
        dfs(to);
    }
    sv.push_back(v);
    tAll[T] = v;
    tOUT[v] = T++;
}
int t[1601010];
int tAdd[1601010];
void build(int v, int vl, int vr) {
    if (vl == vr) {
        t[v] = know[tAll[vl]];
        return;
    }
    int vm = (vl + vr) / 2;
    build(2 * v, vl, vm);
    build(2 * v + 1, vm + 1, vr);
    t[v] = t[2 * v] + t[2 * v + 1];
}
void push(int v, int vl, int vr) {
    if (tAdd[v] == 0)return;
    t[v] = (vr - vl) + 1;
    if (vl != vr) {
        tAdd[2 * v] = tAdd[v];
        tAdd[2 * v + 1] = tAdd[v];
    }
    tAdd[v] = 0;
}
void color(int v, int vl, int vr, int l, int r) {
    push(v, vl, vr);
    if (l <= vl && vr <= r) {
        tAdd[v] = 1;
        push(v, vl, vr);
        return;
    }
    if (r < vl || vr < l)return;
    int vm = (vl + vr) / 2;
    color(2 * v, vl, vm, l, r);
    color(2 * v + 1, vm + 1, vr, l, r);
    t[v] = t[2 * v] + t[2 * v + 1];
}
int gt(int v, int vl, int vr, int l, int r) {
    push(v, vl, vr);
    if (l <= vl && vr <= r) {
        return t[v];
    }
    if (r < vl || vr < l)return 0;
    int vm = (vl + vr) / 2;
    return gt(2 * v, vl, vm, l, r) + gt(2 * v + 1, vm + 1, vr, l, r);
}
bool Task2 = true;
int zType[201010], zX[201010], zK[201010];
vector<int> MainTree[1601010];
void BB(int v, int vl, int vr) {
    if (vl == vr) {
        if (know[tAll[vl]] == 1)MainTree[v].push_back(Depth[tAll[vl]]);
        return;
    }
    int vm = (vl + vr) / 2;
    BB(2 * v, vl, vm);
    BB(2 * v + 1, vm + 1, vr);
    int p1 = 0, p2 = 0;
    while (true) {
        if (p1 >= MainTree[2 * v].size() && p2 >= MainTree[2 * v + 1].size())break;
        if (p1 >= MainTree[2 * v].size()) {
            MainTree[v].push_back(MainTree[2 * v + 1][p2++]);
            continue;
        }
        if (p2 >= MainTree[2 * v + 1].size()) {
            MainTree[v].push_back(MainTree[2 * v][p1++]);
            continue;
        }
        if (MainTree[2 * v][p1] <= MainTree[2 * v + 1][p2]) {
            MainTree[v].push_back(MainTree[2 * v][p1++]);
            continue;
        } else {
            MainTree[v].push_back(MainTree[2 * v + 1][p2++]);
            continue;
        }
    }
    return;
}
int GG(int v, int vl, int vr, int l, int r, int h) {
    if (l <= vl && vr <= r) {
        if (MainTree[v].empty())return 0;

        int L = -1, R = MainTree[v].size();
        while (L + 1 < R) {
            int mid = (L + R) / 2;
            if (MainTree[v][mid] <= h)L = mid;
            else R = mid;
        }
        return L + 1;
    }
    if (r < vl || vr < l)return 0;
    int vm = (vl + vr) / 2;
    return GG(2 * v, vl, vm, l, r, h) + GG(2 * v + 1, vm + 1, vr, l, r, h);
}
int main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin >> n;
    for (int i = 1; i < n; i++) {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
    }
    for (int i = 1; i <= n; i++)cin >> know[i];
    cin >> q;
    if (n <= 10000 && q <= 10000) {
        while (q--) {
            int type, x, k;
            cin >> type >> x >> k;
            if (type == 1) {
                mark(x, k);
            } else {
                cout << get(x, k) << '\n';
            }
        }
        return 0;
    }
    sv.push_back(0);
    dfs(1);
    for (int i = 1; i <= q; i++) {
        cin >> zType[i] >> zX[i] >> zK[i];
        if (zK[i] != n)Task2 = false;
    }
    if (Task2) {
        build(1, 1, 2*n);
        for (int i = 1; i <= q; i++) {
            if (zType[i] == 1) {
                color(1, 1, 2*n, tIN[zX[i]], tOUT[zX[i]]);
            } else {
                cout << gt(1, 1, 2*n, tIN[zX[i]], tOUT[zX[i]])/2 << '\n';
            }
        }
        return 0;
    }
    BB(1, 1, 2*n);
    for (int i = 1; i <= q; i++) {
        cout << GG(1, 1, 2*n, tIN[zX[i]], tOUT[zX[i]], Depth[zX[i]] + zK[i])/2 << '\n';
    }
    return 0;
}

/**
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1 0
1
9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2
*/
