#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using ll = long long;

int const nmax = 50;
int const sigma = 10;

ll const inf = 1000000000;

std::pair<int,int> dp[1 + nmax][1 + 2 * nmax];

std::pair<int,int> mex(std::vector<std::pair<int,int>> aux) {
  std::sort(aux.begin(), aux.end());
  aux.erase(std::unique(aux.begin(), aux.end()), aux.end());
  if(0 == aux.size())
    return {0, 0};
  if(aux[0].first != 0 || aux[0].second != 0)
    return {0, 0};

  for(int i = 0; i < aux.size() - 1; i++)
    if(aux[i].first + 1 < aux[i + 1].first) {
      if(nmax < aux[i].second)
        return {aux[i].first + 1, 0};
      else
        return {aux[i].first, aux[i].second + 1};

    } else if(aux[i].first + 1 == aux[i + 1].first && aux[i + 1].second != 0)
      return {aux[i].first + 1, 0};
    else if(aux[i].first == aux[i + 1].first && aux[i].second + 1 < aux[i + 1].second)
      return {aux[i].first, aux[i].second + 1};
  
  if(nmax < aux.back().second)
    return {aux.back().first + 1, 0};
  else
    return {aux.back().first, aux.back().second + 1};
}

ll lim[1 + nmax], last[1 + nmax], era[1 + nmax];
int k;
void precompute() {
  lim[0] = 0;
  lim[1] = k - 1;
  era[1] = 1;
  last[1] = k - 1;
  int ptr = 1;

  for(int step = 2; step <= nmax; step++) {
    for(int j = 1; j <= step; j++) {
      if(ptr < nmax) {
        lim[++ptr] = 1LL * (step - 1) * k + (k - 1);
        era[ptr] = step;
        last[ptr] = last[ptr - 1] + k;
      } else
        return ;
    }
  }
}
ll getval(int x, int y) {
  if(x == 0)
    return y;
  if(y == 0)
    return 0;
  if(lim[x] < y)
    return inf * x;
  else {
    int start = 0;
    for(int jump = (1 << 20); 0 < jump; jump /= 2)
      if(start + jump <= x && lim[start + jump] < y)
        start += jump;
    start++;

    //std::cout << "getval: " << last[start] << " " << era[start]
    int coef = (x - start) % era[start];
    return last[start] + 1LL * k * coef - (lim[start] - y);
  }
}
int solve() {
  int n;
  std::cin >> n;
  if(k == 0) {
    int x1 = 0, x2 = 0;
    for(int i = 1;i <= n; i++) {
      int a, b;
      std::cin >> a >> b;
      x1 ^= a;
      x2 ^= b;
    }
    if(0 == x1 && 0 == x2)
      return 0;
    else
      return 1;
  } else {
    std::vector<ll> x(1 + 5);
    for(int i = 1;i <= n; i++) {
      int a, b;
      std::cin >> a >> b;

      //ll val = getval(a, b);

      if(b <= nmax) {
        std::pair<int,int> val = dp[a][b];
        x[val.first] ^= val.second;
      } else {
        std::pair<int,int> val = dp[a][nmax];
        x[val.first] ^= val.second + b - nmax;
      }
    }
    for(int j = 0; j <= 5; j++)
      if(0 < x[j])
        return 1;
    return 0;
  }
}
int main() {
  int q;
  std::cin >> k >> q;
  precompute();

  for(int i = 0; i <= 5; i++) {
    for(int j = 0; j <= nmax; j++) { 
      if(0 < i || 0 < j) {
        std::vector<std::pair<int,int>> aux;
        for(int i2 = 0; i2 <= i; i2++)
          for(int j2 = 0; j2 <= j; j2++)
            for(int nxt = i2 * k; nxt <= 2 * nmax; nxt++)
              if((0 < i2 || 0 < j2) && j - j2 + nxt <= 2 * nmax) {
                aux.push_back({dp[i - i2][j - j2 + nxt]});
                /*
                if(i == 2 && j == 1 && i2 == 1)
                  std::cout << "add " << i - i2 << " " << j - j2 + nxt << " " << dp[i - i2][j - j2 + nxt].first << " " << dp[i - i2][j - j2 + nxt].second << '\n';
                */

              }
        dp[i][j] = mex(aux);
        
        /*
        if(i == 1 && j == 1) {
          for(int h = 0; h < aux.size(); h++)
            std::cout << aux[h].first << " " << aux[h].second << ": ";
          std::cout << '\n';
        }
        */

      }
     
      /*
      if(i <= sigma && j <= sigma)
        std::cout << dp[i][j].first << " " << dp[i][j].second << "| ";
      */

    }
    
    for(int j = nmax + 1; j <= nmax * 2; j++) {
      dp[i][j] = dp[i][j - 1];
      dp[i][j].second++;
    }

    if(i <= sigma) {
      std::cout << '\n';
    }

  }
  for(int i = 1;i <= q; i++) {
    if(solve() == 0)
      std::cout << "Loss\n";
    else
      std::cout << "Win\n";
  }
  return 0;
}
