#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <cmath>
#include <map>

using ll = long long;

int const nmax = 500000;
int v[5 + nmax], v2[5 + nmax], level[5 + nmax];

std::vector<std::pair<int,int>> g[5 + nmax];

std::map<int, int> mp[5 + nmax];

ll base[5 + nmax];

void dfs(int node) {
  for(int h = 0; h < g[node].size(); h++) {
    int to = g[node][h].first;
    level[to] = level[node] + g[node][h].second;
    dfs(to);
    if(mp[node].size() < mp[to].size()) {
      std::swap(mp[node], mp[to]);
      std::swap(base[node], base[to]);
    }
    base[node] += base[to];
    for(std::map<int, int>::iterator it = mp[to].begin(); it != mp[to].end(); it++)
      mp[node][it->first] += it->second;
    mp[to].clear();
  }

  mp[node][level[node]] += v2[node];
  std::vector<std::pair<ll,int>> aux;

  std::map<int,int>::iterator it = mp[node].end();
  int used = 0;
  if(it != mp[node].begin()) {
    it--;
    while(0 < v[node]) {
      if(0 < it->first - level[node]) {
        int coef = std::min(it->second, v[node]);
        base[node] += 1LL * coef * (it->first - level[node]);
        v[node] -= coef;
        it->second -= coef;
        used += coef;
        if(v[node] == 0)
          break;
      } else
        break;
      if(it == mp[node].begin())
        break;
      else {
        mp[node].erase(it--);
      }
    }
  }
  mp[node][level[node]] += used;
}

int main() {
  std::ios::sync_with_stdio(0);
  std::cin.tie(0);

  int n;
  std::cin >> n;
  for(int i = 1;i <= n; i++)
    std::cin >> v[i];
  for(int i = 1; i <= n; i++)
    std::cin >> v2[i];

  for(int i = 2; i <= n; i++) {
    int far, cost;
    std::cin >> far >> cost;
    g[far].push_back({i, cost});
  }
  dfs(1);
  std::cout << base[1] << '\n'; 
  return 0;
}
