#include <bits/stdc++.h>

using namespace std;

#define pb push_back

struct dot
{
    //int super = 0;
    vector <int> desc;
    bool act;
    int loc;
    int subtree;
}tree[200001];

int euler[200001];
int segtree[1000001];
int lazy[1000001];

int build(int left, int right, int segnode)
{
    if (left > right)
    {
        return 0;
    }
    if (left == right)
    {
        segtree[segnode] = euler[left];
        return segtree[segnode];
    }
    int mid = (left+right)/2;
    segtree[segnode] = build(left, mid, segnode*2) + build(mid+1, right, segnode*2+1);
    return segtree[segnode];
}

int update(int left, int right, int segnode, int lrange, int rrange)
{
    if (left > right)
    {
        return 0;
    }
    if (lazy[segnode] == 1)
    {
        segtree[segnode] = (right - left + 1);
        lazy[segnode] = 0;
        if (left < right)
        {
            lazy[segnode * 2] = 1;
            lazy[segnode * 2 + 1] = 1;
        }
    }
    if (right < lrange  or left > rrange)
    {
        return segtree[segnode];
    }
    if (left >= lrange and right <= rrange)
    {
        lazy[segnode] = 1;
        return (right - left + 1);
    }
    int mid = (left + right) / 2;
    segtree[segnode] = update (left, mid, segnode*2, lrange, rrange) + update (mid+1, right, segnode*2+1, lrange, rrange);
    return segtree[segnode];
}

int quest (int left, int right, int segnode, int lrange, int rrange)
{
    if (left > right)
    {
        return 0;
    }
    if (lazy[segnode] == 1)
    {
        segtree[segnode] = (right - left + 1);
        lazy[segnode] = 0;
        if (left < right)
        {
            lazy[segnode * 2] = 1;
            lazy[segnode * 2 + 1] = 1;
        }
    }
    if (right < lrange or left > rrange)
    {
        return 0;
    }
    if (left >= lrange and right <= rrange)
    {
        return segtree[segnode];
    }
    int mid = (left + right) / 2;
    int sum = 0;
    sum += quest (left, mid, segnode*2, lrange, rrange);
    sum += quest (mid+1, right, segnode*2+1, lrange, rrange);
    return sum;
}

int tim = 0;

int dfs (int node)
{
    tree[node].loc = tim;
    euler[tim] = tree[node].act;
    tim++;
    int subord = 1;
    for (auto next : tree[node].desc)
    {
        subord += dfs(next);
    }
    tree[node].subtree = subord;
    return subord;
}

void print ()
{
    for (int i=0; i<10; i++)
    {
        cout<<quest(0, 9, 1, i, i)<<" ";
    }
    cout<<"\n";
}

int main()
{
    int n;
    cin>>n;
    memset (lazy, 0 , sizeof (lazy));
    memset (euler, 0, sizeof(euler));
    for (int i=0; i<n-1; i++)
    {
        int a, b;
        cin>>a>>b;
        //tree[b].super = a;
        tree[a].desc.pb(b);
    }
    for (int i=1; i<=n; i++)
    {
        int a;
        cin>>a;
        tree[i].act = a;
    }
    dfs (1);
    build (0, n-1, 1);
   /* for (int i=0; i<n; i++)
    {
        cout<<euler[i]<<" ";
    }
    cout<<"\n";
    print();*/
    int q;
    cin>>q;
    for (int i=0; i<q; i++)
    {
        int type, node, k;
        cin>>type>>node>>k;
        if (type == 1)
        {
            int l = tree[node].loc;
            int r = tree[node].loc + tree[node].subtree - 1;
            update(0, n-1, 1, l, r);
            //print();
        }
        if (type == 2)
        {
            int l = tree[node].loc;
            int r = tree[node].loc + tree[node].subtree - 1;
            //cout<<"from "<<l<<" to "<<r<<"\n";
            //print();
            cout<<quest(0, n-1, 1, l, r)<<"\n";
        }
    }
}
