#include <iostream>
#include <vector>

using namespace std;

const int max_s = 1e4 + 1; 
int val;  
int b[max_s]; 
int rnk[max_s];  

void calc_rank(int root, vector<vector<int>> & adj){
    for (int c : adj[root]){
        rnk[c] = rnk[root] + 1; 
        calc_rank(c, adj); 
    }
}

void dfs(int root, vector<vector<int>> & adj, int bar, int m){
    if (rnk[root] > bar) return;
    for (int c : adj[root]){
        dfs(c, adj, bar, m); 
    }
    if (m == 1) b[root] = 1; 
    else val += b[root]; 
}

int main(){
    ios_base::sync_with_stdio(false); 
    cin.tie(0);
    int n; cin >> n; 
    vector<vector<int>> adj(n + 1, vector<int>()); 
    
    for (int i = 1; i < n; ++i){
        int x, y; cin >> x >> y; 
        adj[x].push_back(y); 
    }
    
    for (int i = 1; i <= n; ++i) cin >> b[i]; 
    
    calc_rank(1, adj); 

    int q; cin >> q;

    while (q--){
        int m, x, k; cin >> m >> x >> k; 
        dfs(x, adj, rnk[x] + k, m); 
        if (m == 2) cout << val << "\n"; 
        val = 0; 
    }
}
