#include <bits/stdc++.h>

using namespace std;

const int offset = (1 << 18);
int aint[2 * offset];
int lazy[2 * offset];

void push_lazy(int node, int l, int r) {
    if(lazy[node] == 1) {
        aint[node] = r - l + 1;

        if(offset > node) {
            lazy[2 * node] = 1;
            lazy[2 * node + 1] = 1;
        }

        lazy[node] = 0;
    }
}

void update(int node, int l, int r, int gl, int gr) {
    if(r < gl || gr < l) return;
    push_lazy(node, l, r);

    if(gl <= l && r <= gr) {
        lazy[node] = 1;
        push_lazy(node, l, r);
        return;
    }

    int mid = (l + r) / 2;
    update(2 * node, l, mid, gl, gr);
    update(2 * node + 1, mid + 1, r, gl, gr);

    aint[node] = aint[2 * node] + aint[2 * node + 1];
}

int query(int node, int l, int r, int gl, int gr) {
    if(r < gl || gr < l) return 0;
    push_lazy(node, l, r);

    if(gl <= l && r <= gr) {
        return aint[node];
    }

    int mid = (l + r) / 2;
    return query(2 * node, l, mid, gl, gr) + query(2 * node + 1, mid + 1, r, gl, gr);
}

const int NMAX = 2e5 + 7;
vector<int> sons[NMAX];

vector<int> preorder;
int inv_preorder[NMAX];
int subtree_size[NMAX];

void dfs(int node) {
    inv_preorder[node] = preorder.size();
    preorder.push_back(node);
    subtree_size[node] = 1;

    for(auto son : sons[node]) {
        dfs(son);
        subtree_size[node] += subtree_size[son];
    }
}

int main() {
    assert(offset > NMAX);

    int n; cin >> n;
    for(int i = 1; i < n; i++) {
        int x, y; cin >> x >> y;
        sons[x].push_back(y);
    }

    dfs(1);

    for(int i = 1; i <= n; i++) {
        char ch; cin >> ch;
        if(ch == '1') {
            update(1, 0, offset - 1, inv_preorder[i], inv_preorder[i]);
        }
    }

    int q; cin >> q;
    for(int i = 0; i < q; i++) {
        char t; cin >> t;
        if(t == '1') {
            int x, k; cin >> x >> k;
            assert(k == n);
            update(1, 0, offset - 1, inv_preorder[x], inv_preorder[x] + subtree_size[x] - 1);
        }
        else {
            int x, k; cin >> x >> k;
            assert(k == n);
            cout << query(1, 0, offset - 1, inv_preorder[x], inv_preorder[x] + subtree_size[x] - 1) << '\n';
        }
    }
}
