#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define int long long

const int NMAX = 5e5 + 6;

vector<int> preorder;
int inv_preorder[NMAX];
int subtree_size[NMAX];

vector<pair<int, int>> g[NMAX];
int path_cost[NMAX];

int cost_calc[NMAX];

void dfs(int node, int dad, int cost) {
    inv_preorder[node] = preorder.size();
    preorder.push_back(node);
    subtree_size[node] = 1;
    path_cost[node] = cost;

    for(auto vec : g[node]) {
        if(vec.first == dad) continue;

        dfs(vec.first, node, cost + vec.second);
        subtree_size[node] += subtree_size[vec.first];
    }

    return;
}

int n;
int s[NMAX], e[NMAX];

multiset<pair<int, pair<int, int>>> finishes[NMAX];
int occupied[NMAX];

void push_children(int node) {
#ifdef LOCAL
    cerr << "Pushing: " << node << endl;
#endif // LOCAL

    if(s[node] == 0) return;

    // TODO: Get max faster (probably aint)

    while(s[node] > 0) {
        int max_index = node;
        for(int i = inv_preorder[node]; i < inv_preorder[node] + subtree_size[node]; i++) {
            int cnt_node = preorder[i];
            if(cost_calc[cnt_node] - path_cost[node] > cost_calc[max_index] - path_cost[node]) {
                max_index = cnt_node;
            }
        }

#ifdef LOCAL
        cerr << "\tFound max_index: " << max_index << " with cost " << cost_calc[max_index] - path_cost[node] << endl;
#endif // LOCAL

        if(cost_calc[max_index] - path_cost[node] <= 0) {
            s[node] = 0;
        }
        else {
            // Push miners starting at s to max_index
            if(occupied[max_index] == e[max_index]) {
                auto cnt = *(finishes[max_index].begin());
#ifdef LOCAL
                assert(cnt.first < path_cost[max_index] - path_cost[node]);
#endif // LOCAL
                finishes[max_index].erase(cnt);

                if(cnt.second.first > s[node]) {
                    #ifdef LOCAL
                        cerr << "\t\tPushed A" << endl;
                    #endif // LOCAL
                    finishes[max_index].insert({cnt.first, {cnt.second.first - s[node], cnt.second.second}});
                    finishes[max_index].insert({path_cost[max_index] - path_cost[node], {s[node], node}});

                    s[cnt.second.second] += s[node];
                    push_children(cnt.second.second);

                    s[node] = 0;
                }
                else {
                    #ifdef LOCAL
                        cerr << "\t\tPushed B" << endl;
                    #endif // LOCAL
                    finishes[max_index].insert({path_cost[max_index] - path_cost[node], {cnt.second.first, node}});

                    s[cnt.second.second] += cnt.second.first;
                    push_children(cnt.second.second);

                    s[node] -= cnt.second.first;
                }
            }
            else {
                if(e[max_index] - occupied[max_index] >= s[node]) {
                    #ifdef LOCAL
                        cerr << "\t\tPushed C" << endl;
                    #endif // LOCAL
                    occupied[max_index] += s[node];
                    finishes[max_index].insert({path_cost[max_index] - path_cost[node], {s[node], node}});

                    s[node] = 0;
                }
                else {
                    #ifdef LOCAL
                        cerr << "\t\tPushed D" << endl;
                    #endif // LOCAL
                    finishes[max_index].insert({path_cost[max_index] - path_cost[node], {e[max_index] - occupied[max_index], node}});
                    s[node] -= (e[max_index] - occupied[max_index]);
                    occupied[max_index] = e[max_index];
                }
            }
        }


        cost_calc[max_index] = path_cost[max_index];
        if(occupied[max_index] == e[max_index])
            cost_calc[max_index] -= (*(finishes[max_index].begin())).first;
    }
}

bool cmp(int a, int b) {
    return subtree_size[a] < subtree_size[b];
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
#endif // LOCAL

    cin >> n;
    for(int i = 1; i <= n; i++) {
        cin >> s[i];
    }
    for(int i = 1; i <= n; i++) {
        cin >> e[i];
    }

    for(int i = 1; i <= n - 1; i++) {
        int p, w; cin >> p >> w;
        g[i + 1].push_back({p, w});
        g[p].push_back({i + 1, w});
    }

    dfs(1, 0, 0LL);
#ifdef LOCAL
    for(auto e : preorder)
        cerr << e << endl;
#endif // LOCAL

    for(int i = 0; i <= n; i++) {
        cost_calc[i] = path_cost[i];
        if(e[i] == 0)
            cost_calc[i] = -1e16;
    }

    vector<int> perm(n);
    for(int i = 0; i < n; i++)
        perm[i] = i + 1;
    sort(perm.begin(), perm.end(), cmp);
    random_shuffle(perm.begin(), perm.end());
    sort(perm.begin(), perm.end(), cmp);

    for(int i = 0; i < n; i++) {
        push_children(perm[i]);
        //push_children(i + 1);
    }

    int answer = 0;
    for(int i = 1; i <= n; i++) {
        for(auto e : finishes[i]) {
#ifdef LOCAL
            cerr << e.first << " " << e.second.first << " " << e.second.second << endl;
#endif // LOCAL

            answer += e.first * e.second.first;
        }
    }

    cout << answer << endl;
}
