#ifndef LOCAL
#pragma GCC optimize("Ofast")
#endif // LOCAL

#include <bits/stdc++.h>

using namespace std;

const int NMAX = 5e5 + 7;
const int offset = (1 << 19);

int s[NMAX], e[NMAX];
int occupied[NMAX];

vector<pair<int, int>> g[NMAX];
int depth[NMAX], st_size[NMAX];

vector<int> preorder;
int inv_pre[NMAX];

int path_cost[NMAX];
int cost_calc[NMAX];

map<pair<int, int>, int> finishes[NMAX];

void dfs(int node, int dpth, int cost) {
    path_cost[node] = cost;

    inv_pre[node] = preorder.size();
    preorder.push_back(node);

    depth[node] = dpth;

    st_size[node] = 1;
    for(auto son : g[node]) {
        dfs(son.first, dpth + 1, cost + son.second);
        st_size[node] += st_size[son.first];
    }

    return;
}

bool depth_cmp(int a, int b) {
    return depth[a] > depth[b];
}

int aint[2 * offset];

void update_aint(int pos) {
    aint[inv_pre[pos] + offset] = pos;
    pos = inv_pre[pos] + offset; pos /= 2;

    while(pos > 0) {
        if(cost_calc[aint[2 * pos]] > cost_calc[aint[2 * pos + 1]])
            aint[pos] = aint[2 * pos];
        else
            aint[pos] = aint[2 * pos + 1];

        pos /= 2;
    }

    return;
}

int query_aint(int node, int l, int r, int gl, int gr) {
    if(r < gl || gr < l) return 0;

    if(gl <= l && r <= gr) return aint[node];

    int mid = (l + r) / 2;
    int a = query_aint(2 * node, l, mid, gl, gr);
    int b = query_aint(2 * node + 1, mid + 1, r, gl, gr);

    if(a == 0) return b;
    if(b == 0) return a;

    if(cost_calc[a] > cost_calc[b]) return a;
    else return b;
}

int get_max_in(int l, int r) {
    return query_aint(1, 0, offset - 1, l, r);
}

int calc_cost(int node) {
    if(e[node] == 0) return -2e9 - 7;
    if(e[node] > occupied[node]) return path_cost[node];
    return path_cost[node] - (*(finishes[node].begin())).first.first;
}

void add_to_finishes(int max_index, int cost, int origin, int num) {
    finishes[max_index][make_pair(cost, origin)] += num;
}

void push_children(int node) {
    if(s[node] == 0) return;

    while(s[node] > 0) {
        /*
        int max_index = node;
        for(int i = inv_pre[node]; i < inv_pre[node] + st_size[node]; i++) {
            int cnt_node = preorder[i];
            if(cost_calc[cnt_node] > cost_calc[max_index])
                max_index = cnt_node;
        }
        assert(cost_calc[max_index] == cost_calc[get_max_in(inv_pre[node], inv_pre[node] + st_size[node] - 1)]);
        */

        int max_index = get_max_in(inv_pre[node], inv_pre[node] + st_size[node] - 1);

        if(cost_calc[max_index] <= path_cost[node]) {
            s[node] = 0;
        }
        else {
            if(occupied[max_index] == e[max_index]) {
                auto cnt = *(finishes[max_index].begin());
                finishes[max_index].erase(finishes[max_index].begin());

                if(cnt.second > s[node]) {
                    add_to_finishes(max_index, cnt.first.first, cnt.first.second, cnt.second - s[node]);
                    add_to_finishes(max_index, path_cost[max_index] - path_cost[node], node, s[node]);

                    s[cnt.first.second] += s[node];
                    s[node] = 0;

                    //push_children(cnt.first.second);
                }
                else {
                    add_to_finishes(max_index, path_cost[max_index] - path_cost[node], node, cnt.second);

                    s[node] -= cnt.second;
                    s[cnt.first.second] += cnt.second;

                    //push_children(cnt.first.second);
                }
            }
            else {
                if(e[max_index] - occupied[max_index] >= s[node]) {
                    occupied[max_index] += s[node];
                    add_to_finishes(max_index, path_cost[max_index] - path_cost[node], node, s[node]);

                    s[node] = 0;
                }
                else {
                    add_to_finishes(max_index, path_cost[max_index] - path_cost[node], node, e[max_index] - occupied[max_index]);
                    s[node] -= (e[max_index] - occupied[max_index]);
                    occupied[max_index] = e[max_index];
                }
            }
        }

        cost_calc[max_index] = calc_cost(max_index);
        update_aint(max_index);
    }
}

int main() {
#ifdef LOCAL
    assert(offset > NMAX);
#endif // LOCAL

    int n; cin >> n;
    for(int i = 1; i <= n; i++) cin >> s[i];
    for(int i = 1; i <= n; i++) cin >> e[i];

    for(int i = 1; i < n; i++) {
        int x, w; cin >> x >> w;
        g[x].push_back({i + 1, w});
    }

    dfs(1, 1, 0LL);

    vector<int> perm(n);
    iota(perm.begin(), perm.end(), 1);
    sort(perm.begin(), perm.end(), depth_cmp);

    for(int i = 1; i <= n; i++) {
        cost_calc[i] = calc_cost(i);
    }
    for(int i = 1; i <= n;i ++) {
        update_aint(i);
    }

    for(int i = 0; i < n; i++) {
        push_children(perm[i]);
    }

    int64_t ans = 0;
    for(int i = 1; i <= n; i++) {
        for(auto e : finishes[i]) {
            ans = 1LL * ans + 1LL * e.first.first * e.second;
        }
    }

    cout << ans << endl;
}
