#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

const int NMAX = 2e5 + 7;
int father[NMAX];
vector<int> sons[NMAX];

int knows[NMAX];
int subknows[NMAX];

void dfs(int node, int depth, int max_depth) {
    knows[node] = 1;
    if(depth == max_depth) return;

    for(auto son : sons[node])
        dfs(son, depth + 1, max_depth);
}

void update(int node, int depth) {
    dfs(node, 0, depth);
}

int dfs2(int node, int depth, int max_depth) {
    int ans = knows[node];
    if(depth == max_depth) return ans;

    for(auto son : sons[node])
        ans += dfs2(son, depth + 1, max_depth);

    return ans;
}

int query(int node, int depth) {
    return dfs2(node, 0, depth);
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
#endif // LOCAL

    int n; cin >> n;
    for(int i = 1; i < n; i++) {
        int x, y; cin >> x >> y;
        sons[x].push_back(y);
        father[y] = x;
    }

    for(int i = 1; i <= n; i++) {
        char ch; cin >> ch;
        if(ch == '1') {
            update(i, 0);
        }
    }

    int q; cin >> q;
    for(int i = 0; i < q; i++) {
        char t; cin >> t;
        if(t == '1') {
            int x, k; cin >> x >> k;
            update(x, k);
        }
        else {
            int x, k; cin >> x >> k;
            cout << query(x, k) << '\n';
        }
    }
}
