#include <bits/stdc++.h>

using namespace std;

const int NMAX = 2e5 + 7;
const int offset = (1 << 18);
vector<int> sons[NMAX];

int aint[2 * offset], lazy[2 * offset];

void push_lazy(int node, int l, int r) {
    if(lazy[node] == 1) {
        aint[node] = r - l + 1;

        if(node < offset) {
            lazy[2 * node] = 1;
            lazy[2 * node + 1] = 1;
        }
    }
}

void update(int node, int l, int r, int gl, int gr) {
    if(r < gl || gr < l) return;
    push_lazy(node, l, r);

    if(gl <= l && r <= gr) {
        lazy[node] = 1;
        push_lazy(node, l, r);
        return;
    }

    int mid = (l + r) / 2;
    update(2 * node, l, mid, gl, gr);
    update(2 * node + 1, mid + 1, r, gl, gr);
    aint[node] = aint[2 * node] + aint[2 * node + 1];

    return;
}

int query(int node, int l, int r, int gl, int gr) {
    if(r < gl || gr < l) return 0;
    push_lazy(node, l, r);

    if(gl <= l && r <= gr) {
        return aint[node];
    }

    int mid = (l + r) / 2;
    int a = query(2 * node, l, mid, gl, gr);
    int b = query(2 * node + 1, mid + 1, r, gl, gr);

    return a + b;
}

vector<int> preorder;
int st_size[NMAX];
int inv_pre[NMAX];

void dfs(int node, int dad) {
    inv_pre[node] = preorder.size();
    preorder.push_back(node);
    st_size[node] = 1;

    for(auto vec : sons[node]) {
        if(vec == dad) continue;

        dfs(vec, node);
        st_size[node] += st_size[vec];
    }

    return;
}

int main() {
    assert(offset > NMAX);

    int n; cin >> n;
    for(int i = 1; i < n; i++) {
        int x, y; cin >> x >> y;
        sons[x].push_back(y);
        sons[y].push_back(x);
    }

    dfs(1, 0);

    for(int i = 1; i <= n; i++) {
        int knows; cin >> knows;
        if(knows)
            update(1, 0, offset - 1, inv_pre[i], inv_pre[i]);
    }

    int q; cin >> q;
    for(int i = 0; i < q; i++) {
        int t; cin >> t;
        if(t == 1) {
            int x, k; cin >> x >> k;
            assert(k == n);
            update(1, 0, offset - 1, inv_pre[x], inv_pre[x] + st_size[x] - 1);
        }
        if(t == 2) {
            int x, k; cin >> x >> k;
            assert(k == n);
            cout << query(1, 0, offset - 1, inv_pre[x], inv_pre[x] + st_size[x] - 1) << '\n';
        }
    }
}
