#include <bits/stdc++.h>

using namespace std;

const int NMAX = 2e5 + 7;
const int offset = (1 << 18);
vector<int> sons[NMAX];

int aint[2 * offset], lazy[2 * offset];

void push_lazy(int node, int l, int r) {
    if(lazy[node] == 1) {
        aint[node] = r - l + 1;

        if(node < offset) {
            lazy[2 * node] = 1;
            lazy[2 * node + 1] = 1;
        }
    }
}

void update(int node, int l, int r, int gl, int gr) {
    push_lazy(node, l, r);
    if(r < gl || gr < l) return;

    if(gl <= l && r <= gr) {
        lazy[node] = 1;
        push_lazy(node, l, r);
        return;
    }

    int mid = (l + r) / 2;
    push_lazy(node, l, r);
    update(2 * node, l, mid, gl, gr);
    update(2 * node + 1, mid + 1, r, gl, gr);
    push_lazy(node, l, r);
    aint[node] = aint[2 * node] + aint[2 * node + 1];

    return;
}

int query(int node, int l, int r, int gl, int gr) {
    push_lazy(node, l, r);
    if(r < gl || gr < l) return 0;

    if(gl <= l && r <= gr) {
        push_lazy(node, l, r);
        return aint[node];
    }

    int mid = (l + r) / 2;
    int a = query(2 * node, l, mid, gl, gr);
    int b = query(2 * node + 1, mid + 1, r, gl, gr);
    push_lazy(node, l, r);

    return a + b;
}

vector<int> preorder;
int st_size[NMAX];
int inv_pre[NMAX];

int depth[NMAX];

void dfs(int node, int dad, int dpth) {
    inv_pre[node] = preorder.size();
    preorder.push_back(node);
    st_size[node] = 1;
    depth[node] = dpth;

    for(auto vec : sons[node]) {
        if(vec == dad) continue;

        dfs(vec, node, dpth + 1);
        st_size[node] += st_size[vec];
    }

    return;
}

bool cmp_depth(int a, int b) {
    return depth[a] < depth[b];
}

bool cmp_qs(pair<int, int> a, pair<int, int> b) {
    return depth[a.first] + a.second < depth[b.first] + b.second;
}

int knows[NMAX];

map<pair<int, int>, vector<int>> ind;
int anss[NMAX];

int main() {
    assert(offset > NMAX);

    int n; cin >> n;
    for(int i = 1; i < n; i++) {
        int x, y; cin >> x >> y;
        sons[x].push_back(y);
        sons[y].push_back(x);
    }

    dfs(1, 0, 1);

    for(int i = 1; i <= n; i++) {
        cin >> knows[i];
    }

    vector<int> nodes(n);
    iota(nodes.begin(), nodes.end(), 1);
    sort(nodes.begin(), nodes.end(), cmp_depth);

    int q; cin >> q;
    vector<pair<int, int>> queries;
    for(int i = 0; i < q; i++) {
        int t; cin >> t;
        assert(t == 2);
        int x, k; cin >> x >> k;
        k = min(k, n);
        queries.push_back({x, k});
        ind[{x, k}].push_back(i);
    }

    sort(queries.begin(), queries.end(), cmp_qs);

    int ptr_nodes = 0;
    int ptr_qs = 0;

    for(int cnt_depth = 0; cnt_depth < 2 * NMAX; cnt_depth++) {
        while(ptr_nodes < n && depth[nodes[ptr_nodes]] <= cnt_depth) {
            if(knows[nodes[ptr_nodes]])
                update(1, 0, offset - 1, inv_pre[nodes[ptr_nodes]], inv_pre[nodes[ptr_nodes]]);
            ptr_nodes++;
        }
        while(ptr_qs < q && depth[queries[ptr_qs].first] + queries[ptr_qs].second <= cnt_depth) {
            int x = queries[ptr_qs].first;
            int ans = query(1, 0, offset - 1, inv_pre[x], inv_pre[x] + st_size[x] - 1);
            anss[ind[queries[ptr_qs]].back()] = ans;
            ind[queries[ptr_qs]].pop_back();
            ptr_qs++;
        }
    }

    for(int i = 0; i < q; i++) {
        cout << anss[i] << '\n';
    }
}
