#include <iostream>

using namespace std;
const int NMAX = 200001, INF = 1e9;

int cap[NMAX], nrwrk[NMAX], s[NMAX], segTree[4 * NMAX];

inline int myabs(int a);
inline int mymin(int a, int b);
inline int rightSon(int node);
inline int leftSon(int node);
inline int query(int qlo, int qhi, int lo, int hi, int node);
inline void update(int lo, int hi, int pos, int val, int node);

int main()
{
    int n, i, c, p, cmax, maxpos, sub;
    cin >> n;
    for (i = 1; i <= n; i++)
        cin >> nrwrk[i];
    for (i = 1; i <= n; i++)
        cin >> cap[i];
    for (i = 2; i <= n; i++)
    {
        cin >> p >> c;
        s[i] = s[i - 1] + c;
        update(1, n, i, s[i], 1);
    }

    cmax = 0;
    for (i = n - 1 ; i > 0; i--)
    {
        maxpos = query(i + 1, n, 1, n, 1);
        if (s[maxpos] == -INF)
            break;
        if (s[maxpos] - s[i] > 0)
        {
            sub = mymin(nrwrk[i], cap[maxpos]);
            cmax += sub * (s[maxpos] - s[i]);
            nrwrk[i] -= sub;
            if (nrwrk[i] > 0)
                i++;
            cap[maxpos] -= sub;
            if (cap[maxpos] == 0)

                update(1, n, maxpos, -INF, 1);
        }
    }
    cout << cmax;

    return 0;
}

inline int mymin(int a, int b)
{
    if (a > b)
        return b;
    return a;
}
inline int myabs(int a)
{
    if (a < 0)
        return -a;
    return a;
}
inline int rightSon(int node)
{return (node << 1) + 1; }
inline int leftSon(int node)
{return node << 1; }
inline int query(int qlo, int qhi, int lo, int hi, int node)
{
    if (qlo > hi || qhi < lo)
        return -1;
    if (qlo <= lo && qhi >= hi)
        return segTree[node];


    int mid = (lo + hi) >> 1;
    int max1 = query(qlo, qhi, lo, mid, leftSon(node));
    int max2 = query(qlo, qhi, mid + 1, hi, rightSon(node));

    if (max1 == -1)
        return max2;
    if (max2 == -1)
        return max1;
    if (s[max1] > s[max2])
        return max1;
    return max2;
}
inline void update(int lo, int hi, int pos, int val, int node)
{
    if (lo == hi)
    {
        segTree[node] = pos;
        return;
    }

    int mid = (lo + hi) >> 1;
    if (pos <= mid)
        update(lo, mid, pos, val, leftSon(node));
    else
        update(mid + 1, hi, pos, val, rightSon(node));

    if (s[segTree[rightSon(node)]] > s[segTree[leftSon(node)]])
        segTree[node] = segTree[rightSon(node)];
    else
        segTree[node] = segTree[leftSon(node)];
}
