#include <iostream>
#include <fstream>
#include <algorithm>

using namespace std;
const long long NMAX = 200001, INF = 1e16;


long long cap[NMAX], nrwrk[NMAX], s[NMAX], segTree[4 * NMAX], best[NMAX], ordParc[NMAX];
inline bool cmp(int a, int b);
inline long long myabs(long long a);
inline long long mymin(long long a, long long b);
inline long long rightSon(long long node);
inline long long leftSon(long long node);
inline long long query(long long qlo, long long qhi, long long lo, long long hi, long long node);
inline void update(long long lo, long long hi, long long pos, long long val, long long node);

int main()
{
    long long n, i, j, c, p, cmax, maxpos, sub, ind;
    cin >> n;
    for (i = 1; i <= n; i++)
    {
        ordParc[i] = i;
        cin >> nrwrk[i];
    }
    for (i = 1; i <= n; i++)
        cin >> cap[i];
    for (i = 2; i <= n; i++)
    {
        cin >> p >> c;
        s[i] = s[i - 1] + c;
        update(1, n, i, s[i], 1);
    }
    sort(ordParc + 1, ordParc + n + 1, cmp);

    cmax = 0;
    for (i = 1 ; i <= n; i++)
    {
        ind = ordParc[i];
        maxpos = query(ind + 1, n, 1, n, 1);
        if (s[maxpos] <= -INF)
        {
            i++;
            continue;
        }
        if (s[maxpos] - s[ind] > 0)
        {
            sub = mymin(nrwrk[i], cap[maxpos]);
            cmax += sub * (s[maxpos] - s[ind]);
            nrwrk[ind] -= sub;
            if (nrwrk[ind] > 0)
                i--;
            cap[maxpos] -= sub;
            if (cap[maxpos] == 0)
                update(1, n, maxpos, -INF, 1);
        }
    }
    cout << cmax;

    return 0;
}
inline bool cmp(int a, int b)
{
    return s[a] < s[b];
}
inline long long mymin(long long a, long long b)
{
    if (a > b)
        return b;
    return a;
}
inline long long myabs(long long a)
{
    if (a < 0)
        return -a;
    return a;
}
inline long long rightSon(long long node)
{return (node << 1) + 1; }
inline long long leftSon(long long node)
{return node << 1; }
inline long long query(long long qlo, long long qhi, long long lo, long long hi, long long node)
{
    if (qlo > hi || qhi < lo)
        return -1;
    if (qlo <= lo && qhi >= hi)
        return segTree[node];
    long long mid = (lo + hi) >> 1;
    long long max1 = query(qlo, qhi, lo, mid, leftSon(node));
    long long max2 = query(qlo, qhi, mid + 1, hi, rightSon(node));

    if (max1 == -1)
        return max2;
    if (max2 == -1)
        return max1;
    if (s[max1] > s[max2])
        return max1;
    return max2;
}
inline void update(long long lo, long long hi, long long pos, long long val, long long node)
{
    if (lo == hi)
    {
        segTree[node] = pos;
        s[pos] = val;
        return;
    }

    long long mid = (lo + hi) >> 1;
    if (pos <= mid)
        update(lo, mid, pos, val, leftSon(node));
    else
        update(mid + 1, hi, pos, val, rightSon(node));

    if (s[segTree[rightSon(node)]] > s[segTree[leftSon(node)]])
        segTree[node] = segTree[rightSon(node)];
    else
        segTree[node] = segTree[leftSon(node)];
}
