#include <iostream>
#include <fstream>
#include <vector>

using namespace std;
const int NMAX = 300000, NLOG = 19;

//ifstream fin("f.in");
//ofstream fout("f.out");

int depth[NMAX];
int boss[NMAX], cleared[NMAX];

int knows[NMAX], father[NMAX], nrsons[NMAX];
vector<int> neighs[NMAX];


//int UF_find(int e);
void dfs(int node);
//void UF_union(int e1, int e2);
void upd(int node, int k, int curr);
int getKn(int node, int k, int curr);
int setFather(int node, int fth);



int main()
{
    int n, i, type, x, k, v1, v2, q;
    cin >> n;
    for (i = 0; i < n - 1; i++)
    {
        cin >> v1 >> v2;
        v1--, v2--;
        neighs[v1].push_back(v2);
        neighs[v2].push_back(v1);
    }
    setFather(0, 0);
    for (i = 0; i < n; i++)
    {
        cin >> knows[i];
        cleared[i] = 0;
    }
    cin >> q;
    if (n <= 10000 && q <= 10000)
    {
        for (i = 0; i < q; i++)
        {
            cin >> type >> x >> k;
            if (type == 1)
                upd(x - 1, k, 0);
            else
                cout << getKn(x - 1, k, 0) << '\n';
        }
    }
    else
    {
        for (i = 0; i < q; i++)
        {
            cin >> type >> x >> k;
            x--;
            if (type == 1)
            {
                dfs(x);
            }
            else
            {
                if (cleared[x])
                    cout << nrsons[x];
                else
                    cout << getKn(x, k, 0);
            }
        }
    }
    return 0;
}

void dfs(int node)
{
    int i, len = neighs[node].size();
    cleared[node] = 1;
    for (i = 0; i < len; i++)
    {
        int nextn = neighs[node][i];
        if (nextn != father[node] && !cleared[nextn])
            dfs(nextn);
    }
}
/*int UF_find(int e)
{
    if (boss[e] == e)
        return e;
    return UF_find(boss[e]);
}
void UF_union(int e1, int e2)
{
    int boss1 = UF_find(e1);
    int boss2 = UF_find(e2);

    boss[boss1] = boss2;
    cleared[boss2] |= 1;
}*/


int setFather(int node, int fth)
{
    father[node] = fth;
    nrsons[node] = 1;
    int i, len = neighs[node].size();
    for (i = 0; i < len; i++)
        if (neighs[node][i] != fth)
            nrsons[node] += setFather(neighs[node][i], node);
    return nrsons[node];
}
int getKn(int node, int k, int curr)
{
    if (curr > k)
        return 0;
    if (cleared[node])
        return nrsons[node];

    int i, len = neighs[node].size(), add = 0;
    if (knows[node] == 1)
        add = 1;
    for (i = 0; i < len; i++)
        if (neighs[node][i] != father[node])
            add += getKn(neighs[node][i], k, curr + 1);
    return add;
}
void upd(int node, int k, int curr)
{
    knows[node] = 1;
    if (curr >= k)
        return;
    int i, len = neighs[node].size();
    for (i = 0; i < len; i++)
        if (neighs[node][i] != father[node])
            upd(neighs[node][i], k, curr + 1);
}

