#include <bits/stdc++.h>

using namespace std;
#define int long long
int n;
const int maxn = 5e5;
int s[maxn];
int e[maxn];
vector<pair<int, int>> g[maxn];
int ans = 0;

struct node {
    int x, y;
    int kol;
    int unic_id;
    int sz;
    int sum;
    int add;
    node *R;
    node *L;
    int sum_x_kol;

    node(int xx, int kkol, int id) {
        unic_id = id;
        x = xx;
        kol = kkol;
        sz = 1;
        sum = x;
        add = 0;
        sum_x_kol = x * kol;
        y = rand();
        R = nullptr;
        L = nullptr;
    }
};

int getsz(node *v) {
    if (v == nullptr)return 0;
    return v->sz;
}

int getsum(node *v) {
    if (v == nullptr)return 0;
    return v->sum;
}

int getsum_x_kol(node *v) {
    if (v == nullptr)return 0;
    return v->sum_x_kol;
}

void recalc(node *v) {
    v->sz = getsz(v->L) + getsz(v->R) + 1;
    v->sum = getsum(v->L) + getsum(v->R) + v->kol;
    v->sum_x_kol = getsum_x_kol(v->L) + getsum_x_kol(v->R) + v->kol * v->x;
    if (v->L != nullptr) {
        v->L->x += v->add;
        v->L->add += v->add;
        v->L->sum_x_kol += v->add * (v->L->sum);
//        v->L->sum += (v->add) * v->L->sz;
    }
    if (v->R != nullptr) {
        v->R->x += v->add;
        v->R->add += v->add;
        v->R->sum_x_kol += v->add * (v->R->sum);
//        v->L->sum += (v->add) * v->R->sz;
    }
    v->add = 0;
}

pair<node *, node *> split(node *v, pair<int, int> key) {
    if (v == nullptr)return {nullptr, nullptr};
    recalc(v);
    if (make_pair(v->x, v->unic_id) <= key) {
        auto tmp = split(v->R, key);
        v->R = tmp.first;
        recalc(v);
        return {v, tmp.second};
    } else {
        auto tmp = split(v->L, key);
        v->L = tmp.second;
        recalc(v);
        return {tmp.first, v};
    }
}

node *merge(node *L, node *R) {
    if (L == nullptr)return R;
    if (R == nullptr)return L;
    recalc(L);
    recalc(R);
    if (L->y < R->y) {
        auto tmp = merge(L->R, R);
        L->R = tmp;
        recalc(L);
        return L;
    } else {
        auto tmp = merge(L, R->L);
        R->L = tmp;
        recalc(R);
        return R;
    }
}

node *merge_2dec(node *L, node *R) {
    if (L == nullptr)return R;
    if (R == nullptr)return L;
    recalc(L);
    recalc(R);
    if (L->y < R->y) {
        auto pp = split(R, {L->x, L->unic_id});
        L->R = merge_2dec(L->R, pp.second);
        L->L = merge_2dec(L->L, pp.first);
        recalc(L);
        return L;
    } else {
        auto pp = split(L, {R->x, R->unic_id});
        R->R = merge_2dec(R->R, pp.second);
        R->L = merge_2dec(R->L, pp.first);
        recalc(R);
        return R;
    }
}

node *find_last(node *root, int sum) {
    node *v = root;
    while (v != nullptr) {
        recalc(v);
        if (getsum(v->R) > sum) {
            v = v->R;
        } else if (v->kol + getsum(v->R) > sum) {
            return v;
        } else {
            sum -= v->kol + getsum(v->R);
            v = v->L;
        }
    }
    return v;
}

int cntok = 0;

node *rehearse(node *root, int sum) {
    cntok = 0;
    auto bad_good = split(root, {0, 1e18});
    node *y = find_last(bad_good.second, sum);
    if (y == nullptr) {
        ans += getsum_x_kol(bad_good.second);
        cntok += getsum(bad_good.second);
        return bad_good.first;
    }
    auto tmp = split(bad_good.second, {y->x, y->unic_id});
    auto tmp2 = split(tmp.first, {y->x, y->unic_id - 1});
    ans += getsum_x_kol(tmp.second);
    cntok += getsum(tmp.second);
    sum -= getsum(tmp.second);
    ans += sum * tmp2.second->x;
    cntok += sum;
    tmp2.second->kol -= sum;
    tmp2.second->sum_x_kol = tmp2.second->x * tmp2.second->kol;
    return merge(bad_good.first, merge(tmp2.first, tmp2.second));
}

node *add_ver(node *root, node *v) {
    auto tmp = split(root, {v->x, v->unic_id});
    return merge(merge(tmp.first, v), tmp.second);
}
//
//node *pls(node *root, node *root2) {
//    if (root2 == nullptr)return root;
//    recalc(root);
//    recalc(root2);
//    root = add_ver(root, new node(root2->x, root2->kol, root2->unic_id));
//    root = pls(root, root2->L);
//    root = pls(root, root2->R);
//    return root;
//}

node *dfs(int v, int p) {
    node *all = nullptr;
    vector<node *> de;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i].first;
        int w = g[v][i].second;
        if (to == p)continue;
        auto tmp = dfs(to, v);
        if (tmp != nullptr) {
            tmp->add += w;
            tmp->x += w;
            tmp->sum_x_kol += w * tmp->sum;
        }
        de.push_back(tmp);
    }
    if (de.size() != 0) {
        int mx = 0;
        for (int i = 1; i < de.size(); ++i) {
            if (getsz(de[mx]) < getsz(de[i])) {
                mx = i;
            }
        }
        all = de[mx];
        for (int j = 0; j < de.size(); ++j) {
            if (j == mx)continue;
            all = merge_2dec(all, de[j]);
        }
    }
    all = rehearse(all, s[v]);
    all = add_ver(all, new node(0, cntok + e[v], v));
    return all;
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int j = 0; j < n; ++j) {
        cin >> e[j];
    }
    for (int k = 0; k < n - 1; ++k) {
        int o;
        cin >> o;
        o--;
        int w;
        cin >> w;
        g[o].push_back({k + 1, w});
    }
    dfs(0, -1);
    cout << ans;
}