#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("avx, avx2")

#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back

const int inf = 1e18;

mt19937_64 rnd(time(0));

const int maxn = 5e5 + 50;
int a[maxn], b[maxn];
vector<pii> r[maxn];

struct node {
	node *l, *r;
	int s;
	pii x;
	pii mn;
	int y = 0;
	node(pii val) {
		s = 1;
		x = mn = val;
		l = 0, r = 0;
		y = rnd();
	}
};

void upd(node *v) {
	if (!v)
		return;
	v->s = 1 + (v->l ? v->l->s : 0) + (v->r ? v->r->s : 0);
	if (v->l)
		v->mn = v->l->mn;
	else
		v->mn = v->x;
}

pair<node*, node*> split(node *v, pii val) {
	if (!v)
		return {0, 0};
	if (v->x <= val) {
		auto p = split(v->r, val);
		v->r = p.f;
		upd(v);
		return {v, p.s};
	} else {
		auto p = split(v->l, val);
		v->l = p.s;
		upd(v);
		return {p.f, v};
	}
} 
node* merge(node *a, node *b) {
	if (!a)
		return b;
	if (!b)
		return a;
	if (a->y > b->y) {
		a->r = merge(a->r, b);
		upd(a);
		return a;
	} else {
		b->l = merge(a, b->l);
		upd(b);
		return b;
	}
}

node* insert(node *v, node *x) {
	// auto p = split(v, x->x);
	// return merge(p.f, merge(x, p.s));
	if (!v)
		return x;
	if (v->x.f == x->x.f) {
		v->x.s += x->x.s;
		upd(v);
		return v;
	} else {
		if (v->y > x->y) {
			if (v->x < x->x)
				v->r = insert(v->r, x);
			else
				v->l = insert(v->l, x);
			upd(v);
			return v;
		} else {
			auto p = split(v, x->x);
			x->l = p.f;
			x->r = p.s;
			upd(x);
			return x;
		}
	}
}

node* erase(node *v, pii x) {
	// auto p = split(v, x);
	// auto p2 = split(p.f, {x.f, x.s - 1});
	// return merge(p2.f, p.s);
	if (!v)
		return 0;
	if (v->x == x) {
		return merge(v->l, v->r);
	} else {
		if (v->x < x) {
			v->r = erase(v->r, x);
			upd(v);
			return v;
		} else {
			v->l = erase(v->l, x);
			upd(v);
			return v;
		}
	}
}

node* kek(node *a, node *b) {
	if (!a)
		return b;
	if (!b)
		return a;
	a = kek(a, b->l);
	a = kek(a, b->r);
	b->l = b->r = 0;
	upd(b);
	a = insert(a, b);
	return a;
}

ll ans = 0;
int n;

int d[maxn];

node* dfs2(int v, int p = -1) {
	node* now = 0;
	for (auto &[u, w] : r[v]) {
		if (u != p) {
			d[u] = d[v] + w;
			auto x = dfs2(u, v);
			if ((now == 0 ? 0 : now->s) < (x == 0 ? 0: x->s))
				swap(x, now);
			now = kek(now, x);
		}
	}
	int sum = 0;
	while (a[v] > 0 && now && now->s) {
		pii b = now->mn;
		if (-d[v] <= b.f)
			break;
		now = erase(now, b);
		int take = min(b.s, a[v]);
		sum += take;
		a[v] -= take;
		ans += (-d[v] - b.f) * 1LL * take;
		if (b.s > take) {
			node *_v = new node({b.f, b.s - take});
			now = insert(now, _v);
		}
	}
	if (sum + b[v] > 0) {
		node *_v = new node({-d[v], sum + b[v]});
		now = insert(now, _v);
	}
	return now;
}

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
	}
	
	for (int i = 1; i < n; ++i) {
		int x, w;
		cin >> x >> w;
		x--;
		r[x].pb({i, w});
	}
	dfs2(0);
	cout << ans << endl;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	solve();
}