#include <bits/stdc++.h>

typedef long long ll;

#define MS(x,y) memset((x), (y), sizeof((x)))
#define pb push_back
#define MN 1000000007

using namespace std;

int n;
vector<int> pat[100001];
int niza[100001];
vector<int> treeTrav;
int golem[100001];
int tree[400001];
int lazy[400001];
int realIdx[100001];

int constructTreeTraversal (int pos) {
    if (golem[pos] != -1) return golem[pos];

    treeTrav.pb(pos);

    int ret = 1;

    for (auto it:pat[pos]) ret += constructTreeTraversal(it);

    return golem[pos] = ret;
}

void update(int interval_idx, int interval_left, int interval_right, int left, int right, int val) {
    if (lazy[interval_idx] != -1) {
        if (interval_left != interval_right) {
            lazy[2*interval_idx] = lazy[interval_idx];
            lazy[2*interval_idx+1] = lazy[interval_idx];
        }

        tree[interval_idx] = lazy[interval_idx]*(interval_right-interval_left+1);
        lazy[interval_idx] = -1;
    }

    if (interval_left > interval_right || interval_left > right || interval_right < left) return;

    if (interval_left >= left && interval_right <= right) {
        if (interval_left != interval_right) {
            lazy[2*interval_idx] = val;
            lazy[2*interval_idx+1] = val;
        }

        tree[interval_idx] = val*(interval_right-interval_left+1);

        return;
    }

    int mid = (interval_left+interval_right)/2;
    update(2*interval_idx,interval_left,mid,left,right,val);
    update(2*interval_idx+1,mid+1,interval_right,left,right,val);

    tree[interval_idx] = tree[2*interval_idx] + tree[2*interval_idx+1];
}

int query(int interval_idx, int interval_left, int interval_right, int left, int right) {
    if (interval_left > interval_right || interval_left > right || interval_right < left) return 0;

    if (lazy[interval_idx] != -1) {
        if (interval_left != interval_right) {
            lazy[2*interval_idx] = lazy[interval_idx];
            lazy[2*interval_idx+1] = lazy[interval_idx];
        }

        tree[interval_idx] = lazy[interval_idx]*(interval_right-interval_left+1);
        lazy[interval_idx] = -1;
    }

    if (interval_left >= left && interval_right <= right) return tree[interval_idx];

    int mid = (interval_left+interval_right)/2;
    return query(2*interval_idx,interval_left,mid,left,right)+query(2*interval_idx+1,mid+1,interval_right,left,right);
}

int main() {
    #ifdef LOCAL_DEBUG
        fstream cin("in.txt");
    #endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    MS(golem,-1);
    MS(lazy,-1);

    cin>>n;

    for (int i = 0; i<n-1; i++) {
        int a,b;
        cin>>a>>b;

        a--; b--;

        pat[a].pb(b);
    }

    for (int i = 0; i<n; i++) if (golem[i] == -1) constructTreeTraversal(i);
    int root = -1;
    for (int i = 0; i<n; i++) if (golem[i] == n) root = i;
    MS(golem,-1);
    treeTrav.erase(treeTrav.begin(), treeTrav.end());
    constructTreeTraversal(root);
    for (int i = 0; i<n; i++) realIdx[treeTrav[i]] = i;

    for (int i = 0; i<n; i++) {
        int a;
        cin>>a;
        update(1,0,n-1,realIdx[i],realIdx[i],a);
    }

    int q;
    cin>>q;

    for (int i = 0; i<q; i++) {
        int type,x,k;
        cin>>type>>x>>k;

        x--;

        int x2 = realIdx[x];

        if (type == 1) update(1,0,n-1,x2,x2+golem[x]-1,1);
        else cout<<query(1,0,n-1,x2,x2+golem[x]-1)<<endl;
    }
}
