﻿// news.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vp;
typedef vector<vp> vvp;

int glob_cnt = 0;

struct seg {
    int l, r, mid;
    seg* rp, * lp;
    int val = 0;
    int prop = 0;
    int flag = 0;

    seg(int l, int r) : l(l), r(r), mid((l + r) / 2) {
        if (l != r - 1) {
            lp = new seg(0, mid);
            rp = new seg(mid, r);
        }
    }

    void set(int x) {
        flag = 1; prop = x; val = x;
    }

    void push() {
        if (flag) {
            lp->set(prop);
            rp->set(prop);
            flag = 0;
        }
    }

    void pull() {
        val = lp->val + rp->val;
    }

    void update(int a, int b, int x) {
        if (a >= r || b <= l) return;
        if (a == l && b == r) {
            set(x);
            return;
        }
        push();
        lp->update(a, b, x);
        rp->update(a, b, x);
        pull();
    }

    int query(int a, int b) {
        if (a >= r || b <= l) return 0;
        if (a <= l && b >= r) {
            return val;
        }
        push();
        return lp->query(a, b) + rp->query(a, b);
    }

};

void dfs(int v, vvi& adj, vi& visited, vi& ord, vi& sum, vi& lev) {
    visited[v] = 1;
    ord[v] = glob_cnt++;
    for (auto u : adj[v]) {
        if (visited[u]) {
            lev[v] = lev[u] + 1; continue;
        }
        dfs(u, adj, visited, ord, sum, lev);
        sum[v] += sum[u];
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n; cin >> n;
    vvi adj(n + 1);
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        adj[v].push_back(u);
        adj[u].push_back(v);
    }
    vi ord(n+1);
    vi visited(n + 1);
    vi sum(n + 1, 1);
    vi lev(n + 1, 0);
    dfs(1, adj, visited, ord, sum, lev);
    seg sg(0, n);
    for (int i = 1; i <= n; i++) {
        int cur;
        cin >> cur;
        if (cur) {
            sg.update(ord[i], ord[i] + 1, 1);
        }
    }
    int q; cin >> q;
    for (int i = 0; i < q; i++) {
        int s, x, k; cin >> s >> x >> k;
        if (s == 1) {
            sg.update(ord[x], ord[x] + sum[x], 1);
        }
        else {
            cout << sg.query(ord[x], ord[x] + sum[x]);
        }
    }
}

