﻿// news.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<pii, int> piii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vp;
typedef vector<vp> vvp;


struct seg {
    int l, r, mid;
    seg* rp, * lp;
    int val = 0;
    int prop = 0;
    int flag = 0;

    seg(int l, int r) : l(l), r(r), mid((l + r) / 2) {
        if (l != r - 1) {
            lp = new seg(0, mid);
            rp = new seg(mid, r);
        }
    }

    void set(int x) {
        flag = 1; prop = x; val = x;
    }

    void push() {
        if (flag) {
            lp->set(prop);
            rp->set(prop);
            flag = 0;
        }
    }

    void pull() {
        val = lp->val + rp->val;
    }

    void update(int a, int b, int x) {
        if (a >= r || b <= l) return;
        if (a == l && b == r) {
            set(x);
            return;
        }
        push();
        lp->update(a, b, x);
        rp->update(a, b, x);
        pull();
    }

    int query(int a, int b) {
        if (a >= r || b <= l) return 0;
        if (a <= l && b >= r) {
            return val;
        }
        push();
        return lp->query(a, b) + rp->query(a, b);
    }

};

void dfs1(int v, vvi& adj, vi& visited, vi& lev, vi& parent) {
    visited[v] = 1;
    for (auto u : adj[v]) {
        if (visited[u]) {
            lev[v] = lev[u] + 1; 
            parent[v] = u;
            continue;
        }
        dfs1(u, adj, visited, lev, parent);
   }
}

void dfs_quer(int v, vvi& adj, vi& visited, vi& know, int level, vi& lev, int* cnt, vi& parent) {
    visited[v] = 1;
    if (know[v])
        (*cnt)++;
    for (auto u : adj[v]) {
        if (parent[v] == u || visited[u] || lev[u] > level) {
            continue;
        }
        dfs_quer(u, adj, visited, know, level, lev, cnt, parent);
    }
}

void dfs_up(int v, vvi& adj, vi& visited, vi& know, int level, vi& lev, vi& parent) {
    visited[v] = 1;
    know[v] = 1;
    for (auto u : adj[v]) {
        if (parent[v] == u || visited[u] || lev[u]>level) {
            continue;
        }
        dfs_up(u, adj, visited, know, level, lev, parent);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n; cin >> n;
    vvi adj(n + 1);
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        adj[v].push_back(u);
        adj[u].push_back(v);
    }
    vi lev(n + 1, 0);
    vi visitedb(n + 1);
    vi parent(n + 1, -1);
    dfs1(1, adj, visitedb, lev, parent);
    /*vi ord(n+1);
    vi visited(n + 1);
    vvi sum(n + 1, vi(k, 1));
    vi lev(n + 1, 0);
    dfs(1, adj, visited, ord, sum, lev);
    seg sg(0, n);
    vector<piii> quer;
    for (int i = 1; i <= n; i++) {
        int cur;
        cin >> cur;
        if (cur) {
            quer.push_back({ {lev[i], 0}, i });
            //sg.update(ord[i], ord[i] + 1, 1);
        }
    }
    int q; cin >> q;
    for (int i = 0; i < q; i++) {
        int s, x, k; cin >> s >> x >> k;
        int l = lev[x] + k;
        if (l >= max_lev)
            l = max_lev;
        if (s == 1) {
            quer.push_back({ {l, 1}, x });
            //sg.update(ord[x], ord[x] + sum[x], 1);
        }
        else {
            quer.push_back({ {l, 2}, x });
            //cout << sg.query(ord[x], ord[x] + sum[x]);
        }
    }
    sort(quer.begin(), quer.end());
    for (auto iii : quer) {
        int x = iii.second, s = iii.first.second;
        if (s == 0) {
            sg.update(ord[x], ord[x] + 1, 1);
        }
        else if (s == 1) {
            sg.update(ord[x], ord[x] + sum[x], 1);
        }
        else {
            cout << sg.query(ord[x], ord[x] + sum[x]) << endl;
        }
    }*/
    vi know(n + 1, 0);
    for (int i = 1; i <= n; i++) 
        cin >> know[i];
    int q; cin >> q;
    vi visited(n + 1);
    for (int i = 0; i < q; i++) {
        int s, x, k; cin >> s >> x >> k;
        for (int j = 0; j <= n; j++) 
            visited[j] = 0;
        if (s == 1) {
            dfs_up(x, adj, visited, know, lev[x] + k, lev, parent);
        }
        else {
            int cnt = 0;
            dfs_quer(x, adj, visited, know, lev[x] + k, lev, &cnt, parent);
            cout << cnt << endl;
        }
    }
    return 0;
}

