#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const int N = 200000;

vector <int> graf[N+5];

int tjm;
int por[N+5];
vector <int> vec[N+5];
int depth[N+5];
//bool niz[N+5];
int in[N+5], out[N+5];
int niz[N+5];

bool dis_niz[N+5];
bool is_enabled[N+5];

struct Disabled{
    int val[4*N+5];
    void init(int node, int l, int r){
        if(l == r){
            if(!is_enabled[niz[l]]) val[node] = l;
            return;
        }
        int mid = (l+r)/2;
        init(node*2, l, mid);
        init(node*2+1, mid+1, r);
        if(depth[val[node*2]] <= depth[val[node*2+1]]) val[node] = val[node*2];
        else val[node] = val[node*2+1];
    }
    int query(int node, int l, int r, int tl, int tr){
        if(tl > r || l > tr) return 0;
        if(tl <= l && r <= tr) return val[node];
        int mid = (l+r)/2;
        int x = query(node*2, l, mid, tl, tr), y = query(node*2+1, mid+1, r, tl, tr);
        if(depth[x] <= depth[y]) return x;
        return y;
    }
    void brisi(int node, int l, int r, int x){
        if(l == r){
            val[node] = 0;
            return;
        }
        int mid = (l+r)/2;
        if(x <= mid) brisi(node*2, l, mid, x);
        else brisi(node*2+1, mid+1, r, x);
        if(depth[val[node*2]] <= depth[val[node*2+1]]) val[node] = val[node*2];
        else val[node] = val[node*2+1];
    }
} disabled;

void dfs(int v, int p){
    depth[v] = depth[p] + 1;
    in[v] = ++tjm;
    niz[tjm] = v;
    vec[depth[v]].push_back(v);
    for(auto c : graf[v]) dfs(c, v);
    out[v] = tjm;
}

bool is_parent(int a, int b){
    return (a == 0) || (in[a] <= in[b] && out[b] <= out[a]);
}

const int C = 10000000;

int idxx = 1;

struct dSeg{
    int L[C], R[C], val[C], L_lin[C], R_lin[C];
    void upd_lin(int node, int l, int r, int x){
        ///cout << "linearni update na " << l << " " << r << endl;
        val[node]++;
        if(l == r) return;
        int mid = (l+r)/2;
        if(x <= mid){
            if(!L_lin[node]) L_lin[node] = ++idxx;
            upd_lin(L_lin[node], l, mid, x);
        }
        else{
            if(!R_lin[node]) R_lin[node] = ++idxx;
            upd_lin(R_lin[node], mid+1, r, x);
        }
        ///cout << node << " updd " << L_lin[node] << " " << R_lin[node] << " " << idxx << endl;
    }
    void upd(int node, int l1, int r1, int l2, int r2, int x1, int x2){
        ///cout << "treba upd na " << l1 << " " << r1 << " " << l2 << " " << r2 << endl;
        upd_lin(node, l2, r2, x2);
        if(l1 == r1) return;
        int mid = (l1 + r1)/2;
        if(x1 <= mid){
            if(!L[node]) L[node] = ++idxx;
            upd(L[node], l1, mid, l2, r2, x1, x2);
        }
        else{
            if(!R[node]) R[node] = ++idxx;
            upd(R[node], mid+1, r1, l2, r2, x1, x2);
        }
    }
    int query_lin(int node, int l, int r, int tl, int tr){
        if(tl > r || l > tr) return 0;
        ///cout << "line " << node << endl;
        if(tl <= l && r <= tr){
            ///cout << "Linearan kveri na " << l << " " << r << endl;
           /// cout << "Ovde je " << node << " " << val[node] << endl;
            return val[node];
        }
        int mid = (l+r)/2;
        int res = 0;
        ///cout << node << " iz " << L_lin[node] << " " << R_lin[node] << endl;
        if(L_lin[node]) res += query_lin(L_lin[node], l, mid, tl, tr);
        if(R_lin[node]) res += query_lin(R_lin[node], mid+1, r, tl, tr);
        return res;
    }
    int query(int node, int l1, int r1, int l2, int r2, int tl1, int td1, int tl2, int td2){
        if(l1 > td1 || tl1 > r1 || l2 > td2 || tl2 > r2) return 0;
        //cout << "Obican kveri na "
         if(tl1 <= l1 && r1 <= td1){
            ///cout << " Obican kveri na " << l1 << " " << r1 << endl;
            return query_lin(node, l2, r2, tl2, td2);
        }
        int mid = (l1 + r1)/2;
        int res = 0;
        if(L[node]) res += query(L[node], l1, mid, l2, r2, tl1, td1, tl2, td2);
        if(R[node]) res += query(R[node], mid+1, r1, l2, r2, tl1, td1, tl2, td2);
        return res;
    }
} seg;

int main(){
    ios_base::sync_with_stdio(false), cin.tie(0);

    int n, qrs;
    cin >> n;
    for(int i=1; i<n; i++){
        int a, b;
        cin >> a >> b;
        graf[a].push_back(b);
    }
    dfs(1, 0);
    tjm = 0;
    for(int i=1; i<=n; i++){
        cin >> is_enabled[i];
        if(is_enabled[i]) seg.upd(1, 1, n, 1, n, in[i], depth[i]);
    }
    depth[0] = 1000000000;
    disabled.init(1, 1, n);
    cin >> qrs;
    while(qrs--){
        int typ, v, d;
        cin >> typ >> v >> d;
        d += depth[v];
        if(typ == 1){
            for(;;){
                int x = disabled.query(1, 1, n, in[v], out[v]);
                if(depth[x] > d) break;
                disabled.brisi(1, 1, n, x);
                //cout << "enablujem " << x << endl;
                /// dodaj x u enabled
                seg.upd(1, 1, n, 1, n, in[x], depth[x]);
            }
        }
        else{
            cout << seg.query(1, 1, n, 1, n, in[v], out[v], 1, d) << "\n";
        }
    }
    return 0;
}

/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 0 0 0 0 0
0 0
1
2 1 1
*/
