#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const int N = 2e5 + 2;

int n, q;
vector<int> g[N];
bool u[N];
int k[N];
int a[N];

int t[2 * N];
bool d[2 * N];
int chl[2 * N], chr[2 * N];
int ind;

void build(int v = 1, int tl = 1, int tr = n) {
	if (tl == tr) {
		t[v] = u[tl]; 
		return;
	}
	int tm = (tl + tr) / 2;
	chl[v] = ++ind;
	build(chl[v], tl, tm);
	chr[v] = ++ind;
	build(chr[v], tm + 1, tr);
	t[v] = t[chl[v]] + t[chr[v]];
}

void push(int v, int tl, int tr) {
	if (d[v]) {
		d[chl[v]] = 1;
		d[chr[v]] = 1;
		t[v] = tr - tl + 1;
	}
}

int query(int l, int r, int v = 1, int tl = 1, int tr = n) {
	push(v, tl, tr);
	if (l == tl && r == tr) {
		return t[v];
	}
	int tm = (tl + tr) / 2;
	if (r <= tm) {
		return query(l, r, chl[v], tl, tm);
	}
	if (l > tm) {
		return query(l, r, chr[v], tm + 1, tr);
	}
	return query(l, tm, chl[v], tl, tm) +
		query(tm + 1, r, chr[v], tm + 1, tr);
}

void update(int l, int r, int v = 1, int tl = 1, int tr = n) {
	push(v, tl, tr);
	if (l == tl && r == tr) {
		d[v] = 1;
		push(v, tl, tr);
		return;
	}
	int tm = (tl + tr) / 2;
	if (r <= tm) {
		update(l, r, chl[v], tl, tm);
	}
	else if (l > tm) {
		update(l, r, chr[v], tm + 1, tr);
	}
	else {
		update(l, tm, chl[v], tl, tm);
		update(tm + 1, r, chr[v], tm + 1, tr);
	}
	t[v] = t[chl[v]] + t[chr[v]];
}

void dfs(int v) {
	a[v] = ++ind;
	for (int i = 0; i < g[v].size(); i++) {
		dfs(g[v][i]);
		k[a[v]] += k[a[g[v][i]]] + 1;
	}
}

int main() {
	cin >> n;
	for (int i = 0; i < n - 1; i++) {
		int x, y;
		cin >> x >> y;
		g[x].push_back(y);
	}
	dfs(1);
	for (int i = 1; i <= n; i++) {
		cin >> u[a[i]];
	}
	ind = 1;
	build();
	cin >> q;
	for (int i = 0; i < q; i++) {
		int t, x, y;
		cin >> t >> x >> y;
		if (t == 1) {
			update(a[x], a[x] + k[a[x]]);
		}
		else {
			cout << query(a[x], a[x] + k[a[x]]) << endl;
		}
	}
}

/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1 0 1

*/