#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define elif else if
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const ld eps = 1e-7;
const int LOG = 20;

using namespace std;


void INPUT() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
}


#ifndef LOCAL
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#endif // LOCAL


void get_params(vector < vector < pair < int, int > > > &nxt, vector < int > &depth, vector < ll > &score, int curr=0) {
    for(auto i: nxt[curr]) {
        depth[i.F] = depth[curr] + 1;
        score[i.F] = score[curr] + i.S;
        get_params(nxt, depth, score, i.F);
    }
}


vector < vector < int > > pprev;
vector < int > dp;


int lca(int a, int b) {
    for(int i = LOG - 1; i >= 0; i--) {
        if(dp[a] > dp[b]) {
            if(pprev[a][i] != -1 and dp[pprev[a][i]] <= dp[b]) {
                a = pprev[a][i];
            }
        }elif(dp[b] > dp[a]) {
            if(pprev[b][i] != -1 and dp[pprev[b][i]] <= dp[a]) {
                b = pprev[b][i];
            }
        }
    }
    if(a == b) {
        return a;
    }
    for(int i = LOG - 1; i >= 0; i--) {
        if(pprev[a][i] != -1 and pprev[a][i] != pprev[b][i]) {
            a = pprev[a][i];
            b = pprev[b][i];
        }
    }
    a = pprev[a][0];
    return a;
}

ll getans(int v, map < pair < ll, int >, int, greater<> > mp, vector < vector < pair < int, int > > > &nxt, vector < int > &curr_cnt, vector < ll > &score){
    vector < pair < ll, int > > erasing;
    ll ans = 0;
    for(auto &i: mp) {
        if(lca(v, i.F.S) == v){
            if(i.F.F - score[v] <= 0) {
                break;
            }
            if(i.S >= curr_cnt[v]) {
                ans += curr_cnt[v] * (i.F.F - score[v]);
                i.S -= curr_cnt[v];
                if(i.S == 0){
                    erasing.pb(i.F);
                }
                break;
            } else {
                ans += i.S * (i.F.F - score[v]);
                curr_cnt[v] -= i.S;
                i.S = 0;
                erasing.pb(i.F);
            }
        }else{
            erasing.pb(i.F);
        }
    }
    for(auto i: erasing) {
        mp.erase(i);
    }
    for(auto i: nxt[v]){
        ans += getans(i.F, mp, nxt, curr_cnt, score);
    }
    return ans;
}


void solve() {
    int n;
    cin >> n;
    vector < int > curr_cnt(n);
    for(auto &i: curr_cnt) {
        cin >> i;
    }
    vector < int > max_cnt(n);
    for(auto &i: max_cnt) {
        cin >> i;
    }
    vector < vector < pair < int, int > > > nxt(n);
    vector < pair < int, int > > prev(n);
    for(int i = 1; i < n; i++) {
        int vertex, weight;
        cin >> vertex >> weight;
        vertex--;
        nxt[vertex].eb(i, weight);
        prev[i] = {vertex, weight};
    }
    vector < int > depth(n);
    vector < ll > score(n);
    get_params(nxt, depth, score);
    pprev.resize(n, vector < int > (LOG));
    for(int j = 0; j < n; j++) {
        if(j != 0) pprev[j][0] = prev[j].F;
        else pprev[j][0] = -1;
    }
    for(int i = 1; i < LOG; i++) {
        for(int j = 0; j < n; j++) {
            if(pprev[j][i - 1] == -1) {
                pprev[j][i] = -1;
            }else{
                pprev[j][i] = pprev[pprev[j][i - 1]][i - 1];
            }
        }
    }
    dp = depth;
    vector < pair < int, int > > order(n); /// {depth, id}
    for(int i = 0; i < n; i++) {
        order[i] = {depth[i], i};
    }
    sort(rall(order));
    map < pair < ll, int >, int, greater<> > mp;
    for(auto v: order) {
        mp[{score[v.S], v.S}] += max_cnt[v.S];
    }
    cout << getans(0, mp, nxt, curr_cnt, score) << '\n';
}


int32_t main() {
    INPUT();
    int n = 1;
//    cin >> n;
    while(n--) {
        solve();
    }
    return 0;
}
