#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define LD long double
#define INF (1<<30L)

const int maxN = 2005;
int N;
int S[maxN], E[maxN], P[maxN], W[maxN];
vector < vector<int> > adj(maxN);
int dist[maxN][maxN];
int maxScore = 0, currentScore = 0;
const int INVALID = -3000;

void generateDistances();
void distDFS( int, int, int );
void printDistances();
void generateAllAssignments();
void F( int, int );

int main(){ ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    for( int i = 0 ; i < maxN ; i++ ) for( int j = 0 ; j < maxN ; j++ ) dist[i][j] = INVALID;

    cin >> N;
    for( int i = 1 ; i <= N ; i++ ) cin >> S[i];
    for( int i = 1 ; i <= N ; i++ ) cin >> E[i];
    for( int i = 2 ; i <= N ; i++ ){ cin >> P[i] >> W[i]; adj[P[i]].push_back(i); }

    generateDistances();

    generateAllAssignments();

    cout << maxScore << endl;

    // printDistances();

}

void generateAllAssignments(){
    F(1,1);
}

void F( int i, int j ){

    if( i == j ) return F( i, j+1 );
    if( j == N+1 ) return F( i+1, 1 );
    if( i == N+1 ){ maxScore = max( maxScore, currentScore ); return; }

    if( !S[i] ) return F(i+1, 1);

    if( dist[i][j] == INVALID || dist[i][j] <= 0 ) return F(i, j+1);
    
    for( int k = 0 ; k <= min( S[i], E[j] ) ; k++ ){
        int scoreGain = k * dist[i][j];
        currentScore += scoreGain;
        S[i] -= k; E[j] -= k;
        F( i, j+1 );
        S[i] += k; E[j] += k;
        currentScore -= scoreGain;
    }

}

void generateDistances(){

    for( int i = 1 ; i <= N ; i++ ){
        distDFS( i, i, 0 );
    }

}

void distDFS( int source, int i, int d ){
    dist[source][i] = d;
    for( int j : adj[i] ) distDFS( source, j, d+W[j] );
}

void printDistances(){

    for( int i = 1 ; i <= N ; i++ ){
        for( int j = 1 ; j <= N ; j++ ){
            cout << setw(3) << ( dist[i][j] == INVALID ? "---" : to_string(dist[i][j]) ) << ' ';
        } cout << endl;
    } cout << endl;

}