#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define LD long double
#define INF (1<<30L)

struct Pair{
    int i, j, score;
    Pair(){}
    Pair( int _i, int _j, int _s ) : i(_i), j(_j), score(_s) {}
    const bool operator < ( const Pair &o ) const{
        if( score != o.score ) return score > o.score;
        if( i != o.i ) return i < o.i;
        return j < o.j;
    }
};

const int maxN = 2005;
int N;
int S[maxN], E[maxN], P[maxN], W[maxN];
vector < vector<int> > adj(maxN);
int dist[maxN][maxN];
const int INVALID = -3000;

void generateDistances();
void distDFS( int, int, int );
void printDistances();
int greedyAssignment();

int main(){ ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    for( int i = 0 ; i < maxN ; i++ ) for( int j = 0 ; j < maxN ; j++ ) dist[i][j] = INVALID;

    cin >> N;
    for( int i = 1 ; i <= N ; i++ ) cin >> S[i];
    for( int i = 1 ; i <= N ; i++ ) cin >> E[i];
    for( int i = 2 ; i <= N ; i++ ){ cin >> P[i] >> W[i]; adj[P[i]].push_back(i); }

    generateDistances();

    cout << greedyAssignment() << endl;

}

int greedyAssignment(){

    int rv = 0;
    vector <Pair> pairs;

    for( int i = 1 ; i <= N ; i++ ) for( int j = 1 ; j <= N ; j++ ){
        if( i == j || dist[i][j] == INVALID ) continue;
        pairs.push_back( {i,j,dist[i][j]} ); 
    }

    sort( pairs.begin(), pairs.end() );

    for( Pair p : pairs ){
        if( p.score <= 0 ) break;
        int k = min( S[p.i], E[p.j] );
        rv += k * p.score;
        S[p.i] -= k;
        E[p.j] -= k;
    }

    return rv;

}

void generateDistances(){

    for( int i = 1 ; i <= N ; i++ ){
        distDFS( i, i, 0 );
    }

}

void distDFS( int source, int i, int d ){
    dist[source][i] = d;
    for( int j : adj[i] ) distDFS( source, j, d+W[j] );
}

void printDistances(){
    for( int i = 1 ; i <= N ; i++ ){
        for( int j = 1 ; j <= N ; j++ ){
            cout << setw(3) << ( dist[i][j] == INVALID ? "---" : to_string(dist[i][j]) ) << ' ';
        } cout << endl;
    } cout << endl;
}