#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define LD long double
#define INF (1<<30L)

struct Pair{
    int i, j, score;
    Pair(){}
    Pair( int _i, int _j, int _s ) : i(_i), j(_j), score(_s) {}
    const bool operator < ( const Pair &o ) const{
        if( score != o.score ) return score > o.score;
        if( i != o.i ) return i < o.i;
        return j < o.j;
    }
};

const int maxN = 100005;
int N;
int S[maxN], E[maxN], P[maxN], W[maxN];
vector < vector<int> > adj(maxN);
int dist[maxN][maxN];
const int INVALID = -3000;

void generateDistances();
void distDFS( int, int, int );
void printDistances();
int lineAssignment();

int main(){ ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    for( int i = 0 ; i < maxN ; i++ ) for( int j = 0 ; j < maxN ; j++ ) dist[i][j] = INVALID;

    cin >> N;
    for( int i = 1 ; i <= N ; i++ ) cin >> S[i];
    for( int i = 1 ; i <= N ; i++ ) cin >> E[i];
    for( int i = 2 ; i <= N ; i++ ){ cin >> P[i] >> W[i]; adj[P[i]].push_back(i); }

    generateDistances();

    cout << lineAssignment() << endl;

}

int lineAssignment(){

    int rv = 0;
    int M = N-1;
    int A[M]; int nextNum = 1;
    for( int i = 0, j = M-1 ; i <= j ; i++, j-- ) A[i] = A[j] = nextNum++;

    for( int i = 2 ; i <= N ; i++ ){
        rv += A[i-2] * W[i];
    }

    return rv;

}

void generateDistances(){

    for( int i = 1 ; i <= N ; i++ ){
        distDFS( i, i, 0 );
    }

}

void distDFS( int source, int i, int d ){
    dist[source][i] = d;
    for( int j : adj[i] ) distDFS( source, j, d+W[j] );
}

void printDistances(){
    for( int i = 1 ; i <= N ; i++ ){
        for( int j = 1 ; j <= N ; j++ ){
            cout << setw(3) << ( dist[i][j] == INVALID ? "---" : to_string(dist[i][j]) ) << ' ';
        } cout << endl;
    } cout << endl;
}