#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <cmath>

using namespace std;
typedef long long ll;

int n;
vector <int> g[200010];
bool a[200010];
int q;

vector <int> order[200010];
int h[200010];
int num[200010];
int Q = 450;
int p[200010];

int H = 2;

void dfs(int u, int d)
{
	h[u] = d;
	H = max(H, h[u]);
	order[d].push_back(u);
	num[u] = order[d].size() - 1;

	for (auto v : g[u])
	{
		dfs(v, d + 1);
	}
}

vector <int> nval[200010];
vector <int> qval[200010];
pair <int, int> lr[200010];

void gt_(int u, int d, vector <int>& ans)
{
	ans.push_back(u);
	if (d == 0) return;
	for (auto v : g[u]) gt_(v, d - 1, ans);
}

vector <int> gt(int u, int d)
{
	vector <int> ans;
	gt_(u, d, ans);
	return ans;
}

struct seg
{
	int lev, l, r; //[)

	seg() {}

	seg(int u)
	{
		lev = h[u];
		l = num[u];
		r = num[u] + 1;
	}
};

seg mv(const seg& a)
{
	seg ans;
	ans.lev = a.lev + 1;
	if (order[a.lev].size() && a.r != a.l)
	{
		ans.l = lr[order[a.lev][a.l]].first;
		ans.r = lr[order[a.lev][a.r - 1]].second;
	}
	else
	{
		ans.l = 0;
		ans.r = 0;
	}
	return ans;
}

seg mv(seg a, int cnt)
{
	for (int i = 0; i < cnt; ++i)
	{
		a = mv(a);
	}
	return a;
}

seg mvprecnt[200010];

seg mvQ(const seg& a)
{
	seg ans;
	ans.lev = a.lev + Q;
	ans.l = mvprecnt[order[a.lev][a.l]].l;
	ans.r = mvprecnt[order[a.lev][a.r - 1]].r;
	return ans;
}

int getstup(const seg& a)
{
	if (a.l == a.r) return 0;
	return a.l == 0 ? nval[a.lev][a.r - 1] : nval[a.lev][a.r - 1] - nval[a.lev][a.l - 1];
}

int getstupQ(const seg& a)
{
	return a.l == 0 ? qval[a.lev][a.r - 1] : qval[a.lev][a.r - 1] - qval[a.lev][a.l - 1];
}

int getstup(int u, int x)
{
	seg f = seg(u);
	int ans = 0;
	for (int i = 0; i < x + 1; ++i)
	{
		ans += getstup(f);
		f = mv(f);
	}
	return ans;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	p[1] = 1;
	for (int i = 1; i <= n - 1; ++i)
	{
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		p[v] = u;
	}

	for (int i = 1; i <= n; ++i) cin >> a[i];

	dfs(1, 0);

	Q = max(2, (int)sqrt(H));

	for (int i = 0; i < n; ++i)
	{
		for (auto j : order[i]) nval[i].push_back(a[j]);
		for (int j = 1; j < nval[i].size(); ++j) nval[i][j] += nval[i][j - 1];

		if (i % Q == 0)
		{
			for (auto j : order[i])
			{
				auto got = gt(j, Q - 1);
				int sum = 0;
				for (auto i : got) sum += a[i];

				qval[i].push_back(sum);
			}

			for (int j = 1; j < qval[i].size(); ++j) qval[i][j] += qval[i][j - 1];
		}
	}

	for (int i = 0; i < n; ++i)
	{
		int cnt = 0;
		for (auto u : order[i])
		{
			lr[u] = { cnt, cnt + g[u].size() };
			cnt += g[u].size();
		}
	}

	for (int i = 0; i < n; ++i)
	{
		if (i % Q != 0) continue;

		int lst = 0;
		for (auto j : order[i])
		{
			auto got = mv(seg(j), Q);
			got.l = max(got.l, lst);
			got.r = max(got.r, lst);
			lst = got.r;
			mvprecnt[j] = got;
		}
	}

	int q;
	cin >> q;
	while (q--)
	{
		int t, u, x;
		cin >> t >> u >> x;

		int ans;
		if (x <= Q)
		{
			ans = getstup(u, x);
		}
		else
		{
			ans = 0;
			seg y = seg(u);
			int endh = y.lev + x;
			int hl = y.lev / Q;
			int hr = (y.lev + x) / Q;
			while (y.lev / Q == hl)
			{
				ans += getstup(y);
				y = mv(y);
			}
			while (y.lev / Q < hr)
			{
				ans += getstupQ(y);
				y = mvQ(y);
			}
			while (y.lev <= endh)
			{
				ans += getstup(y);
				y = mv(y);
			}

		}
		cout << ans << '\n';
	}

	return 0;
}