#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <cmath>

using namespace std;
typedef long long ll;

int n;
vector <int> g[200010];
int p[200010];
int timer = 1;

int tin[200010];
pair <int, int> st[200010];
int a[200010];
int totree[200010];
int qu[4 * 200010];
int tree[4 * 200010];

void dfs(int u)
{
	tin[u] = timer++;
	totree[tin[u]] = a[u];

	st[u] = { tin[u], tin[u] };
	for (auto v : g[u])
	{
		dfs(v);
		st[u].first = min(st[v].first, st[u].first);
		st[u].second = max(st[u].second, st[v].second);
	}
}

int gt(int i, int l, int r)
{
	return qu[i] ? r - l : tree[i];
}

inline void recount(int i, int l, int r)
{
	int m = (l + r) >> 1;
	tree[i] = gt(2 * i + 1, l, m) + gt(2 * i + 2, m, r);
	qu[i] = 0;
}

inline void push(int i)
{
	if (!qu[i]) return;
	qu[2 * i + 1] = true;
	qu[2 * i + 2] = true;
	qu[i] = false;
}

void build(int i, int l, int r)
{
	if (l + 1 == r)
	{
		tree[i] = totree[l];
		return;
	}

	int m = (l + r) >> 1;
	build(2 * i + 1, l, m);
	build(2 * i + 2, m, r);
	recount(i, l, r);
}

void qu1(int i, int l, int r, int ql, int qr)
{
	if (qr <= l || r <= ql) return;
	if (ql <= l && r <= qr)
	{
		qu[i] = true;
		return;
	}

	int m = (l + r) >> 1;
	push(i);
	qu1(2 * i + 1, l, m, ql, qr);
	qu1(2 * i + 2, m, r, ql, qr);
	recount(i, l, r);
}

int qu2(int i, int l, int r, int ql, int qr)
{
	if (qr <= l || r <= ql) return 0;
	if (ql <= l && r <= qr)
	{
		return gt(i, l, r);
	}

	int m = (l + r) >> 1;
	push(i);
	auto ans = 
		qu2(2 * i + 1, l, m, ql, qr) +
		qu2(2 * i + 2, m, r, ql, qr);
	recount(i, l, r);
	return ans;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;

	for (int i = 1; i <= n - 1; ++i)
	{
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		p[v] = u;
	}

	for (int i = 1; i <= n; ++i) cin >> a[i];

	dfs(1);
	build(0, 1, n + 1);
	int q;
	cin >> q;
	while (q--)
	{
		int t, u, x;
		cin >> t >> u >> x;
		int l = st[u].first, r = st[u].second + 1;
		if (t == 1)
		{
			qu1(0, 1, n + 1, l, r);
		}
		else
		{
			auto got = qu2(0, 1, n + 1, l, r);
			cout << got << '\n';
		}
	}
	return 0;
}