#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

namespace x = __gnu_pbds;
template <typename T>
using ordered_set = x::tree<T, x::null_type, less<T>, x::rb_tree_tag, x::tree_order_statistics_node_update>;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

const int N = 2e5 + 10, TREE = 2 * N;

int n;

vector<int> g[N];
ordered_set<pair<int, int>> t1[TREE], t0[TREE];

int tin[N], tout[N], depth[N];

void dfs(int u = 0, int p = -1, int d = 0) {
	depth[u] = d;
	static int timer = 0;
	tin[u] = timer++;
	for (int v : g[u]) {
		if (v == p) {
			continue;
		}
		dfs(v, u, d + 1);
	}
	tout[u] = timer;
}

int tget(int l, int r, int k) {
	// cout << l << " " << r << " " << k << endl;
	l += n;
	r += n;
	int ans = 0;
	while (l <= r) {
		if (l & 1)	ans += (int) t1[l].order_of_key({k + 1, -1});
		if (!(r & 1))	ans += (int) t1[r].order_of_key({k + 1, -1});
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
	return ans;
}

void tset(int l, int r, int k) {
	auto del = [&](int i) {
		while (sz(t0[i])) {
			auto [d, u] = *t0[i].begin();
			if (d > k) {
				break;
			}
			// cout << "got to know " << d << " " << u << endl;
			int j = tin[u] + n;
			while (j) {
				t0[j].erase({d, u});
				t1[j].insert({d, u});
				j /= 2;
			}
		}
	};
	l += n;
	r += n;
	while (l <= r) {
		if (l & 1) {
			del(l);
		}
		if (!(r & 1)) {
			del(r);
		}
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> n;
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		g[--u].push_back(--v);
		g[v].push_back(u);
	}
	dfs();
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		if (x == 0) {
			t0[n + tin[i]].insert({depth[i], i});
		} else {
			t1[n + tin[i]].insert({depth[i], i});
		}
	}
	for (int i = n; i-- > 0; ) {
		for (auto u : t0[2 * i]) {
			t0[i].insert(u);
		}
		for (auto u : t0[2 * i + 1]) {
			t0[i].insert(u);
		}
		for (auto u : t1[2 * i]) {
			t1[i].insert(u);
		}
		for (auto u : t1[2 * i + 1]) {
			t1[i].insert(u);
		}
	}
	int queries;
	cin >> queries;
	while (queries--) {
		int type, x, k;
		cin >> type >> x >> k;
		--x;
		if (type == 2) {
			cout << tget(tin[x], tout[x] - 1, depth[x] + k) << "\n";
		} else {
			tset(tin[x], tout[x] - 1, depth[x] + k);
		}
	}
}