#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

namespace x = __gnu_pbds;
template <typename T>
using ordered_set = x::tree<T, x::null_type, less<T>, x::rb_tree_tag, x::tree_order_statistics_node_update>;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

const int N = 2e5 + 10, TREE = 2 * N, NODES = 7e7;

struct {
	int x, l, r;
} _[NODES];

int next_free = 1;

int alloc() {
	assert(next_free < NODES);
	// if (sz(curr_free)) {
	// 	int to_ret = curr_free.back();
	// 	curr_free.pop_back();
	// 	_[to_ret] = {};
	// 	return to_ret;
	// }
	return next_free++;
}

int gadd(int qi, int qx, int i, int l, int r) {
	if (qi < l || qi >= r) {
		return 0;
	}
	if (!i) {
		i = alloc();
	}
	_[i].x += qx;
	if (!_[i].x) {
		// curr_free.push_back(i);
		// cout << "bad" << endl;
		return 0;
	}
	if (r - l == 1) {
		return i;
	}
	int mid = (l + r) / 2;
	if (qi < mid) {
		_[i].l = gadd(qi, qx, _[i].l, l, mid);
	} else {
		_[i].r = gadd(qi, qx, _[i].r, mid, r);
	}
	return i;
}

int gsum(int ql, int qr, int i, int l, int r) {
	// cout << ql << " " << qr << " " << i << " " << l << " " << r << endl;
	if (!i) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		return _[i].x;
	}
	if (r <= ql || qr <= l) {
		return 0;
	}
	int mid = (l + r) / 2;
	return gsum(ql, qr, _[i].l, l, mid) + gsum(ql, qr, _[i].r, mid, r);
}

int gbegin(int i, int l, int r) {
	if (!i || !_[i].x) {
		return N;
	}
	if (r - l == 1) {
		return l;
	}
	int mid = (l + r) / 2;
	int ans = gbegin(_[i].l, l, mid);
	if (ans == N) {
		return gbegin(_[i].r, mid, r);
	}
	return ans;
}

int n;

vector<int> g[N];
int t1[TREE], t0[TREE];

int tin[N], tout[N], depth[N];
int by_depth[N];

vector<pair<int, int>> order;
int order_to[N], order_from[N];
int depth_start[N];

void dfs(int u = 0, int p = -1, int d = 0) {
	depth[u] = d;
	order.push_back({d, u});
	static int timer = 0;
	tin[u] = timer++;
	for (int v : g[u]) {
		if (v == p) {
			continue;
		}
		dfs(v, u, d + 1);
	}
	tout[u] = timer;
}

int tget(int l, int r, int k) {
	k = min(k, n);
	// cout << l << " " << r << " " << k << endl;
	l += n;
	r += n;
	int ans = 0;
	while (l <= r) {
		if (l & 1)	ans += gsum(0, depth_start[k + 1], t1[l], 0, n);
		if (!(r & 1))	ans += gsum(0, depth_start[k + 1], t1[r], 0, n);
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
	return ans;
}

void tset(int l, int r, int k) {
	k = min(k, n);
	auto del = [&](int i) {
		// cout << "at" << i << endl;
		while (1) {
			int where = gbegin(t0[i], 0, n);
			if (where >= depth_start[k + 1]) {
				break;
			}
			// cout << "here with " << where << endl;
			int j = tin[order_from[where]] + n;
			// cout << "erasing " << order_from[where] << endl;
			// cout << j << endl;
			while (j) {
				// for (int i = 0; i < n; ++i) {
				// 	cout << gsum(i, i + 1, t0[j], 0, n) << " ";
				// }
				// cout << endl;
				// cout << "prev" << t0[j] << " " << gsum(0, n, t0[j], 0, n) << " " << endl;
				assert(gsum(where, where + 1, t0[j], 0, n) == 1);
				assert(gsum(where, where + 1, t1[j], 0, n) == 0);
				
				t0[j] = gadd(where, -1, t0[j], 0, n);
				// cout << "next" << t0[j] << " " << gsum(0, n, t0[j], 0, n) << endl;
				t1[j] = gadd(where, 1, t1[j], 0, n);
				// for (int i = 0; i < n; ++i) {
				// 	cout << gsum(i, i + 1, t0[j], 0, n) << " ";
				// }
				// cout << endl;
				j /= 2;
			}
		}
	};
	l += n;
	r += n;
	while (l <= r) {
		if (l & 1) {
			del(l);
		}
		if (!(r & 1)) {
			del(r);
		}
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> n;
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		g[--u].push_back(--v);
		g[v].push_back(u);
	}
	dfs();
	sort(all(order));
	for (int i = 0; i < n; ++i) {
		if (!i || order[i - 1].x != order[i].x) {
			depth_start[order[i].x] = i;
		}
		order_to[order[i].y] = i;
		order_from[i] = order[i].y;
	}
	for (int i = order.back().x + 1; i <= n + 1; ++i) {
		depth_start[i] = n;
	}
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		int *t = (x ? t1 : t0);
		int j = tin[i] + n;
		while (j) {
			t[j] = gadd(order_to[i], 1, t[j], 0, n);
			j /= 2;
		}
	}
	
	int queries;
	cin >> queries;
	while (queries--) {
		int type, x, k;
		cin >> type >> x >> k;
		--x;
		if (type == 2) {
			cout << tget(tin[x], tout[x] - 1, depth[x] + k) << "\n";
		} else {
			tset(tin[x], tout[x] - 1, depth[x] + k);
		}
	}
}