#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

namespace x = __gnu_pbds;
template <typename T>
using ordered_set = x::tree<T, x::null_type, less<T>, x::rb_tree_tag, x::tree_order_statistics_node_update>;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

const int N = 2e5 + 10, TREE = 2 * N, NODES = 7e7;

struct {
	int x, y, l, r;
} _[NODES];

int next_free = 1;

int alloc() {
	assert(next_free < NODES);
	return next_free++;
}

int gadd(int qi, int qx, int qy, int i, int l, int r) {
	if (qi < l || qi >= r) {
		return 0;
	}
	if (!i) {
		i = alloc();
	}
	_[i].x += qx;
	_[i].y += qy;
	if (r - l == 1) {
		return i;
	}
	int mid = (l + r) / 2;
	if (qi < mid) {
		_[i].l = gadd(qi, qx, qy, _[i].l, l, mid);
	} else {
		_[i].r = gadd(qi, qx, qy, _[i].r, mid, r);
	}
	return i;
}

int gsum(int ql, int qr, int i, int l, int r) {
	if (!i) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		return _[i].x;
	}
	if (r <= ql || qr <= l) {
		return 0;
	}
	int mid = (l + r) / 2;
	return gsum(ql, qr, _[i].l, l, mid) + gsum(ql, qr, _[i].r, mid, r);
}

vector<int> vwhere;
int tlef[2 * N], trig[2 * N];

void gbegin(int i, int l, int r, int bound) {
	if (l >= bound) {
		return;
	}
	if (!_[i].y) {
		return;
	}
	if (r - l == 1) {
		vwhere.push_back(l);
		return;
	}
	int mid = (l + r) / 2;
	gbegin(_[i].l, l, mid, bound);
	gbegin(_[i].r, mid, r, bound);
}

int n;

vector<int> g[N];
int t1[TREE];

int tin[N], tout[N], depth[N];
int by_depth[N];

vector<pair<int, int>> order;
int order_to[N], order_from[N];
int depth_start[N];

void dfs(int u = 0, int p = -1, int d = 0) {
	depth[u] = d;
	order.push_back({d, u});
	static int timer = 0;
	tin[u] = timer++;
	for (int v : g[u]) {
		if (v == p) {
			continue;
		}
		dfs(v, u, d + 1);
	}
	tout[u] = timer;
}

int tget(int l, int r, int k) {
	k = min(k, n);
	l += n;
	r += n;
	int ans = 0;
	while (l <= r) {
		if (l & 1)	ans += gsum(0, depth_start[k + 1], t1[l], 0, n);
		if (!(r & 1))	ans += gsum(0, depth_start[k + 1], t1[r], 0, n);
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
	return ans;
}

void tset(int l, int r, int k) {
	k = min(k, n);
	auto del = [&](int i) {
		vwhere.clear();
		gbegin(t1[i], 0, n, depth_start[k + 1]);
		for (int where : vwhere) {
			int j = tin[order_from[where]] + n;
			while (j) {
				if (tlef[j] == -1) {
					break;
				}
				t1[j] = gadd(where, 1, -1, t1[j], 0, n);
				j /= 2;
			}
		}
	};
	l += n;
	r += n;
	while (l <= r) {
		if (l & 1) {
			del(l);
		}
		if (!(r & 1)) {
			del(r);
		}
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> n;
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		g[--u].push_back(--v);
		g[v].push_back(u);
	}
	dfs();
	sort(all(order));
	for (int i = 0; i < n; ++i) {
		if (!i || order[i - 1].x != order[i].x) {
			depth_start[order[i].x] = i;
		}
		order_to[order[i].y] = i;
		order_from[i] = order[i].y;
	}
	for (int i = order.back().x + 1; i <= n + 1; ++i) {
		depth_start[i] = n;
	}
	for (int i = 0; i < n; ++i) {
		tlef[n + i] = i;
		trig[n + i] = i + 1;
	}
	for (int i = n; i--; ) {
		if (trig[2 * i] != tlef[2 * i + 1]) {
			tlef[i] = -1;
			trig[i] = -2;
		} else {
			tlef[i] = tlef[2 * i];
			trig[i] = trig[2 * i + 1];
		}
	}
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		if (x) {
			int j = tin[i] + n;
			while (j) {
				if (tlef[j] == -1) {
					break;
				}
				t1[j] = gadd(order_to[i], 1, 0, t1[j], 0, n);
				j /= 2;
			}
		} else {
			int j = tin[i] + n;
			while (j) {
				if (tlef[j] == -1) {
					break;
				}
				t1[j] = gadd(order_to[i], 0, 1, t1[j], 0, n);
				j /= 2;
			}
		}
	}
	
	int queries;
	cin >> queries;
	while (queries--) {
		int type, x, k;
		cin >> type >> x >> k;
		--x;
		if (type == 2) {
			cout << tget(tin[x], tout[x] - 1, depth[x] + k) << "\n";
		} else {
			tset(tin[x], tout[x] - 1, depth[x] + k);
		}
	}
}