#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

namespace x = __gnu_pbds;
template <typename T>
using ordered_set = x::tree<T, x::null_type, less<T>, x::rb_tree_tag, x::tree_order_statistics_node_update>;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

const int N = 2e5 + 10, TREE = 2 * N, NODES = 7e7;

struct {
	int x, y, l, r;
} _[NODES];

int next_free = 1;

int alloc() {
	assert(next_free < NODES);
	return next_free++;
}

int gadd(int qi, int qx, int qy, int i, int l, int r) {
	if (qi < l || qi >= r) {
		return 0;
	}
	if (!i) {
		i = alloc();
	}
	_[i].x += qx;
	_[i].y += qy;
	if (r - l == 1) {
		return i;
	}
	int mid = (l + r) / 2;
	if (qi < mid) {
		_[i].l = gadd(qi, qx, qy, _[i].l, l, mid);
	} else {
		_[i].r = gadd(qi, qx, qy, _[i].r, mid, r);
	}
	return i;
}

int gsum(int ql, int qr, int i, int l, int r) {
	if (!i) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		return _[i].x;
	}
	if (r <= ql || qr <= l) {
		return 0;
	}
	int mid = (l + r) / 2;
	int ans = 0;
	if (_[i].l && mid > ql) {
		ans += gsum(ql, qr, _[i].l, l, mid);
	}
	if (_[i].r && qr > mid) {
		ans += gsum(ql, qr, _[i].r, mid, r);
	}
	return ans;
}

vector<int> vwhere;
int tlef[2 * N], trig[2 * N];

void gbegin(int i, int l, int r, int bound) {
	if (l >= bound) {
		return;
	}
	if (!_[i].y) {
		return;
	}
	if (r - l == 1) {
		vwhere.push_back(l);
		return;
	}
	int mid = (l + r) / 2;
	if (_[i].l) {
		gbegin(_[i].l, l, mid, bound);
	}
	if (_[i].r && mid < bound) {
		gbegin(_[i].r, mid, r, bound);
	}
}

int n;

vector<int> g[N];
int t1[TREE];

int tin[N], tout[N], depth[N];
int by_depth[N];

int order_to[N];
pair<int, int> order_from[N];
int depth_start[N], max_depth[N];

int dfs(int u = 0, int p = -1, int d = 0) {
	max_depth[u] = d;
	depth[u] = d;
	static int timer = 0;
	order_from[timer] = {d, u};
	tin[u] = timer++;
	for (int v : g[u]) {
		if (v == p) {
			continue;
		}
		max_depth[u] = max(max_depth[u], dfs(v, u, d + 1));
	}
	tout[u] = timer;
	return max_depth[u];
}

int tget(int l, int r, int k) {
	k = min(k, n);
	l += n;
	r += n;
	int ans = 0;
	while (l <= r) {
		if (l & 1)	ans += gsum(0, depth_start[k + 1], t1[l], 0, n);
		if (!(r & 1))	ans += gsum(0, depth_start[k + 1], t1[r], 0, n);
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
	return ans;
}

void tset(int l, int r, int k) {
	k = min(k, n);
	auto del = [&](int i) {
		vwhere.clear();
		gbegin(t1[i], 0, n, depth_start[k + 1]);
		for (int where : vwhere) {
			int j = tin[order_from[where].y] + n;
			while (j) {
				if (tlef[j] == -1) {
					break;
				}
				t1[j] = gadd(where, 1, -1, t1[j], 0, n);
				j /= 2;
			}
		}
	};
	l += n;
	r += n;
	while (l <= r) {
		if (l & 1) {
			del(l);
		}
		if (!(r & 1)) {
			del(r);
		}
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
}

const int BUFF = 4096;

char buff[BUFF + 1], wbuff[BUFF];
int buff_pos = 0, buff_len = 0;
int write_pos = 0;

char get_char() {
	if (buff_pos == buff_len) {
		buff_len = (int) fread(buff, 1, BUFF, stdin);
		buff[buff_len] = 0;
		buff_pos = 0;
	}
	return buff[buff_pos++];
}

int get_int() {
	char c;
	while (!isdigit(c = get_char()));
	int res = 0;
	do {
		res *= 10;
		res += c - '0';
	} while (isdigit(c = get_char()));
	return res;
}

void put_flush() {
	fwrite(wbuff, 1, write_pos, stdout);
	write_pos = 0;
}

void put_char(char c) {
	if (write_pos == BUFF) {
		put_flush();
	}
	wbuff[write_pos++] = c;
}

void put_int(int x) {
	static char loc[20];
	int loc_pos = 0;
	if (!x) {
		put_char('0');
		return;
	}
	for (; x; loc[loc_pos++] = x % 10 + '0', x /= 10);
	while (loc_pos--) {
		put_char(loc[loc_pos]);
	}
}

signed main() {
	n = get_int();
	for (int i = 1; i < n; ++i) {
		int u = get_int(), v = get_int();
		g[--u].push_back(--v);
		g[v].push_back(u);
	}
	dfs();
	sort(order_from, order_from + n);
	for (int i = 0; i < n; ++i) {
		if (!i || order_from[i - 1].x != order_from[i].x) {
			depth_start[order_from[i].x] = i;
		}
		order_to[order_from[i].y] = i;
	}
	for (int i = order_from[n - 1].x + 1; i <= n + 1; ++i) {
		depth_start[i] = n;
	}
	for (int i = 0; i < n; ++i) {
		tlef[n + i] = i;
		trig[n + i] = i + 1;
	}
	for (int i = n; i--; ) {
		if (trig[2 * i] != tlef[2 * i + 1]) {
			tlef[i] = -1;
			trig[i] = -2;
		} else {
			tlef[i] = tlef[2 * i];
			trig[i] = trig[2 * i + 1];
		}
	}
	for (int i = 0; i < n; ++i) {
		int x = get_int();
		if (x) {
			int j = tin[i] + n;
			while (j) {
				if (tlef[j] == -1) {
					break;
				}
				t1[j] = gadd(order_to[i], 1, 0, t1[j], 0, n);
				j /= 2;
			}
		} else {
			int j = tin[i] + n;
			while (j) {
				if (tlef[j] == -1) {
					break;
				}
				t1[j] = gadd(order_to[i], 0, 1, t1[j], 0, n);
				j /= 2;
			}
		}
	}
	
	int queries = get_int();
	while (queries--) {
		int type = get_int(), x = get_int(), k = get_int();
		--x;
		k = min(k, max_depth[x] - depth[x]);
		if (type == 2) {
			put_int(tget(tin[x], tout[x] - 1, depth[x] + k));
			put_char('\n');
		} else {
			tset(tin[x], tout[x] - 1, depth[x] + k);
		}
	}
	put_flush();
}