#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

const int N = 1 << 18, TREE = 2 * N;

vector<int> g[N];

struct {
	int x, m;
} t[TREE];

void tpull(int i) {
	t[i].x = t[2 * i + 1].x + t[2 * i + 2].x;
}

void tapply(int i, int x, int l, int r) {
	if (x == -1) {
		return;
	}
	t[i].x = x * (r - l);
	t[i].m = x;
}

void tpush(int i, int l, int mid, int r) {
	if (t[i].m != -1) {
		tapply(2 * i + 1, t[i].m, l, mid);
		tapply(2 * i + 2, t[i].m, mid, r);
		t[i].m = -1;
	}
}

void tset(int ql, int qr, int x, int ci = 0, int cl = 0, int cr = N) {
	if (ql <= cl && cr <= qr) {
		tapply(ci, x, cl, cr);
		return;
	}
	if (cr <= ql || qr <= cl) {
		return;
	}
	int mid = (cl + cr) / 2;
	tpush(ci, cl, mid, cr);
	tset(ql, qr, x, 2 * ci + 1, cl, mid);
	tset(ql, qr, x, 2 * ci + 2, mid, cr);
	tpull(ci);
}

int tget(int ql, int qr, int ci = 0, int cl = 0, int cr = N) {
	if (ql <= cl && cr <= qr) {
		return t[ci].x;
	}
	if (cr <= ql || qr <= cl) {
		return 0;
	}
	int mid = (cl + cr) / 2;
	tpush(ci, cl, mid, cr);
	return tget(ql, qr, 2 * ci + 1, cl, mid) + tget(ql, qr, 2 * ci + 2, mid, cr);
}

int tin[N], tout[N];

void dfs(int u = 0, int p = -1) {
	static int timer = 0;
	tin[u] = timer++;
	for (int v : g[u]) {
		if (v == p) {
			continue;
		}
		dfs(v, u);
	}
	tout[u] = timer;
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n;
	cin >> n;
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		g[--u].push_back(--v);
	}
	dfs();
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		if (x) {
			tset(tin[i], tin[i] + 1, 1);
		}
	}
	int queries;
	cin >> queries;
	while (queries--) {
		int type, x, k;
		cin >> type >> x >> k;
		--x;
		if (type == 1) {
			tset(tin[x], tout[x], 1);
		} else {
			cout << tget(tin[x], tout[x]) << "\n";
		}
	}
}