#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef tree<pair<int,int>,null_type,less<pair<int,int> >,rb_tree_tag,tree_order_statistics_node_update> super_set;
#define endl '\n'
#define all(var) var.begin(),var.end()
const int N = 2e5+7;
vector<int> G[N];
int C[N],tin[N],tout[N],in_pos[N],depth[N],timer = 0;
void dfs(int v,int depth = 0){
    tin[v] = ++timer;
    in_pos[timer] = v;
    ::depth[v] = depth;
    for(int to:G[v]) {
        dfs(to,depth+1);
    }
    tout[v] = timer;
}
super_set T[N<<1];
vector<int> total[N<<1];
int mod[N<<1];
void buildtree(int t,int tl,int tr){
    if (tl==tr){
        if (C[in_pos[tl]]==0)
            T[t].insert({depth[in_pos[tl]],in_pos[tl]});
        total[t].push_back(depth[in_pos[tl]]);
        return;
    }
    int tm = (tl+tr)>>1;
    int nl = t+1,nr = t+((tm-tl+1)<<1);
    buildtree(nl,tl,tm);
    buildtree(nr,tm+1,tr);
    T[t] = T[nl];
    for(pair<int,int> to:T[nr])
        T[t].insert(to);
    merge(all(total[nl]),all(total[nr]),back_inserter(total[t]));
}
void modify(int t,int val){
    mod[t] = max(mod[t],val);
    while(!T[t].empty() && T[t].begin()->first<=val)
        T[t].erase(T[t].begin());
}
void push(int t,int nl,int nr){
    modify(nl,mod[t]);
    modify(nr,mod[t]);
}

void update(int t,int tl,int tr,int l,int r,int val,set<pair<int,int> > &del){
    if (tl>r || l>tr)
        return;
    if (l<=tl && tr<=r){
        mod[t] = max(mod[t],val);
        while(!T[t].empty() && T[t].begin()->first<=val){
            del.insert(*T[t].begin());
            T[t].erase(T[t].begin());
        }
        return;
    }
    int tm = (tl+tr)>>1;
    int nl = t+1,nr = t+((tm-tl+1)<<1);
    push(t,nl,nr);
    update(nl,tl,tm,l,r,val,del);
    set<pair<int,int> > d1;
    update(nr,tm+1,tr,l,r,val,d1);
    for(pair<int,int> to:d1)
        del.insert(to);
    for(pair<int,int> to:del)
        T[t].erase(to);
}
const int INF = 1e9;
int get(int t,int tl,int tr,int l,int r,int val){
    if (l>tr || tl>r)
        return 0;
    if (l<=tl && tr<=r){
        return (upper_bound(all(total[t]),val)-total[t].begin())-T[t].order_of_key({val,INF});
    }
    int tm = (tl+tr)>>1;
    int nl = t+1,nr = t+((tm-tl+1)<<1);
    push(t,nl,nr);
    return get(nl,tl,tm,l,r,val)+get(nr,tm+1,tr,l,r,val);
}
void solve(){
    int n;
    cin>>n;
    for(int i = 1;i<n;++i){
        int x,y;
        cin>>x>>y;
        G[x].push_back(y);
    }
    for(int i = 1;i<=n;++i){
        cin>>C[i];
    }
    dfs(1);
    buildtree(0,1,n);
    int q;
    cin>>q;
    while(q--){
        int type,x,k;
        cin>>type>>x>>k;
        if (type==1){
            set<pair<int,int> > del;
            update(0,1,n,tin[x],tout[x],depth[x]+k,del);
        }
        else{
            cout<<get(0,1,n,tin[x],tout[x],depth[x]+k)<<endl;
        }
    }
}
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    while(t--)
        solve();
}