#include <bits/stdc++.h>
#pragma GCC Optimize("O3")
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef tree<int,null_type,less_equal<int>,rb_tree_tag,tree_order_statistics_node_update> super_set;
#define endl '\n'
#define all(var) var.begin(),var.end()
const int N = 2e5+7;
vector<int> G[N];
int C[N],tin[N],tout[N],in_pos[N],depth[N],timer = 0;
void dfs(int v,int depth = 0){
    tin[v] = ++timer;
    in_pos[timer] = v;
    ::depth[v] = depth;
    for(int to:G[v]) {
        dfs(to,depth+1);
    }
    tout[v] = timer;
}
map<int,int> T[N<<1];
int P[N<<1];
vector<int> total[N<<1];
vector<pair<int,pair<int,int> > > events[N<<1];
int mod[N<<1];
const int INF = 1e9;
vector<int> tr[N<<1],dps[N<<1];
void upd(int t,int pos,int delta){
    int start = upper_bound(all(dps[t]),pos)-dps[t].begin();
    int sz = dps[t].size();
    for(int i = start;i<=sz;i+=i&-i)
        tr[t][i]+=delta;
}
int get(int t,int pos){
    int ret = 0;
    int start = upper_bound(all(dps[t]),pos)-dps[t].begin();
    for(int i = start;i>0;i-=i&-i)
        ret+=tr[t][i];
    return ret;
}
void unite(vector<int> &a,vector<int> &b,vector<int> &c){
    int ptr1 = 0,ptr2 = 0;
    while(ptr1<a.size() || ptr2<b.size()){
        int v1 = INF,v2 = INF;
        if (ptr1<a.size())
            v1 = a[ptr1];
        if (ptr2<b.size())
            v2 = b[ptr2];

        if (c.empty() || c.back()!=min(v1,v2))
            c.push_back(min(v1,v2));
        if (v1<v2)
            ++ptr1;
        else ++ptr2;
    }
}
void buildtree(int t,int tl,int tr){
    if (tl==tr){
        if (C[in_pos[tl]]==0)
            T[t][depth[in_pos[tl]]]++;
        dps[t].push_back(depth[in_pos[tl]]);
        ::tr[t].resize(2);
        for(pair<int,int> to:T[t])
            upd(t,to.first,to.second);
        total[t].push_back(depth[in_pos[tl]]);
        return;
    }
    int tm = (tl+tr)>>1;
    int nl = t+1,nr = t+((tm-tl+1)<<1);
    P[nl] = P[nr] = t;
    buildtree(nl,tl,tm);
    buildtree(nr,tm+1,tr);
    T[t] = T[nl];
    for(pair<int,int> to:T[nr])
        T[t][to.first]+=to.second;
    merge(all(total[nl]),all(total[nr]),back_inserter(total[t]));
    unite(dps[nl],dps[nr],dps[t]);
    ::tr[t].resize(dps[t].size()+1);
    for(pair<int,int> to:T[t])
        upd(t,to.first,to.second);
}
void modify(int t,int val){
    mod[t] = max(mod[t],val);
    while(!T[t].empty() && T[t].begin()->first<=val) {
        upd(t,T[t].begin()->first,-T[t].begin()->second);
        T[t].erase(T[t].begin());
    }
}
void push(int t,int nl,int nr){
    modify(nl,mod[t]);
    modify(nr,mod[t]);
}
void par_del(int t,int val,int cnt){

    while(t!=-1){
        T[t][val]-=cnt;
        upd(t,val,-cnt);
        t = P[t];
    }
}
void update(int t,int tl,int tr,int l,int r,int val){
    if (tl>r || l>tr)
        return;
    if (l<=tl && tr<=r){
        mod[t] = max(mod[t],val);
        while(!T[t].empty() && T[t].begin()->first<=val){
            par_del(t,T[t].begin()->first,T[t].begin()->second);
            T[t].erase(T[t].begin());
        }
        return;
    }
    int tm = (tl+tr)>>1;
    int nl = t+1,nr = t+((tm-tl+1)<<1);
    push(t,nl,nr);
    update(nl,tl,tm,l,r,val);
    update(nr,tm+1,tr,l,r,val);
}

vector<pair<int,int> > to_ans[N<<1];
int ind;
int get(int t,int tl,int tr,int l,int r,int val){
    if (l>tr || tl>r)
        return 0;
    if (l<=tl && tr<=r){
        to_ans[t].push_back({val,ind});
        return -get(t,val);
    }
    int tm = (tl+tr)>>1;
    int nl = t+1,nr = t+((tm-tl+1)<<1);
    push(t,nl,nr);
    return get(nl,tl,tm,l,r,val)+get(nr,tm+1,tr,l,r,val);
}
struct query{
    int type,x,k;
} Q[N];
int ans[N];
void ans_q(int t,int tl,int tr){
    sort(all(to_ans[t]));
    int ptr = 0;
    for(pair<int,int> to:to_ans[t]){
        while (ptr<total[t].size() && total[t][ptr]<=to.first)
            ++ptr;
        ans[to.second]+=ptr;
    }
    int tm = (tl+tr)>>1;
    int nl = t+1,nr = t+((tm-tl+1)<<1);
    if (tl==tr){
        return;
    }
    ans_q(nl,tl,tm);
    ans_q(nr,tm+1,tr);

}
void solve(){
    int n;
    scanf("%d",&n);
    for(int i = 1;i<n;++i){
        int x,y;
        scanf("%d%d",&x,&y);
        G[x].push_back(y);
    }
    for(int i = 1;i<=n;++i){
        scanf("%d",&C[i]);
    }
    dfs(1);
    P[0] = -1;
    buildtree(0,1,n);
    int q;
    scanf("%d",&q);
    set<pair<int,int> > del;
    for(int i = 1;i<=q;++i){
        int type,x,k;
        scanf("%d%d%d",&type,&x,&k);
        ind = i;
        if (type==1){
            update(0,1,n,tin[x],tout[x],depth[x]+k);
        }
        else{
            ans[i]+=get(0,1,n,tin[x],tout[x],depth[x]+k);
        }
        Q[i] = {type,x,k};
    }
    ans_q(0,1,n);
    for(int i = 1;i<=q;++i)
        if (Q[i].type==2)
        printf("%d\n",ans[i]);

}
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    while(t--)
        solve();
}