#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vi = vector<ll>;
using vvi = vector<vi>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vsi = vector<set<ll>>;

#ifndef DEBUG
#define endl '\n';
#endif

#ifdef DEBUG
template<typename X, typename Y>
ostream& operator<<(ostream& s, const pair<X, Y>& v) {
  s << "{" << v.first << ", " << v.second << "}";

  return s;
}
#endif

template<typename X, typename Y>
istream& operator>>(istream& s, pair<X, Y>& v) {
  s >> v.first >> v.second;

  return s;
}

template<typename T>
istream& operator>>(istream& s, vector<T>& v) {
  for (int i = 0; i < v.size(); ++i) {
    s >> v[i];
  }

  return s;
}

template<typename T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (auto e: v) {
    s << e << ' ';
  }

  return s;
}

void solve();

ll k;

int main() {
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);

  ll t;
  cin >> k >> t;
  while (t--)
    solve();
}

// ----


namespace df {

void win() { cout << "Win" << endl; }
void loss() { cout << "Loss" << endl; }

}

#define WIN return df::win();
#define LOSS return df::loss();

bool get(ll p, ll d) {
  static map<ii, ll> cache;
  if (cache.count({p, d}) == 0) {

    ll m = p + d;
    if (m == 0) return false;
    if (m == 1) return true;
    if (m == p and p % 2 == 0) return false;
    if (m == p and p % 2 == 1) return true;
//  if (m == 2 and d == 2) return false;
    if (m == p + 1) return true;

    bool ans = false;
    if (p > 0) ans |= !get(p - 1, d);
    if (d > 0) ans |= !get(p, d - 1);
    if (d > 0) ans |= !get(p + 1, d - 1);
    cache[{p, d}] = ans;
  }
  return cache[{p, d}];
}

void solve() {
  ll n;
  cin >> n;
  vii bs(n);
  cin >> bs;

  if (k == 0) {
    ll m = 0, p = 0, d = 0, o = 0;
    for (auto[b, s]: bs) if ((b + s) > 0) ++m;
    for (auto[b, s]: bs) if ((b + s) == 1) ++p;
    for (auto[b, s]: bs) if ((b + s) >= 2) ++d;
//    for (auto[b, s]: bs) if ((b + s) > 2) ++o;

    if (get(p, d)) WIN else LOSS
  } else {
    abort();
  }
}

