#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vi = vector<ll>;
using vvi = vector<vi>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vsi = vector<set<ll>>;

#ifndef DEBUG
#define endl '\n';
#endif

#ifdef DEBUG
template<typename X, typename Y>
ostream& operator<<(ostream& s, const pair<X, Y>& v) {
  s << "{" << v.first << ", " << v.second << "}";

  return s;
}
#endif

template<typename X, typename Y>
istream& operator>>(istream& s, pair<X, Y>& v) {
  s >> v.first >> v.second;

  return s;
}

template<typename T>
istream& operator>>(istream& s, vector<T>& v) {
  for (int i = 0; i < v.size(); ++i) {
    s >> v[i];
  }

  return s;
}

template<typename T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (auto e: v) {
    s << e << ' ';
  }

  return s;
}

void solve();

//ll k;

int main() {
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);

//  ll t;
//  cin >> k >> t;
//  while (t--)
  solve();
}

// ----

ll n;
vi p;
vsi gr;
vi b;

ll t1_dfs_q(ll v, ll k) {
  ll ans = 0;
  if (b[v] == 1) ++ans;
  if (k == 0) return ans;
  for (auto u: gr[v]) {
    ans += t1_dfs_q(u, k - 1);
  }
  return ans;
}

void t1_dfs_n(ll v, ll k) {
  b[v] = 1;
  if (k == 0) return;
  for (auto u: gr[v]) {
    t1_dfs_n(u, k - 1);
  }
}

ll t3_get(ll v, ll k) {
  static vector<unordered_map<ll, ll>> cache(n);

  if (k == 0) return b[v];

  if (cache[v].count(k) == 0) {
    ll ans = b[v];
    for (auto u: gr[v]) ans += t3_get(u, k - 1);
    cache[v][k] = ans;
  }
  return cache[v][k];
}

void solve() {
  cin >> n;
  p.resize(n, -1);
  gr.resize(n);
  for (int i = 0; i < n - 1; ++i) {
    ll x, y;
    cin >> x >> y;
    --x, --y;
    p[y] = x;
    gr[x].insert(y);
  }

  b.resize(n);
  cin >> b;

  ll q;
  cin >> q;
  for (int qq = 0; qq < q; ++qq) {
    ll t, x, k;
    cin >> t >> x >> k;
    --x;

    if (n <= 10'000) {
      if (t == 1) {
        t1_dfs_n(x, k);
      } else if (t == 2) {
        cout << t1_dfs_q(x, k) << endl;
      }
    } else {
      assert(t == 2);
      cout << t3_get(x, k) << endl;
    }
  }
}
