#include <iostream>
#include <vector>
#include <set>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}

const int N = 5e5 + 100, INF = 1e18;

struct segment_tree {
    pair<int, int> t[4 * N];

    segment_tree() {
        for (int i = 0; i < 4 * N; i++) {
            t[i] = {-INF, -INF};
        }
    }

    pair<int, int> get(int v, int l, int r, int tl, int tr) {
        if (l >= tl && r <= tr) {
            return t[v];
        }
        if (l > tr || r < tl) {
            return {-INF, -INF};
        }
        int m = (r + l) / 2;
        return max(get(v * 2, l, m, tl, tr), get(v * 2 + 1, m + 1, r, tl, tr));
    }

    void update(int v, int l, int r, int pos, pair<int, int> val) {
        if (l == r) {
            t[v] = val;
        } else {
            int m = (r + l) / 2;
            if (pos <= m) update(v * 2, l, m, pos, val);
            else update(v * 2 + 1, m + 1, r, pos, val);
            t[v] = max(t[v * 2], t[v * 2 + 1]);
        }
    }
};

int n, s[N], c[N], d[N], tin[N], tout[N], timer = -1;
long long ans;
vector<pair<int, int>> a[N];
segment_tree tree;

void dfs1(int v, int p) {
    tin[v] = ++timer;
    for (auto to : a[v]) {
        if (to.first == p) continue;
        dfs1(to.first, v);
    }
    tout[v] = timer;
}

void dfs(int v, int p) {
    for (auto to : a[v]) {
        if (to.first == p) continue;
        d[to.first] = d[v] + to.second;
        dfs(to.first, v);
    }
    int ss = s[v];

    pair<int, int> z = tree.get(1, 0, n - 1, tin[v], tout[v]);
    while (z.first != -INF && s[v] > 0) {
        if (z.first - d[v] < 0) break;
        if (s[v] >= c[z.second]) {
            tree.update(1, 0, n - 1, tin[z.second], {-INF, -INF});
            s[v] -= c[z.second];
            ans += 1ll * (z.first - d[v]) * c[z.second];
        } else {
            ans += 1ll * (z.first - d[v]) * s[v];
            c[z.second] -= s[v];
            s[v] = 0;
        }
        z = tree.get(1, 0, n - 1, tin[v], tout[v]);
    }
    tree.update(1, 0, n - 1, tin[v], {d[v], v});
    c[v] += ss - s[v];
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (int i = 1; i < n; i++) {
        int p, w;
        cin >> p >> w;
        p--;
        a[p].push_back({i, w});
    }
    dfs1(0, 0);
    dfs(0, 0);
    cout << ans;
}