#include <iostream>
#include <vector>
#include <set>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}

const int N = 5e5 + 100, INF = 1e18;

struct segment_tree {
    int t[4 * N];
    bool mod[4 * N];

//    segment_tree() {
//        for (int i = 0; i < 4 * N; i++) {
//            t[i] = -INF;
//        }
//    }

    void push(int v, int l, int r) {
        if (mod[v]) {
            t[v] = r - l + 1;
            if (l < r) {
                mod[v * 2] = true;
                mod[v * 2 + 1] = true;
            }
            mod[v] = false;
        }
    }

    int get(int v, int l, int r, int tl, int tr) {
        push(v, l, r);
        if (l >= tl && r <= tr) {
            return t[v];
        }
        if (l > tr || r < tl) {
            return 0;
        }
        int m = (r + l) / 2;
        return get(v * 2, l, m, tl, tr) + get(v * 2 + 1, m + 1, r, tl, tr);
    }

    void update(int v, int l, int r, int tl, int tr) {
        push(v, l, r);
        if (l >= tl && r <= tr) {
            mod[v] = true;
            push(v, l, r);
            return;
        }
        if (l > tr || r < tl) {
            return;
        }
        int m = (r + l) / 2;
        update(v * 2, l, m, tl, tr);
        update(v * 2 + 1, m + 1, r, tl, tr);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }

//    void update(int v, int l, int r, int pos, pair<int, int> val) {
//        if (l == r) {
//            t[v] = val;
//        } else {
//            int m = (r + l) / 2;
//            if (pos <= m) update(v * 2, l, m, pos, val);
//            else update(v * 2 + 1, m + 1, r, pos, val);
//            t[v] = max(t[v * 2], t[v * 2 + 1]);
//        }
//    }
};

int n, q, tin[N], tout[N], timer = -1, fen[N], b[N], ans, pp[N];
vector<int> a[N];
segment_tree tree;

int get(int v) {
    if (v < 0)
        return 0;
    int res = 0;
    for (; v >= 0; v = (v & (v + 1)) - 1) {
        res += fen[v];
    }
    return res;
}

void update(int v, int val) {
    for (; v < N; v |= v + 1) {
        fen[v] += val;
    }
}

void dfs1(int v, int p) {
    pp[v] = p;
    tin[v] = ++timer;
    for (int to : a[v]) {
        if (to == p) continue;
        dfs1(to, v);
    }
    tout[v] = timer;
}

void dfs2(int v, int p, int d) {
    b[v] = 1;
    if (d == 0) return;
    for (int to : a[v]) {
        if (to == p) continue;
        dfs2(to, v, d - 1);
    }
    tout[v] = timer;
}

void dfs3(int v, int p, int d) {
    ans += b[v];
    if (d == 0) return;
    for (int to : a[v]) {
        if (to == p) continue;
        dfs3(to, v, d - 1);
    }
}

void solve() {
    cin >> n;
    for (int i = 1; i < n; i++) {
        int f, s;
        cin >> f >> s;
        f--, s--;
        a[f].push_back(s);
        a[s].push_back(f);
    }
    dfs1(0, 0);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
        if (b[i]) {
            tree.update(1, 0, n - 1, tin[i], tin[i]);
        }
    }
    cin >> q;
    if (n <= 1e4 && q <= 1e4) {
        for (int qq = 0; qq < q; qq++) {
            int t, x, k;
            cin >> t >> x >> k;
            x--;
            if (t == 1) {
                dfs2(x, pp[x], k);
            } else {
                ans = 0;
                dfs3(x, pp[x], k);
                cout << ans << '\n';
            }
        }
        return;
    }
    for (int qq = 0; qq < q; qq++) {
        int t, x, k;
        cin >> t >> x >> k;
        x--;
        if (t == 1) {
            tree.update(1, 0, n - 1, tin[x], tout[x]);
        } else {
            cout << tree.get(1, 0, n - 1, tin[x], tout[x]) << '\n';
        }
    }
}