#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int NMAX = 5e5 + 1;
const int ROOT = 1;

int N, s[NMAX], e[NMAX];
int w[NMAX];

vector < int > G[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for(int i = 1; i <= N; ++i)
        cin >> s[i];

    for(int i = 1; i <= N; ++i)
        cin >> e[i];

    for(int i = 2; i <= N; ++i)
    {
        int p = 0;
        cin >> p;

        G[p].push_back(i);

        cin >> w[i];
    }

    return;
}

typedef pair < int, int > PII;
typedef pair < int, PII > PIII;
vector < PIII > Vals;

int START;

static inline void Go (int Node, int until_now = 0)
{
    for(auto it : G[Node])
    {
        Go(it, until_now + w[it]);

        if(e[it])
            Vals.push_back({until_now + w[it], {START, it}});
    }

    return;
}

auto cmp = [] (PIII A, PIII B)
{
    if(A.first > B.first)
        return 1;

    return 0;
};

static inline void Solve ()
{
    long long ans = 0;

    while(1)
    {
        Vals.clear();

        for(int i = 1; i <= N; ++i)
            if(s[i])
                START = i, Go(i, 0);

        if(Vals.empty())
            break;

        sort(Vals.begin(), Vals.end(), cmp);

        if(Vals[0].first <= 0)
            break;

        ans += 1LL * Vals[0].first;
        --s[Vals[0].second.first];
        --e[Vals[0].second.second];
    }

    cout << ans << '\n';

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
