#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

typedef pair < int, int > PII;

const int NMAX = 10;
const int ROOT = 1;

int N, s[NMAX], e[NMAX];
int w[NMAX];
vector < int > G[NMAX];

int COST[NMAX][NMAX];

int LIM = 14000000;

vector < pair < int, PII > > List;

static inline void DFS (int Start, int Finish)
{
    for(auto it : G[Finish])
    {
        COST[Start][it] = COST[Start][Finish] + w[it];

        DFS(Start, it);
    }

    return;
}

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for(int i = 1; i <= N; ++i)
        cin >> s[i];
    for(int i = 1; i <= N; ++i)
        cin >> e[i];

    for(int i = 2; i <= N; ++i)
    {
        int p = 0;
        cin >> p;

        G[p].push_back(i);

        cin >> w[i];
    }

    for(int i = 1; i <= N; ++i)
        DFS(i, i);

    for(int i = 1; i < N; ++i)
        for(int j = (i + 1); j <= N; ++j)
            if(COST[i][j] > 0)
                List.push_back({COST[i][j], {i, j}});

    sort(List.begin(), List.end());
    reverse(List.begin(), List.end());

    return;
}

int ans = 0;
static inline int my_max (int a, int b)
{
    return ((a > b) ? a : b);
}

static inline int my_min (int a, int b)
{
    return ((a < b) ? a : b);
}

static inline void Solve (int sum = 0)
{
    --LIM;

    if(LIM < 0)
        return;

    ans = my_max(ans, sum);

    for(auto it : List)
    {
        if(LIM < 0)
            return;

        int i = it.second.first, j = it.second.second;

        if(s[i] > 0 && e[j] > 0)
        {
            for(int k = my_min(s[i], e[j]); k >= 1; --k)
            {
                s[i] -= k, e[j] -= k;

                Solve(sum + k * COST[i][j]);

                s[i] += k, e[j] += k;
            }
        }
    }

    return;
}

int main()
{
    Read();

    Solve();

    cout << ans << '\n';

    return 0;
}
