#include <iostream>
#include <vector>

using namespace std;

const int NMAX = 2e5 + 1, QMAX = 2e5 + 1;
const int INF = 1e9;

int N, In[NMAX], ROOT, Lvl[NMAX];
bool B[NMAX];
vector < int > G[NMAX];
vector < int > List[NMAX];

int Q;

int M = 0, V[(NMAX << 1)];
int in[NMAX], out[NMAX];

int ANSWER[QMAX];

struct NodeT
{
    int Min, ap;

    NodeT ()
    {
        Min = INF;
        ap = 0;
    }
};

class SegmentTree
{
    NodeT A[(NMAX << 3)];
    int Lazy[(NMAX << 3)];

private:
    inline void Go (int Node, int a, int b)
    {
        if(a == b)
            return;

        if(Lazy[Node] == 0)
            return;

        Lazy[(Node << 1)] += Lazy[Node], Lazy[((Node << 1) + 1)] += Lazy[Node];

        A[(Node << 1)].Min += Lazy[Node], A[((Node << 1) + 1)].Min += Lazy[Node];

        Lazy[Node] = 0;

        return;
    }

public:
    inline void Initialize (int Node, int a, int b)
    {
        if(a == b)
        {
            A[Node].Min = 0;
            A[Node].ap = 1;

            return;
        }

        int Mid = ((a + b) >> 1);

        Initialize((Node << 1), a, Mid), Initialize(((Node << 1) + 1), Mid + 1, b);

        if(A[(Node << 1)].Min < A[((Node << 1) + 1)].Min)
            A[Node] = A[(Node << 1)];
        else if(A[(Node << 1)].Min > A[((Node << 1) + 1)].Min)
            A[Node] = A[((Node << 1) + 1)];
        else
        {
            A[Node].Min = A[(Node << 1)].Min;
            A[Node].ap = A[(Node << 1)].ap + A[((Node << 1) + 1)].ap;
        }

        return;
    }

    inline void Update (int Node, int a, int b, int ua, int ub, int Val)
    {
        if(ua <= a && b <= ub)
        {
            A[Node].Min += Val;

            Lazy[Node] += Val;

            return;
        }

        Go(Node, a, b);

        int Mid = ((a + b) >> 1);

        if(ua <= Mid)
            Update((Node << 1), a, Mid, ua, ub, Val);

        if(ub > Mid)
            Update(((Node << 1) + 1), Mid + 1, b, ua, ub, Val);

        if(A[(Node << 1)].Min < A[((Node << 1) + 1)].Min)
            A[Node] = A[(Node << 1)];
        else if(A[(Node << 1)].Min > A[((Node << 1) + 1)].Min)
            A[Node] = A[((Node << 1) + 1)];
        else
        {
            A[Node].Min = A[(Node << 1)].Min;
            A[Node].ap = A[(Node << 1)].ap + A[((Node << 1) + 1)].ap;
        }

        return;
    }

    inline NodeT Query (int Node, int a, int b, int qa, int qb)
    {
        if(qa <= a && b <= qb)
            return A[Node];

        Go(Node, a, b);

        int Mid = ((a + b) >> 1);
        NodeT p_Left, p_Right;

        if(qa <= Mid)
            p_Left = Query((Node << 1), a, Mid, qa, qb);

        if(qb > Mid)
            p_Right = Query(((Node << 1) + 1), Mid + 1, b, qa, qb);

        if(p_Left.Min < p_Right.Min)
            return p_Left;
        else if(p_Left.Min > p_Right.Min)
            return p_Right;

        NodeT ans;
        ans.Min = p_Left.Min;
        ans.ap = p_Left.ap + p_Right.ap;

        return ans;
    }
} AINT;

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for(int i = 1; i < N; ++i)
    {
        int x = 0, y = 0;
        cin >> x >> y;

        ++In[y];

        G[x].push_back(y);
    }

    for(int i = 1; i <= N; ++i)
        cin >> B[i];

    return;
}

static inline void Find_Root ()
{
    for(int i = 1; i <= N && !ROOT; ++i)
        if(In[i] == 0)
            ROOT = i;

    return;
}

static inline void DFS (int Node, int Level = 1)
{
    V[++M] = Node;
    in[Node] = M;

    Lvl[Node] = Level;
    List[Level].push_back(Node);

    for(auto it : G[Node])
        DFS(it, Level + 1);

    V[++M] = Node;
    out[Node] = M;

    return;
}

static inline void Precalculation ()
{
    Find_Root();

    DFS(ROOT);

    AINT.Initialize(1, 1, (N << 1));

    return;
}

struct Query
{
    int Node;
    int Id;
};
vector < Query > T[NMAX];

static inline int my_min (int a, int b)
{
    return ((a < b) ? a : b);
}

static inline void Solve ()
{
    Precalculation();

    cin >> Q;

    for(int i = 1; i <= Q; ++i)
    {
        int type = 0, x = 0, k = 0;
        cin >> type >> x >> k;

        T[my_min(Lvl[x] + k, N)].push_back({x, i});
    }

    for(int i = 1; i <= N; ++i)
    {
        for(auto it : List[i])
            if(B[it])
                AINT.Update(1, 1, (N << 1), in[it], in[it], +1), AINT.Update(1, 1, (N << 1), out[it], out[it], +1);

        for(auto it : T[i])
        {
            int Node = it.Node;
            int Id = it.Id;

            NodeT now = AINT.Query(1, 1, (N << 1), in[Node], out[Node]);
            if(now.Min == 0)
                ANSWER[Id] = (((out[Node] - in[Node] + 1) - now.ap) >> 1);
            else
                ANSWER[Id] = ((out[Node] - in[Node] + 1) >> 1);
        }
    }

    for(int i = 1; i <= Q; ++i)
        cout << ANSWER[i] << '\n';

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
