#include <iostream>
#include <vector>

using namespace std;

const int NMAX = 2e5 + 1;
const int INF = 1e9;

int N, In[NMAX], ROOT, Level[NMAX];
bool B[NMAX];
vector < int > G[NMAX];

int Q;

int M = 0, V[(NMAX << 1)];
int in[NMAX], out[NMAX];

int LMAX;
vector < int > List[NMAX];

bool Completed[NMAX];

struct NodeT
{
    int Min, ap;
    NodeT ()
    {
        Min = INF;
        ap = 0;
    }
};

class SegmentTree
{
    NodeT *A;
    int *Lazy;

private:
    inline void Go (int Node, int a, int b)
    {
        if(a == b)
            return;
        if(Lazy[Node] == 0)
            return;

        Lazy[(Node << 1)] += Lazy[Node], Lazy[((Node << 1) + 1)] += Lazy[Node];
        A[(Node << 1)].Min += Lazy[Node], A[((Node << 1) + 1)].Min += Lazy[Node];
        Lazy[Node] = 0;
        return;
    }

public:
    inline void Memory (int Size)
    {
        A = new NodeT [((Size << 2) + 1)];
        Lazy = new int [((Size << 2) + 1)];
        for(int i = 1; i < (Size << 1); ++i)
            Lazy[i] = 0;
        return;
    }

    inline void Initialize (int Node, int a, int b, int level)
    {
        if(a == b)
        {
            A[Node].Min = B[V[List[level][a - 1]]];
            A[Node].ap = 1;
            return;
        }
        int Mid = ((a + b) >> 1);
        Initialize((Node << 1), a, Mid, level), Initialize(((Node << 1) + 1), Mid + 1, b, level);
        if(A[(Node << 1)].Min < A[((Node << 1) + 1)].Min)
            A[Node] = A[(Node << 1)];
        else if(A[(Node << 1)].Min > A[((Node << 1) + 1)].Min)
            A[Node] = A[((Node << 1) + 1)];
        else
        {
            A[Node].Min = A[(Node << 1)].Min;
            A[Node].ap = A[(Node << 1)].ap + A[((Node << 1) + 1)].ap;
        }
        return;
    }

    inline void Update (int Node, int a, int b, int ua, int ub, int Val)
    {
        if(ua <= a && b <= ub)
        {
            A[Node].Min += Val;
            Lazy[Node] += Val;
            return;
        }
        Go(Node, a, b);
        int Mid = ((a + b) >> 1);
        if(ua <= Mid)
            Update((Node << 1), a, Mid, ua, ub, Val);
        if(ub > Mid)
            Update(((Node << 1) + 1), Mid + 1, b, ua, ub, Val);
        if(A[(Node << 1)].Min < A[((Node << 1) + 1)].Min)
            A[Node] = A[(Node << 1)];
        else if(A[(Node << 1)].Min > A[((Node << 1) + 1)].Min)
            A[Node] = A[((Node << 1) + 1)];
        else
        {
            A[Node].Min = A[(Node << 1)].Min;
            A[Node].ap = A[(Node << 1)].ap + A[((Node << 1) + 1)].ap;
        }
        return;
    }

    inline NodeT Query (int Node, int a, int b, int qa, int qb)
    {
        if(qa <= a && b <= qb)
            return A[Node];
        Go(Node, a, b);
        int Mid = ((a + b) >> 1);
        NodeT p_Left, p_Right;
        if(qa <= Mid)
            p_Left = Query((Node << 1), a, Mid, qa, qb);
        if(qb > Mid)
            p_Right = Query(((Node << 1) + 1), Mid + 1, b, qa, qb);
        if(p_Left.Min < p_Right.Min)
            return p_Left;
        else if(p_Left.Min > p_Right.Min)
            return p_Right;
        NodeT ans;
        ans.Min = p_Left.Min;
        ans.ap = p_Left.ap + p_Right.ap;
        return ans;
    }
} AINT[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for(int i = 1; i < N; ++i)
    {
        int x = 0, y = 0;
        cin >> x >> y;

        ++In[y];

        G[x].push_back(y);
    }

    for(int i = 1; i <= N; ++i)
        cin >> B[i];

    return;
}

static inline void Find_Root ()
{
    for(int i = 1; i <= N && !ROOT; ++i)
        if(In[i] == 0)
            ROOT = i;

    return;
}

static inline void DFS (int Node, int Lvl = 1)
{
    V[++M] = Node;
    in[Node] = M;
    List[Lvl].push_back(M);

    Level[Node] = Lvl;
    if(Lvl > LMAX)
        LMAX = Lvl;

    for(auto it : G[Node])
        DFS(it, Lvl + 1);

    V[++M] = Node;
    out[Node] = M;
    List[Lvl].push_back(M);

    return;
}

static inline void Precalculation ()
{
    Find_Root();

    DFS(ROOT);

    for(int i = 1; i <= LMAX; ++i)
        AINT[i].Memory((int)List[i].size()), AINT[i].Initialize(1, 1, (int)List[i].size(), i);

    return;
}

static inline void Function (int l, int st, int dr)
{
    if(Completed[l])
        return;
    int left = 0, right = (int)List[l].size(), pos_1 = -1;
    while(left <= right)
    {
        int mid = ((left + right) >> 1);
        if(List[l][mid] >= st)
        {
            pos_1 = mid;
            right = mid - 1;
        }
        else left = mid + 1;
    }
    if(pos_1 == -1)
        return;
    left = pos_1, right = (int)List[l].size();
    int pos_2 = -1;
    while(left <= right)
    {
        int mid = ((left + right) >> 1);
        if(List[l][mid] <= dr)
        {
            pos_2 = mid;
            left = mid + 1;
        }
        else right = mid - 1;
    }
    if(pos_2 == -1)
        return;
    AINT[l].Update(1, 1, (int)List[l].size(), pos_1 + 1, pos_2 + 1, +1);
    return;
}

static inline int Collection (int l, int st, int dr)
{
    int left = 0, right = (int)List[l].size(), pos_1 = -1;
    while(left <= right)
    {
        int mid = ((left + right) >> 1);
        if(List[l][mid] >= st)
        {
            pos_1 = mid;
            right = mid - 1;
        }
        else left = mid + 1;
    }
    if(pos_1 == -1)
        return 0;
    left = pos_1, right = (int)List[l].size();
    int pos_2 = -1;
    while(left <= right)
    {
        int mid = ((left + right) >> 1);
        if(List[l][mid] <= dr)
        {
            pos_2 = mid;
            left = mid + 1;
        }
        else right = mid - 1;
    }
    if(pos_2 == -1)
        return 0;
    if(Completed[l])
        return ((pos_2 - pos_1 + 1) >> 1);
    NodeT now = AINT[l].Query(1, 1, (int)List[l].size(), pos_1 + 1, pos_2 + 1);
    if(now.Min == 0)
        return (((pos_2 - pos_1 + 1) - now.ap) >> 1);
    if((pos_2 - pos_1 + 1) == (int)List[l].size())
        Completed[l] = 1;
    return ((pos_2 - pos_1 + 1) >> 1);
}

static inline void TestCase ()
{
    int type = 0, x = 0, k = 0;
    cin >> type >> x >> k;

    if(type == 1)
    {
        for(int l = Level[x]; l <= Level[x] + k && l <= LMAX; ++l)
            if(!List[l].empty())
                Function(l, in[x], out[x]);

        return;
    }

    int ans = 0;

    for(int l = Level[x]; l <= Level[x] + k && l <= LMAX; ++l)
        if(!List[l].empty())
            ans += Collection(l, in[x], out[x]);

    cout << ans << '\n';

    return;
}

static inline void Solve ()
{
    Precalculation();

    cin >> Q;
    while(Q--)
        TestCase();

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
