#include <bits/stdc++.h>
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "

using namespace std;
typedef long long ll;
typedef pair <int, int> pii;

const int NMAX = 200001;
const int nr_of_bits = 21;
const int MOD = 1000000007;
const int INF = 1e9;

struct edge{
    int from, to, cap, cost;
}edges[NMAX * 2 + 10];

int distt[NMAX], distn[NMAX], dist[NMAX], viz[NMAX], last[NMAX], s[NMAX], e[NMAX];
int n, sursa, sink;
int cnt = 0;
vector <int> v[NMAX];

void addEdge(int a, int b, int cap, int cost){
    edges[++cnt] = {a, b, cap, cost};
    v[a].push_back(cnt);
    edges[++cnt] = {b, a, 0, -cost};
    v[b].push_back(cnt);
}

int invers(int x){
    if(x % 2)
        return x + 1;
    return x - 1;
}

void bellman(){
    for(int i = 1; i <= n; i++){
        viz[i] = 0;
        distt[i] = INF;
    }
    queue <int> q;
    q.push(sursa);
    distt[sursa] = 0;
    while(!q.size()){
        int node = q.front();
        q.pop();
        for(auto x : v[node]){
            /// de revazut
            if(!edges[x].cap)
                continue;
            int to = edges[x].to;
            int cost = edges[x].cost;
            if(distt[node] + cost < distt[to]){
                distt[to] = node;
                if(!viz[to]){
                    viz[to] = 1;
                    q.push(to);
                }
            }
        }
    }
}

bool Dijkstra(){
    int i;
    for(i = 1; i <= n; i++){
        viz[i] = 0;
        dist[i] = INF;
        last[i] = 0;
        distn[i] = INF;
    }
    priority_queue <pii> pq;
    dist[sursa] = distn[sursa] = 0;
    pq.push({0, sursa});
    while(pq.size()){
        while(pq.size() && viz[pq.top().second])
            pq.pop();
        if(!pq.size())
            continue;
        int node = pq.top().second;
        viz[node] = 1;
        pq.pop();
        for(auto x : v[node]){
            if(!edges[x].cap)
                continue;
            int to = edges[x].to;
            int cost = edges[x].cost + distt[node] - distt[to];
            if(dist[node] + cost < dist[to]){
                dist[to] = dist[node] + cost;
                last[to] = x;
                distn[to] = distn[node] + edges[x].cost; /// problems
                pq.push({-dist[to], to});
            }
        }
    }
    for(i = 1; i <= n; i++){
        distt[i] = distn[i];
    }
    if(viz[sink])
        return 1;
    return 0;
}

int flux(){
    int sol = 0;
    while(Dijkstra()){
        int node = last[sink];
        int minim = INF;
        if(distt[sink] >= 0)
            break;
        int cv = 0;
        while(node != 0){
            minim = min(minim, edges[node].cap);
            cv += edges[node].cost;
            node = last[edges[node].from];
        }
        sol += minim * cv;
        node = last[sink];
        while(node != 0){
            edges[node].cap -= minim;
            edges[invers(node)].cap += minim;
            node = last[edges[node].from];
        }
    }
    return sol;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int i;
    cin >> n;
    sursa = n + 1;
    sink = n + 2;
    for(i = 1; i <= n; i++){
        cin >> s[i];
        addEdge(n + 1, i, s[i], 0);
    }
    for(i = 1; i <= n; i++){
        cin >> e[i];
        addEdge(i, n + 2, e[i], 0);
    }
    for(i = 2; i <= n; i++){
        int x, y;
        cin >> x >> y;
        addEdge(x, i, INF, -y);
    }
    n += 2;
    bellman();
    cout << -flux() << "\n";
    return 0;
}
