#include <bits/stdc++.h>
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "

using namespace std;
typedef long long ll;
typedef pair <ll, ll> pii;

const ll NMAX = 200001;
const ll nr_of_bits = 21;
const ll MOD = 1000000007;
const ll INF = (1LL << 59);

struct edge{
    ll from, to, cap, cost;
}edges[NMAX * 2 + 10];

ll distt[NMAX], distn[NMAX], dist[NMAX], viz[NMAX], last[NMAX], s[NMAX], e[NMAX];
ll n, sursa, sink;
ll lvl[NMAX];
ll cnt = 0;
vector <ll> v[NMAX];

void addEdge(ll a, ll b, ll cap, ll cost){
    edges[++cnt] = {a, b, cap, cost};
    v[a].push_back(cnt);
    edges[++cnt] = {b, a, 0, -cost};
    v[b].push_back(cnt);
}

ll invers(ll x){
    if(x % 2)
        return x + 1;
    return x - 1;
}

void bellman(){
    for(ll i = 1; i <= n; i++){
        viz[i] = 0;
        distt[i] = INF;
    }
    queue <ll> q;
    q.push(sursa);
    distt[sursa] = 0;
    while(!q.size()){
        ll node = q.front();
        q.pop();
        for(auto x : v[node]){
            /// de revazut
            if(!edges[x].cap)
                continue;
            ll to = edges[x].to;
            ll cost = edges[x].cost;
            if(distt[node] + cost < distt[to]){
                distt[to] = node;
                if(!viz[to]){
                    viz[to] = 1;
                    q.push(to);
                }
            }
        }
    }
}

bool Dijkstra(){
    ll i;
    for(i = 1; i <= n; i++){
        viz[i] = 0;
        dist[i] = INF;
        last[i] = 0;
        distn[i] = INF;
    }
    priority_queue <pair <pii, ll> > pq;
    dist[sursa] = distn[sursa] = 0;
    pq.push({{0, 0}, sursa});
    while(pq.size()){
        while(pq.size() && viz[pq.top().second])
            pq.pop();
        if(!pq.size())
            continue;
        ll node = pq.top().second;
        viz[node] = 1;
        pq.pop();
        for(auto x : v[node]){
            if(!edges[x].cap)
                continue;
            ll to = edges[x].to;
            ll cost = edges[x].cost + distt[node] - distt[to];
            if(dist[node] + cost < dist[to]){
                dist[to] = dist[node] + cost;
                last[to] = x;
                distn[to] = distn[node] + edges[x].cost; /// problems
                pq.push({{-dist[to], -lvl[to]}, to});
            }
        }
    }
    for(i = 1; i <= n; i++){
        distt[i] = distn[i];
    }
    if(viz[sink])
        return 1;
    return 0;
}

ll flux(){
    ll sol = 0;
    while(Dijkstra()){
        ll node = last[sink];
        ll minim = INF;
        if(distt[sink] >= 0)
            break;
        ll cv = distt[sink];
        while(node != 0){
            minim = min(minim, edges[node].cap);
            node = last[edges[node].from];
        }
        sol += 1LL * minim * cv;
        node = last[sink];
        while(node != 0){
            edges[node].cap -= minim;
            edges[invers(node)].cap += minim;
            node = last[edges[node].from];
        }
    }
    return sol;
}

int main()
{
//    ifstream cin(".in");
//    ofstream cout(".out");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll i;
    cin >> n;
    sursa = n + 1;
    lvl[sursa] = 0;
    sink = n + 2;
    lvl[sink] = n + 1;
    for(i = 1; i <= n; i++){
        cin >> s[i];
        addEdge(n + 1, i, s[i], 0);
    }
    for(i = 1; i <= n; i++){
        cin >> e[i];
        addEdge(i, n + 2, e[i], 0);
    }
    lvl[1] = 1;
    for(i = 2; i <= n; i++){
        ll x, y;
        cin >> x >> y;
        lvl[i] = lvl[x] + 1;
        addEdge(x, i, INF, -y);
    }
    n += 2;
    bellman();
    cout << -flux() << "\n";
    return 0;
}
