#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "
#pragma GCC optimize("Ofast", "unroll-loops")
#pragma GCC target("sse", "sse2", "avx")

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair <int, int> pii;
typedef tree <int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> ordered;

const ll NMAX = 200001;
const ll nr_of_bits = 21;
const ll MOD = 1000000007;
const ll INF = (1LL << 59);

int n, lvl[NMAX], stamp, sz[NMAX];
pii timp[NMAX];

class AINTlvl{
public:
    pii aint[4 * NMAX];
    void init(){
        for(int i = 0; i < 4 * NMAX; i++)
            aint[i] = {2e9, 2e9};
    }
    void update(int node, int st, int dr, int a, pii b){
        if(st == dr){
            aint[node] = b;
            return;
        }
        int mid = (st + dr) / 2;
        if(a <= mid){
            update(node * 2, st, mid, a, b);
        }else{
            update(node * 2 + 1, mid + 1, dr, a, b);
        }
        aint[node] = min(aint[node * 2], aint[node * 2 + 1]);
    }
    pii query(int node, int st, int dr, int a, int b){
        if(a <= st && dr <= b){
            return aint[node];
        }
        int mid = (st + dr) / 2;
        pii sol = {2e9, 2e9};
        if(a <= mid){
            sol = min(sol, query(node * 2, st, mid, a, b));
        }
        if(b > mid){
            sol = min(sol, query(node * 2 + 1, mid + 1, dr, a, b));
        }
        return sol;
    }

}stlvl;


class AINT{
public:
    ordered aint[4 * NMAX];
    void update(int node, int st, int dr, int a, int b, int x){
        if(a <= st && dr <= b){
            aint[node].insert(x);
            return;
        }
        int mid = (st + dr) / 2;
        if(a <= mid){
            update(node * 2, st, mid, a, b, x);
        }
        if(b > mid){
            update(node * 2 + 1, mid + 1, dr, a, b, x);
        }
    }
    int query(int node, int st, int dr, int poz, int x){
        if(st == dr){
            return aint[node].order_of_key(x);
        }
        int mid = (st + dr) / 2;
        int sol = aint[node].order_of_key(x);
        if(poz <= mid){
            sol += query(node * 2, st, mid, poz, x);
        }else{
            sol += query(node * 2 + 1, mid + 1, dr, poz, x);
        }
        return sol;
    }
    void baga(int st, int dr, int x){
        update(1, 1, n, st, dr, x);
    }
    int ask(int node, int x){
        return query(1, 1, n, timp[node].first, x + 1);
    }
}st;

vector <int> v[NMAX];
int maxim[NMAX];

void DFS(int node, int p){
    lvl[node] = lvl[p] + 1;
    sz[node] = 1;
    for(auto x : v[node]){
        if(x == p)
            continue;
        DFS(x, node);
        sz[node] += sz[x];
        if(maxim[node] == 0 || sz[x] > sz[maxim[node]])
            maxim[node] = x;
    }
}

int parent[NMAX];
int pp[NMAX];

void Heavy(int node, int p, int capat){
    parent[node] = capat;
    pp[node] = p;
    timp[node].first = ++stamp;
    if(maxim[node] != 0){
        Heavy(maxim[node], node, capat);
    }
    for(auto x : v[node]){
        if(x == p || x == maxim[node])
            continue;
        Heavy(x, node, x);
    }
    timp[node].second = stamp;
}


void stie(int x){
    stlvl.update(1, 1, n, timp[x].first, {2e9, 2e9});
    int node = x;
    while(node != 0){
        st.baga(timp[parent[node]].first, timp[node].first, lvl[x]);
        node = pp[parent[node]];
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int i;
    stlvl.init();
    cin >> n;
    for(i = 1; i < n; i++){
        int x, y;
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    lvl[1] = 1;
    DFS(1, 0);
    Heavy(1, 0, 1);
    for(i = 1; i <= n; i++){
        stlvl.update(1, 1, n, timp[i].first, {lvl[i], i});
    }
    for(i = 1; i <= n; i++){
        int x;
        cin >> x;
        if(x)
            stie(i);
    }
    int q;
    cin >> q;
    while(q--){
        int a, x, k;
        cin >> a >>  x >> k;
        if(a == 1){
            pii c = stlvl.query(1, 1, n, timp[x].first, timp[x].second);
            int trebuie = lvl[x] + k;
            while(c.first <= trebuie){
                stie(c.second);
                c = stlvl.query(1, 1, n, timp[x].first, timp[x].second);
            }
        }else{
            cout << st.ask(x, lvl[x] + k) << "\n";
        }
    }
    return 0;
}
