#include <cstdio>
#include <utility>
#include <vector>
#include <cassert>

const int N = 500000;
int n, up[N], s[N], e[N], ord[N], in[N];
std::vector<std::pair<int, int> > g[N];
std::pair<int, int> t[N << 1];
long long ans = 0;

void upd(int i, std::pair<int, int> x)
{
    for (i += n, t[i] = x; i > 1; i >>= 1) t[i >> 1] = std::max(t[i], t[i ^ 1]);
}

std::pair<int, int> get(int l, int r)
{
    std::pair<int, int> ans(1 << 31, 0);
    for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
        if (l & 1) ans = std::max(ans, t[l++]);
        if (r & 1) ans = std::max(ans, t[--r]);
    }
    return ans;
}

void dfs(int v)
{
    static int dt = 0;
    ord[dt] = v;
    in[v] = dt++;
    for (int i = 0; i < (int)g[v].size(); ++i) {
        up[g[v][i].first] = up[v] + g[v][i].second;
        dfs(g[v][i].first);
    }
    bool any = 0;
    while (s[v]) {
        any = false;
        std::pair<int, int> mx = get(in[v] + 1, dt);
        if (mx.first > up[v]) {
            int amt = std::min(s[v], e[mx.second]);
            s[v] -= amt;
            e[mx.second] -= amt;
            e[v] += amt;
            ans += (long long)amt * (mx.first - up[v]);
            upd(in[mx.second], std::make_pair(e[mx.second] ? mx.first : -1070000000, mx.second));
            any = true;
        }
        else break;
    }
    if (e[v]) upd(in[v], std::make_pair(up[v], v));
}

int main()
{
    scanf("%d", &n);
    assert(n <= N);
    for (int i = 0; i < n; ++i) {
        scanf("%d", s + i);
        assert(s[i] >= 0 && s[i] <= 2000);
    }
    for (int i = 0; i < n; ++i) {
        scanf("%d", e + i);
        assert(e[i] >= 0 && e[i] <= 2000);
    }
    for (int i = 1; i < n; ++i) {
        int p, w;
        scanf("%d%d", &p, &w);
        assert(p >= 1 && p - 1 < i);
        assert(w >= -2000 && w <= 2000);
        g[p - 1].push_back(std::make_pair(i, w));
    }
    dfs(0);
    printf("%lld\n", ans);
    return 0;
}
/*
5
5 1 0 0 0
100 1 1 2 4
1 6
1 1
2 2
2 -1
*/
