#include <cstdio>
#include <utility>
#include <algorithm>
#include <vector>

const int N = 200000;
int n, dep[N], in[N], out[N], q, b[N];
std::pair<int, int> rmq[N << 1];
std::vector<int> g[N];

struct bit {
    std::vector<std::pair<int, int> > val;
    std::vector<int> b;
    void add(int i, int d) {
        while (i < (int)b.size()) {
            b[i] += d;
            i |= i + 1;
        }
    }
    int get(int i) {
        int s = 0;
        while (i >= 0) {
            fflush(stdout);
            s += b[i];
            i = (i & i + 1) - 1;
        }
        return s;
    }
    void insert(std::pair<int, int> p) {
        add(std::lower_bound(val.begin(), val.end(), p) - val.begin(), 1);
    }
    int less_than(int x) {
        return get(std::lower_bound(val.begin(), val.end(), std::make_pair(x, 0)) - val.begin() - 1);
    }
};
bit t[N << 1];

void dfs(int v)
{
    static int dt = 0;
    in[v] = dt++;
    for (int i = 0; i < (int)g[v].size(); ++i) {
        dep[g[v][i]] = dep[v] + 1;
        dfs(g[v][i]);
    }
    out[v] = dt;
}

int query(int l, int r, int x)
{
    int ans = 0;
    for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
        if (l & 1) ans += t[l++].less_than(x);
        if (r & 1) ans += t[--r].less_than(x);
    }
    return ans;
}

void insert(int i, std::pair<int, int> p)
{
    for (i += n; i > 0; i >>= 1) t[i].insert(p);
}

void rmq_upd(int i, std::pair<int, int> p)
{
    for (i += n, rmq[i] = p; i > 1; i >>= 1) rmq[i >> 1] = std::min(rmq[i], rmq[i ^ 1]);
}

std::pair<int, int> rmq_get(int l, int r)
{
    std::pair<int, int> res(~(1 << 31), 0);
    for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
        if (l & 1) res = std::min(res, rmq[l++]);
        if (r & 1) res = std::min(res, rmq[--r]);
    }
    return res;
}

int main()
{
    scanf("%d", &n);
    for (int i = 1; i < n; ++i) {
        int a, b;
        scanf("%d%d", &a, &b);
        g[a - 1].push_back(b - 1);
    }
    dfs(0);
    for (int i = 0; i < n; ++i) {
        scanf("%d", b + i);
        t[n + in[i]].val.push_back(std::make_pair(dep[i], i));
        t[n + in[i]].b.resize(1);
    }
    for (int i = n - 1; i > 0; --i) {
        t[i].val.resize(t[i << 1].val.size() + t[i << 1 | 1].val.size());
        t[i].b.resize(t[i].val.size());
        std::merge(t[i << 1].val.begin(), t[i << 1].val.end(), t[i << 1 | 1].val.begin(), t[i << 1 | 1].val.end(), t[i].val.begin());
    }
    for (int i = 0; i < n; ++i) {
        if (b[i]) insert(in[i], std::make_pair(dep[i], i));
        rmq_upd(in[i], std::make_pair(b[i] ? ~(1 << 31) : dep[i], i));
    }
    scanf("%d", &q);
    while (q--) {
        int type, x, k;
        scanf("%d%d%d", &type, &x, &k);
        --x;
        if (type == 1) {
            std::pair<int, int> p;
            while ((p = rmq_get(in[x], out[x])).first - dep[x] <= k) {
                insert(in[p.second], p);
                rmq_upd(in[p.second], std::make_pair(~(1 << 31), 0));
            }
        } else {
            printf("%d\n", query(in[x], out[x], dep[x] + k + 1));
        }
    }
    return 0;
}
/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1
0 1
9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2

*/
