#include <bits/stdc++.h>

using namespace std;
const int NMAX = 2e5;
vector <int> g[NMAX + 5];
int tin[NMAX + 5], tout[NMAX + 5], timer, re[NMAX + 5], d[NMAX + 5], n;
bool news[NMAX + 5];
class kSegtree {
    struct node {
        node *l, *r;
        int s;
        node(node *_l = nullptr, node *_r = nullptr, int _s = 0) : l(_l), r(_r), s(_s) {if(l) s += l -> s; if(r) s += r -> s;}
    };
    vector <node*> t; int n;
    node *build(vector <int> &init, int ll, int rr, int ind) {
        if(ll == rr) return new node();
        return new node(build(init, ll, (ll + rr) / 2, ind << 1), build(init, (ll + rr) / 2 + 1, rr, ind << 1 | 1));
    }
    node *build(vector <int>& init) {return build(init, 1, n, 1);}
    node *root(node *curr, int val, int ll, int rr, int ind) {
        //cout << ll << " " << rr << "\n";
        if(ll == val && ll == rr) return new node(nullptr, nullptr, 1 + curr -> s);
        if((ll + rr) / 2 >= val) return new node(root(curr -> l, val, ll, (ll + rr) / 2, ind << 1), curr -> r);
        return new node(curr -> l, root(curr -> r, val, (ll + rr) / 2 + 1, rr, ind << 1 | 1));
    }
    node *root(node *curr, int val) { return root(curr, val, 1, n, 1); }
public:
    kSegtree(vector <int>& v) {
        n = v.size(); int h = 32 - __builtin_clz(n);
        t.push_back(build(v)); //cout << "#";
        for(int i = 1; i <= n; i++)
            t.push_back(root(t[i - 1], v[i - 1]));
    }
    int q(node* r1, node* r2, int k, int ll, int rr, int ind) {
        //cout << ll << " " << rr << " " << r2 -> s - r1 -> s << "\n";
        if(rr <= k) return r2 -> s - r1 -> s;
        if(ll > k) return 0;
        return q(r1 -> l, r2 -> l, k, ll, (ll + rr) / 2, ind << 1) + q(r1 -> r, r2 -> r, k, (ll + rr) / 2 + 1, rr, ind << 1 | 1);
    }
    int query(int l, int r, int k) {
        //cout << l << " " << r << " " << k << "\n";
        return q(t[l - 1], t[r], k, 1, n, 1);
    }
};

void dfs(int u, int v) {
    tin[u] = ++timer; re[timer] = u;
    d[u] = d[v] + 1;
    for(int adj : g[u]) if(adj != v)
        dfs(adj, u);
    tout[u] = timer;
}
void update(int u, int k) {
    k += d[u];
    //tupdate(tin[u], tout[u]);
}
int query(kSegtree& S, int u, int k) {
    k += d[u];
    //return tquery(tin[u], tout[u]);
    return S.query(tin[u], tout[u], k);
}

int main()
{
    ios_base :: sync_with_stdio(false); cin.tie(nullptr);
    int q, t, x, y;
    cin >> n;
    for(int i = 1; i < n; i++)
        cin >> x >> y,
        g[x].push_back(y),
        g[y].push_back(x);
    dfs(1, 0);
    for(int i = 1; i <= n; i++)
        cin >> news[tin[i]];
    //build();
    vector <int> dep(n);
    for(int i = 1; i <= n; i++) dep[tin[i] - 1] = (news[tin[i]] ? d[i] : n);
    kSegtree S(dep);
    cin >> q;
    for(int i = 1; i <= q; i++) {
        cin >> t >> x >> y;
        assert(t == 2);
        if(t == 1) update(x, y);
        else cout << query(S, x, y) << "\n";
        //cout << "#";
    }
    return 0;
}
/*int t[2 * NMAX + 5], len[2 * NMAX + 5];
bool lazy[2 * NMAX + 5];

void build(int ll = 1, int rr = n, int ind = 1) {
    //cout << ll << " " << rr << "\n";
    if(ll == rr) {
        len[ind] = 1;
        t[ind] = news[ll];
        return;
    }
    build(ll, (ll + rr) >> 1, ind << 1);
    build(((ll + rr) >> 1) + 1, rr, ind << 1 | 1);
    len[ind] = len[ind << 1] + len[ind << 1 | 1];
    t[ind] = t[ind << 1] + t[ind << 1 | 1];
}

void tupdate(int l, int r, int ll = 1, int rr = n, int ind = 1) {
    if(l <= ll && r >= rr) {
        t[ind] = len[ind];
        lazy[ind] = true;
        return;
    }
    if(rr < l || ll > r) return;
    tupdate(l, r, ll, (ll + rr) >> 1, ind << 1);
    tupdate(l, r, ((ll + rr) >> 1) + 1, ind << 1 | 1);
    t[ind] = t[ind << 1] + t[ind << 1 | 1];
}

int tquery(int l, int r, int ll = 1, int rr = n, int ind = 1) {
    //cout << l << " " << r << " " << ll << " " << rr << "\n";
    if(lazy[ind]) {
        t[ind] = len[ind];
        lazy[ind] = false;
        if(ll != rr) lazy[ind << 1] = lazy[ind << 1 | 1] = true;
    }
    if(l <= ll && r >= rr) return t[ind];
    if(ll > r || rr < l) return 0;
    return tquery(l, r, ll, (ll + rr) >> 1, ind << 1) + tquery(l, r, ((ll + rr) >> 1) + 1, rr, ind << 1 | 1);
}
*/
