#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <iostream>
#include <vector>
#include <set>

using namespace std;

using ll = long long;

void dfs(int v, int d, vector<vector<pair<int, int>>>& adj, vector<int>& dist)
{
    dist[v] = d;
    for (auto uw : adj[v]) dfs(uw.first, d + uw.second, adj, dist);
}

signed main()
{
    cin.tie(0)->sync_with_stdio(0);
    int n;
    cin >> n;
    vector<pair<int, int>> es(n + 1);
    for (int i = 1; i <= n; ++i) cin >> es[i].first;
    for (int i = 1; i <= n; ++i) cin >> es[i].second;
    vector<vector<pair<int, int>>> adj(n + 1);
    for (int i = 2; i <= n; ++i)
    {
        int p, w;
        cin >> p >> w;
        adj[p].emplace_back(i, w);
    }
    set<pair<int, int>> vertices;
    int delta = 0;
    vector<int> dist(n + 1);
    dfs(1, 0, adj, dist);
    for (int i = 1; i <= n; ++i) vertices.insert({ dist[i], i });
    int res = 0;
    for (int i = 1; i < n; ++i)
    {
        if (vertices.empty()) break;
        vertices.erase({ dist[i] + delta, i });
        auto it = vertices.rbegin();
        if (it->first + delta > 0)
        {
            res += it->first + delta;
            vertices.erase(--vertices.end());
        }
        delta -= adj[i][0].second;
    }
    cout << res;
    return 0;
}/*
 4
 1 1 1 1
 1 1 1 1
 1 1
 2 1
 3 1

 */