#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());

struct Treap;
using twoTreaps=array<Treap*,2>;

struct Treap
{
    int d;
    int news;
    int sum;
    int lazy;
    int sz;
    twoTreaps kids;
    int priority;
    Treap(int nd,int nnews){d=nd;news=sum=nnews;lazy=0;sz=1;kids={nullptr,nullptr};priority=gen();}
};

int sz(Treap *me){return (me?me->sz:0);}

void trecalc(Treap *me)
{
    if(!me) return;
    me->sum=(me->news);
    me->sz=1;
    for(Treap *to:me->kids)if(to){me->sum+=to->sum;me->sz+=to->sz;}
}

void tapply(Treap *me)
{
    if(!me) return;
    me->news=1;
    me->sum=me->sz;
    me->lazy=1;
}

void tpush(Treap *me)
{
    if(me&&me->lazy==1)
    {
        for(Treap *to:me->kids) tapply(to);
        me->lazy=0;
    }
}

twoTreaps tsplit(Treap *me,int lim) //<=lim | >lim
{
    if(!me) return {nullptr,nullptr};
    tpush(me);
    if(me->d<=lim)
    {
        twoTreaps res=tsplit(me->kids[1],lim);
        me->kids[1]=res[0];
        trecalc(me);
        return {me,res[1]};
    }
    else
    {
        twoTreaps res=tsplit(me->kids[0],lim);
        me->kids[0]=res[1];
        trecalc(me);
        return {res[0],me};
    }
}

Treap* tmerge(Treap *a,Treap *b)
{
    if(!a) return b;
    if(!b) return a;
    tpush(a);
    tpush(b);
    if(a->priority<b->priority)
    {
        a->kids[1]=tmerge(a->kids[1],b);
        trecalc(a);
        return a;
    }
    else
    {
        b->kids[0]=tmerge(a,b->kids[0]);
        trecalc(b);
        return b;
    }
}

void tupdate(Treap *me,int lim)
{
    auto [one,two]=tsplit(me,lim);
    tapply(one);
    tmerge(one,two);
}

int tquery(Treap *me,int lim)
{
    auto [one,two]=tsplit(me,lim);
    int r=(one?one->sum:0);
    tmerge(one,two);
    return r;
}

const int N=200005;
vector<Treap*> tree(4*N,nullptr);
//vector<int> lazy(4*N,-1);

void add(int idx,int l,int r,int pos,int d,int news)
{
    tree[idx]=tmerge(tree[idx],new Treap(d,news));
    if(l<r)
    {
        int m=(l+r)/2;
        if(pos<=m) add(2*idx,l,m,pos,d,news);
        else add(2*idx+1,m+1,r,pos,d,news);
    }
}

//void apply(int idx,int lim)
//{
//    tupdate(tree[idx],lim);
//    lazy[idx]=max(lazy[idx],lim);
//}
//
//void push(int idx)
//{
//    if(lazy[idx]!=-1)
//    {
//        for(int i=0;i<2;i++) apply(2*idx+i,lazy[idx]);
//        lazy[idx]=-1;
//    }
//}
//
//void update(int idx,int l,int r,int ql,int qr,int lim)
//{
//    if(ql>qr) return;
//    if(l==ql&&r==qr) apply(idx,lim);
//    else
//    {
//        int m=(l+r)/2;
//        push(idx);
//        update(2*idx,l,m,ql,min(qr,m)) //here
//    }
//}

int query(int idx,int l,int r,int ql,int qr,int lim)
{
    if(ql>qr) return 0;
    if(l==ql&&r==qr) return tquery(tree[idx],lim);
    int m=(l+r)/2;
    return (query(2*idx,l,m,ql,min(qr,m),lim)+query(2*idx+1,m+1,r,max(ql,m+1),qr,lim));
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> v[n+1];
    for(int i=1;i<=n-1;i++)
    {
        int x,y;
        cin >> x >> y;
        v[x].push_back(y);
    }
    vector<int> news(n+1,0);
    for(int i=1;i<=n;i++) cin >> news[i];
    vector<int> d(n+1,0);
    vector<int> tin(n+1,0);
    vector<int> tout(n+1,0);
    int tcnt=0;
    vector<array<int,3>> u;
    function<void(int)> dfs=[&](int a)
    {
        tin[a]=++tcnt;
        u.push_back({d[a],tin[a],news[a]});
        for(int to:v[a])
        {
            d[to]=d[a]+1;
            dfs(to);
        }
        tout[a]=tcnt;
    };
    dfs(1);
    sort(u.begin(),u.end());
    for(auto [depth,t,b]:u) add(1,1,n,t,depth,b);
    int q;
    cin >> q;
    while(q--)
    {
        int t,x,k;
        cin >> t >> x >> k;
        assert(t==2);
        cout << query(1,1,n,tin[x],tout[x],d[x]+k) << "\n";
    }
    return 0;
}
