#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int N=200005;
vector<int> news(N,0);
vector<int> tree(4*N,0);
vector<int> lazy(4*N,0);

void pull(int idx)
{
    tree[idx]=tree[2*idx]+tree[2*idx+1];
}

void apply(int idx,int l,int r)
{
    tree[idx]=(r-l+1);
    lazy[idx]=1;
}

void push(int idx,int l,int r,int m)
{
    if(lazy[idx]==1)
    {
        apply(2*idx,l,m);
        apply(2*idx+1,m+1,r);
    }
}

void build(int idx,int l,int r)
{
    if(l==r) tree[idx]=news[l];
    else
    {
        int m=(l+r)/2;
        build(2*idx,l,m);
        build(2*idx+1,m+1,r);
        pull(idx);
    }
}

void update(int idx,int l,int r,int ql,int qr)
{
    if(ql>qr) return;
    if(l==ql&&r==qr) apply(idx,l,r);
    else
    {
        int m=(l+r)/2;
        push(idx,l,r,m);
        update(2*idx,l,m,ql,min(qr,m));
        update(2*idx+1,m+1,r,max(ql,m+1),qr);
        pull(idx);
    }
}

int query(int idx,int l,int r,int ql,int qr)
{
    if(ql>qr) return 0;
    if(l==ql&&r==qr) return tree[idx];
    int m=(l+r)/2;
    push(idx,l,r,m);
    return (query(2*idx,l,m,ql,min(qr,m))+query(2*idx+1,m+1,r,max(ql,m+1),qr));
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> v[n+1];
    for(int i=1;i<=n-1;i++)
    {
        int x,y;
        cin >> x >> y;
        v[x].push_back(y);
    }
    for(int i=1;i<=n;i++) cin >> news[i];
    vector<int> d(n+1,0);
    vector<int> tin(n+1,0);
    vector<int> tout(n+1,0);
    int tcnt=0;
    function<void(int)> dfs=[&](int a)
    {
        tin[a]=++tcnt;
        for(int to:v[a])
        {
            d[to]=d[a]+1;
            dfs(to);
        }
        tout[a]=tcnt;
    };
    dfs(1);
    build(1,1,n);
    int q;
    cin >> q;
    while(q--)
    {
        int t,x,k;
        cin >> t >> x >> k;
        assert(k==n);
        if(t==1) update(1,1,n,tin[x],tout[x]);
        else cout << query(1,1,n,tin[x],tout[x]) << "\n";
    }
    return 0;
}
