#include <bits/stdc++.h>
#pragma GCC optimize ("Ofast")

using namespace std;
typedef long long ll;

struct ST
{
    int n;
    vector<int> tree;
    vector<int> lazy;
    vector<int> news;
    void ini(vector<int> tnews)
    {
        n=int(tnews.size())-1;
        tree.assign(4*(n+5),0);
        lazy.assign(4*(n+5),0);
        news=tnews;
        build(1,1,n);
    }
    void pull(int idx){tree[idx]=tree[2*idx]+tree[2*idx+1];}
    void apply(int idx,int l,int r)
    {
        tree[idx]=(r-l+1);
        lazy[idx]=1;
    }
    void push(int idx,int l,int r,int m)
    {
        if(lazy[idx]==1)
        {
            apply(2*idx,l,m);
            apply(2*idx+1,m+1,r);
        }
    }
    void build(int idx,int l,int r)
    {
        if(l==r) tree[idx]=news[l];
        else
        {
            int m=(l+r)/2;
            build(2*idx,l,m);
            build(2*idx+1,m+1,r);
            pull(idx);
        }
    }
    void update(int idx,int l,int r,int ql,int qr)
    {
        if(ql>qr) return;
        if(l==ql&&r==qr) apply(idx,l,r);
        else
        {
            int m=(l+r)/2;
            push(idx,l,r,m);
            update(2*idx,l,m,ql,min(qr,m));
            update(2*idx+1,m+1,r,max(ql,m+1),qr);
            pull(idx);
        }
    }
    void upd(int ql,int qr){update(1,1,n,ql,qr);}
    int query(int idx,int l,int r,int ql,int qr)
    {
        if(ql>qr) return 0;
        if(l==ql&&r==qr) return tree[idx];
        int m=(l+r)/2;
        push(idx,l,r,m);
        return (query(2*idx,l,m,ql,min(qr,m))+query(2*idx+1,m+1,r,max(ql,m+1),qr));
    }
    int qry(int ql,int qr){return query(1,1,n,ql,qr);}
};

const int S=223;

struct obj
{
    ST st;
    int n;
    int shift;
    vector<int> pos;
    vector<int> d;
    vector<array<int,3>> u;
    obj(vector<array<int,3>> tu) //d,tin,news
    {
        u=tu;
        n=u.size();
        shift=u[0][1]-1;
        d.assign(n+1,0);
        for(int i=0;i<n;i++) d[i+1]=u[i][0];
        sort(u.begin(),u.end());
        pos.assign(n+1,0);
        vector<int> tnews(n+1,0);
        for(int i=0;i<n;i++)
        {
            pos[u[i][1]-shift]=i+1;
            tnews[i+1]=u[i][2];
        }
        st.ini(tnews);
    }
    void upd_whole(int lim)
    {
        int p=lower_bound(u.begin(),u.end(),array<int,3>{lim+1,0,0})-u.begin();
        st.upd(1,p);
    }
    void upd_part(int l,int r,int lim)
    {
        for(int i=1;i<=n;i++) if(l<=i+shift&&i+shift<=r&&d[i]<=lim) st.upd(pos[i],pos[i]);
    }
    int qry_whole(int lim)
    {
        int p=lower_bound(u.begin(),u.end(),array<int,3>{lim+1,0,0})-u.begin();
        return st.qry(1,p);
    }
    int qry_part(int l,int r,int lim) //can be improved
    {
        int res=0;
        for(int i=1;i<=n;i++) if(l<=i+shift&&i+shift<=r&&d[i]<=lim) res+=st.qry(pos[i],pos[i]);
        return res;
    }
};

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> v[n+1];
    for(int i=1;i<=n-1;i++)
    {
        int x,y;
        cin >> x >> y;
        v[x].push_back(y);
    }
    vector<int> tnews(n+1,0);
    for(int i=1;i<=n;i++) cin >> tnews[i];
    vector<int> d(n+1,0);
    vector<int> tin(n+1,0);
    vector<int> tout(n+1,0);
    int tcnt=0;
    vector<int> h(n+1,0);
    function<void(int)> dfs=[&](int a)
    {
        tin[a]=++tcnt;
        h[tin[a]]=a;
        for(int to:v[a])
        {
            d[to]=d[a]+1;
            dfs(to);
        }
        tout[a]=tcnt;
    };
    dfs(1);
    vector<obj> buckets;
    for(int i=1;i<=n;i+=S)
    {
        vector<array<int,3>> u;
        for(int j=i;j<=min(i+S-1,n);j++) u.push_back({d[h[j]],j,tnews[h[j]]});
        buckets.push_back(obj(u));
    }
    auto intersect=[&](int a,int b,int e,int f)->array<int,2>{return {max(a,e),min(b,f)};};
    int q;
    cin >> q;
    while(q--)
    {
        int t,x,k;
        cin >> t >> x >> k;
        int ql=tin[x];
        int qr=tout[x];
        int lim=d[x]+k;
        if(t==1)
        {
            int id=0;
            for(int l=1;l<=n;l+=S)
            {
                int r=min(l+S-1,n);
                if(ql<=l&&r<=qr) buckets[id].upd_whole(lim);
                else
                {
                    auto [e,f]=intersect(l,r,ql,qr);
                    if(e<=f) buckets[id].upd_part(e,f,lim);
                }
                id++;
            }
        }
        else
        {
            int res=0;
            int id=0;
            for(int l=1;l<=n;l+=S)
            {
                int r=min(l+S-1,n);
                if(ql<=l&&r<=qr) res+=buckets[id].qry_whole(lim);
                else
                {
                    auto [e,f]=intersect(l,r,ql,qr);
                    if(e<=f) res+=buckets[id].qry_part(e,f,lim);
                }
                id++;
            }
            cout << res << "\n";
        }
    }
    return 0;
}
