#include <bits/stdc++.h>

using namespace std;
#define dbg(x) cerr << #x << " " << x << "\n"
const int RAD = 500;
const int MAX_N = 2e5;

vector <int> gr[1 + MAX_N];
vector <int> new_tree[1 + MAX_N];
int B[1 + MAX_N];
int type[1 + MAX_N], X[1 + MAX_N], K[1 + MAX_N];
int N;
int level[1 + MAX_N];
/// we will have partial sums for the vectors
struct node_info {
    vector <int> bsums; /// how many know for each important level (NR_MAX = RAD)
    vector <int> szlevel;
    int full; /// if an operation made everybody know the news to a certain level
};
map <int, int> imp_levels;
int norm_level[1 + MAX_N];
bool important[1 + MAX_N];
int tag;
node_info nodes[1 + MAX_N];
/// TODO: clean nodes => done
void compress_tree(int node, int par, int last_imp) {
    nodes[last_imp].bsums[norm_level[level[node]]] += B[node];
    nodes[last_imp].szlevel[norm_level[level[node]]]++;
    for (int &son : gr[node])
        if (son != par) {
            if (important[son]) {
                new_tree[last_imp].push_back(son);
                compress_tree(son, node, son);
            }
            else {
                compress_tree(son, node, last_imp);
            }
        }
}
inline void decompress_tree(int node, int par, int last_imp) {
    if (nodes[last_imp].full >= level[node])
        B[node] = 1;
    for (int &son : gr[node])
        if (son != par) {
            if (important[son])
                decompress_tree(son, node, son);
            else
                decompress_tree(son, node, last_imp);
        }
}
inline void clean() {
    imp_levels.clear();
    for (int i = 1; i <= N; i++) {
        if (important[i]) {
            nodes[i].szlevel.clear();
            nodes[i].bsums.clear();
            nodes[i].full = 0;
            important[i] = false;
        }
        norm_level[i] = 0;
    }
}

inline void update(int node, int K_left) {
    nodes[node].full = max(nodes[node].full, min(N, level[node] + K_left));
    for (int &son : new_tree[node]) {
        register int new_K = K_left - (level[son] - level[node]);
        if (new_K >= 0)
            update(son, new_K);
    }
}
int ans;
inline void query(int node, int K_left) {
    register int to = norm_level[min(level[node] + K_left, nodes[node].full)];
    ans += nodes[node].szlevel[to] + nodes[node].bsums[norm_level[min(N, K_left + level[node])]] - nodes[node].bsums[to];
    for (int &son : new_tree[node]) {
        register int new_K = K_left - (level[son] - level[node]);
        if (new_K >= 0)
            query(son, new_K);
    }
}
void solve_bucket(int l, int r) {
    /// find important levels in O(RAD*logRAD+N)
    imp_levels[1];
    imp_levels[N];
    for (int i = l; i <= r; i++) {
        imp_levels[level[X[i]]];
        important[X[i]] = true;
        if (level[X[i]] + K[i] + 1 <= N)
            imp_levels[level[X[i]] + K[i] + 1];
    }
    tag = 0;
    for (auto &it : imp_levels) {
        it.second = ++tag;
        norm_level[it.first] = tag;
    }
    for (register int i = 1; i <= N; i++)
        if (norm_level[i] == 0)
            norm_level[i] = norm_level[i - 1];

    for (register int i = 1; i <= N; i++)
        if (important[i]) {
            nodes[i].bsums.resize(1 + tag);  /// O(RAD*RAD)
            nodes[i].szlevel.resize(1 + tag);
        }

    compress_tree(1, 0, 1); /// O(N)

    for (int i = 1; i <= N; i++)
        if (important[i]) {
            for (int j = 1; j <= tag; j++) {
                nodes[i].bsums[j] += nodes[i].bsums[j - 1];
                nodes[i].szlevel[j] += nodes[i].szlevel[j - 1];
            }
        }

    /// solve_query

    for (register int i = l; i <= r; i++) {
        if (type[i] == 1) {
            update(X[i], K[i]); /// O(RAD)
        }
        else {
            ans = 0;
            query(X[i], K[i]); /// O(RAD)
            cout << ans << "\n";
        }
    }

    decompress_tree(1, 0, 1); /// O(N)
    clean(); /// O(N)
}

inline void precalc(int node, int par) {
    level[node] = level[par] + 1;
    for (int &son : gr[node])
        if (son != par) {
            precalc(son, node);
        }
}

int main() {
  //  freopen("news.in", "r", stdin);
 //   freopen("news.out", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> N;
    for (int i = 1; i < N; i++) {
        int x, y;
        cin >> x >> y;
        gr[x].push_back(y);
        gr[y].push_back(x);
    }
    for (int i = 1; i <= N; i++)
        cin >> B[i];
    precalc(1, 0);
    register int Q;
    cin >> Q;
    for (register int i = 1; i <= Q; i++)
        cin >> type[i] >> X[i] >> K[i];
    for (register int i = 1; i <= Q; i += RAD)
        solve_bucket(i, min(Q, i + RAD - 1));
    return 0;
}
