#include <bits/stdc++.h>
using namespace std;
#define dbg(x) cerr << #x << " " << x << "\n"
const int RAD = 1000;
const int MAX_N = 2e5;
vector <int> gr[1 + MAX_N];
vector <int> new_tree[1 + MAX_N];
int B[1 + MAX_N];
int type[1 + MAX_N], X[1 + MAX_N], K[1 + MAX_N];
int N;
int level[1 + MAX_N];
/// we will have partial sums for the vectors
int full[1 + MAX_N];
int bsums[1 + MAX_N][1 + RAD];
int levelsz[1 + MAX_N][1 + RAD];
int norm_level[1 + MAX_N];
bool important[1 + MAX_N];
int tag;
/// TODO: clean nodes => done
inline void compress_tree(int node, int par, int last_imp) {
    bsums[last_imp][norm_level[level[node]]] += B[node];
    levelsz[last_imp][norm_level[level[node]]]++;
    for (int &son : gr[node])
        if (son != par) {
            if (important[son]) {
                new_tree[last_imp].push_back(son);
                compress_tree(son, node, son);
            }
            else {
                compress_tree(son, node, last_imp);
            }
        }
}
inline void decompress_tree(int node, int par, int last_imp) {
    if (full[last_imp] >= level[node])
        B[node] = 1;
    for (int &son : gr[node])
        if (son != par) {
            if (important[son])
                decompress_tree(son, node, son);
            else
                decompress_tree(son, node, last_imp);
        }
}
inline void clean() {
    for (register int i = 1; i <= N; i++) {
        if (important[i]) {
            new_tree[i].clear();
            important[i] = false;
            full[i] = 0;
        }
        norm_level[i] = 0;
    }
}
inline void update(int node, int K_left) {
    full[node] = max(full[node], min(N, level[node] + K_left));
    for (int &son : new_tree[node]) {
        int new_K = K_left - (level[son] - level[node]);
        if (new_K >= 0)
            update(son, new_K);
    }
}
int ans;
int new_K, to;
inline void query(int node, int K_left) {
    to = norm_level[min(level[node] + K_left, full[node])];
    ans += levelsz[node][to] + bsums[node][norm_level[min(N, K_left + level[node])]] - bsums[node][to];
    for (int &son : new_tree[node]) {
        new_K = K_left - (level[son] - level[node]);
        if (new_K >= 0)
            query(son, new_K);
    }
}
inline void solve_bucket(int l, int r) {
    /// find important levels in O(Q*logRAD)
    vector <int> imp_levels;
    imp_levels.push_back(1);
    important[1] = true;
    for (register int i = l; i <= r; i++) {
        imp_levels.push_back(level[X[i]]);
        important[X[i]] = true;
        if (level[X[i]] + K[i] + 1 <= N)
            imp_levels.push_back(level[X[i]] + K[i] + 1);
    }
    sort(imp_levels.begin(), imp_levels.end());
    tag = 0;
    for (register int i = 0; i < imp_levels.size(); i++) {
        if (i == 0 || imp_levels[i] != imp_levels[i - 1])
            tag++;
        norm_level[imp_levels[i]] = tag;
    }
    for (register int i = 1; i <= N; i++) /// O (Q * Q / RAD)
        if (norm_level[i] == 0)
            norm_level[i] = norm_level[i - 1];
    compress_tree(1, 0, 1); /// O(Q * Q / RAD)
    for (register int i = 1; i <= N; i++)
        if (important[i]) {
            for (int j = norm_level[level[i]]; j <= tag; j++) {
                bsums[i][j] += bsums[i][j - 1]; /// O(Q * RAD)
                levelsz[i][j] += levelsz[i][j - 1];
            }
        }
    /// solve_query
    for (int i = l; i <= r; i++) {
        if (type[i] == 1) {
            update(X[i], K[i]); /// O(RAD)
        }
        else {
            ans = 0;
            query(X[i], K[i]); /// O(RAD)
            cout << ans << "\n";
        }
    }
    decompress_tree(1, 0, 1); /// O(N * 100)

    for (register int i = 1; i <= N; i++)
        if (important[i]) {
            for (int j = norm_level[level[i]]; j <= tag; j++)
                bsums[i][j] = levelsz[i][j] = 0;
        }
    clean(); /// O(N * 100)
}
void precalc(int node, int par) {
    level[node] = level[par] + 1;
    for (int son : gr[node])
        if (son != par) {
            precalc(son, node);
        }
}
int main() {
    freopen("news.in", "r", stdin);
    freopen("news.out", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> N;
    for (int i = 1; i < N; i++) {
        int x, y;
        cin >> x >> y;
        gr[x].push_back(y);
        gr[y].push_back(x);
    }
    for (int i = 1; i <= N; i++)
        cin >> B[i];
    precalc(1, 0);
    int Q;
    cin >> Q;
    for (int i = 1; i <= Q; i++)
        cin >> type[i] >> X[i] >> K[i];
    for (int i = 1; i <= Q; i += RAD)
        solve_bucket(i, min(Q, i + RAD - 1));
    return 0;
}
