#include <bits/stdc++.h>

using namespace std;

const int N = 2e5+7;
const int S = 20 * N;

int n, was_deleted[N], fnw[S], tin[N], tout[N], h[N], gt;
int ord[S], ptr, sgt_l[2*N], sgt_r[2*N], fst_nd[2*N];
vector<int> g[N], where[N];

void fnw_inc(int i) {
    for (; i < S; i |= i + 1) fnw[i]++;
}

int fnw_sum(int i) {
    int ans = 0;
    for (; i >= 0; i = (i&i+1)-1) ans += fnw[i];
    return ans;
}

void build_sgt_accurate() {
    int l = n, r = 2*n-1;

    vector<int> good_vrtx;

    for (int i = n; i--; ) good_vrtx.push_back(i+n);

    while (l <= r) {
        l = (l + 1) / 2, r = (r - 1) / 2;
        for (int v = l; v <= r; ++v) {
            sgt_l[v] = ptr;
            fst_nd[v] = sgt_l[v];
            ptr += sgt_r[2*v] + sgt_r[2*v+1] - sgt_l[2*v] - sgt_l[2*v+1];
            sgt_r[v] = ptr;

            merge(ord+sgt_l[2*v], ord+sgt_r[2*v], ord+sgt_l[2*v+1], ord+sgt_r[2*v+1],
                ord+sgt_l[v], [&] (int l, int r) { return h[l] != h[r] ? h[l] < h[r] : l < r; });

            good_vrtx.push_back(v);
        }
    }

/*
    sort(good_vrtx.begin(), good_vrtx.end());
    for (int v : good_vrtx) {
        cout << v << " - " << sgt_l[v] << ":" << sgt_r[v] << " ->";
        for (int i = sgt_l[v]; i < sgt_r[v]; ++i) cout << ' ' << ord[i];
        cout << endl;
    }
*/

    for (int i = 0; i < ptr; ++i) where[ord[i]].push_back(i);
}

void dfs(int v) {
    tin[v] = gt++;
    for (int to : g[v]) {
        h[to] = h[v]+1;
        dfs(to);
    }
    tout[v] = gt;
}

void delete_vertex(int v) {
    if (was_deleted[v]) return;

    // cout << "Delete vertex v=" << v << endl;
    was_deleted[v] = true;
    for (int j : where[v]) fnw_inc(j);
}

void delete_prefix(int v, int maxh) {
    int& i = fst_nd[v];
    while (i < sgt_r[v]) {
        const int u = ord[i];
        if (h[u] > maxh) break;
        delete_vertex(u); ++i;
    }
}

int get_sum(int v, int maxh) {
    h[n] = maxh;

    int j = upper_bound(ord+sgt_l[v], ord+sgt_r[v], n, [&] (int l, int r) { return h[l] < h[r]; }) - ord;
    // cout << v << ":" << maxh << " --> [" << sgt_l[v] << ", " << j << ")" << endl;
    return fnw_sum(j-1) - fnw_sum(sgt_l[v]-1);
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    cin >> n;

    for (int i = 1; i < n; ++i) {
        int x, y; cin >> x >> y;
        g[x-1].push_back(y-1);
    }

    dfs(0);

    for (int i = 0; i < n; ++i) {
        cin >> was_deleted[i];

        sgt_l[tin[i]+n] = ptr;
        fst_nd[tin[i]+n] = ptr;
        ord[ptr++] = i;
        sgt_r[tin[i]+n] = ptr;
    }

    build_sgt_accurate();

    for (int i = 0; i < n; ++i) {
        if (!was_deleted[i]) continue;
        was_deleted[i] = false;
        delete_vertex(i);
    }

    int q; cin >> q;
    while (q--) {
        int t, v, k; cin >> t >> v >> k; --v;

        // cout << " ? " << t << " " << v << " " << k << endl;

        if (t == 1) {
            for (int l = n+tin[v], r = n+tout[v]-1; l <= r; l >>= 1, r >>= 1) {
                if ((l&1) == 1) delete_prefix(l++, h[v] + k);
                if ((r&1) == 0) delete_prefix(r--, h[v] + k);
            }
        } else {
            int ans = 0;
            for (int l = n+tin[v], r = n+tout[v]-1; l <= r; l >>= 1, r >>= 1) {
                if ((l&1) == 1) ans += get_sum(l++, h[v] + k);
                if ((r&1) == 0) ans += get_sum(r--, h[v] + k);
            }
            cout << ans << '\n';
        }
    }
}