#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N_MAX = 500000;

const ll INF = LLONG_MAX / 2;

int N;

int init[N_MAX + 2];
int maxEnd[N_MAX + 2];

int parent[N_MAX + 2];
int score[N_MAX + 2];

vector <int> sons[N_MAX + 2];

int sub[N_MAX + 2];

void dfs (int u) {
    sub[u] = maxEnd[u];
    for (int v : sons[u]) {
        score[v] += score[u];
        dfs(v);
        sub[u] += sub[v];
    }
}

ll answer = 0;

void solve (int u, map <int, int> &offers) {
    int heavy = -1;
    for (int v : sons[u]) {
        if (heavy == -1 || sub[v] > sub[heavy]) {
            heavy = v;
        }
    }
    if (heavy != -1) {
        solve(heavy, offers);
    }
    for (int v : sons[u]) {
        if (v != heavy) {
            map <int, int> sonOffers;
            solve(v, sonOffers);
            for (pair <int, int> p : sonOffers) {
                offers[p.first] += p.second;
            }
        }
    }
    while (init[u] > 0 && offers.empty() == false) {
        map <int, int> :: iterator it = prev(offers.end());
        if (it->first - score[u] <= 0) {
            break;
        }
        int cnt = min(init[u], it->second);
        answer += (ll) (it->first - score[u]) * cnt;
        offers[score[u]] += cnt;
        init[u] -= cnt;
        if (cnt == it->second) {
            offers.erase(it);
        } else {
            it->second -= cnt;
        }
    }
    if (maxEnd[u] > 0) {
        offers[score[u]] += maxEnd[u];
    }
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> N;
    for (int u = 1; u <= N; u++) {
        cin >> init[u];
    }
    for (int u = 1; u <= N; u++) {
        cin >> maxEnd[u];
    }
    for (int u = 2; u <= N; u++) {
        cin >> parent[u] >> score[u];
        sons[parent[u]].push_back(u);
    }

    dfs(1);
    map <int, int> offers;
    solve(1, offers);

    cout << answer << "\n";

    return 0;
}
