#include <bits/stdc++.h>

using namespace std;

const int N_MAX = 200000;
const int Q_MAX = 200000;

int N;

vector <int> adj[N_MAX + 2];
int parent[N_MAX + 2];

int level[N_MAX + 2];

int L[N_MAX + 2], R[N_MAX + 2];
int euler[N_MAX + 2];
int currLabel;

void dfs (int u) {
    L[u] = ++currLabel;
    R[u] = L[u];
    for (int v : adj[u]) {
        if (v != parent[u]) {
            level[v] = level[u] + 1;
            parent[v] = u;
            dfs(v);
            R[u] = R[v];
        }
    }
    euler[L[u]] = u;
}

int knows[N_MAX + 2];

struct Query {
    int type;
    int u, k;
};

int Q;

Query queries[Q_MAX + 2];

int SGT[N_MAX * 4 + 2];

int join (int a, int b) {
    if (a == -1) {
        return b;
    }
    if (b == -1) {
        return a;
    }
    return (level[a] < level[b] ? a : b);
}

void buildSGT (int node, int l, int r) {
    if (l == r) {
        if (knows[l] == false) {
            SGT[node] = euler[l];
        } else {
            SGT[node] = -1;
        }
        return;
    }

    int mid = (l + r) / 2;
    int lSon = node * 2, rSon = node * 2 + 1;
    buildSGT(lSon, l, mid);
    buildSGT(rSon, mid + 1, r);

    SGT[node] = join(SGT[lSon], SGT[rSon]);
}
void buildSGT () {
    buildSGT(1, 1, N);
}

void updateSGT (int node, int l, int r, int upos) {
    if (l == r) {
        SGT[node] = -1;
        return;
    }

    int mid = (l + r) / 2;
    int lSon = node * 2, rSon = node * 2 + 1;
    if (upos <= mid) {
        updateSGT(lSon, l, mid, upos);
    } else {
        updateSGT(rSon, mid + 1, r, upos);
    }

    SGT[node] = join(SGT[lSon], SGT[rSon]);
}
void updateSGT (int upos) {
    updateSGT(1, 1, N, upos);
}

int querySGT (int node, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return SGT[node];
    }

    int mid = (l + r) / 2;
    int lSon = node * 2, rSon = node * 2 + 1;
    if (ql <= mid && mid + 1 <= qr) {
        return join(querySGT(lSon, l, mid, ql, qr), querySGT(rSon, mid + 1, r, ql, qr));
    } else if (ql <= mid) {
        return querySGT(lSon, l, mid, ql, qr);
    } else {
        return querySGT(rSon, mid + 1, r, ql, qr);
    }
}
int querySGT (int ql, int qr) {
    return querySGT(1, 1, N, ql, qr);
}

map <pair <int, int>, int> Fen;

void updateFen (int x, int y) {
    for (int i = x; i <= N; i += i & -i) {
        for (int j = y; j <= N; j += j & -j) {
            Fen[{i, j}]++;
        }
    }
}

int queryFen (int x, int y) {
    int sum = 0;
    for (int i = x; i >= 1; i -= i & -i) {
        for (int j = y; j >= 1; j -= j & -j) {
            sum += Fen[{i, j}];
        }
    }
    return sum;
}
int queryFen (int xl, int xr, int y) {
    return queryFen(xr, y) - queryFen(xl - 1, y);
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> N;
    for (int i = 1; i <= N - 1; i++) {
        int u, v;
        cin >> u >> v;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }
    for (int u = 1; u <= N; u++) {
        cin >> knows[u];
    }
    cin >> Q;
    for (int i = 1; i <= Q; i++) {
        cin >> queries[i].type >> queries[i].u >> queries[i].k;
    }

    level[1] = 1;
    dfs(1);

    buildSGT();
    for (int u = 1; u <= N; u++) {
        if (knows[u] == true) {
            updateFen(L[u], level[u]);
        }
    }

    for (int i = 1; i <= Q; i++) {
        int u = queries[i].u;
        int maxLevel = level[u] + queries[i].k;
        if (queries[i].type == 1) {
            while (true) {
                int v = querySGT(L[u], R[u]);
                if (v == -1 || level[v] > maxLevel) {
                    break;
                }
                updateSGT(L[v]);
                updateFen(L[v], level[v]);
            }
        } else {
            cout << queryFen(L[u], R[u], maxLevel) << "\n";
        }
    }

    return 0;
}
#include <bits/stdc++.h>

using namespace std;

const int N_MAX = 200000;
const int Q_MAX = 200000;

int N;

vector <int> adj[N_MAX + 2];
int parent[N_MAX + 2];

int level[N_MAX + 2];

int L[N_MAX + 2], R[N_MAX + 2];
int euler[N_MAX + 2];
int currLabel;

void dfs (int u) {
    L[u] = ++currLabel;
    R[u] = L[u];
    for (int v : adj[u]) {
        if (v != parent[u]) {
            level[v] = level[u] + 1;
            parent[v] = u;
            dfs(v);
            R[u] = R[v];
        }
    }
    euler[L[u]] = u;
}

int knows[N_MAX + 2];

struct Query {
    int type;
    int u, k;
};

int Q;

Query queries[Q_MAX + 2];

int SGT[N_MAX * 4 + 2];

int join (int a, int b) {
    if (a == -1) {
        return b;
    }
    if (b == -1) {
        return a;
    }
    return (level[a] < level[b] ? a : b);
}

void buildSGT (int node, int l, int r) {
    if (l == r) {
        if (knows[l] == false) {
            SGT[node] = euler[l];
        } else {
            SGT[node] = -1;
        }
        return;
    }

    int mid = (l + r) / 2;
    int lSon = node * 2, rSon = node * 2 + 1;
    buildSGT(lSon, l, mid);
    buildSGT(rSon, mid + 1, r);

    SGT[node] = join(SGT[lSon], SGT[rSon]);
}
void buildSGT () {
    buildSGT(1, 1, N);
}

void updateSGT (int node, int l, int r, int upos) {
    if (l == r) {
        SGT[node] = -1;
        return;
    }

    int mid = (l + r) / 2;
    int lSon = node * 2, rSon = node * 2 + 1;
    if (upos <= mid) {
        updateSGT(lSon, l, mid, upos);
    } else {
        updateSGT(rSon, mid + 1, r, upos);
    }

    SGT[node] = join(SGT[lSon], SGT[rSon]);
}
void updateSGT (int upos) {
    updateSGT(1, 1, N, upos);
}

int querySGT (int node, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return SGT[node];
    }

    int mid = (l + r) / 2;
    int lSon = node * 2, rSon = node * 2 + 1;
    if (ql <= mid && mid + 1 <= qr) {
        return join(querySGT(lSon, l, mid, ql, qr), querySGT(rSon, mid + 1, r, ql, qr));
    } else if (ql <= mid) {
        return querySGT(lSon, l, mid, ql, qr);
    } else {
        return querySGT(rSon, mid + 1, r, ql, qr);
    }
}
int querySGT (int ql, int qr) {
    return querySGT(1, 1, N, ql, qr);
}

map <pair <int, int>, int> Fen;

void updateFen (int x, int y) {
    for (int i = x; i <= N; i += i & -i) {
        for (int j = y; j <= N; j += j & -j) {
            Fen[{i, j}]++;
        }
    }
}

int queryFen (int x, int y) {
    int sum = 0;
    for (int i = x; i >= 1; i -= i & -i) {
        for (int j = y; j >= 1; j -= j & -j) {
            sum += Fen[{i, j}];
        }
    }
    return sum;
}
int queryFen (int xl, int xr, int y) {
    return queryFen(xr, y) - queryFen(xl - 1, y);
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> N;
    for (int i = 1; i <= N - 1; i++) {
        int u, v;
        cin >> u >> v;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }
    for (int u = 1; u <= N; u++) {
        cin >> knows[u];
    }
    cin >> Q;
    for (int i = 1; i <= Q; i++) {
        cin >> queries[i].type >> queries[i].u >> queries[i].k;
    }

    level[1] = 1;
    dfs(1);

    buildSGT();
    for (int u = 1; u <= N; u++) {
        if (knows[u] == true) {
            updateFen(L[u], level[u]);
        }
    }

    for (int i = 1; i <= Q; i++) {
        int u = queries[i].u;
        int maxLevel = level[u] + queries[i].k;
        if (queries[i].type == 1) {
            while (true) {
                int v = querySGT(L[u], R[u]);
                if (v == -1 || level[v] > maxLevel) {
                    break;
                }
                updateSGT(L[v]);
                updateFen(L[v], level[v]);
            }
        } else {
            cout << queryFen(L[u], R[u], maxLevel) << "\n";
        }
    }

    return 0;
}
