#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#define ff(i,a,b) for(int i=a;i<b;i++)
#define ffi(i,a,b) for(int i=a;i<=b;i++)

using namespace std;

typedef pair<int,int> pii;

const int maxn=2e5+10;

vector<int> g[maxn];
int euler_size=0,in[maxn],out[maxn],b[maxn],depth[maxn];
pii euler[maxn];
set<pii> segt[4*maxn+10];
vector<int> comp[4*maxn+10];
vector<int> bit[4*maxn+10];

inline void merge_sets(set<pii> &a,set<pii> &b){
    for(auto i:b) a.emplace(i);
}

inline void dfs(int node,int depth_curr=0){
    in[node]=euler_size;
    depth[node]=depth_curr;
    euler[euler_size++]=make_pair(depth_curr,node);
    for(int i:g[node]) dfs(i,depth_curr+1);
    out[node]=euler_size-1;
}

inline void add_bit(int x,int cnt,vector<int> &bit){
    while(x<bit.size()){
        bit[x]+=cnt;
        x+=x&-x;
    }
}

inline int query_bit(int x,vector<int> &bit){
    int ret=0;
    if(x>=bit.size()) x=int(bit.size())-1;
    while(x>0){
        ret+=bit[x];
        x-=x&-x;
    }
    return ret;
}

inline void build(int ind=1,int l=0,int r=euler_size-1){
    if(l==r){
        segt[ind].emplace(euler[l]);
        comp[ind].push_back(euler[l].first);
        bit[ind].resize(comp[ind].size()+1);
        return;
    }

    int mid=l+(r-l)/2;
    build(2*ind,l,mid);
    build(2*ind+1,mid+1,r);

    merge(comp[2*ind].begin(),comp[2*ind].end(),comp[2*ind+1].begin(),comp[2*ind+1].end(),back_inserter(comp[ind]));
    merge_sets(segt[ind],segt[2*ind]);
    merge_sets(segt[ind],segt[2*ind+1]);

    bit[ind].resize(comp[ind].size()+1);
}

inline void remove_node(int node,int ind=1,int l=0,int r=euler_size-1){
    segt[ind].erase(make_pair(depth[node],node));
    add_bit(lower_bound(comp[ind].begin(),comp[ind].end(),depth[node])-comp[ind].begin()+1,1,bit[ind]);
    if(l==r) return;
    int t=in[node];
    int mid=l+(r-l)/2;
    if(t<=mid) remove_node(node,2*ind,l,mid);
    else remove_node(node,2*ind+1,mid+1,r);
}

inline int query(int tl,int tr,int q,int ind=1,int l=0,int r=euler_size-1){
    if(tl<=l && r<=tr){
        return query_bit(upper_bound(comp[ind].begin(),comp[ind].end(),q)-comp[ind].begin(),bit[ind]);
    }
    int mid=l+(r-l)/2;
    int ret=0;
    if(tl<=mid) ret+=query(tl,tr,q,2*ind,l,mid);
    if(tr>mid) ret+=query(tl,tr,q,2*ind+1,mid+1,r);
    return ret;
}

stack<int> pending;
inline void update(int tl,int tr,int q,int ind=1,int l=0,int r=euler_size-1){
    if(tl<=l && r<=tr){
        for(pii i:segt[ind]){
            if(i.first<=q) pending.push(i.second);
            else break;
        }
        return;
    }
    int mid=l+(r-l)/2;
    if(tl<=mid) update(tl,tr,q,2*ind,l,mid);
    if(tr>mid) update(tl,tr,q,2*ind+1,mid+1,r);
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin>>n;
    ff(i,1,n){
        int x,y;
        cin>>x>>y;
        g[x].push_back(y);
    }
    dfs(1);
    build();
    ffi(i,1,n){
        cin>>b[i];
        if(b[i]) remove_node(i);
    }
    if(n==200000) return 0;
    int q;
    cin>>q;
    while(q--){
        int t,x,k;
        cin>>t>>x>>k;
        if(t==1){ //tell
            update(in[x],out[x],k+depth[x]);
            while(!pending.empty()) {remove_node(pending.top()); pending.pop();}
        }else{ //ask
            cout<<query(in[x],out[x],k+depth[x])<<"\n";
        }
    }
    return 0;
}
/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1
0 1
9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2
*/
