#include <cmath>
#include <iostream>
#include <vector>
#include <utility>
#include <stack>
#include <queue>
#include <algorithm>

using namespace std;

typedef long long ll;

vector <ll> s;
vector <ll> e;
vector <vector <pair<ll, ll> > > adjl(500000);

ll rjesenje = 0;

vector <pair<ll,ll> > dfs(ll u, ll p){
     
    vector < pair<ll,ll> > tren;
    
    for (int i = 0; i < adjl[u].size(); i++){
        
        ll v = adjl[u][i].first;
        if (v == p)
            continue;;
        
        vector <pair<ll, ll>> temp = dfs(v, u);
        
        ll si = temp.size(), brojac = 0;
        while (brojac < si){
            
            tren.push_back(make_pair(temp[brojac].first + adjl[u][i].second, temp[brojac].second));
            brojac++;
            
        }
        
    }
    
    sort(tren.begin(), tren.end());
    
    ll kraj = tren.size() - 1;
    
    vector <pair<ll,ll>> toss;
    
    while(kraj >= 0 && tren[kraj].first > 0 && s[u] > 0){
        
        if (s[u] >= tren[kraj].second)
            rjesenje += tren[kraj].first * tren[kraj].second, s[u] -= tren[kraj].second, toss.push_back(make_pair(0, tren[kraj].second)), kraj--, tren.pop_back();
        else
            rjesenje += tren[kraj].first * s[u], tren[kraj].second -= s[u], toss.push_back(make_pair(0, s[u])), s[u] = 0;
        
    }
    
    for (int i = 0; i < toss.size(); i++)
        tren.push_back(toss[i]);
    
    tren.push_back(make_pair(0, e[u]));
    
    //cout << rjesenje << " ";
    
    return tren;
    
}

int main(){
    
    int n;
    cin >> n;
    
    s.resize(n), e.resize(n);
    
    for (int i = 0; i < n; i++)
        cin >> s[i];
    for (int i = 0; i < n; i++)
        cin >> e[i];
    
    for (int i = 0; i < n - 1; i++){
        
        int u, w;
        cin >> u >> w;
        u--;
        adjl[u].push_back(make_pair(i+1,w)), adjl[i+1].push_back(make_pair(u,w));
        
    }
    
    //vector <pair<ll,ll> > tete = dfs(0, -1);
    
    vector <ll> wei(n-1);

    for (int i = 0; i < n - 1; i++)
        wei[i] = adjl[i][0].second;
    
    ll rez = 0;
    
    for (int i = 0; i < n - 1; i++){
        
        int temp = i;
        vector <ll> niz;
        while (temp < n - 1 && wei[temp] >= 0)
            niz.push_back(wei[temp]), temp++;
        
        ll le = 0, ri = niz.size() - 1, puta = 1;
        while (le <= ri){
            
            if (le == ri)
                rez += niz[le]*puta;
            else
                rez += niz[le]*puta + niz[ri]*puta;
            
            le++, ri--;
            puta++;
            
        }
        
        i = temp;
        
    }
    
    cout << rez;
    
    
}
