#include <cmath>
#include <iostream>
#include <vector>
#include <utility>
#include <stack>

using namespace std;

typedef long long ll;

vector <ll> st;
vector <ll> lb;
vector <ll> ub;
vector <ll> b;
vector <ll> lazy;

vector <ll> in;
vector <ll> inun;
vector <ll> num;

vector <vector <ll>  > adjl(200000);

ll ord = 1;

void dfs(ll u, ll p){
    
    in[u] = ord;
    inun[ord] = u;
    
    for (int i = 0; i < adjl[u].size(); i++){
        
        ll v = adjl[u][i];
        if (v == p)
            continue;
        
        ord++;
        dfs(v, u);
        num[u] += num[v];
        
    }
    
    num[u]++;
    
}


void build(ll u, ll l, ll r){
    
    lb[u] = l, ub[u] = r;
    
    if (l == r){
        
       if (b[inun[l]] == 1)
           st[u] = 1;
        else
           st[u] = 0;
        
        return;
        
    }
    
    ll mid = (l+r)/2;
    build(2*u, l, mid), build(2*u + 1, mid + 1, r);
    st[u] = st[2*u] + st[2*u + 1];
    
    return;
    
}

void prop(ll u){
    
    st[u] = (ub[u] - lb[u] + 1)*lazy[u], lazy[2*u] = lazy[u], lazy[2*u + 1] = lazy[u];
    return;
    
}

void upd(ll u, ll l, ll r){
    
    if (lazy[u] == 1)
        return;
    
    if (lb[u] > r || ub[u] < l)
        return;
    
    if (lb[u] >= l && ub[u] <= r){
        lazy[u] = 1, prop(u);
        return;
    }
    
    ll mid = (l+r)/2;
    upd(2*u, l, mid), upd(2*u + 1, mid + 1, r);
    st[u] = st[2*u] + st[2*u + 1];
    
    if (st[u] == ub[u] - lb[u] + 1)
        lazy[u] = 1, prop(u);
    
}

ll query(ll u, ll l, ll r){
    
    if (ub[u] < l || lb[u] > r)
        return  0;
    
    if (ub[u] <= r && lb[u] >= l){
        if (lazy[u]) prop(u);
        return st[u];
    }
    
    ll rez = query(2*u, l, r) + query(2*u + 1, l, r);
    //st[u] = st[2*u] + st[2*u + 1];
    return rez;
    
}

int main(){
    
    int n;
    cin >> n;
    
    for (int i = 0; i < n - 1; i++){
        
        int u, v;
        cin >> u >> v;
        u--, v--;
        adjl[u].push_back(v);
        
    }
    
    b.resize(n);
    for (int i = 0; i < n; i++)
        cin >> b[i];
    
    st.resize(4*n + 3), lb.resize(4*n + 3), ub.resize(4*n + 3);
    lazy.resize(4*n + 3, 0);
    in.resize(n), num.resize(n, 0), inun.resize(n);
    
    dfs(0, -1);
    build(1, 1, n);
    
    int q;
    cin >> q;
    
    //cout << query(1, 4, 8) << endl;
    for (int i = 0; i < q; i++){
        
        int t, x, k;
        cin >> t >> x >> k;
        x--;
        
        if (t == 1){
            
            ll beg = in[x], fin = in[x] + num[x] - 1;
            upd(1, beg, fin);
            
        } else if (t == 2){
            
            ll beg = in[x], fin = in[x] + num[x] - 1;
            ll broj = query(1, beg, fin);
            
            cout << broj << endl;

            
        }
        
        
    }
    
}

