#include <iostream>
#include <algorithm>
#include <vector>
#include <functional>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pll;
typedef pair<ll, pll> ppll;

vector<ll> start, finish, depth;
vector<vector<pll>> tree;
vector<ppll> offers;

void calc(ll s, ll v, ll par, ll curr);
void setDepth(ll v, ll par);

int main()
{
	ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	ll n;
	cin >> n;

	start.resize(n + 1), finish.resize(n + 1);
	for (ll i = 1; i <= n; i++)
		cin >> start[i];
	for (ll i = 1; i <= n; i++)
		cin >> finish[i];

	tree.resize(n + 1);
	for (ll i = 2; i <= n; i++)
	{
		ll a, b;
		cin >> a >> b;
		tree[i].push_back({ a, b });
		tree[a].push_back({ i, b });
	}

	depth.resize(n + 1, 1);
	setDepth(1, 0);

	for (ll i = 1; i <= n; i++)
		calc(i, i, i, 0);

	sort(offers.begin(), offers.end(), greater<ppll>());
	ll ans = 0;
	for (ll i = 0; i < offers.size(); i++)
	{
		ll f = offers[i].second.first, t = offers[i].second.second, p = offers[i].first;
		if (start[f] > 0 && finish[t] > 0&&p>0)
		{
			ll minn = (min(start[f], finish[t]));
			ans += p*minn;
			start[f] -= minn;
			finish[t] -= minn;
		}
	}

	cout << ans;
	return 0;
}
void calc(ll s, ll v, ll par, ll curr)
{
	if (s != v)
		offers.push_back({ curr, { s, v } });
	for (ll i = 0; i < tree[v].size(); i++)
		if (depth[tree[v][i].first]>depth[v])
			calc(s, tree[v][i].first, v, curr + tree[v][i].second);
}
void setDepth(ll v, ll par)
{
	depth[v] = depth[par] + 1;
	for (ll i = 0; i < tree[v].size(); i++)
		if (tree[v][i].first != par)
			setDepth(tree[v][i].first, v);
}