#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

vector<vector<ll>> tree;
vector<bool> know;
vector<ll> sum;

void update(ll v, ll k);
ll get(ll v, ll k);

int main()
{
	ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	ll n;
	cin >> n;

	tree.resize(n + 1);
	for (ll i = 0; i < n - 1; i++)
	{
		ll x, y;
		cin >> x >> y;
		tree[x].push_back(y);
	}

	know.resize(n + 1);
	for (ll i = 1; i <= n; i++)
	{
		ll b;
		cin >> b;
		know[i] = b;
	}

	ll q;
	cin >> q;
	for (ll i = 0; i < q; i++)
	{
		ll type, x, k;
		cin >> type >> x >> k;
		if (type == 1)
			update(x, k);
		else
			cout << get(x, k) << "\n";
	}

	return 0;
}
void makesum(ll v)
{
	for (ll i = 0; i < tree[v].size(); i++)
	{
		ll u = tree[v][i];
		sum[v] -= sum[u] - know[u];
		makesum(u);
		sum[v] += sum[u] + know[u];
	}
}
void update(ll v, ll k)
{
	know[v] = true;
	if (k > 0)
		for (ll i = 0; i < tree[v].size(); i++)
		{
			ll u = tree[v][i];
			//sum[v] -= sum[u] - know[u];
			update(u, k - 1);
			//sum[v] += sum[u] + know[u];
		}
}
ll get(ll v, ll k)
{
	ll ans = know[v];
	if (k > 0)
		for (ll i = 0; i < tree[v].size(); i++)
			ans += get(tree[v][i], k - 1);
	return ans;
}