#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

typedef int ll;

ll logn;

vector<vector<ll>> tree;
vector<vector<vector<ll>>> sons;
vector<bool> know;
vector<ll> sum;

ll getlog(ll n);
void makeLevels(ll v);
void makesum(ll v);
void update(ll v, ll k);
ll get(ll v, ll k);

int main()
{
	ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	ll n;
	cin >> n;

	tree.resize(n + 1);
	for (ll i = 0; i < n - 1; i++)
	{
		ll x, y;
		cin >> x >> y;
		tree[x].push_back(y);
	}

	know.resize(n + 1);
	for (ll i = 1; i <= n; i++)
	{
		ll b;
		cin >> b;
		know[i] = b;
	}

	logn = getlog(n);
	sons.resize(n + 1, vector<vector<ll>>(logn));
	sum.resize(n + 1);
	/*makeLevels(1);
	makesum(1);*/

	ll q;
	cin >> q;
	for (ll i = 0; i < q; i++)
	{
		ll type, x, k;
		cin >> type >> x >> k;
		if (type == 1)
			update(x, k);
		else
		{
			//cout << get(x, k) << "\n";
			ll ans = sum[x];
				/*for (ll i = 0; i < sons[x][k].size(); i++)
					ans -= sum[sons[x][k][i]];*/
			cout << ans << "\n";
		}
	}

	return 0;
}
ll getlog(ll n)
{
	if (n == 0)
		return 1;
	return getlog(n / 2) + 1;
}
void makeLevels(ll v)
{
	for (ll i = 0; i < tree[v].size(); i++)
	{
		ll u = tree[v][i];
		makeLevels(u);
		sons[v][0].push_back(u);
		for (ll j = 1; j < sons[u].size(); j++)
			for (ll h = 0; h < sons[u][j - 1].size(); h++)
				sons[v][j].push_back(sons[u][j - 1][h]);
	}
}
void makesum(ll v)
{
	sum[v] = know[v];
	for (ll i = 0; i < tree[v].size(); i++)
	{
		ll u = tree[v][i];
		sum[v] -= sum[u];
		makesum(u);
		sum[v] += sum[u];
	}
}
void update(ll v, ll k)
{
	know[v] = true;
	if (k > 0)
		for (ll i = 0; i < tree[v].size(); i++)
		{
			ll u = tree[v][i];
			//sum[v] -= sum[u] - know[u];
			update(u, k - 1);
			//sum[v] += sum[u] + know[u];
		}
}
ll get(ll v, ll k)
{
	ll ans = know[v];
	if (k > 0)
		for (ll i = 0; i < tree[v].size(); i++)
			ans += get(tree[v][i], k - 1);
	return ans;
}
/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0
1 0 1 0 1
9
2 1 1
2 4 4
2 3 0
2 3 4
2 1 1
2 4 4
2 3 2
*/