#include <map>
#include <set>
#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

pair<int, int> operator ^(const pair<int, int> &a, const pair<int, int> &b) {
  return make_pair(a.first ^ b.first, a.second ^ b.second);
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int k, q;
  cin >> k >> q;
  if (k == 0) {
    while (q--) {
      int n;
      cin >> n;
      pair<int, int> ans(0, 0);
      while (n--) {
        int b, s;
        cin >> b >> s;
        ans = ans ^ make_pair(b, s);
      }
      if (ans == make_pair(0, 0))
        cout << "Loss\n";
      else
        cout << "Win\n";
    }
    return 0;
  }
  const int MAXB = 20;
  vector<pair<int, int>> dp[1 << MAXB];
  dp[0].emplace_back(0, 0);
  for (int mask = 1; mask < (1 << MAXB); ++mask) {
    if (__builtin_popcount(mask) == 1) {
      int id = 31 - __builtin_clz(mask);
      for (int j = 0; j <= (id + 1) * k - 1; ++j)
        dp[mask].emplace_back(0, j);
      for (int i = 1; i <= id + 1; ++i) {
        for (int j = 0; j <= (id + 1 - i) * k - 2; ++j)
          dp[mask].emplace_back(0, j);
      }
    } else {
      vector<pair<int, int>> &ans = dp[mask];
      bool any = false;
      for (int i = 0; i < MAXB; ++i) {
        if (!(mask & (1 << i)))
          continue;
        for (auto p1 : dp[mask ^ (1 << i)]) {
          vector<pair<int, int>> tmp;
          for (auto p2 : dp[1 << i])
            tmp.emplace_back(p1 ^ p2);
          sort(tmp.begin(), tmp.end());
          if (any) {
            vector<pair<int, int>> new_ans(ans.size() + tmp.size());
            new_ans.resize(set_intersection(ans.begin(), ans.end(), tmp.begin(), tmp.end(), new_ans.begin()) - new_ans.begin());
          swap(ans, new_ans);
          } else {
            swap(tmp, ans);
            any = true;
          }
        }
      }
    }
  }
  while (q--) {
    int n;
    cin >> n;
    pair<int, int> ans(0, 0);
    int mask = 0;
    while (n--) {
      int b, s;
      cin >> b >> s;
      if (b == 0) {
        ans = ans ^ make_pair(0, s);
      } else {
        if (s == 0) {
          mask ^= (1 << (b - 1));
        } else {
          ans = ans ^ make_pair(b, s - 1);
        }
      }
    }
    if (binary_search(dp[mask].begin(), dp[mask].end(), ans))
      cout << "Loss\n";
    else
      cout << "Win\n";
  }
  return 0;
}