#include <map>
#include <set>
#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 500'500;
vector<pair<int, int>> G[MAXN];
int S[MAXN];
int E[MAXN];
map<int, int> maps[MAXN];
long long cur_val[MAXN];
int id[MAXN];

void dfs(int v, int w) {
  id[v] = v;
  maps[id[v]][w] = S[v] + E[v];
  cur_val[id[v]] = -w * 1ll * S[v];
  for (auto [u, cost] : G[v]) {
    dfs(u, w + cost);
    if (maps[id[v]].size() < maps[id[u]].size())
      swap(id[u], id[v]);
    cur_val[id[v]] += cur_val[id[u]];
    for (auto tmp : maps[id[u]])
      maps[id[v]][tmp.first] += tmp.second;
  }
  int rest = S[v];
  while (rest) {
    auto tmp = --maps[id[v]].end();
    if (tmp->second <= rest) {
      rest -= tmp->second;
      cur_val[id[v]] += tmp->second * 1ll * tmp->first;
      maps[id[v]].erase(tmp);
    } else {
      cur_val[id[v]] += rest * 1ll * tmp->first;
      tmp->second -= rest;
      rest = 0;
    }
  }
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n;
  cin >> n;
  for (int i = 0; i < n; ++i)
    cin >> S[i];
  for (int i = 0; i < n; ++i)
    cin >> E[i];
  for (int i = 1; i < n; ++i) {
    int p, w;
    cin >> p >> w;
    G[p - 1].emplace_back(i, w);
  }
  dfs(0, 0);
  cout << cur_val[id[0]] << '\n';
  return 0;
}