#include <set>
#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 200'200;
const int K = 18;
const int KK = 448;

int lg[MAXN];

vector<int> G[MAXN];
int up[MAXN][K];
int depth[MAXN];
int mx_depth[MAXN];
vector<int> levels[MAXN];
vector<int> paths[MAXN];
int path_id[MAXN];
int path_ind[MAXN];
int level_id[MAXN];
vector<int> order;

int all_sum[MAXN];
vector<int> pref_all_sums[MAXN];

int n;

void dfs1(int v, int w) {
  order.emplace_back(v);
  depth[v] = w;
  mx_depth[v] = w;
  level_id[v] = levels[w].size();
  levels[w].emplace_back(v);
  all_sum[v] = 1;
  if (G[v].empty()) {
    path_id[v] = v;
    path_ind[v] = paths[v].size();
    paths[v].emplace_back(v);
    return;
  }
  int best = -1;
  for (int u : G[v]) {
    up[u][0] = v;
    dfs1(u, w + 1);
    all_sum[v] += all_sum[u];
    if (best == -1 || mx_depth[u] > mx_depth[best])
      best = u;
  }
  path_id[v] = path_id[best];
  path_ind[v] = paths[path_id[v]].size();
  paths[path_id[v]].emplace_back(v);
}

int la(int v, int d) {
  if (d == 0)
    return v;
  int k = lg[d];
  v = up[v][k];
  d -= 1 << k;
  return paths[path_id[v]][path_ind[v] + d];
}

bool good[MAXN];
int sum[MAXN];
vector<int> pref_sums[MAXN];
vector<int> to_switch;
set<int> alive_levels[MAXN];

void recalc() {
  for (int v : to_switch)
    good[v] = false;
  to_switch.clear();
  for (int v : order) {
    sum[v] = good[v];
    for (int u : G[v])
      sum[v] += sum[u];
  }
  for (int i = 0; i < n; ++i) {
    pref_sums[i].resize(levels[i].size() + 1);
    for (int j = 0; j < (int) levels[i].size(); ++j)
      pref_sums[i][j + 1] = pref_sums[i][j] + sum[levels[i][j]];
  }
}

int get(int v, int k) {
  int ans = sum[v];
  int w = depth[v] + k + 1;
  if (w < n) {
    int left = -1, right = levels[w].size();
    while (right - left > 1) {
      int mid = (left + right) / 2;
      if (level_id[la(levels[w][mid], k + 1)] >= level_id[v])
        right = mid;
      else
        left = mid;
    }
    ans += pref_sums[w][right];
    left = -1, right = levels[w].size();
    while (right - left > 1) {
      int mid = (left + right) / 2;
      if (level_id[la(levels[w][mid], k + 1)] > level_id[v])
        right = mid;
      else
        left = mid;
    }
    ans -= pref_sums[w][right];
  }
  for (int u : to_switch) {
    if (depth[u] >= depth[v] && depth[u] <= depth[v] + k && la(u, depth[u] - depth[v]) == v)
      --ans;
  }
  return ans;
}


int get_all(int v, int k) {
  int ans = all_sum[v];
  int w = depth[v] + k + 1;
  if (w < n) {
    int left = -1, right = levels[w].size();
    while (right - left > 1) {
      int mid = (left + right) / 2;
      if (level_id[la(levels[w][mid], k + 1)] >= level_id[v])
        right = mid;
      else
        left = mid;
    }
    ans += pref_all_sums[w][right];
    left = -1, right = levels[w].size();
    while (right - left > 1) {
      int mid = (left + right) / 2;
      if (level_id[la(levels[w][mid], k + 1)] > level_id[v])
        right = mid;
      else
        left = mid;
    }
    ans -= pref_all_sums[w][right];
  }
  return ans;
}


int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_wtih_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  lg[0] = -1;
  for (int i = 1; i < MAXN; ++i)
    lg[i] = lg[i / 2] + 1;

  cin >> n;
  for (int i = 1; i < n; ++i) {
    int x, y;
    cin >> x >> y;
    G[x - 1].emplace_back(y - 1);
  }
  for (int i = 0; i < n; ++i) {
    int x;
    cin >> x;
    good[i] = !x;
  }
  order.reserve(n);
  dfs1(0, 0);
  for (int i = 0; i < n; ++i) {
    if (good[i])
      alive_levels[depth[i]].emplace(level_id[i]);
  }
  for (int j = 1; j < K; ++j) {
    for (int i = 0; i < n; ++i)
      up[i][j] = up[up[i][j - 1]][j - 1];
  }
  for (int i = 0; i < n; ++i) {
    int k = paths[i].size();
    while (k--) {
      int v = paths[i].back();
      if (up[v][0] != v)
        paths[i].emplace_back(up[v][0]);
      else
        break;
    }
  }

  for (int i = 0; i < n; ++i) {
    pref_all_sums[i].resize(levels[i].size() + 1);
    for (int j = 0; j < (int) levels[i].size(); ++j)
      pref_all_sums[i][j + 1] = pref_all_sums[i][j] + all_sum[levels[i][j]];
  }

  vector<int> checked(n, -1);
  reverse(order.begin(), order.end());
  recalc();
  int q;
  cin >> q;
  while (q--) {
    int t, v, k;
    cin >> t >> v >> k;
    --v;
    if (t == 1) {
      while (checked[v] < k) {
        int left = checked[v], right = n;
        while (right - left > 1) {
          int mid = (left + right) / 2;
          int tmp = get(v, mid);
          if (tmp == 0)
            left = mid;
          else
            right = mid;
        }
        checked[v] = right;
        int w = depth[v] + right;
        if (w >= n || w > depth[v] + k)
          break;
        left = -1, right = levels[w].size();
        while (right - left > 1) {
          int mid = (left + right) / 2;
          if (level_id[la(levels[w][mid], w - depth[v])] >= level_id[v])
            right = mid;
          else
            left = mid;
        }
        int ll = right;
        left = -1, right = levels[w].size();
        while (right - left > 1) {
          int mid = (left + right) / 2;
          if (level_id[la(levels[w][mid], w - depth[v])] > level_id[v])
            right = mid;
          else
            left = mid;
        }
        int rr = right;
        while (true) {
          auto tmp = alive_levels[w].lower_bound(ll);
          if (tmp != alive_levels[w].end() && (*tmp) < rr) {
            to_switch.emplace_back(levels[w][*tmp]);
            alive_levels[w].erase(tmp);
          } else {
            break;
          }
        }
      }
      if (to_switch.size() > KK)
        recalc();
    } else {
      cout << get_all(v, k) - get(v, k) << '\n';
    }
  }
  return 0;
}