#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>

typedef struct node
{
	int data;
	struct node* next;
}Node;

typedef struct worker
{
	Node* subWorkersList;
	int knows;
}Worker;

Worker* workers;
int n;

//void InstantiateCompany()
//{
//	int i;
//	for (i = 0; i < n; i++)
//	{
//		workers[i].numofSubWorkers = 0;
//		workers[i].subWorkersID = (int*)malloc((n - 1) * sizeof(int));
//	}
//}

void GetHierarchy()
{
	int i;
	for (i = 0; i < n - 1; i++)
	{
		//Now get n - 1 lines with syntax {boss}, {worker}
		int bossID, workerID;
		scanf("%d %d", &bossID, &workerID);
		bossID--;
		workerID--;
		Node *newSubWorker = (Node*)malloc(sizeof(Node*));
		newSubWorker->data = workerID;
		newSubWorker->next = workers[bossID].subWorkersList;
		workers[bossID].subWorkersList = newSubWorker;
	}
}

void GetKnowers()
{
	//Now get who knows the news already
	int i;
	for (i = 0; i < n; i++)
	{
		scanf("%d", &workers[i].knows);
	}
}

void Tell(int x, int k)
{
	if (k < 0) return;
	workers[x].knows = 1;
	Node* ptr = workers[x].subWorkersList;
	while (ptr)
	{
		Tell(ptr->data, k - 1);
		ptr = ptr->next;
	}
}

int Ask(int x, int k)
{
	if (k < 0) return 0;
	int sum = 0;
	sum += workers[x].knows;
	int i;
	Node* ptr = workers[x].subWorkersList;
	while (ptr)
	{
		sum += Ask(ptr->data, k - 1);
		ptr = ptr->next;
	}
	return sum;
}

void GetQueries()
{
	int i, queryCount;
	scanf("%d", &queryCount);
	for (i = 0; i < queryCount; i++)
	{
		int queryType, k, x;
		scanf("%d %d %d", &queryType, &x, &k);
		x--;
		if (queryType == 1)
		{
			Tell(x, k);
		}
		else //query type is 2
		{
			printf("%d\n", Ask(x, k));
		}
	}
}

int main()
{
	scanf("%d", &n); //Gets number of workers
	workers = (Worker*)calloc(n, sizeof(Worker));
	//InstantiateCompany();
	GetHierarchy();
	GetKnowers();
	GetQueries();
	return 0;
}