#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <math.h>

typedef struct node
{
	int data;
	struct node* next;
}Node;

typedef struct worker
{
	Node* subWorkersList;
	int knows;
	//int numOfChildren;
	int childrenWhoKnow;
	int calculated;
}Worker;

Worker* workers;
int n;

void UpdateHowManyLevels(int x)
{
	if (workers[x].calculated) return;
	Node* ptr = workers[x].subWorkersList;
	while (ptr)
	{
		int alreadyCalculated = workers[ptr->data].calculated;
		if (alreadyCalculated)
		{
			//workers[x].numOfChildren += 1 + workers[ptr->data].numOfChildren;
			workers[x].childrenWhoKnow += workers[ptr->data].childrenWhoKnow;
			if (workers[ptr->data].knows) workers[x].childrenWhoKnow += 1;
		}
		else
		{
			UpdateHowManyLevels(ptr->data);
			//workers[x].numOfChildren += 1 + workers[ptr->data].numOfChildren;
			workers[x].childrenWhoKnow += workers[ptr->data].childrenWhoKnow;
			if (workers[ptr->data].knows) workers[x].childrenWhoKnow += 1;
		}
		ptr = ptr->next;
	}
	workers[x].calculated = 1;
}

void InstantiateCompany()
{
	int i;
	for (i = 0; i < n; i++)
	{
		UpdateHowManyLevels(i);
	}
}

void GetHierarchy()
{
	int i;
	for (i = 0; i < n - 1; i++)
	{
		//Now get n - 1 lines with syntax {boss}, {worker}
		int bossID, workerID;
		scanf("%d %d", &bossID, &workerID);
		bossID--;
		workerID--;
		Node* newSubWorker = (Node*)malloc(sizeof(Node*));
		newSubWorker->data = workerID;
		newSubWorker->next = workers[bossID].subWorkersList;
		workers[bossID].subWorkersList = newSubWorker;
	}
}

void GetKnowers()
{
	//Now get who knows the news already
	int i;
	for (i = 0; i < n; i++)
	{
		scanf("%d", &workers[i].knows);
	}
}

void Tell(int x, int k)
{

	if (k < 0) return;
	workers[x].knows = 1;
	//workers[x].childrenWhoKnow = workers[x].numOfChildren;
	Node* ptr = workers[x].subWorkersList;
	while (ptr)
	{
		Tell(ptr->data, k - 1);
		ptr = ptr->next;
	}
}

int Ask(int x, int k)
{
	int y = workers[x].childrenWhoKnow + workers[x].knows;
}

void GetQueries()
{
	int i, queryCount;
	scanf("%d", &queryCount);
	InstantiateCompany();
	for (i = 0; i < queryCount; i++)
	{
		int queryType, k, x;
		scanf("%d %d %d", &queryType, &x, &k);
		x--;
		if (queryType == 1)
		{
			Tell(x, k);
		}
		else //query type is 2
		{
			printf("%d\n", Ask(x, k));
		}
	}
}

int main()
{
	scanf("%d", &n); //Gets number of workers
	workers = (Worker*)calloc(n, sizeof(Worker));
	GetHierarchy();
	GetKnowers();
	GetQueries();
	return 0;
}