#include <iostream>
#include <vector>

using namespace std;

const int N = 2e5 + 5;

vector<int> fii[N];
bool marcat[N];
int tin[N], tout[N], aint[4 * N], vc[2 * N], nr[N];
bool lazy[4 * N];
int t, l, r;

void dfs(int nod) {
  tin[nod] = ++t;
  vc[tin[nod]] = nod;
  for (auto f : fii[nod])
    dfs(f);
  tout[nod] = t;
}

void constr_aint(int p, int a, int b) {
  if (a == b) {
    aint[p] = marcat[vc[a]];
    return;
  }
  int st = 2 * p, dr = 2 * p + 1;
  int m = (a + b) / 2;
  constr_aint(st, a, m);
  constr_aint(dr, m + 1, b);
  aint[p] = aint[st] + aint[dr];
}

void update(int p, int a, int b) {
  if (lazy[p])
    return;
  if (a >= l && b <= r) {
    aint[p] = b - a + 1;
    lazy[p] = true;
    return;
  }
  int st = 2 * p, dr = 2 * p + 1;
  int m = (a + b) / 2;
  if (a <= m)
    update(st, a, m);
  if (b > m)
    update(dr, m + 1, b);
  aint[p] = aint[st] + aint[dr];
}

int query(int p, int a, int b) {
  int st = 2 * p, dr = 2 * p + 1;
  int m = (a + b) / 2;
  if (lazy[p]) {
    lazy[p] = false;
    lazy[st] = true;
    lazy[dr] = true;
    aint[st] = m - a + 1;
    aint[dr] = b - m;
  }
  if (a >= l && b <= r)
    return aint[p];
  int rez = 0;
  if (l <= m)
    rez += query(st, a, m);
  if (r > m)
    rez += query(dr, m + 1, b);
  return rez;
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr), cout.tie(nullptr);
  int n;
  cin >> n;
  for (int i = 0; i < n - 1; ++i) {
    int x, y;
    cin >> x >> y;
    fii[x].push_back(y);
  }
  for (int i = 1; i <= n; ++i)
    cin >> marcat[i];
  dfs(1);
  constr_aint(1, 1, tout[1]);
  int q;
  cin >> q;
  while (q--) {
    int cer, nod, k;
    cin >> cer >> nod >> k;
    if (cer == 1) {
      l = tin[nod], r = tout[nod];
      update(1, 1, tout[1]);
    } else {
      l = tin[nod], r = tout[nod];
      cout << query(1, 1, tout[1]) << "\n";
    }
  }
  return 0;
}