// miners.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pii;
typedef vector<pii> vp;
typedef vector<vp> vvp;
typedef vector<ll> vi;
typedef vector<vi> vvi;

vector<set<pii>> paths;
vvp tu;
vi ans;

ll dp(ll v, vvp& g, vi& s, vi& e, ll p)
{
    ll end = 0;
    ll umax = 0;
    for (pii u : g[v])
    {
        if (u.first == p) continue;
        ll eu;
        eu = dp(u.first, g, s, e, v);
        end += eu;
        ans[v] += ans[u.first];
        for (pii t : paths[u.first]) paths[v].insert({ t.first + u.second, t.second });
        if (u.second > 0) tu[v].push_back({u.second, eu});
        umax = max(u.second, umax);
    }
    //sort(paths[v].begin(), paths[v].end());
    ll miners = s[v];
    ll count = 0;
    if (!paths[v].empty())
    {
        auto i = paths[v].end();
        for (i--; i != paths[v].begin() && miners > 0; i--)
        {
            pii path = *i;
            if (e[path.second] > 0 && path.first >= umax)
            {
                ll c = min(e[path.second], miners);
                ans[v] += c * path.first;
                e[path.second] -= c;
                miners -= c;
                count += c;
            }
        }
    }
    for (pii u : g[v]) if (u.first != p) paths[v].insert({ u.second, u.first });
    if (miners >= 0)
    {
        auto i = paths[v].end(); 
        if (!paths[v].empty()) i--;
        else i = paths[v].begin();
        sort(tu[v].begin(), tu[v].end(), greater<pii>());
        int j = 0;
        while (i != paths[v].begin() || j != tu[v].size() && miners > 0)
        {
            if (i == paths[v].begin())
            {
                int c = min(miners, tu[v][j].second);
                ans[v] += tu[v][j].first * c;
                miners -= c;
                j++;
            }
            else if (j == tu[v].size())
            {
                pii path = (*i);
                ll c = min(e[path.second], miners);
                ans[v] += c * path.first;
                e[path.second] -= c;
                miners -= c;
                count += c;
                i--;
            }
            else if ((*i).first > tu[v][j].first)
            {
                pii path = (*i);
                ll c = min(e[path.second], miners);
                ans[v] += c * path.first;
                e[path.second] -= c;
                miners -= c;
                count += c;
                i--;
            }
            else
            {
                int c = min(miners, tu[v][j].second);
                ans[v] += tu[v][j].first * c;
                miners -= c;
                j++;
            }
        }

    }
    end += count;
    return end;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    ll n; cin >> n;
    vi s(n); vi e(n);
    for (ll i = 0; i < n; i++) cin >> s[i];
    for (ll i = 0; i < n; i++) cin >> e[i];
    vvp g(n);
    for (int i = 0; i < n-1; i++)
    {
        ll u, w; cin >> u >> w;
        u--;
        g[i+1].push_back({ u, w });
        g[u].push_back({ i+1, w });
    }
    paths.resize(n);
    ans.resize(n, 0);
    tu.resize(n);
    dp(0, g, s, e, -1);
    cout << ans[0] << endl;
}
