// miners.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pii;
typedef vector<pii> vp;
typedef vector<vp> vvp;
typedef vector<ll> vi;
typedef vector<vi> vvi;

vvp paths;
vi ans;

void dp(ll v, vvp& g, vi& s, vi& e, ll p)
{
    for (pii u : g[v])
    {
        if (u.first == p) continue;
        dp(u.first, g, s, e, v);
        for (pii t : paths[u.first]) paths[v].push_back({ t.first + u.second, t.second });
        paths[v].push_back({ u.second, u.first });
    }
    sort(paths[v].begin(), paths[v].end(), greater<pii>());
}

void calc(ll v, vvp& g, vi& s, vi& e, ll p)
{
    ll miners = s[v];
    for (ll i = 0; i < paths[v].size(); i++)
    {
        pii path = paths[v][i];
        if (path.first <= 0) break;
        ll c = min(miners, e[path.second]);
        ans[v] += c * path.first;
        miners -= c;
        e[path.second] -= c;
        if (miners == 0) break;
    }
    for (pii u : g[v])
    {
        if (u.first == p) continue;
        calc(u.first, g, s, e, v);
        ans[v] += ans[u.first];
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    ll n; cin >> n;
    vi s(n); vi e(n);
    for (ll i = 0; i < n; i++) cin >> s[i];
    for (ll i = 0; i < n; i++) cin >> e[i];
    vvp g(n);
    for (int i = 0; i < n-1; i++)
    {
        ll u, w; cin >> u >> w;
        u--;
        g[i+1].push_back({ u, w });
        g[u].push_back({ i+1, w });
    }
    paths.resize(n);
    ans.resize(n, 0);
    dp(0, g, s, e, -1);
    calc(0, g, s, e, -1);
    cout << ans[0] << endl;
}
