// miners.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <tuple>
#include <climits>

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pii;
typedef vector<pii> vp;
typedef vector<vp> vvp;
typedef vector<ll> vi;
typedef vector<vi> vvi;
typedef tuple<int, int, bool> tiib;

vvi paths;
vvi build;
vi ans;

void dp(ll v, vvp& g, vi& s, vi& e, ll p, int n)
{
    for (pii u : g[v])
    {
        if (u.first == p) continue;
        dp(u.first, g, s, e, v, n);
        for (int i = 0; i < n; i++) if (paths[u.first][i] != INT_MIN) paths[v][i] = paths[u.first][i] + u.second;
        paths[v][u.first] = u.second;
    }
}

void calc(ll v, vvp& g, vi& s, vi& e, ll p, int n)
{
    for (pii u : g[v])
    {
        if (u.first == p) continue;
        calc(u.first, g, s, e, v, n);
        ans[v] += ans[u.first];
    }
    vector<tiib> posib;
    for (int i = 0; i < n; i++)
    {
        if (paths[v][i] > INT_MIN)
        {
            if (e[i] > 0) posib.push_back({ paths[v][i], i, true});
            for (int j : build[i]) posib.push_back({ paths[v][i], j, false });
        }
    }
    sort(posib.begin(), posib.end(), greater <tiib>());
    for (tiib path : posib)
    {
        int c = min(s[v], get<2>(path) ? e[get<1>(path)] : get<1>(path));
        ans[v] += get<0>(path) * c;
        if (get<2>(path)) e[get<1>(path)] -= c;
        s[v] -= c;
        build[v].push_back(c);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    ll n; cin >> n;
    vi s(n); vi e(n);
    for (ll i = 0; i < n; i++) cin >> s[i];
    for (ll i = 0; i < n; i++) cin >> e[i];
    vvp g(n);
    for (int i = 0; i < n-1; i++)
    {
        ll u, w; cin >> u >> w;
        u--;
        g[i+1].push_back({ u, w });
        g[u].push_back({ i+1, w });
    }
    paths.resize(n, vi(n, INT_MIN));
    ans.resize(n, 0);
    build.resize(n);
    dp(0, g, s, e, -1, n);
    calc(0, g, s, e, -1, n);
    cout << ans[0] << endl;
}
