// news.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int>> dp;
vector<vector<int>> child;
void calc(int v, vector<vector<int>>& g, vector<bool>& know, int n)
{
    for (int u : g[v])
    {
        calc(u, g, know, n);
        for (int i = 1; i < n; i++)
        {
            dp[v][i] += dp[u][i - 1];
            child[v][i] += child[u][i - 1];
        }
    }
    for (int i = 0; i < n; i++) dp[v][i] += know[v] ? 1 : 0;
    for (int i = 0; i < n; i++) 
        child[v][i]++;
}

void updateChild(int k, int v, vector<vector<int>>& g, int n)
{
    if (k == 0) return;
    for (int i = k + 1; i < n; i++) dp[v][i] -= dp[v][k];
    for (int i = k; i >= 1; i--) 
        dp[v][i] = child[v][i];
    for (int i = k + 1; i < n; i++) dp[v][i] += dp[v][k];
    for (int u : g[v]) updateChild(k - 1, u, g, n);
}

void updatePar(vector<int> par, int v, int t, int u, int n)
{
    if (v == -1) return;
    if (t == 1)
    {
        for (int i = 2; i < n; i++) dp[v][i] -= dp[u][i - 1];
    }
    else
    {
        for (int i = 2; i < n; i++) dp[v][i] += dp[u][i - 1];
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n; cin >> n;
    vector<bool> knows(n, true); // will be temp used to find the root
    vector<vector<int>> g(n);
    vector<int> par(n, -1);
    for (int i = 0; i < n-1; i++)
    {
        int x, y; cin >> x >> y;
        --x, --y;
        knows[y] = false;
        g[x].push_back(y);
        par[y] = x;
    }
    int root;
    for (int i = 0; i < n; i++) if (knows[i]) root = i;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        knows[i]= t;
    }
    dp.resize(n, vector<int>(n, 0));
    child.resize(n, vector<int>(n, 0));
    calc(root, g, knows, n);
    int q; cin >> q;
    for (int i = 0; i < q; i++)
    {
        int t, x, k; cin >> t >> x >> k; --x;
        if (t == 2)
        {
            cout << dp[x][k] << endl;
        }
        else
        {
            updatePar(par, par[x], 1, x, n);
            updateChild(k, x, g, n);
            updatePar(par, par[x], 2, x, n);
        }
    }
}

