// news.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int>> dp;

void calc(int v, vector<vector<int>>& g, vector<bool>& know, int n)
{
    for (int u : g[v])
    {
        calc(u, g, know, n);
        for (int i = 1; i < n; i++)
        {
            dp[v][i] += dp[u][i - 1];
        }
    }
    for (int i = 0; i < n; i++) dp[v][i] += know[v] ? 1 : 0;
}



void update(int v, int k, vector<vector<int>>& g, vector<bool>& knows)
{
    if (k < 0) return;
    knows[v] = true;
    for (int u : g[v]) update(u, k - 1, g, knows);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n; cin >> n;
    vector<bool> knows(n, true); // will be temp used to find the root
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++)
    {
        int x, y; cin >> x >> y;
        --x, --y;
        knows[y] = false;
        g[x].push_back(y);
    }
    int root;
    for (int i = 0; i < n; i++) if (knows[i]) root = i;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        knows[i] = t;
    }
    dp.resize(n, vector<int>(n, 0LL));
    calc(root, g, knows, n);
    int q; cin >> q;
    for (int i = 0; i < q; i++)
    {
        int t, x, k; cin >> t >> x >> k; --x;
        if (t == 2)
        {
            cout << dp[x][k] << endl;
        }
        else
        {
            update(x, k, g, knows);
            dp.clear();
            dp.resize(n, vector<int>(n, 0));
            calc(root, g, knows, n);
        }
    }
}

