#include <iostream>
#include <vector>

#define int long long

using namespace std;

const int MAXN = 2e5 + 10;
const int INF = 1e9 + 7;


vector<pair<int, int>> graph[MAXN];

int s[MAXN];
int e[MAXN];

int mx;
int dst;

void dfs(int v, int p = -1, int sum = 0) {
    if (sum > mx && e[v] != 0) {
        mx = sum;
        dst = v;
    }
    for (auto[u, c]: graph[v]) {
        if (u != p) {
            dfs(u, v, sum + c);
        }
    }
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> e[i];
    }
    for (int i = 1; i < n; ++i) {
        int p, w;
        cin >> p >> w;
        --p;
        graph[p].emplace_back(i, w);
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        int best_sum = -INF;
        int from = -1, to = -1;
        for (int j = 0; j < n; ++j) {
            if (s[j] == 0) continue;
            mx = -INF;
            dfs(j);
            if (mx > best_sum) {
                best_sum = mx;
                from = j;
                to = dst;
            }
        }
        if (best_sum > 0) {
            int cnt = min(s[from], e[to]);
            s[from] -= cnt;
            e[to] -= cnt;
            ans += cnt * best_sum;
        }
    }
    cout << ans;
}