#include <iostream>
#include <vector>

#define int long long

using namespace std;

const int MAXN = 2e5 + 10;
const int INF = 1e9 + 7;


vector<pair<int, int>> graph[MAXN];

int s[MAXN];
int e[MAXN];

int mx;
int dst;

void dfs(int v, vector<int> &fe, int p = -1, int sum = 0) {
    if (sum > mx && fe[v] != 0) {
        mx = sum;
        dst = v;
    }
    for (auto[u, c]: graph[v]) {
        if (u != p) {
            dfs(u, fe, v, sum + c);
        }
    }
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> e[i];
    }
    for (int i = 1; i < n; ++i) {
        int p, w;
        cin >> p >> w;
        --p;
        graph[p].emplace_back(i, w);
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        vector<int> fs(n), fe(n);
        for (int j = 0; j < n; ++j) {
            fs[j] = s[j], fe[j] = e[j];
        }
        int best = 0;
        while (fs[i] != 0) {
            mx = -INF;
            dfs(i, fe);
            if (mx > 0) {
                int cnt = min(fs[i], fe[dst]);
                fs[i] -= cnt;
                fe[dst] -= cnt;
                best += cnt * mx;
            }else{
                break;
            }
        }
        ans = max(ans, best);
    }
    cout << ans;
}