#include <iostream>
#include <vector>
#include <set>


#define int long long

using namespace std;

const int MAXN = 4e6 + 10;
const int INF = 1e15 + 7;


vector<pair<int, int>> graph[MAXN];
int pref[MAXN];
int s[MAXN];
int e[MAXN];


void dfs(int v, int p = -1, int sum = 0) {
    pref[v] = sum;
    for (auto[u, c]: graph[v]) {
        if (u != p) {
            dfs(u, v, sum + c);
        }
    }
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> e[i];
    }
    for (int i = 1; i < n; ++i) {
        int p, w;
        cin >> p >> w;
        --p;
        graph[p].emplace_back(i, w);
    }
    dfs(0);
    int ans = 0;
    multiset<int> s;
    for (int i = 0; i < n; ++i) {
        auto k = s.upper_bound(pref[i]);
        if (k != s.begin()) {
            ans += pref[i];
            int v = *(--k);
            ans -= v;
            s.erase(s.find(v));
        }
        s.insert(pref[i]);
    }
    cout << ans;
}