#include <iostream>
#include "vector"
#include <algorithm>
#include <tuple>
#include <bits/stdc++.h>

#define int long long
using namespace std;
const int MAXN = 2e5 + 10;
vector<int> graph[MAXN];
int beg[MAXN];
int en[MAXN];
int tin[MAXN];
int tout[MAXN];
int depth[MAXN];
int timer = 0;
vector<int> o;
vector<int> tin_o;

void dfs(int v) {
    tin[v] = timer;
    timer++;
    for (int u: graph[v]) {
        depth[u] = depth[v] + 1;
        dfs(u);
    }
    tout[v] = timer;
}


int t[MAXN * 4];


int get(int l, int r, int v = 1, int tl = 0, int tr = MAXN) {
    if (tr <= l || tl >= r) return 0;
    if (l <= tl && tr <= r) return t[v];
    int m = (tl + tr) / 2;
    return get(l, r, v * 2, tl, m) + get(l, r, v * 2 + 1, m, tr);
}


void update(int i, int v = 1, int tl = 0, int tr = MAXN) {
    if (tr - tl == 1) {
        t[v] = 1;
        return;
    }
    int m = (tl + tr) / 2;
    if (i < m)
        update(i, v * 2, tl, m);
    else
        update(i, v * 2 + 1, m, tr);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

struct request {
    int typ;
    int tin, tout, depth;
    int ind;

};

bool operator<(const request &lhs, const request &rhs) {
    return tie(lhs.depth, lhs.typ) < tie(rhs.depth, rhs.typ);
}


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        graph[x].push_back(y);
    }
    dfs(0);
    for (int i = 0; i < n; ++i)
        o.push_back(i);
    auto comp = [&](int l, int r) -> bool {
        return tie(depth[l], tin[l]) < tie(depth[r], tin[r]);
    };
    sort(o.begin(), o.end(), comp);
    for (int i = 0; i < n; ++i) {
        tin_o.push_back(tin[o[i]]);
    }
    vector<request> requests;
    for (int i = 0; i < n; ++i) {
        int b;
        cin >> b;
        request x = {1, tin[i], tout[i], depth[i], -1};
        if (b == 1) requests.push_back(x);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int ty, x, k;
        cin >> ty >> x >> k;
        --x;
        request y = {2, tin[x], tout[x], depth[x] + k, i};
        requests.push_back(y);
    }
    vector<int> ans(q);
    sort(requests.begin(), requests.end());
    for (auto r: requests) {
        if (r.typ == 1) {
            update(r.tin);
        } else {
            ans[r.ind] = get(r.tin, r.tout);
        }
    }
    for(int x: ans) {
        cout << x << "\n";
    }
}