#include <iostream>
#include <vector>
#include <algorithm>

#define int long long
using namespace std;
const int MAXN = 2e5 + 10;
vector<int> graph[MAXN];
int beg[MAXN];
int en[MAXN];
int tin[MAXN];
int tout[MAXN];
int depth[MAXN];
int timer = 0;
vector<int> o;
vector<int> tin_o;

void dfs(int v) {
    tin[v] = timer;
    timer++;
    for (int u: graph[v]) {
        depth[u] = depth[v] + 1;
        dfs(u);
    }
    tout[v] = timer;
}

int t[MAXN * 4];
bool add[MAXN * 4];

void push(int v, int tl, int tr) {
    if (tr > tl) {
        if (add[v]) {
            t[v] = tr - tl;
            if (tr - tl > 1) {
                add[v * 2] = true;
                add[v * 2 + 1] = true;
            }
        }
    }
}

int get(int l, int r, int v = 1, int tl = 0, int tr = MAXN) {
    push(v, tl, tr);
    if (l <= tl && tr <= r) return t[v];
    if (tr <= l || tl >= r) return 0;
    int m = (tl + tr) / 2;
    return get(l, r, v * 2, tl, m) + get(l, r, v * 2 + 1, m, tr);
}

void update(int l, int r, int v = 1, int tl = 0, int tr = MAXN) {
    push(v, tl, tr);
    if (tr <= l || tl >= r) return;
    if (l <= tl && tr <= r) {
        add[v] = true;
        push(v, tl, tr);
        return;
    }
    int m = (tl + tr) / 2;
    update(l, r, v * 2, tl, m);
    update(l, r, v * 2 + 1, m, tr);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        graph[x].push_back(y);
    }
    dfs(0);
    for (int i = 0; i < n; ++i)
        o.push_back(i);
    auto comp = [&](int l, int r) -> bool {
        return tie(depth[l], tin[l]) < tie(depth[r], tin[r]);
    };
    sort(o.begin(), o.end(), comp);
    for (int i = 0; i < n; ++i) {
        tin_o.push_back(tin[o[i]]);
    }
    fill(beg, beg + 2 * n, n);
    for (int i = 0; i < o.size(); ++i) {
        int x = o[i];
        beg[depth[x]] = min(i, beg[depth[x]]);
        en[depth[x]] = max(i + 1, en[depth[x]]);
    }
    for (int i = 0; i < n; ++i) {
        int b;
        cin >> b;
        int d = depth[i];
        int l = lower_bound(tin_o.begin() + beg[d], tin_o.begin() + en[d], tin[i]) - tin_o.begin();
        if (b == 1) update(l, l + 1);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int ty, x, k;
        cin >> ty >> x >> k;
        --x;
        int sum = 0;
        for (int d = depth[x]; d <= depth[x] + k; ++d) {
            if (beg[d] == n) continue;
            int l = lower_bound(tin_o.begin() + beg[d], tin_o.begin() + en[d], tin[x]) - tin_o.begin();
            int r = lower_bound(tin_o.begin() + beg[d], tin_o.begin() + en[d], tout[x]) - tin_o.begin();
            if (ty == 1) {
                if (l < r)
                    update(l, r);
            } else {
                if (l < r)
                    sum += get(l, r);
            }
        }
        if (ty == 2)
            cout << sum << "\n";
    }
}