#include "bits/stdc++.h"

using namespace std;

#define len(a) (int)((a).size())

using ll = int_fast64_t;

const int INF = 1 << 29;

int n, q;
vector<vector<int>> g;
vector<int> ord, pos, subtreeEnd;

struct query{
    int type, x, k;

    query(int type, int x, int k) : type(type), x(x), k(k) {}
};

void order_tree(int i){
    pos[i] = len(ord);
    ord.push_back(i);
    for(int j: g[i]){
        order_tree(j);
    }
    subtreeEnd[i] = len(ord) - 1;
}

struct segmentTree{
    int n = 1;
    vector<int> tree, push;

    explicit segmentTree(int m){
        while(n < m) n <<= 1;
        tree.resize(n * 2);
        push.resize(n * 2, -INF);
    }

    [[nodiscard]] int subtreeSize(int i) const {
        return 1 << (__builtin_clz(i | 1) - __builtin_clz(n));
    }

    int get(int i){
        return push[i] == -INF ? tree[i] : push[i] * subtreeSize(i);
    }

    void do_push(int i){
        if(push[i] == -INF)
            return;
        push[i<<1] = push[i];
        push[i<<1|1] = push[i];
        tree[i] = push[i] * subtreeSize(i);
        push[i] = -INF;
    }

    void update(int l, int r, int v){
        _update(1, 0, n - 1, l, r, v);
    }

    void _update(int t, int tl, int tr, int l, int r, int v){
        if(tr < l || r < tl)
            return;
        if(l <= tl && tr <= r) {
            push[t] = v;
            return;
        }
        do_push(t);
        _update(t << 1, tl, (tl + tr) / 2, l, r, v);
        _update(t << 1 | 1, (tl + tr) / 2 + 1, tr, l, r, v);
        tree[t] = get(t << 1) + get(t << 1 | 1);
    }

    int query(int l, int r){
        return _query(1, 0, n-1, l, r);
    }

    int _query(int t, int tl, int tr, int l, int r){
        if(tr < l || r < tl)
            return 0;
        if(l <= tl && tr <= r)
            return get(t);
        do_push(t);
        return _query(t << 1, tl, (tl + tr) / 2, l, r) +
        _query(t << 1 | 1, (tl + tr) / 2 + 1, tr, l, r);
    }
};

void solve(){
    cin >> n;
    g.resize(n);
    subtreeEnd.resize(n);
    pos.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        g[x].push_back(y);
    }
    order_tree(0);
    segmentTree st(n);
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        st.update(pos[i], pos[i], t);
    }
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int type, x, k;
        cin >> type >> x >> k;
        --x;
        if(type == 1){
            st.update(pos[x], subtreeEnd[x], 1);
        }else{
            cout << st.query(pos[x], subtreeEnd[x]) << "\n";
        }
    }

}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
