#include <iostream>
#include <vector>
using namespace std;
vector<int> intime, outtime, scan;
vector<vector<int>> nei;
int t = 0;
void dfs(int v){
    intime[v] = t;
    scan.push_back(v);
    t++;
    for(auto t: nei[v]) dfs(t);
    outtime[v] = t;
}
struct Seg{
    int l, r, mid;
    int val = 0, prop = 0;
    Seg *lp, *rp;
    Seg(int l, int r): l(l), r(r), mid((l+r)/2){
        if(l+1<r){
            lp = new Seg(l, mid);
            rp = new Seg(mid, r);
        }
    }
    void pull(){
        val = lp->val + rp->val;
        prop = 0;
    }
    void push(){
        if(!prop) return;
        lp->val = (mid-l)*prop;
        rp->val = (r-mid)*prop;
        lp->prop = prop, rp->prop = prop;
        prop = 0;
    }
    void update(int p, int x){
        if(l+1==r){
            val = x;
            return;
        }
        if(p<mid) lp->update(p, x);
        else rp->update(p, x);
        pull();
    }
    void update(int a, int b, int x){
        if(b<=l||a>=r) return;
        if(a<=l&&r<=b){
            val = (r-l)*x;
            prop = x;
            return;
        }
        lp->update(a, b, x);
        rp->update(a, b, x);
        pull();
    }
    int query(int a, int b){
        if(b<=l||a>=r) return 0;
        if(a<=l&&r<=b){
            return val;
        }
        push();
        return lp->query(a, b)+rp->query(a, b);
    }
};
int main(){
    int n; cin>>n;
    nei.resize(n), intime.resize(n), outtime.resize(n);
    for(int i=0; i<n - 1; i++){
        int x, y; cin>>x>>y;
        x--, y--;
        nei[x].push_back(y);
    }
    dfs(0);
    Seg seg = Seg(0, n);
    for(int i=0; i<n; i++){
        int b; cin>>b;
        if(b) seg.update(intime[i], b);
    }
    int q; cin>>q;
    for(int i=0; i<q; i++){
        int c, x, k; cin>>c>>x>>k;
        x--;
        if(c==1){
            seg.update(intime[x], outtime[x], 1);
        }
        else{
            cout<<seg.query(intime[x], outtime[x])<<"\n";
        }
    }
}