
#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
using namespace std;

void dfs1(long long int orgElement, long long int currElement, vector<vector<pair<long long int, long long int>>> adj, long long int currWeight, set<pair<long long int, pair<long long int, long long int>>> &results){
    if(currWeight < 0){
        results.insert(make_pair(currWeight, make_pair(orgElement, currElement)));
    }
    // results2[orgElement].insert(make_pair(currWeight, make_pair(orgElement, currElement)));
    for(auto newElement : adj[currElement]){
        dfs1(orgElement, newElement.first, adj, currWeight+newElement.second, results);
    }
    return;
}



int main(){
    long long int N;
    cin >> N;
    vector<long long int> starting(N+1, 0);
    vector<long long int> org(N+1, 0);
    vector<long long int> maxMiners(N+1, 0);
    for(int i=1; i<=N; i++){
        cin >> starting[i];
        org[i] = starting[i];
    }
    for(int i=1; i<=N; i++){
        cin >> maxMiners[i];
    }
    vector<vector<pair<long long int, long long int>>> adj(N+1, vector<pair<long long int, long long int>>(0, {0, 0}));
    long long int x, y;
    for(int i=2; i<N+1; i++){
        cin >> x >> y;
        adj[x].push_back(make_pair(i, -1*y));
    }

    set<pair<long long int, pair<long long int, long long int>>> results;
    // vector<set<pair<int, pair<int, int>>>> results2(N+1, results);
    for(int i=1; i<=N; i++){
        dfs1(i, i, adj, 0, results);
    }
    int resultSum = 0;
    for(auto it = results.begin(); it!=results.end(); it++){
        if((*it).first >= 0) break;
        if(starting[(*it).second.second]-org[(*it).second.second] >= maxMiners[(*it).second.second]) continue;
        int currAddition = min(maxMiners[(*it).second.second]-starting[(*it).second.second]+org[(*it).second.second], starting[(*it).second.first]);
        starting[(*it).second.first]-=currAddition;
        org[(*it).second.first]-=currAddition;
        starting[(*it).second.second]+=currAddition;
        resultSum -= (*it).first*currAddition;
    }

    cout << resultSum << endl;
    


}