#include<bits/stdc++.h>
using namespace std;

#define pb push_back
#define ll long long
#define sz(a) (int)a.size()
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()


const int N = 2e5 + 1;
int b[N], s[N], pos[N];
vector<int> adj[N];
int ans = 0;
vector<int> euler;
void go(int u, int depth, int k, bool f){
    if(!f)b[u] = 1;
    else ans += b[u];
    if(depth == k)return;

    for(int v: adj[u]){
        go(v, depth + 1, k, f);
    }
}

void dfs(int u){
    s[u] = 1;
    euler.pb(u);
    for(int v: adj[u]){
        dfs(v);
        s[u] += s[v];
    }
}

int t[4 * N], lazy[4 * N];

void push(int i, int l, int r){
    if(lazy[i] == -1)return;
    t[i] = lazy[i] * (r - l + 1);
    if(l != r){
        lazy[2 * i] = lazy[i];
        lazy[2 * i + 1] = lazy[i];
    }
    lazy[i] = -1;
}
void modif(int i, int l, int r, int tl, int tr, int val){
    push(i, l, r);
    if(l > tr || r < tl)return;

    if(l >= tl && r <= tr){
        lazy[i] = val;
        push(i, l, r);
        return;
    }

    int mid = (l + r) / 2;
    modif(2 * i, l, mid, tl, tr, val);
    modif(2 * i + 1, mid + 1, r, tl, tr, val);

    t[i] = t[2 * i] + t[2 * i + 1];
}

int query(int i, int l, int r, int tl, int tr){
    push(i, l, r);
    if(l > tr || r < tl)return 0;
    if(l >= tl && r <= tr)return t[i];

    int mid = (l + r) / 2;

    int left = query(2 * i, l, mid, tl, tr);
    int right = query(2 * i + 1, mid + 1, r, tl, tr);

    return left + right;
}

void solve(){
    int n, q;
    cin >> n;
    for(int i = 0;i < n - 1; ++i){
        int u, v;
        cin >> u >> v;
        --u, --v;
        adj[u].pb(v);
    }
    for(int i = 0;i < n; ++i){
        cin >> b[i];
    }
    cin >> q;

    if(n <= 10000 && q <= 10000){
        while(q--)
        {
            int type;
            cin >> type;
            if(type == 1){
                int x, k;
                cin >> x >> k;
                --x;
                go(x, 0, k, 0);
            }else{
                int x, k;
                cin >> x >> k;
                --x;
                ans = 0;
                go(x, 0, k, 1);

                cout << ans << "\n";
            }
        }
    }else{
        //segment tree with range set range sum in euler tour order

        dfs(0);
        for(int i = 0;i < n; ++i){
            pos[euler[i]] = i;
        }
        for(int i = 0;i < 4 * N; ++i){
            t[i] = 0;
            lazy[i] = -1;
        }

        for(int i = 0;i < n; ++i){
            if(b[i] == 1){
                modif(1, 0, n - 1, pos[i], pos[i], 1);
            }
        }

        while(q--)
        {
            int type;
            cin >> type;
            if(type == 1){
                int x, k;
                cin >> x >> k;
                --x;
                modif(1, 0, n - 1, pos[x], pos[x] + s[x] - 1, 1);
            }else{
                int x, k;
                cin >> x >> k;
                --x;
                cout << query(1, 0, n - 1, pos[x], pos[x] + s[x] - 1) << "\n";
            }
        }

    }
}

int32_t main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int t = 1;
    //cin >> t;

    while(t--){
        solve();
    }
}
