#include <bits/stdc++.h>
#define ll long long
#define all(x) (x).begin(),(x).end()

#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#pragma GCC optimize("unroll-loops")

using namespace std;

const int N = 5005;
int c[N][N], cost[N][N], d[N];

vector <int> gr[N];

struct edge { int v, u, cap, cost, flow; };

int s, t;
vector <edge> e;
queue <int> q;

int inq[N], p[N];

inline int dijskstra(int n) {
    fill(d, d + n, 1e9); d[s] = 0;
    q.push(s);

    while (!q.empty()) {
        int v = q.front(); q.pop(); inq[v] = 0;
        for (int to : gr[v]) {
            if (!c[v][to]) continue;
            if (d[to] > d[v] + cost[v][to]) {
                p[to] = v;
                d[to] = d[v] + cost[v][to];
                if (!inq[to]) q.push(to);
                inq[to] = 1;
            }
        }
    }
    return d[t];
}

inline int build(int n) {
    for (auto [v, u, cap, cst, flow] : e) {
        c[v][u] = cap, c[u][v] = 0;
        cost[v][u] = -cst, cost[u][v] = cst;

        gr[v].push_back(u);
        gr[u].push_back(v);
    }

    int K = 1e9, cost = 0;

    while (K) {
        int dt = dijskstra(n);
        if (dt > 0) break;

        int flow = 1e9;
        int v = t;

        while (v != s) {
            flow = min(flow, c[p[v]][v]);
            v = p[v];
        }
        flow = min(flow, K);
        K -= flow;
        v = t;

        cost -= dt * flow;

        while (v != s) {
            c[p[v]][v] -= flow;
            c[v][p[v]] += flow;
            v = p[v];
        }
    }
    return cost;
}

vector <int> eu;
vector <pair<int, int>> g[N];
int in[N], out[N], de[N];

int timer = 0;

inline void dfs(int v, int p = -1) {
    in[v] = eu.size();
    eu.push_back(v);

    for (auto &[to, w] : g[v]) {
        if (to == p) continue;
        de[to] = de[v] + w;
        dfs(to, v);
    }
    out[v] = eu.size() - 1;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    int N = 2 * n + 2;
    s = N - 1, t = N - 2;

    vector <int> a(n), b(n);
    for (auto &i : a) cin >> i;
    for (auto &i : b) cin >> i;

    for (int i = 1; i < n; ++i) {
        int p, w;
        cin >> p >> w, --p;
        g[i].push_back({p, w});
        g[p].push_back({i, w});
    }

    dfs(0);
    for (int i = 0; i < n; ++i) {
        for (int j = in[i]; j <= out[i]; ++j) {

            int v = eu[j];
            if (de[v] - de[i] <= 0) continue;
            e.push_back({i, v + n, (int)1e9, de[v] - de[i], 0});
        }
    }
    for (int i = 0; i < n; ++i) {
        e.push_back({s, i, a[i], 0, 0});
        e.push_back({i + n, t, b[i], 0, 0});
    }
    cout << build(N);
}
