#include<bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define int long long

int n, timer = 0;
vector<int> s, e, d, tin, tout, par;
vector<vector<pair<int, int>>> g;

void dfs1(int v, int p = -1) {
    par[v] = p;
    tin[v] = timer++;
    for (auto &U : g[v]) {
        int u = U.first, w = U.second;
        if (u != p) {
            d[u] = d[v] + w;
            dfs1(u, v);
        }
    }
    tout[v] = timer++;
}

bool parent(int i, int j) {
    return tin[i] <= tin[j] && tout[i] >= tout[j];
}

int get_dist(int v, int u) {
    if (v > u)
        swap(v, u);
    return d[u] - d[v];
}

multiset<pair<int, int>> pairing;

multiset<pair<int, int>> dfs(int v, int p = -1) {
    multiset<pair<int, int>> cur;
    for (auto &U : g[v]) {
        int u = U.first, w = U.second;
        if (u != p) {
            auto t = dfs(u, v);
            for (auto val : t) {
                cur.insert({val.first + w, val.second});
            }
        }
    }

    for (int i = 0; i < e[v]; ++i)cur.insert({0, v});

    multiset<pair<int, pair<int, int>>> ms;
    for (auto &t : cur) {
        ms.insert({t.first, {t.second, -1}});
    }
    for (auto &t : pairing) {
        if (parent(v, t.second) && parent(v, t.first))
            ms.insert({get_dist(v, t.second), {t.first, t.second}});
    }

    while (!ms.empty() && s[v] > 0) {
        auto val = *(--ms.end());
        ms.erase(ms.find(val));

        if (val.second.second == -1) {
            pairing.insert({v, val.second.first});
            cur.erase(cur.find({val.first, val.second.first}));
            s[v]--;
        } else {
            int dcur = get_dist(val.second.first, val.second.second);
            int dour = val.first;
            if (dour > dcur) {
                pairing.erase(pairing.find({val.second.first, val.second.second}));
                pairing.insert({v, val.second.second});
                s[v]--;
            }
        }
    }

    return cur;
}

const int inf = 1e9;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    s.resize(n);
    e.resize(n);
    g.resize(n);
    d.resize(n);
    tin.resize(n);
    tout.resize(n);
    par.resize(n);

    for (int i = 0; i < n; ++i)cin >> s[i];
    for (int i = 0; i < n; ++i) cin >> e[i];
    for (int i = 1; i < n; ++i) {
        int p, w;
        cin >> p >> w;
        g[--p].push_back({i, w});
        g[i].push_back({p, w});
    }

    dfs1(0);

    int res = 0;
    dfs(0);

    bool better = true;
    vector<pair<int, int>> tot;
    for (auto t : pairing)tot.push_back(t);

    while (better) {
        better = false;
        for (int i = 0; i < (int) tot.size(); ++i) {
            for (int j = 0; j < i; ++j) {
                int v1 = tot[i].first, u1 = tot[i].second;
                int v2 = tot[j].first, u2 = tot[j].second;
                int cur = get_dist(v1, u1) + get_dist(v2, u2);
                if(parent(v1, u2) && parent(v2, u1)){
                    int mb = get_dist(v1, u2) + get_dist(v2, u1);
                    if(mb > cur){
                        better = true;
                        tot[i].second = u2;
                        tot[j].second = u1;
                    }
                }
            }
        }
    }
    cout << res;
}
