#include<bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)

int n, timer = 0;
vector<vector<int>> g;
vector<int> tin, lTin, rTin, h, euler;

void dfs(int v) {
    tin[v] = timer++;
    euler.push_back(v);
    lTin[v] = tin[v], rTin[v] = tin[v];
    for (int u : g[v]) {
        h[u] = h[v] + 1;
        dfs(u);
        ckmin(lTin[v], lTin[u]);
        ckmax(rTin[v], rTin[u]);
    }
}

struct FenwickTree {
    vector<int> t;

    int n;

    FenwickTree() {}

    void init(int N) {
        n = N;
        t.clear();
        t.resize(n);
    }

    void inc(int i, int x) {
        while (i < n) {
            t[i] += x;
            i = (i | (i + 1));
        }
    }



    int get(int i) {
        int res = 0;
        while (i >= 0) {
            res += t[i];
            i = (i & (i + 1)) - 1;
        }
        return res;
    }

};

vector<int> knows;
vector<set<pair<int, int>>> tree;
vector<vector<int>> allDepths;

vector<FenwickTree> fts;

void markKnown(int v, int tl, int tr, int id) {
    int id_ft = lower_bound(all(allDepths[v]), h[euler[id]]) - allDepths[v].begin();
    fts[v].inc(id_ft, 1);
    if (tl == tr)return;
    int tm = (tl + tr) >> 1;
    if (id <= tm)markKnown(v << 1, tl, tm, id);
    else markKnown(v << 1 | 1, tm + 1, tr, id);
}

int queryKnowing(int v, int tl, int tr, int l, int r, int depth) {
    if (tl > r || l > tr)return 0;
    if (l <= tl && tr <= r) {
        int st_id = upper_bound(all(allDepths[v]), depth) - allDepths[v].begin();
        return fts[v].get(st_id - 1);
    }
    int tm = (tl + tr) >> 1;
    return queryKnowing((v << 1), tl, tm, l, r, depth) + queryKnowing((v << 1) | 1, tm + 1, tr, l, r, depth);
}

void push_uncolored(int v, int tl, int tr, int id) {
    tree[v].insert({h[euler[id]], euler[id]});
    if (tl == tr)return;
    int tm = (tl + tr) / 2;
    if (id <= tm)push_uncolored(v * 2, tl, tm, id);
    else push_uncolored(v * 2 + 1, tm + 1, tr, id);
}


void pushDepth(int v, int tl, int tr, int id) {
    allDepths[v].push_back(h[euler[id]]);
    if (tl == tr)return;
    int tm = (tl + tr) / 2;
    if (id <= tm)pushDepth(v * 2, tl, tm, id);
    else pushDepth(v * 2 + 1, tm + 1, tr, id);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    g.resize(n);
    tin.resize(n);
    rTin.resize(n);
    lTin.resize(n);
    h.resize(n);

    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        g[--x].push_back(--y);
    }

    dfs(0);

    knows.resize(n);
    for (int i = 0; i < n; ++i) cin >> knows[i];

    int treeSz = timer;
    tree.resize(4 * treeSz);
    allDepths.resize(4 * treeSz);
    fts.resize(4 * treeSz);

    for (int i = 0; i < n; ++i) {
        if (knows[i] == 0)push_uncolored(1, 0, treeSz - 1, tin[i]);
        pushDepth(1, 0, treeSz - 1, tin[i]);
    }

    for (int i = 0; i < 4 * treeSz; ++i) {
        sort(all(allDepths[i]));
        fts[i].init((int) allDepths[i].size());
    }

    for (int i = 0; i < n; ++i) {
        if (knows[i] == 1)markKnown(1, 0, treeSz - 1, tin[i]);
    }

    int q;
    cin >> q;
    while (q--) {
        int type, v, k;
        cin >> type >> v >> k;
        --v;

        if (type == 1) {
            assert(false);
            for (int i = lTin[v]; i <= rTin[v]; ++i) {
                if (h[euler[i]] <= h[v] + k)knows[euler[i]] = 1;
            }
        } else {
            int need_depth = h[v] + k;
            cout << queryKnowing(1, 0, treeSz - 1, lTin[v], rTin[v], need_depth) << '\n';
//            int res = 0;
//            for (int i = lTin[v]; i <= rTin[v]; ++i) {
//                if (h[euler[i]] <= h[v] + k)res += knows[euler[i]];
//            }
//            cout << res << '\n';
        }
    }
}
