#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;

using vi = vector<int>;
const int INFi = 2e9;

struct SegTree {
    struct Node {
        int sum;
        int mn;
        int ind;

        void check(int x, int i) {
            mn = x;
            ind = i;
            sum = 0;
        }

        void upd() {
            sum = 1;
            mn = INFi;
            ind = -1;
        }

        Node() : sum(0), mn(INFi), ind(-1) {}
    };

    Node combine(const Node &a, const Node &b) {
        Node c;
        c.sum = a.sum + b.sum;
        c.mn = min(a.mn, b.mn);
        if (c.mn == a.mn) c.ind = a.ind;
        else c.ind = b.ind;
        return c;
    }

    vector<Node> t;
    int n;

    void build(vi &h) {
        int k = h.size();
        n = k + 5;;
        t.resize(n * 2);
        for(int i = 0; i < k; ++i) t[i + n].check(h[i], i);
        for(int i = n - 1; i >= 1; --i) t[i] = combine(t[i << 1], t[i << 1 | 1]);
    }

    void upd(int i) {
        for(t[i += n].upd(); i > 1; i >>= 1) t[i>>1] = combine(t[i], t[i^1]);
    }

    Node get(int l, int r) {
        Node res;
        for(l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) res = combine(res, t[l++]);
            if (r & 1) res = combine(res, t[--r]);
        }
        return res;
    }
} ST;

struct Fenwick {
    vector<int> fenw;
    int n;

    void build(int k) {
        fenw.resize(k, 0);
        n = k;
    }

    void upd(int i, int x) {
        for(; i < n; i = i | (i + 1)) fenw[i] += x;
    }

    int get(int i) {
        int res = 0;
        for(; i >= 0; i = (i & (i + 1)) - 1) res += fenw[i];
        return res;
    }
};

struct MergeSortTree {
    struct Node {
        Fenwick f;
        vector<pair<int, int>> hh;

        void combine(const Node &a, const Node &b) {
            int sz = (int)a.hh.size() + (int)b.hh.size();
            f.build(sz);
            hh.resize(sz);
            int cur = 0;
            int i = 0, j = 0;
            while(i < (int)a.hh.size() || j < (int)b.hh.size()) {
                if (i == (int)a.hh.size()) {
                    hh[cur++] = b.hh[j++];
                    continue;
                }
                if (j == (int)b.hh.size()) {
                    hh[cur++] = a.hh[i++];
                    continue;
                }
                if (a.hh[i] < b.hh[j]) {
                    hh[cur++] = a.hh[i++];
                } else {
                    hh[cur++] = b.hh[j++];
                }
            }
        }

        void upd(int x, int i) {
            int j = lower_bound(all(hh), pair<int, int> {x, i}) - hh.begin();
            f.upd(j, 1);
        }

        int get(int x) {
            pair<int, int> tmp = {x + 1, -1};
            int i = lower_bound(all(hh), tmp) - hh.begin();
            return f.get(i - 1);
        }
    };
    vector<Node> t;
    int n;

    void build(vector<int> &h) {
        n = h.size();
        t.resize(n * 4);
        make(1, 0, n, h);
    }

    void make(int v, int l, int r, vector<int> &h) {
        if (l + 1 == r) {
            t[v].f.build(1);
            t[v].hh.emplace_back(h[l], l);
            return;
        }
        make(v << 1, l, (l + r) >> 1, h);
        make(v << 1 | 1, (l + r) >> 1, r, h);
        t[v].combine(t[v << 1], t[v << 1 | 1]);
    }

    void upd(int v, int l, int r, int i, int x) {
        if (i >= r || i < l) return;
        t[v].upd(x, i);
        if (l + 1 == r) return;
        upd(v << 1, l, (l + r) >> 1, i, x);
        upd(v << 1 | 1, (l + r) >> 1, r, i, x);
    }

    void upd(int i, int x) {
        upd(1, 0, n, i, x);
    }

    int get(int v, int l, int r, int lq, int rq, int x) {
        if (rq <= l || r <= lq) return 0;
        if (lq <= l && r <= rq) {
            return t[v].get(x);
        }
        return get(v << 1, l, (l + r) >> 1, lq, rq, x) + get(v << 1 | 1, (l + r) >> 1, r, lq, rq, x);
    }

    int get(int lq, int rq, int x) {
        return get(1, 0, n, lq, rq, x);
    }
} MT;

const int maxN = 2e5 + 5;
vi g[maxN];
int h[maxN];
int b[maxN];
vi hh;
int tin[maxN];
int tout[maxN];
vi bb;
int T = 0;

void dfs(int v) {
    tin[v] = T++;
    hh.push_back(h[v]);
    bb.push_back(b[v]);
    for(auto &u : g[v]) {
        dfs(u);
    }
    tout[v] = T;
}

void solve() {
    int n; cin >> n;
    rep(_, n - 1) {
        int x, y; cin >> x >> y;
        h[y] = h[x] + 1;
        g[x].push_back(y);
    }
    for(int i = 1; i <= n; ++i) cin >> b[i];
    dfs(1);
    ST.build(hh);
    MT.build(hh);
    rep(i, n) {
        if (bb[i]) {
            MT.upd(i, hh[i]);
            ST.upd(i);
        }
    }
    int q; cin >> q;
    while(q--) {
        int t; cin >> t;
        if (t == 1) {
            int x, k; cin >> x >> k;
            auto res = ST.get(tin[x], tout[x]);
            while(res.ind != -1 && res.mn <= h[x] + k) {
                ST.upd(res.ind);
                assert(res.mn == hh[res.ind]);
                MT.upd(res.ind, hh[res.ind]);
                res = ST.get(tin[x], tout[x]);
            }
        } else {
            int x, k; cin >> x >> k;
            cout << MT.get(tin[x], tout[x], h[x] + k) << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    rep(_, tests) {
        solve();
    }
    return 0;
}