// news
#include <iostream>
#include <vector>
#include <fstream>
#include <bitset>

using namespace std;

// ifstream f("input.in");
#define f cin
#define g cout

const int NMAX = 2 * 10e5 + 5;
const int ROOT = 1;

struct informedData {
    bool value;
    int updateDownwards;

    informedData(): value(0), updateDownwards(0) {}
    informedData(const bool& value): value(value), updateDownwards(0) {}
};

int N, depth[NMAX], Q, maxDepth;
vector < int > G[NMAX];
vector < informedData > isInformed;

void dfs(int node, int nodeDepth = 1) {
    maxDepth = max(maxDepth, nodeDepth);
    depth[node] = nodeDepth;

    for(const auto& neighbor : G[node])
        dfs(neighbor, nodeDepth + 1);
}

void update(const int& node, const int& k) {
    isInformed[node] = true;

    if (k == 0)
        return;

    for(auto& it : G[node])
        update(it, k - 1); // ?? cum scap de asta
}

int query(const int& node, const int& k) {
    if (k < 0)
        return 0;

    int informed{};
    for(auto& it : G[node])
        informed += query(it, k - 1);

    return isInformed[node].value + informed;
}

int main() {
    // BUG IN TERMINAL??
    std::ios::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);

    f >> N;

    for (int i = 1;i < N;++i) {
        int u, v;
        f >> u >> v;

        G[u].push_back(v);
    }

    isInformed.resize(N + 1);
    for (int i = 1; i <= N; ++i) {
        bool value{};
        f >> value;

        isInformed[i].value = value;
    }

    dfs(ROOT);

    f >> Q;
    while(Q--) {
        int t, x, k;
        f >> t >> x >> k;

        if (t == 1)
            update(x, k);
        else 
            g << query(x, k) << '\n';
    }

    return 0;
}