#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL
#include <bits/stdc++.h>
using namespace std;

#define int long long
#define f first
#define s second

struct seg_tree
{
    vector <int> t;
    vector <int> add;
    int n;
    seg_tree(){}
    void resiz(int N)
    {
        n=N;
        add.assign(4*N+5,0);
        t.assign(4*N+5,0);
    }
    void push(int v, int l, int r)
    {
        if (add[v]==0)return;
        if (l==r){
            t[v]+=add[v];
            add[v]=0;
            return;
        }
        t[v]+=add[v]*(r-l+1);
        add[v*2]+=add[v];
        add[v*2+1]+=add[v];
        add[v]=0;
    }
    void update(int v, int l, int r, int A, int B, int x)
    {
        push(v,l,r);
        if (r<A || B<l)return;
        if (A<=l && r<=B){
            add[v]+=x;
            push(v,l,r);
            //t[v]+=x;
            return;
        }
        int m=(l+r)>>1;
        update(v*2,l,m,A,B,x);
        update(v*2+1,m+1,r,A,B,x);
        t[v]=t[v*2]+t[v*2+1];
    }
    int get(int v, int l, int r, int A, int B)
    {
        push(v,l,r);
        if (r<A || B<l)return 0;
        if (A<=l && r<=B)return t[v];
        int m=(l+r)>>1;
        return get(v*2,l,m,A,B)+get(v*2+1,m+1,r,A,B);
    }
    void Add(int A, int B, int x)
    {
        //cout << "add: " << A << " " << B << " " << x << endl;
        update(1,0,n-1,A,B,x);
    }
    int sum(int l, int r)
    {
        //cout << "zapros: " << l << " " << r << " " << get(1,0,n-1,l,r) << endl;
        return get(1,0,n-1,l,r);
    }
};

struct Lca
{
    int n;
    vector <vector <int> > g;
    vector <int> h;
    vector <int> used;
    vector <vector <int> > par;

    void dfs(int v, int p)
    {
        used[v]=1;
        h[v]=h[p]+1;
        par[0][v]=p;
        for (int u:g[v]){
            if (used[u])continue;
            dfs(u,v);
        }
    }
    void build(int N, vector <vector <int> > G)
    {
        g=G;
        n=N;
        h.assign(n,-1);
        par.assign(20,vector <int> (n,0));
        used.assign(n,0);
        dfs(0,0);

        for (int j=1; j<20; j++){
            for (int i=0; i<n; i++){
                par[j][i]=par[j-1][par[j-1][i]];
            }
        }
    }
    int lca(int v, int u)
    {
        if (h[v]<h[u])swap(v,u);
        for (int j=19; j>=0; j--){
            if (h[par[j][v]]>=h[u])v=par[j][v];
        }
        for (int j=19; j>=0; j--){
            if (par[j][v]!=par[j][u]){
                v=par[j][v];
                u=par[j][u];
            }
        }
        if (v!=u)v=par[0][v];
        return v;
    }
    int jump(int v, int k)
    {
        for (int j=19; j>=0; j--){
            if (k<(1<<j))continue;
            k-=(1<<j);
            v=par[j][v];
        }
        return v;
    }
};

struct hld
{
    seg_tree t;
    vector <vector <int> > g;
    vector <vector <int> > g_num;
    vector <int> num;
    vector <int> re_num;
    vector <int> big;
    vector <int> used;
    vector <int> cnt;
    vector <int> up;
    vector <int> h;
    vector <int> up_num;
    int now;
    Lca q;
    seg_tree T;

    hld(){}

    void obhod(int v)
    {
        used[v]=1;
        re_num[now]=v;
        num[v]=now++;
        if (up[v]==-1)up[v]=v;

        int u=big[v];
        if (u!=-1){
            up[u]=up[v];
            //cout << "!!! " << v << " " << u << endl;
            obhod(u);
            //cout << "!!! " << u << " " << num[u] << endl;
            //if (num[u]==-1)assert(0);
            //up[num[u]]=up[num[v]];
        }
        for (int u:g[v]){
            if (used[u])continue;
            obhod(u);
        }
    }
    void dfs(int v, int p)
    {
        h[v]=h[p]+1;
        used[v]=1;
        cnt[v]=1;
        for (int u:g[v]){
            if (used[u])continue;
            dfs(u,v);
            cnt[v]+=cnt[u];
        }
        for (int u:g[v]){
            if (u==p)continue;
            if (cnt[u]*2>=cnt[v])big[v]=u;
        }
    }
    void build(int n, vector <vector <int> > G){
        g=G;
        used.assign(n,0);
        cnt.resize(n,0);
        now=0;
        big.resize(n,-1);
        h.assign(n,-1);
        dfs(0,0);

        used.assign(n,0);
        num.resize(n,0);
        re_num.resize(n,0);
        up.resize(n,-1);
        obhod(0);

        up_num.resize(n);
        for (int i=0; i<n; i++){
            up_num[num[i]]=num[up[i]];
        }

        g_num.resize(n);
        for (int i=0; i<n; i++){
            for (int j:g[i]){
                g_num[num[i]].push_back(num[j]);
            }
        }
        q.build(n,g_num);
        t.resiz(n);
        T.resiz(n);
    }

    int sum(int v)
    {
        v=num[v];
        return t.sum(v,v);
    }
    /*int sum(int v, int p)
    {
        int ans=0;
        while (h[v]>=h[p]){
            int u=up[v];
            if (h[u]<h[p]){
                u=p;
            }
            ans+=t.sum(u,v);
            v=u;
            if (u==0)break;
            v=par[0][v];
        }
        return ans;
    }
    int get(int v, int u)
    {
        v=num[v];
        u=num[u];
        int w=q.lca(v,u);
        return sum(v,w)+sum(u,w);
    }*/
    void update(int v, int p, int x)
    {
        //cout << v << " " << p << " " << x << endl;
        while (h[v]>=h[p]){
            int u=up_num[v];
            if (h[u]<h[p]){
                u=p;
            }
            t.Add(u,v,x);
            if (u==0)break;
            v=q.par[0][u];
        }
    }
    void add(int v, int u, int x)
    {
        v=num[v];
        u=num[u];
        int w=q.lca(v,u);
        update(v,w,x);
        update(u,w,x);
        update(w,w,-x);
    }
    void def(int v)
    {
        v=num[v];
        T.Add(v,v,1);
        return;
        /*while (h[v]>=0){
            int u=up_num[v];
            T.Add(u,v,1);
            if (u==0)break;
            v=q.par[0][u];
        }*/
    }
    bool was(int v)
    {
        v=num[v];
        int ans=0;
        while (h[v]>=0){
            int u=up_num[v];
            ans+=T.sum(u,v);
            if (u==0)break;
            v=q.par[0][u];
        }
        return (ans>0);
    }
};


signed main()
{
    int n;
    cin >> n;
    vector <vector <int> > g(n);
    for (int i=0; i<n-1; i++){
        int v,u;
        cin >> v >> u;
        v--;
        u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    hld t;
    t.build(n,g);
    for (int i=0; i<n; i++){
        int x;
        cin >> x;
        if (!x)continue;
        t.add(i,0,1);
    }
    int q;
    cin >> q;
    while (q--){
        int ty;
        cin >> ty;
        if (ty==1){
            int v,k;
            cin >> v >> k;
            v--;
            if (k!=n)assert(0);
            int was=t.sum(v);
            int will=t.cnt[v];
            t.add(v,0,will-was);
            t.def(v);
        }
        else {
            int v,k;
            cin >> v >> k;
            v--;
            if (k!=n)assert(0);
            if (t.was(v)){
                cout << t.cnt[v] << endl;
                continue;
            }
            cout << t.sum(v) << endl;
        }
    }
}
/**
15
1 2
1 3
2 4
2 5
3 6
3 7
4 8
4 9
5 10
5 11
6 12
6 13
7 14
7 15

0 0 0 0 0 0 0 0 0 0 0 0 0 0 0

100

2 1 15
2 15 15
*/
