#include<bits/stdc++.h>
#define p pair<int, int>
#define endl '\n'
const int INF = 1000000001;

using namespace std;

mt19937 randint(179);

struct Node{
    int x, y;
    Node *l, *r;
    int num, size;

    Node(int x1) : x(x1), y(randint()), l(nullptr), r(nullptr), num(1), size(1) {}
};

void update(Node* tree) {
    if (tree == nullptr) {
        return;
    }
    tree->size = tree->num+(tree->l == nullptr ? 0 : tree->l->size)+(tree->r == nullptr ? 0 : tree->r->size);
}

Node* merge(Node* tree1, Node* tree2) {
    if (tree1 == nullptr) {
        return tree2;
    }
    if (tree2 == nullptr) {
        return tree1;
    }
    if (tree1->y < tree2->y) {
        tree1->r = merge(tree1->r, tree2);
        update(tree1);
        return tree1;
    }
    tree2->l = merge(tree1, tree2->l);
    update(tree2);
    return tree2;
}

pair<Node*, Node*> split(Node* tree, int x) {
    if (tree == nullptr) {
        return {nullptr, nullptr};
    }
    if (tree->x <= x) {
        pair<Node*, Node*> trees = split(tree->r, x);
        tree->r = trees.first;
        update(tree);
        return {tree, trees.second};
    }
    pair<Node*, Node*> trees = split(tree->l, x);
    tree->l = trees.second;
    update(tree);
    return {trees.first, tree};
}

Node* add(Node* tree, int x) {
    Node* now = new Node(x);
    pair<Node*, Node*> trees1 = split(tree, x);
    pair<Node*, Node*> trees2 = split(trees1.first, x-1);
    if (trees2.second == nullptr) {
        trees2.second = now;
    } else {
        trees2.second->num++, trees2.second->size++;
    }
    return merge(merge(trees2.first, trees2.second), trees1.second);
}

Node* del(Node* tree, int x) {
    pair<Node*, Node*> trees1 = split(tree, x);
    pair<Node*, Node*> trees2 = split(trees1.first, x-1);
    if (trees2.second == nullptr) {
        exit(179);
    }
    if (trees2.second->num != 1) {
        trees2.second->num--, trees2.second->size--;
        return merge(merge(trees2.first, trees2.second), trees1.second);
    }
    return merge(trees2.first, trees1.second);
}

struct DO{
    vector<vector<int>> do_arr;
    vector<int> mod;
    int len;

    DO(vector<int> &a) {
        len = 1;
        while (len < a.size()) {
            len *= 2;
        }
        do_arr.assign(2*len, {}), mod.assign(2*len, -1);
        for (int q = len; q < len+a.size(); q++) {
            do_arr[q].push_back(a[q-len]);
        }
        for (int q = len-1; q > 0; q--) {
            merge(do_arr[2*q].begin(), do_arr[2*q].end(), do_arr[2*q+1].begin(), do_arr[2*q+1].end(), back_inserter(do_arr[q]));
        }
    }

    int ans(int l, int r, int l1, int r1, int q, int h) {
        if (l >= r1 || l1 >= r) {
            return 0;
        }
        if (l1 <= l && r <= r1) {
            return upper_bound(do_arr[q].begin(), do_arr[q].end(), h)-do_arr[q].begin();
        }
        int m = (l+r)/2;
        return ans(l, m, l1, r1, 2*q, h)+ans(m, r, l1, r1, 2*q+1, h);
    }
};

struct MST{
    vector<Node*> do_arr;
    vector<int> mod;
    int len;

    MST(vector<int> &a) {
        len = 1;
        while (len < a.size()) {
            len *= 2;
        }
        do_arr.assign(2*len, nullptr), mod.assign(2*len, -1);
        for (int q = len; q < len+a.size(); q++) {
            int q1 = q;
            while (q1 > 0) {
                do_arr[q1] = add(do_arr[q1], a[q-len]);
                q1 >>= 1;
            }
        }
    }

    void del(int q) {
        pair<Node*, Node*> trees = split(do_arr[q], mod[q]);
        do_arr[q] = trees.second;
    }

    void del_all(int q) {
        pair<Node*, Node*> trees = split(do_arr[q], mod[q]);
        do_arr[q] = trees.second;
        queue<Node*> a;
        if (trees.first != nullptr) {
            a.push(trees.first);
        }
        while (!a.empty()) {
            Node* vertex = a.front();
            if (vertex->l != nullptr) {
                a.push(vertex->l);
            }
            if (vertex->r != nullptr) {
                a.push(vertex->r);
            }
            a.pop();
            int now = vertex->x, q1 = (q >> 1);
            while (q1 > 0) {
                do_arr[q1] = ::del(do_arr[q1], now);
                q1 >>= 1;
            }
        }
    }

    void push(int q) {
        mod[2*q] = max(mod[2*q], mod[q]), mod[2*q+1] = max(mod[2*q+1], mod[q]);
        del(2*q), del(2*q+1);
    }

    void update(int l, int r, int l1, int r1, int q, int h) {
        if (l >= r1 || l1 >= r) {
            return;
        }
        if (l1 <= l && r <= r1) {
            mod[q] = max(mod[q], h);
            del_all(q);
            return;
        }
        push(q);
        int m = (l+r)/2;
        update(l, m, l1, r1, 2*q, h);
        update(m, r, l1, r1, 2*q+1, h);
    }

    int ans(int l, int r, int l1, int r1, int q, int h) {
        if (l >= r1 || l1 >= r) {
            return 0;
        }
        if (l1 <= l && r <= r1) {
            pair<Node*, Node*> trees = split(do_arr[q], h);
            int w = (trees.first == nullptr ? 0 : trees.first->size);
            do_arr[q] = merge(trees.first, trees.second);
            return w;
        }
        push(q);
        int m = (l+r)/2;
        return ans(l, m, l1, r1, 2*q, h)+ans(m, r, l1, r1, 2*q+1, h);
    }
};

vector<vector<int>> d;
vector<int> is, tin, tout, height, order;
int time1 = 0;

void make(int vertex, int h) {
    tin[vertex] = time1++, height[vertex] = h;
    order.push_back(h);
    for (int q : d[vertex]) {
        make(q, h+1);
    }
    tout[vertex] = time1;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n;
    d.assign(n, {}), is.assign(n, -1), tin.assign(n, -1), tout.assign(n, -1), height.assign(n, -1);
    for (int q = 0; q < n-1; q++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        d[x].push_back(y);
    }
    for (int q = 0; q < n; q++) {
        cin >> is[q];
    }
    make(0, 0);
    DO do_arr = DO(order);
    MST mst = MST(order);
    for (int q = 0; q < n; q++) {
        if (is[q]) {
            mst.update(0, mst.len, tin[q], tout[q], 1, height[q]);
        }
    }
    cin >> m;
    for (int q = 0; q < m; q++) {
        int type, x, k;
        cin >> type >> x >> k;
        x--;
        if (type == 1) {
            mst.update(0, mst.len, tin[x], tout[x], 1, height[x]+k);
        } else {
            cout << do_arr.ans(0, do_arr.len, tin[x], tout[x], 1, height[x]+k)-mst.ans(0, mst.len, tin[x], tout[x], 1, height[x]+k) << endl;
        }
    }
    return 0;
}
