#include<bits/stdc++.h>
#define p pair<int, int>
#define endl '\n'
const int INF = 1000000001;

using namespace std;

struct DO{
    vector<vector<int>> do_arr;
    vector<int> mod;
    int len;

    DO(vector<int> &a) {
        len = 1;
        while (len < a.size()) {
            len *= 2;
        }
        do_arr.assign(2*len, {}), mod.assign(2*len, -1);
        for (int q = len; q < len+a.size(); q++) {
            do_arr[q].push_back(a[q-len]);
        }
        for (int q = len-1; q > 0; q--) {
            merge(do_arr[2*q].begin(), do_arr[2*q].end(), do_arr[2*q+1].begin(), do_arr[2*q+1].end(), back_inserter(do_arr[q]));
        }
    }

    int ans(int l, int r, int l1, int r1, int q, int h) {
        if (l >= r1 || l1 >= r) {
            return 0;
        }
        if (l1 <= l && r <= r1) {
            return upper_bound(do_arr[q].begin(), do_arr[q].end(), h)-do_arr[q].begin();
        }
        int m = (l+r)/2;
        return ans(l, m, l1, r1, 2*q, h)+ans(m, r, l1, r1, 2*q+1, h);
    }
};

struct MST{
    vector<int> do_arr;
    vector<bool> mod;
    int len;

    MST(vector<p> &a) {
        len = 1;
        while (len < a.size()) {
            len *= 2;
        }
        do_arr.assign(2*len, {}), mod.assign(2*len, false);
        for (int q = len; q < len+a.size(); q++) {
            do_arr[q] = 1;
        }
        for (int q = len-1; q > 0; q--) {
            do_arr[q] = do_arr[2*q]+do_arr[2*q+1];
        }
    }

    void push(int q) {
        if (mod[q]) {
            do_arr[2*q] = do_arr[2*q+1] = 0, mod[2*q] = mod[2*q+1] = true;
        }
    }

    void update(int l, int r, int l1, int r1, int q) {
        if (l >= r1 || l1 >= r) {
            return;
        }
        if (l1 <= l && r <= r1) {
            do_arr[q] = 0, mod[q] = true;
            return;
        }
        push(q);
        int m = (l+r)/2;
        update(l, m, l1, r1, 2*q);
        update(m, r, l1, r1, 2*q+1);
        do_arr[q] = do_arr[2*q]+do_arr[2*q+1];
    }

    int ans(int l, int r, int l1, int r1, int q) {
        if (l >= r1 || l1 >= r) {
            return 0;
        }
        if (l1 <= l && r <= r1) {
            return do_arr[q];
        }
        push(q);
        int m = (l+r)/2;
        return ans(l, m, l1, r1, 2*q)+ans(m, r, l1, r1, 2*q+1);
    }
};

vector<vector<int>> d;
vector<int> is, tin, tout, height;
vector<p> order;
int time1 = 0;

void make(int vertex, int h) {
    tin[vertex] = time1++, height[vertex] = h;
    order.push_back({vertex, h});
    for (int q : d[vertex]) {
        make(q, h+1);
    }
    tout[vertex] = time1;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n;
    d.assign(n, {}), is.assign(n, -1), tin.assign(n, -1), tout.assign(n, -1), height.assign(n, -1);
    for (int q = 0; q < n-1; q++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        d[x].push_back(y);
    }
    for (int q = 0; q < n; q++) {
        cin >> is[q];
    }
    make(0, 0);
    vector<int> order_h;
    for (p q : order) {
        order_h.push_back(q.second);
    }
    DO do_arr = DO(order_h);
    MST mst = MST(order);
    for (int q = 0; q < n; q++) {
        if (is[q]) {
            mst.update(0, mst.len, tin[q], tin[q]+1, 1);
        }
    }
    cin >> m;
    for (int q = 0; q < m; q++) {
        int type, x, k;
        cin >> type >> x >> k;
        x--;
        if (type == 1) {
            mst.update(0, mst.len, tin[x], tout[x], 1);
        } else {
            cout << tout[x]-tin[x]-mst.ans(0, mst.len, tin[x], tout[x], 1) << endl;
        }
    }
    return 0;
}
