#include<bits/extc++.h>
#define p pair<int, int>
#define endl '\n'
const long long INF = 200179, INF1 = 200057;

using namespace __gnu_pbds;
using namespace std;

struct DO{
    vector<vector<int>> do_arr;
    vector<int> mod;
    int len;
    DO(vector<int> &a) {
        len = 1;
        while (len < a.size()) {
            len *= 2;
        }
        do_arr.assign(2*len, {}), mod.assign(2*len, -1);
        for (int q = len; q < len+a.size(); q++) {
            do_arr[q].push_back(a[q-len]);
        }
        for (int q = len-1; q > 0; q--) {
            merge(do_arr[2*q].begin(), do_arr[2*q].end(), do_arr[2*q+1].begin(), do_arr[2*q+1].end(), back_inserter(do_arr[q]));
        }
    }
    int ans(int l, int r, int l1, int r1, int q, int h) {
        if (l >= r1 || l1 >= r) {
            return 0;
        }
        if (l1 <= l && r <= r1) {
            return upper_bound(do_arr[q].begin(), do_arr[q].end(), h)-do_arr[q].begin();
        }
        int m = (l+r)/2;
        return ans(l, m, l1, r1, 2*q, h)+ans(m, r, l1, r1, 2*q+1, h);
    }
};

typedef tree<long long, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

struct MST{
    vector<ordered_set> do_arr;
    vector<int> mod;
    int len;

    MST(vector<p> &a) {
        len = 1;
        while (len < a.size()) {
            len *= 2;
        }
        do_arr.assign(2*len, {}), mod.assign(2*len, -1);
        for (int q = len; q < len+a.size(); q++) {
            do_arr[q].insert(a[q-len].second*INF+a[q-len].first);
        }
        for (int q = len-1; q > 0; q--) {
            for (long long q1 : do_arr[2*q]) {
                do_arr[q].insert(q1);
            }
            for (long long q1 : do_arr[2*q+1]) {
                do_arr[q].insert(q1);
            }
        }
    }

    void del(int q) {
        while (!do_arr[q].empty() && *do_arr[q].begin() <= mod[q]*INF+INF1) {
            do_arr[q].erase(do_arr[q].begin());
        }
    }

    void del_all(int q) {
        while (!do_arr[q].empty() && *do_arr[q].begin() <= mod[q]*INF+INF1) {
            long long now = *do_arr[q].begin();
            int q1 = q;
            while (q1 > 0) {
                do_arr[q1].erase(now);
                q1 >>= 1;
            }
        }
    }

    void push(int q) {
        mod[2*q] = max(mod[2*q], mod[q]), mod[2*q+1] = max(mod[2*q+1], mod[q]);
        del(2*q), del(2*q+1);
    }

    void update(int l, int r, int l1, int r1, int q, int h) {
        if (l >= r1 || l1 >= r) {
            return;
        }
        if (l1 <= l && r <= r1) {
            mod[q] = max(mod[q], h);
            del_all(q);
            return;
        }
        push(q);
        int m = (l+r)/2;
        update(l, m, l1, r1, 2*q, h);
        update(m, r, l1, r1, 2*q+1, h);
    }

    int ans(int l, int r, int l1, int r1, int q, int h) {
        if (l >= r1 || l1 >= r) {
            return 0;
        }
        if (l1 <= l && r <= r1) {
            int w = do_arr[q].order_of_key(h*INF+INF1);
            return w;
        }
        push(q);
        int m = (l+r)/2;
        return ans(l, m, l1, r1, 2*q, h)+ans(m, r, l1, r1, 2*q+1, h);
    }
};

vector<vector<int>> d;
vector<int> is, tin, tout, height;
vector<p> order;
int time1 = 0;

void make(int vertex, int h) {
    tin[vertex] = time1++, height[vertex] = h;
    order.push_back({vertex, h});
    for (int q : d[vertex]) {
        make(q, h+1);
    }
    tout[vertex] = time1;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n;
    d.assign(n, {}), is.assign(n, -1), tin.assign(n, -1), tout.assign(n, -1), height.assign(n, -1);
    for (int q = 0; q < n-1; q++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        d[x].push_back(y);
    }
    for (int q = 0; q < n; q++) {
        cin >> is[q];
    }
    make(0, 0);
    vector<int> order_h;
    for (p q : order) {
        order_h.push_back(q.second);
    }
    DO do_arr = DO(order_h);
    MST mst = MST(order);
    for (int q = 0; q < n; q++) {
        if (is[q]) {
            mst.update(0, mst.len, tin[q], tout[q], 1, height[q]);
        }
    }
    cin >> m;
    for (int q = 0; q < m; q++) {
        int type, x, k;
        cin >> type >> x >> k;
        x--;
        if (type == 1) {
            mst.update(0, mst.len, tin[x], tout[x], 1, height[x]+k);
        } else {
            cout << do_arr.ans(0, do_arr.len, tin[x], tout[x], 1, height[x]+k)-mst.ans(0, mst.len, tin[x], tout[x], 1, height[x]+k) << endl;
        }
    }
    return 0;
}
