#include <bits/stdc++.h>

using namespace std;



class IntervalContainer {
	vector<pair<int, int>> items;

public:
	int get(int i) const {
		auto it = lower_bound(items.begin(), items.end(), make_pair(i + 1, 0));
		--it;
		return i - it->first + it->second;
	}

	void build_from_next(const vector<int>& next) {
		int s = 0;
		int c = 0;
		items.emplace_back(s, c);
		for(int elem: next) {
			s += elem - c;
			c = elem + 1;
			items.emplace_back(s, c);
		}
	}
};


const int MAXB = 3000;
IntervalContainer dp[MAXB + 1];


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int k, q;
	cin >> k >> q;

	for(int b = 0; b <= MAXB; b++) {
		vector<int> next;
		for(int x = 1; x <= b; x++) {
			next.push_back(dp[b - x].get(k * x));
		}
		sort(next.begin(), next.end());
		next.erase(unique(next.begin(), next.end()), next.end());
		dp[b].build_from_next(next);
	}

	for(int i = 0; i < q; i++) {
		int n;
		cin >> n;

		int xx = 0;
		for(int j = 0; j < n; j++) {
			int b, s;
			cin >> b >> s;
			xx ^= dp[b].get(s);
		}

		cout << (xx == 0 ? "Loss" : "Win") << endl;
	}

	return 0;
}
