#include <bits/stdc++.h>

using namespace std;


vector<int> s, e;
vector<vector<pair<int, int>>> adj;
vector<tuple<long long, map<long long, long long>, long long>> dp;


void dfs(int u) {
	long long& sum = get<0>(dp[u]);
	auto& diff = get<1>(dp[u]);
	long long& global_diff_mod = get<2>(dp[u]);

	for(auto [v, w]: adj[u]) {
		dfs(v);
		auto& [child_sum, child_diff, child_diff_mod] = dp[v];
		sum += child_sum;
		if(child_diff.size() < diff.size()) {
			for(auto [d1, k]: child_diff) {
				diff[d1 + child_diff_mod + w - global_diff_mod] += k;
			}
		} else {
			for(auto [d1, k]: diff) {
				child_diff[d1 - child_diff_mod - w + global_diff_mod] += k;
			}
			swap(child_diff, diff);
			global_diff_mod = child_diff_mod + w;
		}
		child_diff.clear();
	}

	int cnt_left = s[u];
	while(cnt_left > 0 && !diff.empty() && diff.rbegin()->first + global_diff_mod > 0) {
		auto it = diff.end();
		--it;

		long long k = min((long long)cnt_left, it->second);
		cnt_left -= k;
		sum += (it->first + global_diff_mod) * k;
		if((it->second -= k) == 0) {
			diff.erase(it);
		}
	}
	int c = s[u] - cnt_left;

	diff[-global_diff_mod] += c + e[u];
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;

	dp.resize(n);

	s.resize(n);
	for(int i = 0; i < n; i++) {
		cin >> s[i];
	}
	e.resize(n);
	for(int i = 0; i < n; i++) {
		cin >> e[i];
	}

	adj.resize(n);
	for(int v = 1; v < n; v++) {
		int p, w;
		cin >> p >> w;
		p--;
		adj[p].emplace_back(v, w);
	}


	dp.resize(n);

	dfs(0);

	cout << get<0>(dp[0]) << endl;

	return 0;
}
