#include <bits/stdc++.h>

using namespace std;


int n;

vector<int> time_first_learned;
vector<vector<pair<int, int>>> updates;
vector<vector<int>> adj;


class SegmentTreeMin {
	vector<int> a;
	int n;

public:
	SegmentTreeMin() {
	}

	void resize(int n_) {
		n = n_;
		a.resize(2 * n, 1000000000);
	}

	int size() const {
		return n;
	}

	int get(int l, int r) const {
		l += n;
		r += n;
		int ans = 1000000000;
		while(l < r) {
			ans = min(ans, a[l]);
			ans = min(ans, a[r - 1]);
			l = (l + 1) / 2;
			r /= 2;
		}
		return ans;
	}

	int get(int i) const {
		return a[n + i];
	}

	void set(int i, int x) {
		i += n;
		a[i] = x;
		i /= 2;
		while(i >= 1) {
			a[i] = min(a[i * 2], a[i * 2 + 1]);
			i /= 2;
		}
	}
};


SegmentTreeMin time_first_learned_by_height;


void dfs1(int u, int h) {
	vector<pair<int, int>> restorer;
	for(auto [k, q]: updates[u]) {
		int hh = min(h + k, n);
		int oldval = time_first_learned_by_height.get(hh);
		restorer.emplace_back(hh, oldval);
		time_first_learned_by_height.set(hh, min(oldval, q));
	}
	time_first_learned[u] = min(time_first_learned[u], time_first_learned_by_height.get(h, time_first_learned_by_height.size()));
	for(int v: adj[u]) {
		dfs1(v, h + 1);
	}
	for(int j = (int)restorer.size() - 1; j >= 0; j--) {
		auto [i, x] = restorer[j];
		time_first_learned_by_height.set(i, x);
	}
}


vector<vector<pair<int, int>>> queries;
vector<int> answers;


void dfs2(int u, int h, vector<pair<int, int>>& children) {
	for(int v: adj[u]) {
		vector<pair<int, int>> tmp_children;
		dfs2(v, h + 1, tmp_children);
		for(auto [hh, qq]: tmp_children) {
			children.emplace_back(hh, qq);
		}
	}
	children.emplace_back(h, time_first_learned[u]);

	for(auto [k, q]: queries[u]) {
		int ans = 0;
		for(auto [hh, qq]: children) {
			if(q >= qq && hh <= h + k) {
				ans++;
			}
		}
		answers[q] = ans;
	}
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);


	cin >> n;

	adj.resize(n);
	for(int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		adj[u].push_back(v);
	}

	time_first_learned.resize(n);
	for(int i = 0; i < n; i++) {
		int b;
		cin >> b;
		time_first_learned[i] = b == 1 ? 0 : 1000000000;
	}


	int q;
	cin >> q;

	updates.resize(n);
	queries.resize(n);
	for(int i = 0; i < q; i++) {
		int c, x, k;
		cin >> c >> x >> k;
		x--;
		if(c == 1) {
			updates[x].emplace_back(k, i);
		} else if(c == 2) {
			queries[x].emplace_back(k, i);
		}
	}

	time_first_learned_by_height.resize(n + 1);
	dfs1(0, 0);

	vector<pair<int, int>> tmp;
	answers.resize(q, -1);
	dfs2(0, 0, tmp);

	for(int x: answers) {
		if(x != -1) {
			cout << x << "\n";
		}
	}

	return 0;
}
