#include <bits/stdc++.h>

using namespace std;


mt19937 rng{random_device{}()};


int n;

vector<int> time_first_learned;
vector<vector<pair<int, int>>> updates;
vector<vector<int>> adj;
vector<int> tin, tout, height;
int curtm;


class SegmentTreeMin {
	vector<int> a;
	int n;

public:
	SegmentTreeMin() {
	}

	void resize(int n_) {
		n = n_;
		a.resize(2 * n, 1000000000);
	}

	int size() const {
		return n;
	}

	int get(int l, int r) const {
		l += n;
		r += n;
		int ans = 1000000000;
		while(l < r) {
			ans = min(ans, a[l]);
			ans = min(ans, a[r - 1]);
			l = (l + 1) / 2;
			r /= 2;
		}
		return ans;
	}

	int get(int i) const {
		return a[n + i];
	}

	void set(int i, int x) {
		i += n;
		a[i] = x;
		i /= 2;
		while(i >= 1) {
			a[i] = min(a[i * 2], a[i * 2 + 1]);
			i /= 2;
		}
	}
};


SegmentTreeMin time_first_learned_by_height;


void dfs1(int u, int h) {
	tin[u] = curtm++;
	height[u] = h;
	vector<pair<int, int>> restorer;
	for(auto [k, q]: updates[u]) {
		int hh = min(h + k, n);
		int oldval = time_first_learned_by_height.get(hh);
		restorer.emplace_back(hh, oldval);
		time_first_learned_by_height.set(hh, min(oldval, q));
	}
	time_first_learned[u] = min(time_first_learned[u], time_first_learned_by_height.get(h, time_first_learned_by_height.size()));
	for(int v: adj[u]) {
		dfs1(v, h + 1);
	}
	for(int j = (int)restorer.size() - 1; j >= 0; j--) {
		auto [i, x] = restorer[j];
		time_first_learned_by_height.set(i, x);
	}
	tout[u] = curtm;
}


vector<vector<pair<int, int>>> queries;
vector<int> answers;


struct Node;

vector<Node> nodes;

struct Node {
	int x, y;
	int left;
	int right;
	int size;

	Node(int x): x(x), y(rng()), left(-1), right(-1), size(1) {
	}

	void pull() {
		size = (left == -1 ? 0 : nodes[left].size) + 1 + (right == -1 ? 0 : nodes[right].size);
	}
};


class Treap {
	mutable int root;

public:
	Treap(): root(-1) {
	}

	int merge(int u, int v) const {
		if(u == -1) {
			return v;
		} else if(v == -1) {
			return u;
		}
		if(nodes[u].y > nodes[v].y) {
			nodes[u].right = merge(nodes[u].right, v);
			nodes[u].pull();
			return u;
		} else {
			nodes[v].left = merge(u, nodes[v].left);
			nodes[v].pull();
			return v;
		}
	}

	pair<int, int> split(int u, int x) const {
		if(u == -1) {
			return {u, u};
		}
		if(x <= nodes[u].x) {
			auto pp = split(nodes[u].left, x);
			nodes[u].left = pp.second;
			nodes[u].pull();
			return {pp.first, u};
		} else {
			auto pp = split(nodes[u].right, x);
			nodes[u].right = pp.first;
			nodes[u].pull();
			return {u, pp.second};
		}
	}

	int count_less(int high) const {
		auto pp = split(root, high);
		int cnt = pp.first == -1 ? 0 : nodes[pp.first].size;
		root = merge(pp.first, pp.second);
		return cnt;
	}


	int add(int u, int v) {
		if(u == -1) {
			return v;
		}
		if(nodes[v].y > nodes[u].y) {
			auto pp = split(u, nodes[v].x + rng() % 2);
			nodes[v].left = pp.first;
			nodes[v].right = pp.second;
			nodes[v].pull();
			return v;
		}
		if(pair{nodes[v].x, nodes[v].y} < pair{nodes[u].x, nodes[v].y}) {
			nodes[u].left = add(nodes[u].left, v);
		} else {
			nodes[u].right = add(nodes[u].right, v);
		}
		nodes[u].pull();
		return u;
	}


	void add(int x) {
		int node = nodes.size();
		nodes.emplace_back(x);
		root = add(root, node);
		// auto pp = split(root, x);
		// root = merge(merge(pp.first, node), pp.second);
	}
};


class MergeSortTree {
	vector<Treap> a;
	int n;

public:
	MergeSortTree(int n): n(n) {
		a.resize(4 * n);
	}

	int size() const {
		return n;
	}

	int get(int v, int vl, int vr, int l, int r, int high) const {
		if(l == vl && r == vr) {
			return a[v].count_less(high);
		}
		int vm = (vl + vr) / 2;
		if(r <= vm) {
			return get(v * 2, vl, vm, l, r, high);
		} else if(l >= vm) {
			return get(v * 2 + 1, vm, vr, l, r, high);
		} else {
			return get(v * 2, vl, vm, l, vm, high) + get(v * 2 + 1, vm, vr, vm, r, high);
		}
	}
	int get(int l, int r, int high) const {
		return get(1, 0, n, l, r, high);
	}

	void add(int v, int vl, int vr, int i, int x) {
		a[v].add(x);
		if(vr - vl > 1) {
			int vm = (vl + vr) / 2;
			if(i < vm) {
				add(v * 2, vl, vm, i, x);
			} else {
				add(v * 2 + 1, vm, vr, i, x);
			}
		}
	}
	void add(int i, int x) {
		add(1, 0, n, i, x);
	}
};


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	srand(time(0));


	cin >> n;

	adj.resize(n);
	for(int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		adj[u].push_back(v);
	}

	time_first_learned.resize(n);
	for(int i = 0; i < n; i++) {
		int b;
		cin >> b;
		time_first_learned[i] = b == 1 ? 0 : 1000000000;
	}


	int q;
	cin >> q;

	updates.resize(n);
	queries.resize(n);
	for(int i = 0; i < q; i++) {
		int c, x, k;
		cin >> c >> x >> k;
		x--;
		if(c == 1) {
			updates[x].emplace_back(k, i);
		} else if(c == 2) {
			queries[x].emplace_back(k, i);
		}
	}

	time_first_learned_by_height.resize(n + 1);
	tin.resize(n);
	tout.resize(n);
	height.resize(n);
	dfs1(0, 0);


	vector<tuple<int, int, int, int>> events;
	for(int u = 0; u < n; u++) {
		for(auto [k, q]: queries[u]) {
			events.emplace_back(q, 2, u, k);
		}
		events.emplace_back(time_first_learned[u], 1, u, -1);
	}
	sort(events.begin(), events.end());


	MergeSortTree arr(n);
	answers.resize(q, -1);

	for(auto [q, c, u, k]: events) {
		if(c == 1) {
			// Add
			arr.add(tin[u], height[u]);
		} else if(c == 2) {
			// Count
			int ans = arr.get(tin[u], tout[u], height[u] + k + 1);
			answers[q] = ans;
		}
	}

	for(int x: answers) {
		if(x != -1) {
			cout << x << "\n";
		}
	}

	return 0;
}
