#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define sz(x) ((int)x.size())
using namespace std;

const int inf = 1e9;
const int N = 200005;
int n, in[N], out[N], depth[N], subtree[N];
vector<int> v[N], u(1);

struct ooo {
	ooo(int _vl, int _vr) {
		l = r = 0;
		vl = _vl;
		vr = _vr;
		ind = val = f = (vector<int>){0};
	}

	vector<int> val, f, ind;
	int vl, vr;
	ooo *l, *r;

	void S() {
		int vm = vl + vr >> 1;
		l = new ooo(vl, vm);
		r = new ooo(vm + 1, vr);

		for(int i = 1; i < sz(val); ++i) {
			if(val[i] <= vm) {
				// li[i] = sz(l->val);
				l->val.push_back(val[i]);
				l->ind.push_back(ind[i]);
				l->f.push_back(0);
			} else {
				// ri[i] = sz(r->val);
				r->val.push_back(val[i]);
				r->ind.push_back(ind[i]);
				r->f.push_back(0);
			}
		}

		l->I();
		r->I();
	}

	void I() {
		for(int i = 1; i < sz(f); ++i) {
			for(int j = i; j < sz(f); j += (j & -j)) {
				++f[j];
			}
		}
	}

	int M() {
		return vl + vr >> 1;
	}

	int Ps(int i) {
		int x = 0;
		for(; i; i -= (i & -i)) {
			x += f[i];
		}
		return x;
	}
} *root, *rt;

struct omin {
	omin() {
		mn = inf;
		l = r = 0;
	}
	omin *l, *r;
	int mn;

	void P() {
		if(!l) l = new omin();
		if(!r) r = new omin();
		mn = min(l->mn, r->mn);
	}
} *rootmin;

void updmin(int si, int x = inf, int l = 1, int r = n, omin *&t = rootmin) {
	if(!t) t = new omin();
	if(l == r) {
		t->mn = x;
		return;
	}
	int m = l + r >> 1;
	if(si > m) updmin(si, x, m + 1, r, t->r);
	else updmin(si, x, l, m, t->l);
	t->P();
}

int minn(int sl, int sr, int l = 1, int r = n, omin *&t = rootmin) {
	if(!t || r < sl || l > sr) return inf;
	if(l >= sl && r <= sr) return t->mn;
	int m = l + r >> 1;
	return min(minn(sl, sr, l, m, t->l), minn(sl, sr, m + 1, r, t->r));
}

void build(ooo *&t = root) {
	if(t->vl == t->vr) return;

	t->S();
	build(t->l);
	build(t->r);
}

void erase(int i, ooo *&t = root) {
	int l = 1, r = sz(t->ind) - 1;
	while(l < r) {
		int m = l + r >> 1;
		if(t->ind[m] < i) l = m + 1;
		else r = m;
	}
	// cout << "[] "; for(int i = 1; i < sz(t->val); ++i) cout << t->ind[i] << " "; cout << ", " << i << endl;
	// cout << "   "; for(int i = 1; i < sz(t->val); ++i) cout << t->val[i] << " "; cout << ", " << i << endl;
	assert(t->ind[l] == i);

	for(int j = l; j < sz(t->f); j += (j & -j)) {
		--t->f[j];
	}

	if(t->vl == t->vr) return;

	if(t->val[l] > t->M()) erase(i, t->r);
	else erase(i, t->l);
}

int count(int sl, int sr, int svl, int svr, ooo *&t = root) {
	if(svl <= t->vl && svr >= t->vr) {
		if(!sz(t->ind)) return 0;
		if(t->ind[1] > sr) return 0;
		if(t->ind.back() < sl) return 0;
		int l = 1, r = sz(t->ind) - 1;
		while(l < r) {
			int m = l + r >> 1;
			if(t->ind[m] < sl) l = m + 1;
			else r = m;
		}
		sl = l;
		l = 1, r = sz(t->ind) - 1;
		while(l < r) {
			int m = l + r + 1 >> 1;
			if(t->ind[m] > sr) r = m - 1;
			else l = m;
		}
		sr = l;
		if(sl > sr) return 0;
		return t->Ps(sr) - t->Ps(sl - 1);
	}

	if(svl > t->M()) {
		return count(sl, sr, svl, svr, t->r);
	}

	if(svr <= t->M()) {
		return count(sl, sr, svl, svr, t->l);
	}

	return count(sl, sr, svl, svr, t->l) + count(sl, sr, svl, svr, t->r);
}

void dfs(int x = 1) {
	subtree[x] = 1;
	in[x] = sz(u);
	u.push_back(x);

	for(int z : v[x]) {
		depth[z] = depth[x] + 1;
		dfs(z);
		subtree[x] += subtree[z];
	}

	out[x] = in[u.back()];
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	root = new ooo(1, n);
	rt = new ooo(1, n);
	for(int i = 1; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		v[x].push_back(y);
	}

	depth[1] = 1;
	dfs();

	for(int i = 1; i <= n; ++i) {
		root->val.push_back(depth[u[i]]);
		root->ind.push_back(i);
		root->f.push_back(0);
	}
	rt->val = root->val;
	rt->ind = root->ind;
	rt->f = root->f;
	root->I();
	rt->I();
	build();
	build(rt);

	int b[n];
	for(int i = 1; i <= n; ++i) {
		cin >> b[i];
		// upd
		if(b[i]) {
			erase(in[i]);
		} else {
			updmin(in[i], depth[i]);
		}
	}

	int q;
	cin >> q;
	for(int qi = 1; qi <= q; ++qi) {
		int t, x, k;
		cin >> t >> x >> k;
		if(t == 1) {
			// upd

			/////
			// for(int i = 1; i <= n; ++i) {
			// 	if(in[i] >= in[x] && out[i] <= out[x] && depth[i] <= depth[x] + k) {
			// 		if(!b[i]) {
			// 			b[i] = 1;
			// 			erase(in[i]);
			// 		}
			// 	}
			// }
			// continue;
			/////

			int z = depth[x] + k;
			while(minn(in[x], out[x]) <= z) {
				int l = in[x], r = out[x];
				while(l < r) {
					int m = l + r >> 1;
					if(minn(in[x], m) <= z) r = m;
					else l = m + 1;
				}
				updmin(l, inf);
				erase(l);
			}
		} else {
			// query
			cout << count(in[x], out[x], depth[x], depth[x] + k, rt) - count(in[x], out[x], depth[x], depth[x] + k) << "\n";
		}
	}
	return 0;
}
