#include <bits/stdc++.h>
using namespace std;
#define vint vector<int>
#define pb push_back
#define int long long
vector<vint> adj;

struct SegmentTree
{
    int N, sz;
    vector<int> tree, lazy;
    SegmentTree(int n)
    {
        N = n;
        sz = 4*N;
        tree.assign(sz, 0);
        lazy.assign(sz, 0);
    }
    void update(int v, int nowl, int nowr, int l, int r)
    {
        if(nowl > nowr || nowr < l || nowl > r)
        {
            return;
        }
        if(nowl >= l && nowr <= r)
        {
            lazy[v] = 1;
            push(v, nowl, nowr);
            return;
        }
        push(v, nowl, nowr);
        int mid = (nowl+nowr)/2;
        update(2*v, nowl, mid, l, r);
        update(2*v+1, mid+1, nowr, l, r);
        tree[v] = tree[2*v]+tree[2*v+1];
    }
    int get(int v, int nowl, int nowr, int l, int r)
    {
        if(nowl > nowr || nowl > r || nowr < l)
        {
            return 0;
        }
        if(nowl >= l && nowr <= r)
        {
            push(v, nowl, nowr);
            return tree[v];
        }
        push(v, nowl, nowr);
        int mid = (nowl+nowr)/2;
        return get(2*v, nowl, mid, l, r)+get(2*v+1, mid+1, nowr, l, r);
    }
    void push(int v, int nowl, int nowr)
    {
        if(lazy[v] == 0)
        {
            return;
        }
        if(nowl == nowr)
        {
            tree[v] = 1;
            lazy[v] = 0;
        }
        else
        {
            tree[v] = nowr-nowl+1;
            lazy[v] = 0;
            lazy[2*v] = 1;
            lazy[2*v+1] = 1;
        }
    }
};

vector<int> tour;
vint idx, sizesub;

int dfs(int u)
{
    tour.pb(u);
    idx[u] = tour.size();
    int sizenow = 0;
    for(auto v : adj[u])
    {
        sizenow+=dfs(v);
    }
    sizesub[u] = sizenow;
    return sizenow+1;
}

void solve()
{
    int n;
    cin >> n;
    for(int i = 0; i <= n; i++)
    {
        vint now;
        adj.pb(now);
    }
    for(int i = 0; i < n-1; i++)
    {
        int u, v;
        cin >> u >> v;
        adj[u].pb(v);
    }
    idx.assign(n+1, 0);
    sizesub.assign(n+1, 0);
    dfs(1);
    SegmentTree st(n);
    int b;
    for(int i = 0; i < n; i++)
    {
        cin >> b;
        if(b == 1)
        {
            st.update(1, 1, n, idx[i+1], idx[i+1]);
        }
    }
    int q;
    cin >> q;
    for(int i = 0; i < q; i++)
    {
        int type;
        cin >> type;
        int x, k;
        cin >> x >> k;
        assert(k == n);
        if(type == 1)
        {
            st.update(1, 1, n, idx[x], idx[x]+sizesub[x]);
        }
        else
        {
            cout << st.get(1, 1, n, idx[x], idx[x]+sizesub[x]) << endl;
        }
    }
}

int32_t main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    solve();
    //test();
}

/*
13
1 2
2 9
2 10
10 11
10 12
10 13
1 3
3 4
4 5
3 6
6 7
6 8
0 1 0 0 0 1 0 0 1 1 1 0 0

10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1
0 1


6
1 2 3
2 2 3

6
1 1 1 1 1 1
1 1 1 1 1 1
1 1
2 1
3 100
4 -1
5 -1

6
1 1 1 1 1 1
1 1 1 1 1 1
1 1
2 1
3 1
4 1
5 1
*/

