#include <bits/stdc++.h>
using namespace std;
#define vint vector<int>
#define pb push_back
vector<vint> adj;
struct SegmentTree
{
    int N, sz;
    vector<int> tree, lazy;
    SegmentTree(int n)
    {
        N = n;
        sz = 4*N;
        tree.assign(sz, 0);
        lazy.assign(sz, 0);
    }
    void update(int v, int nowl, int nowr, int l, int r)
    {
        if(nowl > nowr || nowr < l || nowl > r)
        {
            return;
        }
        if(nowl >= l && nowr <= r)
        {
            lazy[v] = 1;
            push(v, nowl, nowr);
            return;
        }
        push(v, nowl, nowr);
        int mid = nowl+(nowr-nowl)/2;
        update(2*v, nowl, mid, l, r);
        update(2*v+1, mid+1, nowr, l, r);
        push(v, nowl, nowr);
        tree[v] = tree[2*v]+tree[2*v+1];
    }
    int get(int v, int nowl, int nowr, int l, int r)
    {
        if(nowl > nowr || nowl > r || nowr < l)
        {
            return 0;
        }
        if(nowl >= l && nowr <= r)
        {
            push(v, nowl, nowr);
            return tree[v];
        }
        push(v, nowl, nowr);
        int mid = nowl+(nowr-nowl)/2;
        return get(2*v, nowl, mid, l, r)+get(2*v+1, mid+1, nowr, l, r);
    }
    void push(int v, int nowl, int nowr)
    {
        if(lazy[v] == 0)
        {
            return;
        }
        if(nowl == nowr)
        {
            tree[v] = 1;
            lazy[v] = 0;
        }
        else
        {
            tree[v] = nowr-nowl+1;
            lazy[v] = 0;
            lazy[2*v] = 1;
            lazy[2*v+1] = 1;
        }
    }
};
vector<int> tour;
vint idx, sizesub;
int dfs(int u)
{
    tour.pb(u);
    idx[u] = tour.size();
    int sizenow = 0;
    for(auto v : adj[u])
    {
        sizenow+=dfs(v);
    }
    sizesub[u] = sizenow;
    return sizenow+1;
}
void solve()
{
    int n;
    cin >> n;
    for(int i = 0; i <= n; i++)
    {
        vint now;
        adj.pb(now);
    }
    for(int i = 0; i < n-1; i++)
    {
        int u, v;
        cin >> u >> v;
        adj[u].pb(v);
    }
    idx.assign(n+100, 0);
    sizesub.assign(n+100, 0);
    dfs(1);
    SegmentTree st(n+100);
    int b;
    for(int i = 0; i < n; i++)
    {
        cin >> b;
        if(b == 1)
        {
            st.update(1, 1, n, idx[i+1], idx[i+1]);
        }
    }
    int q;
    cin >> q;
    vint ans;
    for(int i = 0; i < q; i++)
    {
        int type;
        cin >> type;
        int x, k;
        cin >> x >> k;
        assert(k == n);
        if(type == 1)
        {
            st.update(1, 1, n, idx[x], idx[x]+sizesub[x]);
        }
        else
        {
            ans.pb(st.get(1, 1, n, idx[x], idx[x]+sizesub[x]);
        }
    }
    for(auto x : ans)
    {
        cout << x << endl;
    }
}
int32_t main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    solve();
    //test();
}