#include <bits/stdc++.h>

#define forn(j, i, n) for(int i = j; i <= n; ++i)
#define FOR(j, i, n) for(int i = j; i < n; ++i)
#define pb push_back
#define mp make_pair
#define all(v) v.begin(), v.end()
#define f first
#define s second

using namespace std;

const int maxn = 2e5+100;
int inf = 1e9;
#define pii pair <int, int>
#define IOS ios_base::sync_with_stdio(false);

int n, q, deep[maxn], L[maxn], R[maxn], mn_nz[4*maxn];
vector <int> edge[maxn], order, fen[4*maxn];
vector <pii> vec[4*maxn];

void add2(int v, int pos, int len)
{
	for(; pos <= len; pos = (pos|(pos+1)))
	{
		fen[v][pos]++;
	}
}

int get2(int v, int pos, int len)
{
	int ret = 0;
	for(; pos >= 0; pos = ((pos+1)&pos)-1)
	{
		ret += fen[v][pos];
	}
	return ret;
}

void build(int v, int tl, int tr)
{
	if(tl == tr)
	{
		mn_nz[v] = tl;
		vec[v].pb({deep[order[tl-1]], tl});
		fen[v].assign(vec[v].size()+1, 0);
		return;
	}
	build(v * 2, tl, (tl + tr) / 2);
	build(v * 2 + 1, (tl + tr) / 2 + 1, tr);
	if(deep[order[mn_nz[v*2]-1]] > deep[order[mn_nz[v*2+1]-1]])
		mn_nz[v] = mn_nz[v*2+1];
	else
		mn_nz[v] = mn_nz[v*2];
	int uk1 = 0;
	int uk2 = 0;
	while(uk1 < vec[v*2].size() && uk2 < vec[v*2+1].size())
	{
		pii v1 = vec[v*2][uk1];
		pii v2 = vec[v*2+1][uk2];
		if(v1.f > v2.f)
		{
			vec[v].pb(v2);
			uk2++;
		}
		else
		{
			vec[v].pb(v1);
			uk1++;
		}
	}
	while(uk2 < vec[v*2+1].size())
	{
		pii v2 = vec[v*2+1][uk2];
		vec[v].pb(v2);
		uk2++;
	}
	while(uk1 < vec[v*2].size())
	{
		pii v1 = vec[v*2][uk1];
		vec[v].pb(v1);
		uk1++;
	}
	fen[v].assign(vec[v].size()+1, 0);
}

void calc(int v, int pred = -1)
{
	order.pb(v);
	L[v] = order.size();
	for(auto to : edge[v])
	{
		if(to == pred) continue;
		deep[to] = deep[v] + 1;
		calc(to, v);
	}
	R[v] = order.size();
}

void add(int v, int tl, int tr, int pos)
{
	if(pos < tl || tr < pos) return;
	int it = lower_bound(all(vec[v]), mp(deep[order[pos-1]], pos)) - vec[v].begin();
	add2(v, it, vec[v].size()-1);
	if(tl == tr)
	{
		mn_nz[v] = -1;
		return;
	}
	add(v * 2, tl, (tl + tr) / 2, pos);
	add(v * 2 + 1, (tl + tr) / 2 + 1, tr, pos);
	if(mn_nz[v*2]==-1) mn_nz[v] = mn_nz[v*2+1];
	else 
	if(mn_nz[v*2+1]==-1) mn_nz[v] = mn_nz[v*2];
	else
	if(deep[order[mn_nz[v*2]-1]] > deep[order[mn_nz[v*2+1]-1]])
		mn_nz[v] = mn_nz[v*2+1];
	else
		mn_nz[v] = mn_nz[v*2];
}

int getmn_nz(int v, int tl, int tr, int l, int r)
{
	if(l > tr || r < tl) return -1;
	if(l <= tl && tr <= r) return mn_nz[v];
	int ret1 = getmn_nz(v * 2, tl, (tl + tr) / 2, l, r);
	int ret2 = getmn_nz(v * 2 + 1, (tl + tr) / 2 + 1, tr, l, r);
	if(ret1 == -1) return ret2;
	if(ret2 == -1) return ret1;
	if(deep[order[ret1-1]] > deep[order[ret2-1]]) return ret2;
	return ret1;
}

int get(int v, int tl, int tr, int l, int r, int val)
{
	if(l <= tl && tr <= r)
	{
		int boun = upper_bound(all(vec[v]), mp(val, inf)) - vec[v].begin();
//		cout << "GET " << tl << " " << tr << " " << boun << endl;
		return get2(v, boun - 1, vec[v].size()-1);
	}
	if(l > tr || r < tl) return 0;
	return get(v * 2, tl, (tl + tr) / 2, l, r, val) + get(v * 2 + 1, (tl + tr) / 2 + 1, tr, l, r, val);
}

void print(int v, int tl, int tr)
{
	cout << "FOR TREE " << v << " " << tl << " " << tr << "\n";
	cout << "mn_nz " << mn_nz[v] << endl;
	cout << "VEC ";
	for(auto i : vec[v]) cout << order[i.s-1] << " ";
	cout << endl;
	cout << "FEN ";
	FOR(0, i, vec[v].size()) cout << get2(v, i, vec[v].size()-1) << " ";
	cout << endl;
	if(tl != tr)
	{
		print(v * 2, tl, (tl + tr) / 2);
		print(v * 2 + 1, (tl + tr) / 2 + 1, tr);
	}
}

main()
{
	IOS
	cin >> n;
	forn(1, i, n - 1)
	{
		int l, r;
		cin >> l >> r;
		edge[l].pb(r);
		edge[r].pb(l);
	}
	deep[0] = inf;
	deep[1] = 1;
	calc(1);
	build(1, 1, n);
	forn(1, i, n)
	{
		int ty;
		cin >> ty;
		if(ty == 1)
		{
			add(1, 1, n, L[i]);
		}
	}
//	print(1, 1, n);
	cin >> q;
	forn(1, iter, q)
	{
		int ty, v, k;
		cin >> ty >> v >> k;
		if(ty == 1)
		{
			while(true)
			{
				int fin = getmn_nz(1, 1, n, L[v], R[v]);
				if(fin != -1 && deep[order[fin-1]] <= deep[v] + k)
					add(1, 1, n, fin);
				else
					break;
			}
//			print(1, 1, n);
		}
		else
		{
			cout << get(1, 1, n, L[v], R[v], deep[v] + k) << endl;
		}
	}
}