#include <iostream>
#include "vector"
#include "algorithm"
#include "cmath"
#define all(a) (a).begin(), (a).end()
using namespace std;
struct segtree {
    vector<int> tree, add;
    int sz;
    segtree(vector<int> a) {
        int n = a.size();
        while (n < a.size())
            n *= 2;
        tree.assign(sz * 2, 0);
        add.assign(sz * 2, -1);
        for (int i = 0; i < n; ++i) {
            tree[i + sz] = a[i];
        }
        for (int i = sz - 1; i > 0; --i) {
            tree[i] = tree[i * 2] + tree[i * 2 + 1];
        }
    }
    int get(int v, int l, int r) {
        if (add[v] != -1)
            return (r - l) * add[v];
        return tree[v];
    }
    void push(int v, int l, int r) {
        if (add[v] != -1) {
            add[v * 2] = add[v];
            add[v * 2 + 1] = add[v];
            add[v] = -1;
        }
    }
    void pull(int v, int l, int r) {
        int m = l + r >> 1;
        tree[v] = get(v * 2, l, m) + get(v * 2 + 1, m, r);
    }
};
vector<vector<int>> g;
vector<int> p;
vector<int> marked;
void dfs(int v, int pp = -1) {
    p[v] = pp;
    for (auto i : g[v]) {
        if (i != pp)
            dfs(i, v);
    }
}
int getik(int v, int glb) {
    if (glb == 0)
        return marked[v];
    int res = marked[v];
    for (auto i : g[v]) {
        if (i != p[v])
            res += getik(i, glb - 1);
    }
    return res;
}
void pushik(int v, int glb) {
    marked[v] = 1;
    if (glb == 0)
        return;
    for (auto i : g[v]) {
        if (i != p[v])
            pushik(i, glb - 1);
    }
}
int main() {
    int n;
    cin >> n;
    p.assign(n, -1);
    g.assign(n, {});
    marked.assign(n, {});
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;a--;b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0);
    for (int i = 0; i < n; ++i) {
        cin >> marked[i];
    }
    int q;
    cin >> q;
    while (q--) {
        int t, a, k;
        cin >> t >> a >> k;
        t--;a--;
        if (t) {
            cout << getik(a, k) << '\n';
        } else {
            pushik(a, k);
        }
    }
}
