#include <iostream>
#include "vector"
#include "algorithm"
#include "cmath"
#define all(a) (a).begin(), (a).end()
using namespace std;
struct segtree {
    vector<int> tree, add;
    int sz;
    void make(vector<int> a) {
        int n = a.size();
        sz = 1;
        while (sz < n)
            sz *= 2;
        tree.assign(sz * 2, 0);
        add.assign(sz * 2, -1);
        for (int i = 0; i < n; ++i) {
            tree[i + sz] = a[i];
        }
        for (int i = sz - 1; i > 0; --i) {
            tree[i] = tree[i * 2] + tree[i * 2 + 1];
        }
    }
    int get(int v, int l, int r) {
        if (add[v] != -1)
            return (r - l) * add[v];
        return tree[v];
    }
    void push(int v, int l, int r) {
        if (add[v] != -1) {
            add[v * 2] = add[v];
            add[v * 2 + 1] = add[v];
            add[v] = -1;
        }
    }
    void pull(int v, int l, int r) {
        int m = l + r >> 1;
        tree[v] = get(v * 2, l, m) + get(v * 2 + 1, m, r);
    }
    void ch(int v, int l, int r, int ll, int rr, int x) {
        if (ll <= l and r <= rr) {
            add[v] = x;
            return;
        }
        if (rr <= l or ll >= r)
            return;
        push(v, l, r);
        int m = l + r >> 1;
        ch(v * 2, l, m, ll, rr, x);
        ch(v * 2 +1, m, r, ll, rr, x);
        pull(v, l, r);
    }
    void ch(int l, int r, int x) {
        return ch(1, 0, sz, l, r, x);
    }
    int segsum(int v, int l, int r, int ll, int rr) {
        if (ll <= l and r <= rr) {
            return get(v, l, r);
        }
        if (rr <= l or ll >= r)
            return 0;
        push(v, l, r);
        int res = 0;
        int m = l + r >> 1;
        res += segsum(v * 2, l, m, ll, rr);
        res += segsum(v * 2 + 1, m, r, ll, rr);
        pull(v, l, r);
        return res;
    }
    int segsum(int l, int r) {
        return segsum(1, 0, sz, l, r);
    }
};
vector<vector<int>> g;
vector<int> p;
vector<int> marked;
vector<int> tin, tout;
vector<int> elems;
void dfs(int v, int pp = -1) {
    tin[v] = elems.size();
    elems.push_back(marked[v]);
    p[v] = pp;
    for (auto i : g[v]) {
        if (i != pp)
            dfs(i, v);
    }
    tout[v] = elems.size();
}
int getik(int v, int glb) {
    if (glb == 0)
        return marked[v];
    int res = marked[v];
    for (auto i : g[v]) {
        if (i != p[v])
            res += getik(i, glb - 1);
    }
    return res;
}
void pushik(int v, int glb) {
    marked[v] = 1;
    if (glb == 0)
        return;
    for (auto i : g[v]) {
        if (i != p[v])
            pushik(i, glb - 1);
    }
}
segtree sg;
int main() {
    int n;
    cin >> n;
    tin.assign(n, {});
    tout.assign(n, {});
    p.assign(n, -1);
    g.assign(n, {});
    marked.assign(n, {});
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;a--;b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    for (int i = 0; i < n; ++i) {
        cin >> marked[i];
    }
    dfs(0);
    int q;
    sg.make(elems);
    cin >> q;
    while (q--) {
        int t, a, k;
        cin >> t >> a >> k;
        t--;a--;
        if (t) {
            cout << sg.segsum(tin[a], tout[a]) << '\n';
        } else {
            sg.ch(tin[a], tout[a], 1);
        }
    }
}
