#include <bits/stdc++.h>

#define pb push_back

using namespace std;

typedef pair<int, int> pii;

const int SIZE = 2e5 + 5;
const int INF = 1e9;

struct node {
    node *l = 0, *r = 0;
    int sum = 0;

    void update() {
        sum = 0;
        if(l) sum += l->sum;
        if(r) sum += r->sum;
    }
};

int n, q, b[SIZE], sz[SIZE], eul[SIZE], pos[SIZE], tmr, d[SIZE];
pii unmarked[4 * SIZE];
node* marked[4 * SIZE];
vector<int> g[SIZE];

void build_unmarked(int x = 1, int lx = 0, int rx = n) {
    if(lx + 1 == rx) {
        unmarked[x] = {d[eul[lx]], lx};
        return;
    }

    int mx = (lx + rx) >> 1;
    build_unmarked(2 * x, lx, mx);
    build_unmarked(2 * x + 1, mx, rx);
    unmarked[x] = min(unmarked[2 * x], unmarked[2 * x + 1]);
}

void update_unmarked(int pos, int x = 1, int lx = 0, int rx = n) {
    if(lx + 1 == rx) {
        unmarked[x].first = INF;
        return;
    }
    int mx = (lx + rx) >> 1;
    if(pos < mx) {
        update_unmarked(pos, 2 * x, lx, mx);
    }
    else {
        update_unmarked(pos, 2 * x + 1, mx, rx);
    }
    unmarked[x] = min(unmarked[2 * x], unmarked[2 * x + 1]);
}

pii get_unmarked(int l, int r, int x = 1, int lx = 0, int rx = n) {
    if(r <= lx || rx <= l) {
        return {INF, INF};
    }

    if(l <= lx && rx <= r) {
        return unmarked[x];
    }

    int mx = (lx + rx) >> 1;
    return min(get_unmarked(l, r, 2 * x, lx, mx), get_unmarked(l, r, 2 * x + 1, mx, rx));
}

void add(int pos, node* &x, int lx = 0, int rx = n) {
    if(!x) x = new node();
    if(lx + 1 == rx) {
        x->sum++;
        return;
    }

    int mx = (lx + rx) >> 1;

    if(pos < mx) {
        add(pos, x->l, lx, mx);
    }
    else {
        add(pos, x->r, mx, rx);
    }

    x->update();
}

int get(int l, int r, node* &x, int lx = 0, int rx = n) {
    if(!x) return 0;

    if(r <= lx || rx <= l) {
        return 0;
    }

    if(l <= lx && rx <= r) {
        return x->sum;
    }

    int mx = (lx + rx) >> 1;

    return get(l, r, x->l, lx, mx) + get(l, r, x->r, mx, rx);
}

void update_marked(int pos, int val, int x = 1, int lx = 0, int rx = n) {
    add(val, marked[x]);

    if(lx + 1 == rx) return;

    int mx = (lx + rx) >> 1;
    if(pos < mx) {
        update_marked(pos, val, 2 * x, lx, mx);
    }
    else {
        update_marked(pos, val, 2 * x + 1, mx, rx);
    }
}

void mark(int x, int k) {
    while(1) {
        pii res = get_unmarked(pos[x], pos[x] + sz[x]);
        if(res.first > d[x] + k) {
            break;
        }
        update_unmarked(res.second);
        update_marked(res.second, d[eul[res.second]]);
    }
}

int get_marked(int l, int r, int vall, int valr, int x = 1, int lx = 0, int rx = n) {
    if(r <= lx || rx <= l) {
        return 0;
    }

    if(l <= lx && rx <= r) {
        return get(vall, valr, marked[x]);
    }

    int mx = (lx + rx) >> 1;
    return get_marked(l, r, vall, valr, 2 * x, lx, mx) + get_marked(l, r, vall, valr, 2 * x + 1, mx, rx);
}

int get(int x, int k) {
    return get_marked(pos[x], pos[x] + sz[x], d[x], d[x] + k + 1);
}

void dfs(int x, int e) {
    sz[x] = 1;
    d[x] = (e == -1) ? 0 : d[e] + 1;
    eul[tmr] = x;
    pos[x] = tmr;
    tmr++;

    for(auto i : g[x]) {
        if(i != e) {
            dfs(i, x);
            sz[x] += sz[i];
        }
    }
}



int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n;
    for(int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].pb(v);
        g[v].pb(u);
    }

    for(int i = 0; i < n; i++) {
        cin >> b[i];
    }

    dfs(0, -1);
    build_unmarked();

    for(int i = 0; i < n; i++) {
        if(b[i]) {
            mark(i, 0);
        }
    }

    cin >> q;

    for(int i = 0; i < q; i++) {
        int t, x, k;
        cin >> t >> x >> k;
        x--;
        if(t == 1) {
            mark(x, k);
        }
        else {
            cout << get(x, k) << '\n';
        }

    }


    return 0;
}
