#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <random>
#include <cassert>
#include <array>
#include <deque>
#include <map>
#include <set>


using namespace std;


#define ll long long
#define ld long double
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define emb emplace_back


const ll inf = 1e18;
const int mxb = 300;


ll dlt(set<pair<ll, ll>>& x1, set<pair<ll, ll>>& x2, ll x) {
    
    for (auto [l, r] : x2) {
        ll ln = r - l + 1;
        if (x >= ln) {
            x -= ln;
            continue;
        }
        l += x;
        x = 0;
        while (!x1.empty()) {
            auto it = x1.lower_bound(make_pair(r + 1, -1));
            if (it == x1.begin()) {
                break;
            }
            --it;
            auto [tl, tr] = *it;
            if (tr < l) {
                break;
            }
            x1.erase(it);
            if (tl < l) {
                x1.insert(make_pair(tl, l - 1));
            }
            if (r < tr) {
                x1.insert(make_pair(r + 1, tr));
            }
        }
    }
    return x;
    
}


struct node {
    vector<set<pair<ll, ll>>> a;


    set<pair<ll, ll>> st0() {
        set<pair<ll, ll>> res;
        res.insert(make_pair(0, inf));
        return res;
    }


    bool is_inf(set<pair<ll, ll>>& x) {
        if (x.empty()) {
            return false;
        }
        return (--x.end())->second == inf;
    }


    void build(vector<node> &f, int n, int k) {
        a.resize(1);
        a[0] = set<pair<ll, ll>>();
        a[0].insert(make_pair(0, inf));
        for (int i = 0; i < n; ++i) {
            ll c = (ll)(k) * (n - i);
            a.resize(f[i].a.size(), st0());
            for (int x = 0; x < f[i].a.size(); ++x) {
                c = dlt(a[x], f[i].a[x], c);
            }
        }
        a.push_back(st0());
        int mninf = 0;
        for (int x = 0; x < a.size(); ++x) {
            if (is_inf(a[x])) {
                mninf = x;
                break;
            }
        }
        while (a.size() > mninf + 1) {
            a.pop_back();
        }
    }


    pair<ll, ll> get(ll y) {
        for (int x = 0; x < a.size(); ++x) {
            for (auto [l, r] : a[x]) {
                ll ln = r - l + 1;
                if (y >= ln) {
                    y -= ln;
                } else {
                    return make_pair(x, l + y);
                }
            }
        }
    }
};

int k;
vector<node> f;


void build() {
    f.resize(mxb + 1);
    for (int i = 0; i <= mxb; ++i) {
        f[i].build(f, i, k);
    }
}


pair<ll, ll> get(ll x, ll y) {
    return f[x].get(y);
}


int n;
vector<int> b;
vector<int> s;


bool solve0() {
    int x = 0;
    int y = 0;
    for (int i = 0; i < n; ++i) {
        x = (x ^ b[i]);
        y = (y ^ s[i]);
    }
    return ((x != 0) || (y != 0));
}


bool solve1() {
    ll xx = 0;
    ll xy = 0;
    for (int i = 0; i < n; ++i) {
        auto [x, y] = get(b[i], s[i]);
        xx = (xx ^ x);
        xy = (xy ^ y);
    }
    return ((xx != 0) || (xy != 0));
}


int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> k;
    build();
    cin >> q;
    while (q--) {
        cin >> n;
        b.resize(n);
        s.resize(n);
        for (int i = 0; i < n; ++i) {
            cin >> b[i] >> s[i];
        }
        bool rs = false;
        if (k == 0) {
            rs = solve0();
        } else {
            rs = solve1();
        }
        if (rs) {
            cout << "Win" << "\n";
        } else {
            cout << "Loss" << "\n";
        }
    }
    return 0;
}