#pragma GCC optimize("Ofast")



#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <random>
#include <cassert>
#include <array>
#include <deque>
#include <queue>
#include <map>
#include <set>


using namespace std;


#define ll long long
#define ld long double
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define emb emplace_back


struct edge {
    int to;
    ll f;
    ll w;
    ll d;

    int inv;


    edge(ll to, ll w, ll d, int inv) : to(to), w(w), d(d), inv(inv) {
        f = 0;
    }
};


const ll inf = 1e16;


int gn;
vector<vector<edge>> g;
vector<ll> p;
vector<ll> d;
vector<int> par;
vector<int> pari;
vector<bool> usd;


void add_edge(int v, int to, ll d, ll w) {
    int i1 = g[v].size();
    int i2 = g[to].size();
    g[v].push_back(edge(to, w, d, i2));
    g[to].push_back(edge(v, -w, 0, i1));
}


void build_g(int n) {
    gn = n;
    g.assign(gn, vector<edge>());
}


ll ford_belm(int s, int t, ll x = 1) {
    queue<int> q;
    q.push(s);
    d.assign(gn, inf);
    usd.assign(gn, 0);
    d[s] = 0;
    usd[s] = 1;
    par.assign(gn, -1);
    pari.resize(gn);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if (!usd[v]) {
            continue;
        }
        usd[v] = 0;
        for (int i = 0; i < g[v].size(); ++i) {
            auto& e = g[v][i];
            int to = e.to;
            if (e.f < e.d) {
                ll w = e.w / x;
                if (d[to] > d[v] + w) {
                    d[to] = d[v] + w;
                    q.push(to);
                    par[to] = v;
                    pari[to] = i;
                    usd[to] = 1;
                }
            }
        }
    }
    if (par[t] == -1) {
        return 0;
    }
    int v = t;
    ll f = inf;
    ll res = 0;
    while (v != s) {
        int i = pari[v];
        v = par[v];
        auto& e = g[v][i];
        f = min(f, e.d - e.f);
        res += e.w;
    }
    if (res >= 0) {
        return 0; 
    }
    v = t;
    while (v != s) {
        int i = pari[v];
        v = par[v];
        auto& e = g[v][i];
        auto& re = g[e.to][e.inv];
        e.f += f;
        re.f -= f;
    }
    return f * res;
}




ll flow_d(int s, int t, ll f) {
    ll res = 0;
    while (true) {
        ll x = ford_belm(s, t, f);
        if (x < 0) {
            res += x;
        } else {
            break;
        }
    }
    return res;
}


ll flow(int s, int t) {
    ll res = 0;
    ll f = 10;
    while (f > 0) {
        res += flow_d(s, t, f);
        f /= 2;
    }
    return res;
}


int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    build_g(n + 2);
    for (int i = 0; i < n; ++i) {
        ll s;
        cin >> s;
        add_edge(n, i, s, 0);
    }
    for (int i = 0; i < n; ++i) {
        ll e;
        cin >> e;
        add_edge(i, n + 1, e, 0);
    }
    for (int i = 1; i < n; ++i) {
        int p;
        ll w;
        cin >> p >> w;
        --p;
        add_edge(p, i, inf, -w);
    }
    cout << -flow(n, n + 1) << "\n";
    return 0;
}