#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <random>
#include <cassert>
#include <array>
#include <deque>
#include <map>
#include <set>


using namespace std;


#define ll long long
#define ld long double
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define emb emplace_back


const int inf = 1e9;


struct Fenv {
    int n;
    vector<int> t;


    void build(int _n) {
        n = _n;
        t.assign(n, 0);
    }


    void add(int i, int x) {
        while (i < n) {
            t[i] += x;
            i = (i | (i + 1));
        }
    }


    int get(int i) {
        if (i < 0) {
            return 0;
        }
        if (i >= n) {
            i = n - 1;
        }
        int res = 0;
        while (i >= 0) {
            res += t[i];
            i = (i & (i + 1)) - 1;
        }
        return res;
    }
};


int tn;
vector<Fenv> t;




int n, q;
vector<vector<int>> g;
vector<int> mnhnk;
vector<int> mnh;
vector<int> tin;
vector<int> tout;
vector<int> h;
vector<int> b;
vector<int> e;


void upd(int v) {
    mnhnk[v] = min(mnhnk[v + v], mnhnk[v + v + 1]);
}


void add(int v, int h) {
    while (v > 0) {
        t[v].add(h - mnh[v], 1);
        v /= 2;
    }
}


void st(int v, int tl, int tr, int l, int r, int mh) {
    if (tr < l || r < tl) {
        return;
    }
    if (tl == tr) {
        int u = e[tl];
        if (!b[u] && h[u] <= mh) {
            b[u] = 1;
            add(v, h[u]);
            mnhnk[v] = inf;
        }
        return;
    }
    if (mh < mnhnk[v]) {
        return;
    }
    int tm = (tl + tr) / 2;
    st(v + v, tl, tm, l, r, mh);
    st(v + v + 1, tm + 1, tr, l, r, mh);
    upd(v);
}


void st(int l, int r, int mh) {
    st(1, 0, tn - 1, l, r, mh);
}


int get(int l, int r, int mh) {
    l += tn;
    r += tn + 1;
    int res = 0;
    while (l < r) {
        if (l & 1) {
            res += t[l].get(mh - mnh[l]);
            ++l;
        }
        if (r & 1) {
            --r;
            res += t[r].get(mh - mnh[r]);
        }
        l /= 2;
        r /= 2;
    }
    return res;
}


void build_t(int v, int tl, int tr) {
    int mxh = 0;
    mnh[v] = inf;
    mnhnk[v] = inf;
    for (int i = tl; i <= tr && i < e.size(); ++i) {
        int u = e[i];
        mxh = max(mxh, h[u]);
        mnh[v] = min(mnh[v], h[u]);
        if (b[u]) {
            mnhnk[v] = min(mnhnk[v], h[u]);
        }
    }
    t[v].build(max(0, mxh - mnh[v] + 1));
    for (int i = tl; i <= tr && i < e.size(); ++i) {
        int u = e[i];
        if (b[u]) {
            t[v].add(h[u] - mnh[v], 1);
        }
    }
    if (tl < tr) {
        int tm = (tl + tr) / 2;
        build_t(v + v, tl, tm);
        build_t(v + v + 1, tm + 1, tr);
    }
}


void build_t() {
    tn = 1;
    while (tn < e.size()) {
        tn *= 2;
    }
    t.resize(tn + tn);
    mnh.resize(tn + tn);
    mnhnk.resize(tn + tn);
    build_t(1, 0, tn - 1);
}


void dfs0(int v, int mh) {
    h[v] = mh;
    tin[v] = e.size();
    e.push_back(v);
    for (auto to : g[v]) {
        dfs0(to, mh + 1);
    }
    tout[v] = (int)(e.size()) - 1;
}


void build() {
    tin.resize(n);
    tout.resize(n);
    h.resize(n);
    e.clear();
    e.reserve(n + n);
    dfs0(0, 0);
    build_t();
}


void st(int v, int k) {
    st(tin[v], tout[v], h[v] + k);
}


int get(int v, int k) {
    return get(tin[v], tout[v], h[v] + k);
}


int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    g.assign(n, vector<int>());
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        --x;
        --y;
        g[x].push_back(y);
    }
    b.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    build();
    int q;
    cin >> q;
    while (q--) {
        int tp;
        int v, k;
        cin >> tp >> v >> k;
        --v;
        if (tp == 1) {
            st(v, k);
        } else if (tp == 2) {
            cout << get(v, k) << "\n";
        }
    }
    return 0;
}