#include <bits/stdc++.h>
using namespace std;
typedef vector<int> vi;
typedef vector<vi> vvi;
#define pb push_back
#define all(x) x.begin(), x.end()
struct Seg
{
    int val = 0, prop = 0, l, r, mid;
    Seg *lp, *rp;
    Seg(int l, int r) : l(l), r(r), mid((l + r) / 2)
    {
        if (l + 1 < r)
        {
            lp = new Seg(l, mid);
            rp = new Seg(mid, r);
        }
    }
    void set(int v)
    {
        val = (r - l) * v;
        prop = v;
    }
    void pull()
    {
        val = lp->val + rp->val;
    }
    void push()
    {
        if (prop != 0)
        {
            lp->set(prop), rp->set(prop);
            prop = 0;
        }
    }
    void update(int p, int v)
    {
        if (l + 1 == r)
        {
            val = v;
            return;
        }
        if (p < mid)
            lp->update(p, v);
        else
            rp->update(p, v);
        pull();
    }
    int query(int a, int b)
    {
        if (b <= l || a >= r)
            return 0;
        if (a <= l && r <= b)
            return val;
        push();
        return lp->query(a, b) + rp->query(a, b);
    }
    void update(int a, int b, int v)
    {
        if (b <= l || a >= r)
            return;
        if (a <= l && r <= b)
        {
            set(v);
            return;
        }
        push();
        lp->update(a, b, v), rp->update(a, b, v);
        pull();
    }
};
void sz(int src, vvi &ni, vi &size, int father, vi &dist)
{
    size[src]++;
    for (int u : ni[src])
    {
        if (u == father)
            continue;
        dist[u] = dist[src] + 1;
        sz(u, ni, size, src, dist);
        size[src] += size[u];
    }
}
int pos = 0;
void order(int src, vvi &ni, vi &ord, int father)
{
    ord[pos] = src;
    pos++;
    for (int u : ni[src])
    {
        if (u == father)
            continue;
        order(u, ni, ord, src);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, a, b;
    cin >> n;
    vvi ni(n + 1);
    for (int i = 0; i < n - 1; i++)
    {
        cin >> a >> b;
        ni[a].pb(b);
        ni[b].pb(a);
    }
    vi size(n + 1), ord(n), find(n + 1), dist(n + 1);
    sz(1, ni, size, -1, dist);
    order(1, ni, ord, -1);
    for (int i = 0; i < n; i++)
        find[ord[i]] = i;
    Seg seg(0, n);

    vector<pair<int, int>> start;
    bool tmp;
    for (int i = 1; i <= n; i++)
    {
        cin >> tmp;
        if (tmp == 1)
            start.pb({dist[tmp], i});
    }
    sort(all(start));
    int q;
    cin >> q;
    vector<tuple<int, int, int>> queries;
    vi ans(q);
    for (int i = 0; i < q; i++)
    {
        int a, b;
        cin >> a >> b;
        queries.pb({b + dist[a], a, i});
    }
    sort(all(queries));
    int pointer = 0;
    for (int i = 0; i < q; i++)
    {
        int a, b, c;
        tie(a, b, c) = queries[i];
        while (pointer < start.size() && a > start[pointer].first)
        {
            seg.update(find[start[pointer].second], 1);
            pointer++;
        }
        ans[c] = seg.query(find[b], find[b] + size[b]);
    }
    for (int i = 0; i < q; i++)
        cout << ans[i] << "\n";
}