#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#include <cstdio>
using namespace std;

#define pb push_back
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()

const int N = 3e5 + 10;
int n, timer, euler[4 * N], tin[N], tout[N], t, a[N];
vector<int> adj[N];

void dfs(int node) {
  tin[node] = timer;
  euler[timer++] = node;
  for(auto i: adj[node]) {
    dfs(i);
  }
  tout[node] = timer;
}

struct segTree {
  int size = 1;
  vector<int> tree;

  void init(int m) {
    while(size < m) {
      size *= 2;
    }
    tree.assign(size * 2 - 1, 0);
  }

  void upd(int u, int x, int lx, int rx) {
    if(rx - lx == 1) {
      tree[x] = 1;
      return;
    }

    int mid = (lx + rx) / 2;
    if(u < mid) {
      upd(u,  2 * x + 1, lx, mid);
    } else {
      upd(u,  2 * x + 2, mid, rx);
    }

    tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
  }

  void upd(int u) {
    upd(u, 0, 0, size);
  }

  int qry(int l, int r, int x, int lx, int rx) {
    if(rx <= l || lx >= r) {
      return 0;
    }

    if(lx >= l && rx <= r) {
      return tree[x];
    }

    int mid = (lx + rx) / 2;
    int s1 = qry(l, r, 2 * x + 1, lx, mid);
    int s2 = qry(l, r, 2 * x + 2, mid, rx);
    return s1 + s2;
  }

  int qry(int l, int r) {
    return qry(l, r, 0, 0, size);
  }
};

segTree seg;

int main () {
  cin >> n;

  for(int i = 0; i < n - 1; i++) {
    int x,y; cin >> x >> y;
    adj[x].pb(y);
  }

  for(int i = 1; i <= n; i++) {
    cin >> a[i];
  }

//  dfs(1);
//  seg.init(n);
//
//  for(int i = 0; i < n; i++) {
//    if(a[euler[i]]) {
//      seg.upd(i);
//    }
//    cout << euler[i] << " ";
//  }
//
//  cout << endl;

  cin >> t;

  for(int i = 0; i < t; i++) {
    int type, x, y; cin >> type >> x >> y, type--;
    if(!type) {
      queue<pair<int,int>> q;
      q.push({x, 0});
      while(!q.empty()) {
        auto u = q.front();
        q.pop();

        a[u.first] = 1;
        if(u.second == y) continue;

        for(auto j: adj[u.first]) {
          q.push({j, u.second + 1});
        }
      }
    } else {
      int ans = 0;
      queue<pair<int,int>> q;
      q.push({x, 0});
      while(!q.empty()) {
        auto u = q.front();
        q.pop();
        if(a[u.first] == 1) {
          ans++;
        }
        if(u.second == y) continue;

        for(auto j: adj[u.first]) {
          q.push({j, u.second + 1});
        }
      }
      cout << ans << endl;
    }
  }

  return 0;
}