#include <bits/stdc++.h>
using namespace std;

const int maxn = 2e5 + 5;
int n, q;
vector <int> adj [maxn];
int par [maxn];
bool knows [maxn];
int subtreesz [maxn];
vector <int> hld_order;
int hld_pos [maxn];
int chain_start [maxn], chain_end [maxn];

void dfs (int a){
    subtreesz [a] = 1;
    for (int i : adj [a]){
        dfs (i);
        subtreesz [a] += subtreesz [i];
    }
}
void build_hld (int a){
    hld_pos [a] = hld_order.size ();
    hld_order.push_back (a);
    if (adj [a].empty ()){
        chain_end [a] = a;
        return;
    }
    int nxt = 0;
    for (int i : adj [a]) if (subtreesz [i] > subtreesz [nxt]) nxt = i;
    chain_start [nxt] = chain_start [a];
    build_hld (nxt);
    chain_end [a] = chain_end [nxt];
    for (int i : adj [a]){
        if (i == nxt) continue;
        chain_start [i] = i;
        build_hld (i);
    }
}

int tree [maxn * 4];
bool tree2 [maxn * 4];
void upd (int l, int r, int pos, int x, int val){
    if (l == r){
        if (val == -1) tree2 [pos] = 1;
        else tree [pos] += val;
        return;
    }
    int mid = l + r >> 1;
    if (x <= mid) upd (l, mid, pos << 1, x, val);
    else upd (mid + 1, r, pos << 1 | 1, x, val);
    if (val == -1) tree2 [pos] = tree2 [pos << 1] || tree2 [pos << 1 | 1];
    else tree [pos] = tree [pos << 1] + tree [pos << 1 | 1];
}
int query (int l, int r, int pos, int ql, int qr){
    if (l >= ql && r <= qr) return tree [pos];
    if (l > qr || r < ql) return 0;
    int mid = l + r >> 1;
    return query (l, mid, pos << 1, ql, qr) + query (mid + 1, r, pos << 1 | 1, ql, qr);
}
bool query2 (int l, int r, int pos, int ql, int qr){
    if (l >= ql && r <= qr) return tree2 [pos];
    if (l > qr || r < ql) return 0;
    int mid = l + r >> 1;
    return query2 (l, mid, pos << 1, ql, qr) || query2 (mid + 1, r, pos << 1 | 1, ql, qr);
}

void up_hld1 (int a, int cnt){
    if (a == 0) return;
    upd (0, n - 1, 1, hld_pos [a], cnt);
    up_hld1 (par [chain_start [a]], cnt);
}
bool up_hld2 (int a){
    if (a == 0) return 0;
    if (query2 (0, n - 1, 1, hld_pos [chain_start [a]], hld_pos [a])) return 1;
    return up_hld2 (par [chain_start [a]]);
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;
    for (int i = 1; i < n; i ++){
        int x, y;
        cin >> x >> y;
        adj [x].push_back (y);
        par [y] = x;
    }
    dfs (1);
    build_hld (1);
    for (int i = 1; i <= n; i ++){
        cin >> knows [i];
        if (knows [i]){
            up_hld1 (i, 1);
        }
    }
    cin >> q;
    for (int i = 0; i < q; i ++){
        int t, x, k;
        cin >> t >> x >> k;
        int cnt;
        if (up_hld2 (x)) cnt = subtreesz [x];
        else cnt = query (0, n - 1, 1, hld_pos [x], hld_pos [chain_end [x]]);
        if (t == 2) cout << cnt << '\n';
        else{
            upd (0, n - 1, 1, hld_pos [x], -1);
            up_hld1 (x, subtreesz [x] - cnt);
        }
    }

}