#include <bits/stdc++.h>
using namespace std;

const int maxn = 2e5 + 5;
int n, q;
vector <int> adj [maxn];
int par [maxn];
bool knows [maxn];
int subtreesz [maxn];
vector <int> hld_order;
int hld_pos [maxn];
int chain_start [maxn], chain_end [maxn];
vector <int> depths [maxn];
int depth [maxn];

void dfs (int a){
    depth [a] = depth [par [a]] + 1;
    subtreesz [a] = 1;
    for (int i : adj [a]){
        dfs (i);
        subtreesz [a] += subtreesz [i];
    }
}
void build_hld (int a){
    hld_pos [a] = hld_order.size ();
    hld_order.push_back (a);
    if (adj [a].empty ()){
        chain_end [a] = a;
        return;
    }
    int nxt = 0;
    for (int i : adj [a]) if (subtreesz [i] > subtreesz [nxt]) nxt = i;
    chain_start [nxt] = chain_start [a];
    build_hld (nxt);
    chain_end [a] = chain_end [nxt];
    for (int i : adj [a]){
        if (i == nxt) continue;
        chain_start [i] = i;
        build_hld (i);
    }
}
/*
int tree [maxn * 4];
bool tree2 [maxn * 4];
void upd (int l, int r, int pos, int x, int val){
    if (l == r){
        if (val == -1) tree2 [pos] = 1;
        else tree [pos] += val;
        return;
    }
    int mid = l + r >> 1;
    if (x <= mid) upd (l, mid, pos << 1, x, val);
    else upd (mid + 1, r, pos << 1 | 1, x, val);
    if (val == -1) tree2 [pos] = tree2 [pos << 1] || tree2 [pos << 1 | 1];
    else tree [pos] = tree [pos << 1] + tree [pos << 1 | 1];
}
int query (int l, int r, int pos, int ql, int qr){
    if (l >= ql && r <= qr) return tree [pos];
    if (l > qr || r < ql) return 0;
    int mid = l + r >> 1;
    return query (l, mid, pos << 1, ql, qr) + query (mid + 1, r, pos << 1 | 1, ql, qr);
}
bool query2 (int l, int r, int pos, int ql, int qr){
    if (l >= ql && r <= qr) return tree2 [pos];
    if (l > qr || r < ql) return 0;
    int mid = l + r >> 1;
    return query2 (l, mid, pos << 1, ql, qr) || query2 (mid + 1, r, pos << 1 | 1, ql, qr);
}*/

vector <int> Merge (vector <int> v1, vector <int> v2){
    int sz1 = v1.size (), sz2 = v2.size ();
    int i1 = 0, i2 = 0;
    vector <int> v3;
    while (i1 < sz1 || i2 < sz2){
        if (i2 == sz2 || i1 < sz1 && v1 [i1] <= v2 [i2]) v3.push_back (v1 [i1 ++]);
        else v3.push_back (v2 [i2 ++]);
    }
    return v3;
}

vector <int> tree [maxn * 4];
void build (int l, int r, int pos){
    if (l == r){
        tree [pos] = depths [hld_order [l]];
        return;
    }
    int mid = l + r >> 1;
    build (l, mid, pos << 1);
    build (mid + 1, r, pos << 1 | 1);
    tree [pos] = Merge (tree [pos << 1], tree [pos << 1 | 1]);
}
int query (int l, int r, int pos, int ql, int qr, int d){
    if (l >= ql && r <= qr){
        return upper_bound (tree [pos].begin (), tree [pos].end (), d) - tree [pos].begin ();
    }
    if (l > qr || r < ql) return 0;
    int mid = l + r >> 1;
    return query (l, mid, pos << 1, ql, qr, d) + query (mid + 1, r, pos << 1 | 1, ql, qr, d);
}

void up_hld1 (int a, int d){
    if (a == 0) return;
    // upd (0, n - 1, 1, hld_pos [a], cnt);
    depths [a].push_back (d);
    up_hld1 (par [chain_start [a]], d);
}
/*
bool up_hld2 (int a){
    if (a == 0) return 0;
    if (query2 (0, n - 1, 1, hld_pos [chain_start [a]], hld_pos [a])) return 1;
    return up_hld2 (par [chain_start [a]]);
}*/

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;
    for (int i = 1; i < n; i ++){
        int x, y;
        cin >> x >> y;
        adj [x].push_back (y);
        par [y] = x;
    }
    dfs (1);
    build_hld (1);
    for (int i = 1; i <= n; i ++){
        cin >> knows [i];
        if (knows [i]){
            up_hld1 (i, depth [i]);
        }
    }
    build (0, n -1, 1);
    cin >> q;
    for (int i = 0; i < q; i ++){
        int t, x, k;
        cin >> t >> x >> k;
        int cnt;
        /*if (up_hld2 (x)) cnt = subtreesz [x];
        else cnt = query (0, n - 1, 1, hld_pos [x], hld_pos [chain_end [x]]);
        if (t == 2) cout << cnt << '\n';
        else{
            upd (0, n - 1, 1, hld_pos [x], -1);
            up_hld1 (x, subtreesz [x] - cnt);
        }*/
        cout << query (0, n - 1, 1, hld_pos [x], hld_pos [chain_end [x]], depth [x] + k) << '\n';
    }

}