#include <bits/stdc++.h>
using namespace std;
#ifndef LOCAL
#define cerr if(false) cerr
#endif
#define endl "\n"
typedef long long ll;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) { out << x.first << " " << x.second; return out;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }
const ll mod = 1e9 + 7;

const int MAX_N = 1 << 18;

struct FenwickTree {
    vector<int> ans;
    void construct(int n) {
        ans.resize(n + 1);
    }
    void add(int x) {
        x ++;
        for(int i = x; i < ans.size(); i += (i & (-i))) {
            ans[i] ++;
        }
    }
    int sum(int x) {
        x ++;
        int ret = 0;
        for(int i = x; i > 0; i -= (i & (-i))) {
            ret += ans[i];
        }        
        return ret;
    }
};

pair<int, int> val[MAX_N];

struct Node {
    vector<pair<int, int> > vert;
    FenwickTree fn;
};

Node tree[2 * MAX_N];

void build(int curr, int l, int r) {
    if(l == r) {
        tree[curr].vert.push_back({val[l].first, val[l].second});
        tree[curr].fn.construct(tree[curr].vert.size());
        return;
    }
    int m = (l + r) / 2ll;
    build(curr * 2, l, m);
    build(curr * 2 + 1, m + 1, r);
    merge(tree[curr * 2].vert.begin(), tree[curr * 2].vert.end(), tree[curr * 2 + 1].vert.begin(), tree[curr * 2 + 1].vert.end(), back_inserter(tree[curr].vert));
    tree[curr].fn.construct(tree[curr].vert.size());
}

void upd(int curr, int l, int r, int ind, pair<int, int> who) {
    if(l > ind || r < ind) {return;}
    auto pos = lower_bound(tree[curr].vert.begin(), tree[curr].vert.end(), who) - tree[curr].vert.begin();
    tree[curr].fn.add(pos);
    if(l == r) {return;}
    int m = (l + r) / 2ll;
    upd(curr * 2, l, m, ind, who);
    upd(curr * 2 + 1, m + 1, r, ind, who);
}

int sum(int curr, int l, int r, int ql, int qr, int dl, int dr) {
    if(ql <= l && r <= qr) {
        auto start = lower_bound(tree[curr].vert.begin(), tree[curr].vert.end(), make_pair(dl, -1)) - tree[curr].vert.begin();
        auto end = lower_bound(tree[curr].vert.begin(), tree[curr].vert.end(), make_pair(dr + 1, -1)) - tree[curr].vert.begin();
        return tree[curr].fn.sum(end - 1) - tree[curr].fn.sum(start - 1);
    } else if(ql > r || qr < l) {return 0;}
    int m = (l + r) / 2ll;
    return sum(curr * 2, l, m, ql, qr, dl, dr) + sum(curr * 2 + 1, m + 1, r, ql, qr, dl, dr);
}

struct SegTree {
    pair<int, int> tree[2 * MAX_N];
    SegTree() {
        for(int i = 0; i < 2 * MAX_N; i ++) {
            tree[i] = {mod, 0};
        }
    }
    pair<int, int> merge(pair<int, int> a, pair<int, int> b) {
        if(a.first < b.first) {
            return a;
        } else {
            return b;
        }
    }
    void upd(int curr, int l, int r, int ind, int val) {
        if(l == r && l == ind) {
            tree[curr] = {val, ind};
            return;
        } else if(l > ind || r < ind) {return;}
        int m = (l + r) / 2ll;
        upd(curr * 2, l, m, ind, val);
        upd(curr * 2 + 1, m + 1, r, ind, val);
        tree[curr] = merge(tree[curr * 2], tree[curr * 2 + 1]);
    }
    pair<int, int> ans(int curr, int l, int r, int ql, int qr) {
        if(ql <= l && r <= qr) {
            return tree[curr];
        } else if(ql > r || qr < l) {return {mod, 0};}
        int m = (l + r) / 2ll;
        return merge(ans(curr * 2, l, m, ql, qr), ans(curr * 2 + 1, m + 1, r, ql, qr));
    }
};

SegTree st;

vector<int> g[MAX_N];
int in[MAX_N], out[MAX_N], d[MAX_N], tme = -1;
int n, q;
vector<int> ord;

void dfs(int x, int p) {
    in[x] = ++ tme;
    ord.push_back(x);
    for(auto it : g[x]) {
        if(it == p) {continue;}
        d[it] = d[x] + 1;
        dfs(it, x);
    }
    out[x] = tme;
}

const int SQRT = 1000;

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif
    cin >> n;
    for(int i = 0; i < n - 1; i ++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(1, 0);
    for(int i = 1; i <= n; i ++) {
        val[in[i]] = {d[i], i};
    }
    build(1, 0, n - 1);
    for(int i = 1; i <= n; i ++) {
        int on;
        cin >> on;
        if(on) {
            upd(1, 0, n - 1, in[i], {d[i], i});
        } else {
            st.upd(1, 0, n - 1, in[i], d[i]);
        }
    }

    cin >> q;
    while(q --) {
        int t;
        cin >> t;
        if(t == 2) {
            int x, k;
            cin >> x >> k;
            cout << sum(1, 0, n - 1, in[x], out[x], d[x], d[x] + k) << endl;
        } else {
            int x, k;
            cin >> x >> k;
            while(true) {
                auto ans = st.ans(1, 0, n - 1, in[x], out[x]);
                if(ans.first > d[x] + k) {
                    break;
                }
                int vert = ord[ans.second];
                upd(1, 0, n - 1, in[vert], {d[vert], vert});
                st.upd(1, 0, n - 1, in[vert], mod);
            }
        }
    }

    return 0;
}
