#include<bits/stdc++.h>
using namespace std;
const int MAXN=2e5+6;
const int logN=20;
struct query
{
	int type,x,k;
};
struct segment_tree
{
	int tree[4*MAXN];
	void build(int l,int r,int idx)
	{
		tree[idx]=0;
		if(l==r)return;
		int mid=(l+r)/2;
		build(l,mid,idx*2);
		build(mid+1,r,idx*2+1);
	}
	void update(int l,int r,int idx,int ql,int qr,int val)
	{
		if(l>qr)return;
		if(r<ql)return;
		if(l>=ql&&r<=qr)
		{
			tree[idx]=max(tree[idx],val);
			return;
		}
		int mid=(l+r)/2;
		update(l,mid,idx*2,ql,qr,val);
		update(mid+1,r,idx*2+1,ql,qr,val);
	}
	int ask(int l,int r,int idx,int pos)
	{
		if(l==r)return tree[idx];
		int mid=(l+r)/2;
		if(pos<=mid)return max(tree[idx],ask(l,mid,idx*2,pos));
		else return max(tree[idx],ask(mid+1,r,idx*2+1,pos));
	}
}st1;
vector<int>g[MAXN];
int time_in[MAXN],time_out[MAXN];
int depth[MAXN];
int l1[MAXN],r1[MAXN],ans1[MAXN];
vector<int>to_check[MAXN];
int t;
int n,q;
bool b[MAXN];
vector<query>all_q;
void dfs(int u,int p)
{
	depth[u]=depth[p]+1;
	time_in[u]=++t;
	for(auto xd:g[u])
	{
		if(xd==p)continue;
		dfs(xd,u);
	}
	time_out[u]=t;
}

void read()
{
	cin>>n;
	for(int i=1;i<n;i++)
	{
		int x,y;
		cin>>x>>y;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	for(int i=1;i<=n;i++)cin>>b[i];
	dfs(1,0);
	cin>>q;
	for(int i=0;i<q;i++)
	{
		int type,x,k;
		cin>>type>>x>>k;
		all_q.push_back({type,x,k});
	}
}
void solve()
{
	for(int i=1;i<=n;i++)
	{
		if(b[i]==1)
		{
			l1[i]=1;r1[i]=0;
			ans1[i]=0;
		}
		else
		{
			l1[i]=1;r1[i]=q;
			ans1[i]=q+1;
		}
	}
	for(int step=0;step<logN;step++)
	{
		for(int i=1;i<=n;i++)
		{
			if(l1[i]>r1[i])continue;
			int mid=(l1[i]+r1[i])/2;
			to_check[mid].push_back(i);
		}
		st1.build(1,n,1);
		for(int i=1;i<=n;i++)
		{
			if(b[i]==1)
			{
				st1.update(1,n,1,time_in[i],time_out[i],depth[i]);
			}
		}
		for(int i=1;i<=n;i++)
		{
			if(all_q[i].type==1)
			{
				st1.update(1,n,1,time_in[all_q[i].x],time_out[all_q[i].x],depth[all_q[i].x]+all_q[i].k);
			}
			for(auto xd:to_check[i])
			{
				if(st1.ask(1,n,1,time_in[xd])>=depth[xd])
				{
					ans1[xd]=i;
					r1[xd]=i-1;
				}
				else
				{
					l1[xd]=i+1;
				}
			}
			to_check[i].clear();
		}
	}
	for(int i=1;i<=n;i++)cout<<ans1[i]<<" ";
	cout<<endl;
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	read();
	solve();
return 0;
}
