#include<bits/stdc++.h>
using namespace std;
const int MAXN=2e5+6;
const int logN=22;
struct query
{
	int type,x,k;
};
struct cdq_object
{
	int x,y,z;
	int q_idx;
	int factor;
	bool operator<(cdq_object const& other)const
	{
		if(x!=other.x)return x<other.x;
		if(y!=other.y)return y<other.y;
		if(z!=other.z)return z<other.z;
		return q_idx<other.q_idx;
	}
};
bool cmp(cdq_object obj1,cdq_object obj2)
{
	if(obj1.y!=obj2.y)return obj1.y<obj2.y;
	if(obj1.z!=obj2.z)return obj1.z<obj2.z;
	return obj1.q_idx<obj2.q_idx;
}
struct segment_tree
{
	int tree[4*MAXN];
	void build(int l,int r,int idx)
	{
		tree[idx]=0;
		if(l==r)return;
		int mid=(l+r)/2;
		build(l,mid,idx*2);
		build(mid+1,r,idx*2+1);
	}
	void update(int l,int r,int idx,int ql,int qr,int val)
	{
		if(l>qr)return;
		if(r<ql)return;
		if(l>=ql&&r<=qr)
		{
			tree[idx]=max(tree[idx],val);
			return;
		}
		int mid=(l+r)/2;
		update(l,mid,idx*2,ql,qr,val);
		update(mid+1,r,idx*2+1,ql,qr,val);
	}
	int ask(int l,int r,int idx,int pos)
	{
		if(l==r)return tree[idx];
		int mid=(l+r)/2;
		if(pos<=mid)return max(tree[idx],ask(l,mid,idx*2,pos));
		else return max(tree[idx],ask(mid+1,r,idx*2+1,pos));
	}
}st1;
struct BIT
{
	int tree[MAXN];
	void update(int idx,int val)
	{
		for(;idx<MAXN;idx+=idx&(-idx))
		{
			tree[idx]+=val;
		}
	}
	int ask(int idx)
	{
		int ret=0;
		for(;idx>0;idx-=idx&(-idx))
		{
			ret+=tree[idx];
		}
		return ret;
	}
}fen;
vector<int>g[MAXN];
int time_in[MAXN],time_out[MAXN];
int depth[MAXN];
int l1[MAXN],r1[MAXN],ans1[MAXN];
vector<int>to_check[MAXN];
int ansq[MAXN];
int t;
int n,q;
bool b[MAXN];
vector<query>all_q;
vector<cdq_object>all_objects;

void exec1(cdq_object obj)
{
	if(obj.q_idx==0)
	{
		fen.update(obj.z,+1);
	}
	else
	{
		return;
		ansq[obj.q_idx]+=obj.factor*fen.ask(obj.z);
	}
}
void exec2(cdq_object obj)
{
	if(obj.q_idx==0)
	{
		return;
		fen.update(obj.z,+1);
	}
	else
	{
		ansq[obj.q_idx]+=obj.factor*fen.ask(obj.z);
	}
}

void cdq(int l,int r)
{
	//cout<<l<<" "<<r<<endl;
	if(l+1>=r)return;
	int mid=(l+r)/2;
	cdq(l,mid);cdq(mid,r);
	vector<cdq_object>current;
	vector<bool>skip;
	int i1=l,i2=mid;
	while(i1<mid&&i2<r)
	{
		if(cmp(all_objects[i1],all_objects[i2]))
		{
			current.push_back(all_objects[i1]);
			exec1(all_objects[i1]);
			i1++;
			skip.push_back(0);
		}
		else
		{
			current.push_back(all_objects[i2]);
			exec2(all_objects[i2]);
			i2++;
			skip.push_back(1);
		}
	}
	while(i1<mid)
	{
		current.push_back(all_objects[i1]);
		exec1(all_objects[i1]);
		i1++;
		skip.push_back(0);
	}
	while(i2<r)
	{
		current.push_back(all_objects[i2]);
		exec2(all_objects[i2]);
		i2++;
		skip.push_back(1);
	}
	for(int i=0;i<current.size();i++)
	{
		all_objects[l+i]=current[i];
		if(!skip[i]&&current[i].q_idx==0)
		{
			fen.update(current[i].z,-1);
		}
	}
}
void dfs(int u,int p)
{
	depth[u]=depth[p]+1;
	time_in[u]=++t;
	for(auto xd:g[u])
	{
		if(xd==p)continue;
		dfs(xd,u);
	}
	time_out[u]=t;
}

void read()
{
	cin>>n;
	for(int i=1;i<n;i++)
	{
		int x,y;
		cin>>x>>y;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	for(int i=1;i<=n;i++)cin>>b[i];
	dfs(1,0);
	cin>>q;
	for(int i=0;i<q;i++)
	{
		int type,x,k;
		cin>>type>>x>>k;
		all_q.push_back({type,x,k});
	}
}
void solve()
{
	for(int i=1;i<=n;i++)
	{
		if(b[i]==1)
		{
			l1[i]=1;r1[i]=0;
			ans1[i]=-1;
		}
		else
		{
			l1[i]=1;r1[i]=q;
			ans1[i]=q+1;
		}
	}
	for(int step=0;step<logN;step++)
	{
		for(int i=1;i<=n;i++)
		{
			if(l1[i]>r1[i])continue;
			int mid=(l1[i]+r1[i])/2;
			to_check[mid].push_back(i);
		}
		st1.build(1,n,1);
		for(int i=1;i<=n;i++)
		{
			if(b[i]==1)
			{
				st1.update(1,n,1,time_in[i],time_out[i],depth[i]);
			}
		}
		for(int i=1;i<=n;i++)
		{
			if(all_q[i].type==1)
			{
				st1.update(1,n,1,time_in[all_q[i].x],time_out[all_q[i].x],depth[all_q[i].x]+all_q[i].k);
			}
			for(auto xd:to_check[i])
			{
				if(st1.ask(1,n,1,time_in[xd])>=depth[xd])
				{
					ans1[xd]=i;
					r1[xd]=i-1;
				}
				else
				{
					l1[xd]=i+1;
				}
			}
			to_check[i].clear();
		}
	}
	int cnt_queries=0;
	for(int i=0;i<q;i++)
	{
		if(all_q[i].type==2)
		{
			//cout<<"-2"<<" "<<i<<" "<<i+1<<" "<<depth[all_q[i].x]+all_q[i].k<<" "<<time_out[all_q[i].x]-1<<" "<<cnt_queries+1<<" "<<1<<endl;
			//cout<<"-2"<<" "<<i<<" "<<i+1<<" "<<depth[all_q[i].x]+all_q[i].k<<" "<<time_in[all_q[i].x]-1<<" "<<cnt_queries+1<<" "<<-1<<endl;
			all_objects.push_back({i,depth[all_q[i].x]+all_q[i].k,time_out[all_q[i].x],++cnt_queries,1});
			all_objects.push_back({i,depth[all_q[i].x]+all_q[i].k,time_in[all_q[i].x]-1,cnt_queries,-1});
		}
	}
	//cout<<time_in[2]<<" "<<time_out[2]<<endl;
	//cout<<time_in[3]<<" "<<time_out[3]<<endl;
	for(int i=1;i<=n;i++)
	{
		//cout<<"-1- "<<i<<" "<<ans1[i]<<" "<<depth[i]<<" "<<time_in[i]<<endl;
		all_objects.push_back({ans1[i],depth[i],time_in[i],0,1});
	}
	sort(all_objects.begin(),all_objects.end());
	cdq(0,all_objects.size());
	for(int i=1;i<=cnt_queries;i++)
	{
		cout<<ansq[i]<<endl;
	}
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	read();
	solve();
return 0;
}
