#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 200003
using namespace std;
int n, q;
vector <int> adj[MAXN];
vector <int> order;
bool b[MAXN];
int start[MAXN];
int finish[MAXN];
int arr[MAXN];
int tree[MAXN << 2];

void merge(int v)
{
    tree[v] = tree[v << 1] + tree[(v << 1) + 1];
}

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v] = b[l] ? 1 : 0;
        return;
    }

    int mid = (l + r) >> 1;
    build(v << 1, l, mid);
    build((v << 1) + 1, mid + 1, r);
    merge(v);
}

int get(int v, int l, int r, int x, int y)
{
    if (l > y || r < x)
        return 0;

    if (l >= x && r <= y)
        return tree[v];

    int mid = (l + r) >> 1;
    int left_q = get(v << 1, l, mid, x, y);
    int right_q = get((v << 1) + 1, mid + 1, r, x, y);
    return left_q + right_q;
}

void update(int v, int l, int r, int x, int y)
{
    if (l > y || r < x)
        return;

    if (l == r)
    {
        //cout << "update: " << v << " " << l << " " << r << endl;
        b[l] = 1;
        tree[v] = 1;
        return;
    }

    int mid = (l + r) >> 1;
    update(v << 1, l, mid, x, y);
    update((v << 1) + 1, mid + 1, r, x, y);
    merge(v);
}

void input()
{
    cin >> n;
    for (int i = 1; i < n; ++i)
    {
        int x, y;
        cin >> x >> y;
        adj[x].push_back(y);
    }

    for (int i = 1; i <= n; ++i)
    {
        cin >> b[i];
    }
}

void dfs(int tmp, int par = -1)
{
    order.push_back(tmp);
    for (int i = 0; i < adj[tmp].size(); ++i)
    {
        int nb = adj[tmp][i];
        if (nb != par)
            dfs(nb, tmp);
    }
    order.push_back(tmp);
}

void init()
{
    for (int i = 1; i <= n; ++i)
    {
        start[i] = -1;
        finish[i] = -1;
    }

    int sz = order.size();
    int idx = 1;
    for (int i = 0; i < sz; ++i)
    {
        int tmp = order[i];
        if (start[tmp] == -1)
        {
            start[tmp] = idx;
            arr[idx++] = tmp;
        }
        else
        {
            finish[tmp] = idx - 1;
        }
    }

    /// test
    /*
    for (int i = 0; i < sz; ++i)
    {
        cout << order[i] << " ";
    }
    cout << endl;

    for (int i = 1; i < idx; ++i)
    {
        cout << arr[i] << " ";
    }
    cout << endl;

    for (int i = 1; i <= n; ++i)
    {
        cout << i << ": " << start[i] << " - " << finish[i] << endl;
    }
    */
}

void solve()
{
    dfs(1);
    init();
    build(1, 1, n);

    cin >> q;
    for (int i = 0; i < q; ++i)
    {
        int type, x, k;
        cin >> type >> x >> k;

        //cout << "q: " << type << " " << x << " " << k << endl;
        //cout << start[x] << " " << finish[x] << endl;

        if (type == 1)
            update(1, 1, n, start[x], finish[x]);
        else
            cout << get(1, 1, n, start[x], finish[x]) << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}

/**

10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1 0 1
9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2

*/
