#include<iostream>
#include<map>
#include<vector>
#include<queue>
#include<tuple>
using namespace std;

struct edge
{
    int cnt, val;
};

const int MAXN=5e5+2, INF=1e9;

map<pair<int, int>, edge> mp;
vector<int> graph[MAXN];
int s[MAXN], e[MAXN], pr[MAXN], sz[MAXN];
int ans=0;

pair<int, vector<int> > GetBestPath(int n, int idx)
{
    pair<int, vector<int> > res;
    res.first=0;

    for(int i=0; i<=n+1; i++)
    {
        pr[i]=-1;
    }

    priority_queue<tuple<int, int, int, int> > q;

    sz[idx]=INF;
    q.push({0, INF, pr[idx], idx});

    while(!q.empty())
    {
        int val, cnt, prx;
        tie(val, cnt, prx, idx)=q.top();
        q.pop();

        if(pr[idx]!=-1)
        {
            continue;
        }

        pr[idx]=prx;
        sz[idx]=cnt;

        if(idx==n+1)
        {
            if(val<=0)
            {
                return res;
            }

            break;
        }

        for(int node:graph[idx])
        {
            if(mp[{idx, node}].cnt>0)
            {
                q.push({val+mp[{idx, node}].val, min(cnt, mp[{idx, node}].cnt), idx, node});
            }
        }
    }

    if(pr[n+1]==-1)
    {
        return res;
    }

    res.first=sz[n+1];

    idx=n+1;
    while(idx!=-1)
    {
        res.second.push_back(idx);
        idx=pr[idx];
    }

    return res;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    for(int i=1; i<=n; i++)
    {
        cin >> s[i];
    }

    for(int i=1; i<=n; i++)
    {
        cin >> e[i];
    }

    for(int i=2; i<=n; i++)
    {
        int p, w;
        cin >> p >> w;

        graph[p].push_back(i);
        mp[{p, i}]={n, w};

        graph[i].push_back(p);
        mp[{i, p}]={0, -w};
    }

    for(int i=1; i<=n; i++)
    {
        graph[0].push_back(i);
        mp[{0, i}]={s[i], 0};

        graph[i].push_back(0);
        mp[{i, 0}]={0, 0};

        graph[i].push_back(n+1);
        mp[{i, n+1}]={e[i], 0};

        graph[n+1].push_back(i);
        mp[{n+1, i}]={0, 0};
    }

    vector<int> path;
    int cnt;
    tie(cnt, path)=GetBestPath(n, 0);

    while(cnt!=0)
    {
        for(int i=path.size()-1; i>0; i--)
        {
            int a=path[i], b=path[i-1];
            ans+=mp[{a, b}].val*cnt;

            mp[{a, b}].cnt-=cnt;
            mp[{b, a}].cnt+=cnt;
        }

        tie(cnt, path)=GetBestPath(n, 0);
    }

    cout << ans << "\n";

    return 0;
}
