#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")

using namespace std;

const int maxn = 2e5 + 3; 
const int bucket_sz = 2000;

int n, q;
vector <int> adj[maxn];
bool b[maxn];
void read()
{
	cin >> n;
	for (int i = 1; i <= n-1; i++)
	{
		int a, b;
		cin >> a >> b;
		
		adj[a].push_back(b);
	}
	
	for (int i = 1; i <= n; i++)
	cin >> b[i];
	
	cin >> q; 
}


vector <int> order;
int sz[maxn], pos[maxn], depth[maxn];
void dfs(int ver)
{
	sz[ver] = 1;
	order.push_back(ver);
	pos[ver] = (int)order.size()-1;
	
	for (auto i: adj[ver])
	{
		depth[i] = depth[ver] + 1; 
		dfs(i);
		sz[ver] += sz[i];
	}
}

int idx_in_bucket[maxn];
struct bucket
{
	int max_val, pos; 
	vector <pair <int, int> > order;
	vector <int> tr;
	bucket() {max_val = -1, pos = 0, order.clear();}
};

void update(vector <int> &v, int pos, int val)
{
	for (; pos < (int)v.size(); pos += pos & -pos)
	v[pos] += val;
}

int get(vector <int> &v, int pos)
{
	int ans = 0;
	for (; pos > 0; pos -= pos & -pos)
	ans += v[pos];
	
	return ans;
}

bucket buckets[maxn];
void precompute()
{
	dfs(1);
	for (int i = 0; i < (int)order.size(); i += bucket_sz)
	{
		int curr_idx = i / bucket_sz;
		for (int j = i; j < min((int)order.size(), i + bucket_sz); j++)
		buckets[curr_idx].order.push_back({depth[order[j]], order[j]});
		
		sort (buckets[curr_idx].order.begin(), buckets[curr_idx].order.end());
	    for (int j = 0; j < (int)buckets[curr_idx].order.size(); j++)
	    idx_in_bucket[buckets[curr_idx].order[j].second] = j;
	    
	    buckets[curr_idx].tr.resize((int)buckets[curr_idx].order.size() + 1);
	    for (int j = 0; j < (int)buckets[curr_idx].order.size(); j++)
	    if (b[buckets[curr_idx].order[j].second])
	    update(buckets[curr_idx].tr, j + 1, 1);
	}
}

void solve()
{
	precompute();
	while (q--)
	{
		int type, x, k;
		cin >> type >> x >> k;
		
		if (type == 1)
		{
			int l = pos[x], r = pos[x] + sz[x] - 1; 
			int border = depth[x] + k; 
			
			if (l / bucket_sz == r / bucket_sz)
			{
				int curr_idx = l / bucket_sz;
				for (int i = l; i <= r; i++)
				if (depth[order[i]] <= border && !b[order[i]])
			    {
				   b[order[i]] = 1;
				   update(buckets[curr_idx].tr, idx_in_bucket[order[i]] + 1, 1);
			    }
			    
			    continue;
			}
			
			for (int i = l / bucket_sz + 1; i < r / bucket_sz; i++)
			{
				if (border > buckets[i].max_val)
				{
					buckets[i].max_val = border;
					int curr_pos = buckets[i].pos;
					while (curr_pos < (int)buckets[i].order.size() && buckets[i].order[curr_pos].first <= buckets[i].max_val)
					{
						if (!b[buckets[i].order[curr_pos].second])
						{
							b[buckets[i].order[curr_pos].second] = 1;
							update(buckets[i].tr, curr_pos + 1, 1);
						}
						
						curr_pos++;
					}
				}
			};
			
			int curr_idx = l / bucket_sz;
			for (int i = l; i < (l / bucket_sz + 1) * bucket_sz; i++)
			if (depth[order[i]] <= border && !b[order[i]])
			{
				b[order[i]] = 1;
				update(buckets[curr_idx].tr, idx_in_bucket[order[i]] + 1, 1);
			}
			
			curr_idx = r / bucket_sz;
			for (int i = r; i >= r / bucket_sz * bucket_sz; i--)
			if (depth[order[i]] <= border && !b[order[i]])
			{
				b[order[i]] = 1;
				update(buckets[curr_idx].tr, idx_in_bucket[order[i]] + 1, 1);
			}
		}
		
		else
		{
			int l = pos[x], r = pos[x] + sz[x] - 1; 
			int border = depth[x] + k; 
			int ans = 0; 
			
			if (l / bucket_sz == r / bucket_sz)
			{
				for (int i = l; i <= r; i++)
				if (depth[order[i]] <= border && b[order[i]])
				ans++;
				
				cout << ans << endl;
				continue;
			}
			
			for (int i = l / bucket_sz + 1; i < r / bucket_sz; i++)
			{
				auto curr_pos = lower_bound(buckets[i].order.begin(), buckets[i].order.end(), make_pair(border + 1, 0)) - buckets[i].order.begin();
				ans += get(buckets[i].tr, curr_pos);
			}
			
			for (int i = l; i < (l / bucket_sz + 1) * bucket_sz; i++)
			if (depth[order[i]] <= border && b[order[i]])
			ans++;
			
			for (int i = r; i >= r / bucket_sz * bucket_sz; i--)
			if (depth[order[i]] <= border && b[order[i]])
			ans++;
			
			cout << ans << endl;
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	read();
	solve();
}
