#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define ll long long
#define fr first
#define sc second
#define pb push_back

using namespace std;
using namespace __gnu_pbds;

template<class T> using matrix = vector<vector<T>>;
template<class T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = 2e5 + 5;

struct Node{
	int val, lz;
};

int n, q, T = 0;
Node segmtree[4 * MAXN];
matrix<int> G;
vector<int> tin, tout;

void dfs(int u = 1){
	tin[u] = ++ T;
	for(auto v : G[u])
		dfs(v);
	tout[u] = T;
}

void push(int node, int l, int r){
	if(segmtree[node].lz){
		segmtree[node].val = (r - l + 1);
		if(l != r){
			segmtree[2 * node + 0].lz = segmtree[2 * node + 1].lz = 1;
		}
		segmtree[node].lz = 0;
	}
}

void upd(int node, int l, int r, int ql, int qr, int v){
	if(qr < l || r < ql) return;
	else if(ql <= l && r <= qr){
		segmtree[node].lz = v;
		push(node, l, r);
	}
	else{
		int m = (l + r) / 2;
		push(node, l, r);
		upd(2 * node + 0, l + 0, m, ql, qr, v);
		upd(2 * node + 1, m + 1, r, ql, qr, v);
		segmtree[node].val = segmtree[2 * node].val + segmtree[2 * node + 1].val;
	}
}

int qry(int node, int l, int r, int ql, int qr){
	if(qr < l || r < ql) return 0;
	else if(ql <= l && r <= qr){
		push(node, l, r);
		return segmtree[node].val;
	}
	else{
		int m = (l + r) / 2;
		push(node, l, r);
		return qry(2 * node + 0, l, m, ql, qr) + qry(2 * node + 1, m + 1, r, ql, qr);
	}
}

void upd(int l, int r, int v){ upd(1, 1, n, l, r, v); }
int  qry(int l, int r) { return qry(1, 1, n, l, r); }

int main(){
	cin >> n;
	G = matrix<int>(n + 1);
	tin = tout = vector<int>(n + 1);
	for(int i = 0; i < n - 1; i ++){
		int u, v; cin >> u >> v;
		G[u].pb(v);
	}
	dfs();
	for(int i = 1; i <= n; i ++){
		int x; cin >> x;
		upd(tin[i], tin[i], x);
	}
	cin >> q;
	for(int i = 0; i < q; i ++){
		int t, x, k; cin >> t >> x >> k;
		if(t == 1){
			upd(tin[x], tout[x], 1);
		}
		if(t == 2){
			cout << qry(tin[x], tout[x]) << endl;
		}
	}
}
/**
7
1 2
1 5
2 3
2 4
5 6
5 7
0 0 0 0 0 0 0 
8
1 2 7
2 2 7
2 1 7
1 5 7
2 5 7
2 1 7
1 1 7
2 1 7
*/