#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 500000;
const int LOG = 20;

vector< pair<int, int> > G[MAXN + 5];
int st[MAXN + 5][LOG + 5], d[MAXN + 5], sum[MAXN + 5];
int s[MAXN + 5], e[MAXN + 5], p[MAXN + 5], w[MAXN + 5], idx[MAXN + 5];

void DFS(int u)
{
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i].first;
        int w = G[u][i].second;
        d[v] = d[u] + 1;
        sum[v] = sum[u] + w;
        DFS(v);
    }
}

int LCA(int u, int v)
{
    if (d[u] > d[v]) swap(u, v);

    for (int j = LOG; j >= 0; -- j)
    {
        if (d[v] - (1ll << j) >= d[u])
        {
            v = st[v][j];
        }
    }

    for (int j = LOG; j >= 0; -- j)
    {
        if (st[u][j] != st[v][j])
        {
            u = st[u][j];
            v = st[v][j];
        }
    }

    if (u == v) return u;
    return p[u];
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> s[i];
    }

    for (int i = 1; i <= n; ++ i)
    {
        cin >> e[i];
    }

    for (int i = 2; i <= n; ++ i)
    {
        cin >> p[i] >> w[i];
        st[i][0] = p[i];
        G[p[i]].push_back(make_pair(i, w[i]));
    }

    for (int j = 1; j <= LOG; ++ j)
    {
        for (int i = 1; i <= n; ++ i)
        {
            st[i][j] = st[st[i][j - 1]][j - 1];
        }
    }

    d[1] = 0;
    sum[1] = 0;
    DFS(1);

    for (int i = 1; i <= n; ++ i)
    {
        G[i].clear();
        for (int j = 1; j <= n; ++ j)
        {
            if (i == j) continue;
            if (LCA(i, j) == i and sum[j] - sum[i] > 0)
            {
                G[i].push_back(make_pair(sum[j] - sum[i], j));
            }
        }
    }

    vector< pair<int, int> > v;
    for (int i = 1; i <= n; ++ i)
    {
        v.push_back(make_pair(s[i], i));
        sort(G[i].begin(), G[i].end());
        reverse(G[i].begin(), G[i].end());
    }

    sort(v.begin(), v.end());
    reverse(v.begin(), v.end());

    long long ans = 0;
    for (int i = 0; i < v.size(); ++ i)
    {
        for (int j = 0; j < G[v[i].second].size(); ++ j)
        {
            int k = min(s[v[i].second], e[G[v[i].second][j].second]);
            ans += 1ll * k * G[v[i].second][j].first;
            s[v[i].second] -= k;
            e[G[v[i].second][j].second] -= k;
        }
    }

    cout << ans << endl;

    return 0;
}
