#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 8;
const int MAXS = 8 * 2000;

vector< pair<int, int> > G[MAXN + 5];
int s[MAXN + 5], e[MAXN + 5], p[MAXN + 5], w[MAXN + 5];

pair<long long, int> solve(int u, int i, int j, int sum)
{
    if (G[u].size() == 0)
    {
        long long ans = 0;
        int cnte = e[u];
        return make_pair(ans, cnte);
    }

    if (i == j)
    {
        auto t = solve(G[u][i].first, 0, G[G[u][i].first].size() - 1, s[G[u][i].first] + sum);
        long long ans = t.first + 1ll * min(sum, t.second) * G[u][i].second;
        int cnte = min(sum, t.second);
        return make_pair(ans, cnte);
    }

    int cnte = 0;
    long long ans = 0;
    for (int k = i; k < j; ++ k)
    {
        for (int l = 0; l <= sum; ++ l)
        {
            if (solve(u, i, k, l).first + solve(u, k + 1, j, sum - l).first > ans)
            {
                ans = solve(u, i, k, l).first + solve(u, k + 1, j, sum - l).first;
                cnte = solve(u, i, k, l).second + solve(u, k + 1, j, sum - l).second;
            }
            else if (solve(u, i, k, l).first + solve(u, k + 1, j, sum - l).first == ans)
            {
                cnte = max(cnte, solve(u, i, k, l).second + solve(u, k + 1, j, sum - l).second);
            }
        }
    }

    if (i == 0 and j == G[u].size() - 1) cnte += e[u];
    return make_pair(ans, cnte);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> s[i];
    }

    for (int i = 1; i <= n; ++ i)
    {
        cin >> e[i];
    }

    for (int i = 2; i <= n; ++ i)
    {
        cin >> p[i] >> w[i];
        G[p[i]].push_back(make_pair(i, w[i]));
    }

    cout << solve(1, 0, G[1].size() - 1, s[1]).first << endl;

    return 0;
}
