#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 500000;
const int LOG = 20;

struct edge
{
    int u, v, w;

    edge(int u, int v, int w)
    {
        this -> u = u;
        this -> v = v;
        this -> w = w;
    }
};

vector< pair<int, int> > G[MAXN + 5];
int st[MAXN + 5][LOG + 5], d[MAXN + 5], sum[MAXN + 5];
int s[MAXN + 5], e[MAXN + 5], p[MAXN + 5], w[MAXN + 5], idx[MAXN + 5];

void DFS(int u)
{
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i].first;
        int w = G[u][i].second;
        d[v] = d[u] + 1;
        sum[v] = sum[u] + w;
        DFS(v);
    }
}

int LCA(int u, int v)
{
    if (d[u] > d[v]) swap(u, v);

    for (int j = LOG; j >= 0; -- j)
    {
        if (d[v] - (1ll << j) >= d[u])
        {
            v = st[v][j];
        }
    }

    for (int j = LOG; j >= 0; -- j)
    {
        if (st[u][j] != st[v][j])
        {
            u = st[u][j];
            v = st[v][j];
        }
    }

    if (u == v) return u;
    return p[u];
}

bool cmp(edge e1, edge e2)
{
    return (e1.w > e2.w);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> s[i];
    }

    for (int i = 1; i <= n; ++ i)
    {
        cin >> e[i];
    }

    for (int i = 2; i <= n; ++ i)
    {
        cin >> p[i] >> w[i];
        st[i][0] = p[i];
        G[p[i]].push_back(make_pair(i, w[i]));
    }

    for (int j = 1; j <= LOG; ++ j)
    {
        for (int i = 1; i <= n; ++ i)
        {
            st[i][j] = st[st[i][j - 1]][j - 1];
        }
    }

    d[1] = 0;
    sum[1] = 0;
    DFS(1);

    vector<edge> v;
    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= n; ++ j)
        {
            if (i == j) continue;
            if (LCA(i, j) == i and sum[j] - sum[i] > 0)
            {
                v.emplace_back(i, j, sum[j] - sum[i]);
            }
        }
    }

    if (v.size() > 20) while (true) {}

    sort(v.begin(), v.end(), cmp);

    long long ans = 0;
    for (int i = 0; i < v.size(); ++ i)
    {
        int k = min(s[v[i].u], e[v[i].v]);
        ans += 1ll * k * v[i].w;
        s[v[i].u] -= k;
        e[v[i].v] -= k;
    }

    cout << ans << endl;

    return 0;
}
