#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

int cnt = 0;
int a[MAXN + 5];
int b[MAXN + 5];
int tree[MAXN + 5];
int lazy[MAXN + 5];
vector<int> G[MAXN + 5];
int le[MAXN + 5], ri[MAXN + 5];

void DFS(int u)
{
    cnt++;
    le[u] = cnt;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        DFS(v);
    }
    ri[u] = cnt;
}

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v] = a[l];
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

void push(int v, int l, int r)
{
    if (lazy[v])
    {
        tree[v] = (r - l + 1);
        lazy[2 * v] = lazy[2 * v + 1] = true;
    }
}

void update(int v, int l, int r, int L, int R)
{
    push(v, l, r);
    if (r < L or R < l) return;
    if (L <= l and r <= R)
    {
        tree[v] = (r - l + 1);
        lazy[v] = true;
        push(v, l, r);
        return;
    }

    int mid = (l + r) / 2;
    update(2 * v, l, mid, L, R);
    update(2 * v + 1, mid + 1, r, L, R);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

int query(int v, int l, int r, int L, int R)
{
    push(v, l, r);
    if (r < L or R < l) return 0;
    if (L <= l and r <= R) return tree[v];

    int mid = (l + r) / 2;
    int q1 = query(2 * v, l, mid, L, R);
    int q2 = query(2 * v + 1, mid + 1, r, L, R);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
    return q1 + q2;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i < n; ++ i)
    {
        int x, y;
        cin >> x >> y;
        G[x].push_back(y);
    }

    DFS(1);

    for (int i = 1; i <= n; ++ i)
    {
        cin >> b[i];
        a[le[i]] = b[i];
    }

    build(1, 1, n);

    int q;
    cin >> q;

    for (int i = 1; i <= n; ++ i)
    {
        int t, x, k;
        cin >> t >> x >> k;

        if (t == 1) update(1, 1, n, le[x], ri[x]);
        else cout << query(1, 1, n, le[x], ri[x]) << endl;
    }

    return 0;
}
