#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;
const int LOG = 20;

int b[MAXN + 5];
int s[MAXN + 5][LOG + 5];
vector<int> G[MAXN + 5][LOG + 5];

void DFS(int u)
{
    for (int i = 0; i < G[u][0].size(); ++ i)
    {
        int v = G[u][0][i];
        s[u][0] += b[v];
        DFS(v);

    }

    for (int j = 0; j < LOG; ++ j)
    {
        for (int k = 0; k < G[u][j].size(); ++ k)
        {
            int v = G[u][j][k];
            for (int p = 0; p < G[v][j].size(); ++ p)
            {
                G[u][j + 1].push_back(G[v][j][p]);
            }
        }
    }

    for (int j = 0; j < LOG; ++ j)
    {
        s[u][j + 1] += s[u][j];
        for (int i = 0; i < G[u][j].size(); ++ i)
        {
            s[u][j + 1] += s[G[u][j][i]][j];
        }
    }
}

int query(int x, int k)
{
    int res = b[x];

    vector<int> v, t;
    v.push_back(x);
    for (int j = LOG; j >= 0; -- j)
    {
        t.clear();
        if (k >= (1ll << j))
        {
            k -= (1ll << j);
            for (int i = 0; i < v.size(); ++ i)
            {
                res += s[v[i]][j];
                for (int p = 0; p < G[v[i]][j].size(); ++ p)
                {
                    t.push_back(G[v[i]][j][p]);
                }
            }
            swap(v, t);
        }
    }

    return res;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i < n; ++ i)
    {
        int x, y;
        cin >> x >> y;
        G[x][0].push_back(y);
    }

    for (int i = 1; i <= n; ++ i)
    {
        cin >> b[i];
    }

    DFS(1);

    int q;
    cin >> q;

    for (int i = 1; i <= q; ++ i)
    {
        int t, x, k;
        cin >> t >> x >> k;

        cout << query(x, k) << endl;
    }

    return 0;
}
