#include<bits/stdc++.h>
using namespace std;

const int maxN = 2e5;
int n, q;
vector<vector<int>> t;
bool col[maxN];
vector<int> d, tin, tout, e;
int timer = 0;

void dfs(int v = 0, int p = 0)
{
	tin[v] = timer++;
	d[v] = d[p] + 1;
	e.emplace_back(v);
	for(int to : t[v])
	{
		dfs(to, v);
	}
	tout[v] = timer;
}

vector<int> seg, lz, segDN, segDX;

#define segTree 1, 0, n
inline void comb(int v, int le, int ri)
{
	seg[v] = seg[le] + seg[ri];
	segDN[v] = min(segDN[le], segDN[ri]);
	segDX[v] = max(segDX[le], segDX[ri]);
}

void build(int v, int l, int r)
{
	if(r - l == 1)
	{
		seg[v] = col[e[l]];
		segDN[v] = segDX[v] = d[e[l]];
		return;
	}
	int mid = l + (r - l >> 1),
	    le = v + 1,
	    ri = v + (mid - l << 1);
	build(le, l, mid);
	build(ri, mid, r);
	comb(v, le, ri);
}

inline void pushSt(int v, int le, int ri, int l, int mid, int r)
{
	lz[le] = mid - l - seg[le];
	seg[le] += lz[le];
	lz[ri] = r - mid - seg[ri];
	seg[ri] += lz[ri];
	lz[v] = 0;
}

int ql, qr, qdN, qdX;
int query(int v, int l, int r)
{
	if(qr <= l || r <= ql) return 0;
	int mid = l + (r - l >> 1),
	    le = v + 1,
	    ri = v + (mid - l << 1);
	if(lz[v] != 0 && r - l != 1)
		pushSt(v, le, ri, l, mid, r);
	if(ql <= l && r <= qr && qdN <= segDN[v] && segDX[v] <= qdX) return seg[v];
	if(r - l == 1) return 0;
	return
		query(le, l, mid) +
		query(ri, mid, r);
}

void update(int v, int l, int r)
{
	if(qr <= l || r <= ql) return;
	int mid = l + (r - l >> 1),
	    le = v + 1,
	    ri = v + (mid - l << 1);
	if(lz[v] != 0 && r - l != 1)
		pushSt(v, le, ri, l, mid, r);
	if(ql <= l && r <= qr && qdN <= segDN[v] && segDX[v] <= qdX)
	{
		lz[v] = r - l - seg[v];
		seg[v] += lz[v];
		return;
	}
	if(r - l == 1) return;
	update(le, l, mid);
	update(ri, mid, r);
	comb(v, le, ri);
}

void print(int v, int l, int r)
{
	cout <<"v: " <<v <<" l: " <<l <<" r: " <<r <<" seg[v]: " <<seg[v] <<" lz[v]: " <<lz[v] <<" segDN[v]: " <<segDN[v] <<" segDX[v]: " <<segDX[v] <<endl;
	if(r - l == 1) return;
	int mid = l + (r - l >> 1),
	    le = v + 1,
	    ri = v + (mid - l << 1);
	print(le, l, mid);
	print(ri, mid, r);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >>n;
    t.resize(n);
    d.resize(n);
    tin.resize(n);
    tout.resize(n);
    e.reserve(n);
    seg.resize(n << 1);
    segDN.resize(n << 1);
    segDX.resize(n << 1);
    lz.assign(n << 1, 0);
    int a, b, c;
	for(int i = 1; i < n; i++)
	{
		cin >>a >>b;
		a--; b--;
		t[a].emplace_back(b);
	}
	for(int i = 0; i < n; i++)
		cin >>col[i];
	d[0] = -1;
	dfs();
	build(segTree);
	//cout <<"e: "; for(int i : e) cout <<i <<" "; cout <<endl;
	//for(int i = 0; i < n; i++)
	//	cout <<"i: " <<tin[i] <<" o: " <<tout[i] <<" dif: " <<tout[i] - tin[i] <<endl;
	//print(segTree);
	cin >>q;
	for(int z = 0; z < q; z++)
	{
		cin >>c >>a >>b;
		a--;
		qdN = d[a];
		qdX = d[a] + b;
		switch(c)
		{
		case 1:
			ql = tin[a];
			qr = tout[a];
			update(segTree);
			//print(segTree);
			break;
		case 2:
			ql = tin[a];
			qr = tout[a];
			//cout <<"q: ";
			cout <<query(segTree) <<"\n";
			//print(segTree);
		}
	}
}
/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1 0 1
9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2
*/
