#include<bits/stdc++.h>
using namespace std;

const int nmax=5e5+42;

int n;
int people[nmax],MX_out[nmax];

vector< pair<int/*to*/,int/*weight*/> > adj[nmax];

int source,sink;

int dist[nmax];
int parent[nmax];//id of edge

struct edge
{
    int from,to,cost,flow;
};

vector<edge> all;

void add(int from,int to,int flow,int cost)
{
    edge cur;
    cur.from=from;
    cur.to=to;
    cur.cost=cost;
    cur.flow=flow;

    all.push_back(cur);

    swap(cur.from,cur.to);
    cur.flow=0;
    cur.cost=-cur.cost;

    all.push_back(cur);
}

bool bellman()
{
    for(int i=0;i<=n+1;i++)dist[i]=1e9,parent[i]=0;

    dist[0]=0;

    bool change=1;

    while(change)
    {
        change=0;

        //cout<<"gaz"<<endl;

        for(int i=0;i<all.size();i++)
        {
            edge w=all[i];

            if(w.flow)
            {
                //cout<<dist[w.from]<<" "<<w.cost<<" "<<dist[w.to]<<endl;

                if(dist[w.from]+w.cost<dist[w.to])
                {
                    change=1;
                    dist[w.to]=dist[w.from]+w.cost;
                    parent[w.to]=i;
                }
            }
        }
    }

    //for(int i=source;i<=sink;i++)cout<<i<<" -> "<<dist[i]<<endl;

    return dist[sink]<0;
}

int main()
{
    scanf("%i",&n);

    source=0;
    sink=n+1;

    for(int i=1;i<=n;i++)
    {
        scanf("%i",&people[i]);
        add(source,i,people[i],0);
    }

    for(int i=1;i<=n;i++)
    {
        scanf("%i",&MX_out[i]);
        add(i,sink,MX_out[i],0);
    }

    for(int i=2;i<=n;i++)
    {
        int p,w;

        scanf("%i%i",&p,&w);

        adj[p].push_back({i,w});

        add(p,i,1e9,-w);
    }

    //cout<<"all: ";for(auto w:all)cout<<w.from<<" "<<w.to<<" w.cost= "<<w.cost<<" w.flow= "<<w.flow<<endl;

    long long outp=0;

    while(bellman())
    {
        vector<int> edges={};

        int node=sink;

        while(node!=source)
        {
            edges.push_back(parent[node]);
            node=all[parent[node]].from;
        }

        int mini_flow=1e9;

        long long coeff=0;

        for(auto w:edges)
        {
            mini_flow=min(mini_flow,all[w].flow);
            coeff+=all[w].cost;
        }

        outp+=coeff*mini_flow;

        for(auto w:edges)
        {
            all[w].flow-=mini_flow;
            all[w^1].flow+=mini_flow;
        }
    }

    printf("%lld\n",-outp);

    return 0;
}
