#include<bits/stdc++.h>
#pragma GCC optimize ("Ofast")
#pragma GCC target ("avx2")
#define endl "\n"

using namespace std;

struct Q
{
    int t, x, k;
    Q() { }
    Q(int t, int x, int k) :t(t), x(x), k(k) { }
};

const int N = 200010;
int news[N];
vector<int> v[N], euler;
vector<Q> queries;
int cnt;
int tree[4 * N], lazy[4 * N];
int first[4 * N], last[4 * N];

void update(int root, int k)
{
    if(k == -1) return;
    news[root] = 1;
    for(int i : v[root])
    {
        if(i != root) update(i, k - 1);
    }
}

void query(int root, int k)
{
    if(k == -1) return;
    cnt += news[root];
    //cout << " === " << root << endl;
    for(int i : v[root])
    {
        if(i != root) query(i, k - 1);
    }
}

void travel(int root)
{
    euler.push_back(root);
    for(int i : v[root])
    {
        if(i != root) travel(i), euler.push_back(root);
    }
}

void push(int root)
{
    if(lazy[root]) tree[root * 2] = tree[root * 2 + 1] = lazy[root * 2] = lazy[root * 2 + 1] = lazy[root];
    lazy[root] = 0;
}

void update1(int root, int l, int r, int ql, int qr)
{
    if(ql > qr) return;
    if(l == ql && r == qr)
    {
        tree[root] = 1;
        lazy[root] = 1;
    }
    else
    {
        push(root);
        int mid = (l + r) / 2;
        update1(root * 2, l, mid, ql, min(mid, qr));
        update1(root * 2 + 1, mid + 1, r, max(mid + 1, ql), qr);
    }
}

int query1(int root, int l, int r, int ql, int qr)
{
    if(ql > qr) return 0;
    if(l == ql && r == qr) return tree[root];
    else
    {
        push(root);
        int mid = (l + r) / 2;
        return query1(root * 2, l, mid, ql, min(mid, qr)) +
               query1(root * 2 + 1, mid + 1, r, max(mid + 1, ql), qr);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int n, q, t, x, y, k, p = 0;
    cin >> n;
    for(int i = 0; i < n - 1; ++i)
    {
        cin >> x >> y;
        v[x].push_back(y);
        //v[y].push_back(x);
    }
    for(int i = 1; i <= n; ++i)
    {
        cin >> x;
        if(x) update(i, 0);
    }
    //for(int i = 0; i <= n; ++i) cout << news[i] << " ";
    //cout << endl;
    cin >> q;
    for(int i = 0; i < q; ++i)
    {
        cin >> t >> x >> k;
        queries.push_back({t, x, k});
        if(k == n) p++;

    }
    if(p < q)
    {
        for(int i = 0; i < q; ++i)
        {
            if(queries[i].t == 1) update(queries[i].x, queries[i].k);
            else
            {
                cnt = 0;
                query(queries[i].x, queries[i].k);
                cout << cnt << endl;
            }
        }
    }
    /*else
    {
        euler.push_back(0);
        travel(1);
        int et = euler.size() - 1;
        for(int i = 1; i <= et; ++i)
        {
            if(first[euler[i]] == 0) first[euler[i]] = i;
            last[euler[i]] = i;
        }
        //for(int i = 0; i < euler.size(); ++i) cout << euler[i] << " ";
        //cout << endl;
        for(int i = 0; i < q; ++i)
        {
            if(queries[i].t == 1) update1(1, 1, et, first[queries[i].x], first[queries[i].x]);
            else cout << query1(1, 1, et, first[queries[i].x], last[queries[i].x]) << endl;
        }
    }*/
    return 0;
}
/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1 0 1
9
2 1 10
2 4 10
2 3 10
1 1 10
2 3 10
1 4 10
2 1 10
2 4 10
2 3 10
*/
