#include <iostream>
#include <set>
#include <iterator>
#include <map>
#include <vector>
#include <algorithm>
#include <cstdio>
using namespace std;
struct Path
{
	int weight;
	int from;
	int to;
	Path(int f,int t,int w)
	{
		from=f;
		to=t;
		weight=w;
	}
};

int N,People[100010],Maxes[100010],Points[100010],Parent[100010];
vector<int> gr[100010];
map<int,pair<int,int> >BestPaths;

void print()
{
	for(int i=0;i<=N;i++)
		cout<<People[i]<<" ";
	cout<<endl;
	for(int i=0;i<=N;i++)
		cout<<Maxes[i]<<" ";
	cout<<endl;
	for(int i=0;i<=N;i++)
		cout<<Points[i]<<" ";
	cout<<endl;
	for(int i=0;i<=N;i++)
		cout<<Parent[i]<<" ";
	cout<<endl;	
	cout<<"__________________"<<endl;	
	for(int i=0;i<=N;i++)
	{
		cout<<i<<" :";
		for(int j=0;j<gr[i].size();j++)
			cout<<gr[i][j]<<" ";
		cout<<endl;
	}
	cout<<"__________________"<<endl;
}

void DFS(int start,int node,int sum)
{
	if(start!=node)BestPaths[sum]={start,node};
	for(int i=0;i<gr[node].size();i++)
		DFS(start,gr[node][i],sum+Points[gr[node][i]]);
}

int CalcAllPaths()
{
	int total=0;
	for(int i=1;i<=N;i++)
		DFS(i,i,0);
	for(map<int,pair<int,int> >::reverse_iterator it=BestPaths.rbegin();it!=BestPaths.rend();it++)
	{
		int p = (*it).first;
		int p1 = (*it).second.first;
		int p2 = (*it).second.second;
		int M=min(People[p1],Maxes[p2]);
		if(p<0)return total;
		People[p1]-=M;
		Maxes[p2]-=M;
		total+=M*p;		
		cout<<p<<" "<<p1<<" "<<p2<<endl;
	}
	return total;
}

int init()
{
	int p1,p2;
	scanf("%d",&N);
	for(int i=1;i<=N;i++)
		scanf("%d",&People[i]);
	for(int i=1;i<=N;i++)
		scanf("%d",&Maxes[i]);
	for(int i=1;i<N;i++)
	{
		scanf("%d%d",&p1,&p2);
		Parent[i+1]=p1;
		Points[i+1]=p2;
		gr[p1].push_back(i+1);
	}
}


int main()
{
	init();
//	print();
	cout<<CalcAllPaths()<<endl;
}