#include <iostream>
#include <cstdio>
#include <vector>
#include <queue>
using namespace std;
vector<int> gr[100010];
int N,Q;
int DepthPerNode[100010],AllUnder[100010];
bool colored[100010];

void Print()
{
	for(int i=1;i<=N;i++)
		cout<<DepthPerNode[i]<<" ";
	cout<<endl;
	for(int i=1;i<=N;i++)
		cout<<AllUnder[i]<<" ";
	cout<<endl;
}

pair<int,int> DFS(int node)//count,depth
{
	pair<int,int> temp;
	AllUnder[node]=0;
	for(int i=0;i<gr[node].size();i++)
	{
		temp=DFS(gr[node][i]);
		AllUnder[node]+=temp.first;
		DepthPerNode[node]=max(DepthPerNode[node],temp.second+1);
	}
	if(colored[node])AllUnder[node]++;
	return {AllUnder[node],DepthPerNode[node]};
}

void Color(int pos,int depth)
{
	queue<pair<int,int> > BFS;
	BFS.push({pos,0});
	while(!BFS.empty())
	{
		pair<int,int> curr=BFS.front();
		BFS.pop();
		colored[curr.first]=true;
		if(curr.second<depth)
		for(int i=0;i<gr[curr.first].size();i++)
			BFS.push({gr[curr.first][i],curr.second+1});
	}
	DFS(pos);
}

int Count(int pos,int depth)
{
	int total=0;
//	if(DepthPerNode[pos]<=depth)return AllUnder[pos];
	queue<pair<int,int> > BFS;
	BFS.push({pos,0});
	while(!BFS.empty())
	{
		pair<int,int> curr=BFS.front();
		BFS.pop();
		if(colored[curr.first])total++;
		if(curr.second<depth)
		for(int i=0;i<gr[curr.first].size();i++)
			BFS.push({gr[curr.first][i],curr.second+1});
	}	
	return total;
}

void solve()
{
	int a,b,c;
	for(int i=0;i<Q;i++)
	{
		scanf("%d%d%d",&a,&b,&c);
		if(a==1)Color(b,c);
		else cout<<Count(b,c)<<endl;
	}
}

void init()
{
	int a,b;
	scanf("%d",&N);
	for(int i=1;i<N;i++)
	{
		scanf("%d%d",&a,&b);
		gr[a].push_back(b);
	}
	for(int i=1;i<=N;i++)
		scanf("%d",&colored[i]);
	scanf("%d",&Q);
		DFS(1);

	
}

int main()
{
	init();
	solve();
}