#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
vector<int> s, e;
vector<vector<pair<int, long long>>> children;

void read() {
    cin >> n;

    s.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> s[i];
    }

    e.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> e[i];
    }

    children.resize(n + 1);
    for (int i = 2; i <= n; i++) {
        int p;
        long long w;
        cin >> p >> w;

        children[p].emplace_back(i, w);
    }
}

vector<pair<int, long long>> paths;

void getPaths(int root, long long totalCost) {
    paths.emplace_back(root, totalCost);

    for (auto &child : children[root]) {
        getPaths(child.first, totalCost + child.second);
    }
}

bool compCosts(const pair<int, long long> &x, const pair<int, long long> &y) {
    return (x.second > y.second);
}

void solve() {
    long long total = 0;
    for (int i = 1; i <= n; i++) {
        paths.clear();

        getPaths(i, 0);
        paths.erase(paths.begin());

        sort(paths.begin(), paths.end(), compCosts);

        for (auto &path : paths) {
            if (path.second <= 0) {
                break;
            }

            if (s[i] <= e[path.first]) {
                e[path.first] -= s[i];
                total += (1ll * s[i] * path.second);
                break;
            } else {
                s[i] -= e[path.first];
                total += (1ll * e[path.first] * path.second);
                e[path.first] = 0;
            }
        }
    }

    cout << total << endl;
}

int main() {
    setIO();

    read();

    solve();
}
