#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

vector<int> s, e;

struct Path {
    int from;
    int to;
    long long cost;

    Path(int from, int to, long long cost) {
        this->from = from;
        this->to = to;
        this->cost = cost;
    }

    bool operator <(const Path &rhs) const {
        return (this->cost > rhs.cost);
    }
};

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
vector<vector<pair<int, long long>>> children;

void read() {
    cin >> n;

    s.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> s[i];
    }

    e.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> e[i];
    }

    children.resize(n + 1);
    for (int i = 2; i <= n; i++) {
        int p;
        long long w;
        cin >> p >> w;

        children[p].emplace_back(i, w);
    }
}

vector<Path> paths;

void getPaths(int root, int from, long long totalCost) {
    if (root != from) {
        paths.emplace_back(from, root, totalCost);
    }

    for (auto &child : children[root]) {
        getPaths(child.first, from, totalCost + child.second);
    }
}

void solve() {
    for (int i = 1; i <= n; i++) {
        getPaths(i, i, 0);
    }

    sort(paths.begin(), paths.end());

    long long total = 0;
    for (auto &i : paths) {
        if (i.cost <= 0) {
            break;
        }

        int cnt = min(s[i.from], e[i.to]);
        total += (cnt * i.cost);
        s[i.from] -= cnt;
        e[i.to] -= cnt;
    }

    cout << total << endl;
}

int main() {
    setIO();

    read();

    solve();
}
