#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
vector<vector<int>> children;
vector<int> knows;

void read() {
    cin >> n;

    children.resize(n + 1);
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;

        children[x].emplace_back(y);
    }

    knows.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> knows[i];
    }
}

int query(int node, int level, int k) {
    int answer = knows[node];

    if (level < k) {
        for (int child : children[node]) {
            answer += query(child, level + 1, k);
        }
    }

    return answer;
}

void update(int node, int level, int k) {
    knows[node] = 1;

    if (level < k) {
        for (int child : children[node]) {
            update(child, level + 1, k);
        }
    }
}

void solve() {
    int q;
    cin >> q;

    while (q--) {
        int type, x, k;
        cin >> type >> x >> k;

        if (type == 1) {
            update(x, 0, k);
        } else {
            cout << query(x, 0, k) << endl;
        }
    }
}

int main() {
    setIO();

    read();

    solve();
}
