#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
vector<vector<int>> children;
vector<int> knows;

void read() {
    cin >> n;

    children.resize(n + 1);
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;

        children[x].emplace_back(y);
    }

    knows.resize(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> knows[i];
    }
}

vector<int> in, to;
int dfsTime = 1;

void precompute(int root) {
    in[root] = to[root] = dfsTime++;

    for (int child : children[root]) {
        precompute(child);
        to[root] = max(to[root], to[child]);
    }
}

vector<int> tree, lazy;

void push(int node, int low, int high) {
    if (lazy[node]) {
        tree[node] = (high - low + 1);

        if (low != high) {
            lazy[node << 1] += lazy[node];
            lazy[node << 1 | 1] += lazy[node];
        }

        lazy[node] = 0;
    }
}

void update(int node, int low, int high, int l, int r) {
    push(node, low, high);

    if (high < l || low > r) {
        return;
    }

    if (low >= l && high <= r) {
        lazy[node]++;
        push(node, low, high);
        return;
    }

    int mid = low + ((high - low) >> 1);
    update(node << 1, low, mid, l, r);
    update(node << 1 | 1, mid + 1, high, l, r);

    tree[node] = tree[node << 1] + tree[node << 1 | 1];
}

int query(int node, int low, int high, int l, int r) {
    push(node, low, high);

    if (high < l || low > r) {
        return 0;
    }

    if (low >= l && high <= r) {
        return tree[node];
    }

    int mid = low + ((high - low) >> 1);
    int rl = query(node << 1, low, mid, l, r);
    int rr = query(node << 1 | 1, mid + 1, high, l, r);

    return (rl + rr);
}

void solve() {
    in.resize(n + 1);
    to.resize(n + 1);
    precompute(1);

    tree.resize((n + 1) << 2, 0);
    lazy.resize((n + 1) << 2, 0);
    for (int i = 1; i <= n; i++) {
        if (knows[i]) {
            update(1, 1, n, in[i], in[i]);
        }
    }

    int q;
    cin >> q;

    while (q--) {
        int type, x, k; /// k is always n
        cin >> type >> x >> k;

        if (type == 1) {
            update(1, 1, n, in[x], to[x]);
        } else {
            cout << query(1, 1, n, in[x], to[x]) << endl;
        }
    }
}

int main() {
    setIO();

    read();

    solve();
}

/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1 0 1
5
2 1 10
1 4 10
2 1 10
1 1 10
2 1 10
*/
