#include <iostream>
#include <vector>
#define endl "\n"
#define ll long long
using namespace std;

const int maxn=2*(1e5)+10;
vector<long long> neib[maxn];
bool knows[maxn];
bool updated[maxn];
ll tree[maxn];

long long build(ll curr){
    if(neib[curr].size()==0){
        tree[curr]=knows[curr];
        return tree[curr];
    }
    ll sum=0;
    for(ll i=0;i<neib[curr].size();i++){
        sum+=build(neib[curr][i]);
    }
    sum+=knows[curr];
    tree[curr]=sum;
    return tree[curr];
}

long long update(ll curr){
    if(updated[curr]){
        return tree[curr];
    }
    if(neib[curr].size()==0){
        tree[curr]=1;
        updated[curr]=true;
        return 1;
    }
    ll sum=0;
    for(ll i=0;i<neib[curr].size();i++){
        if(updated[neib[curr][i]]){
            sum+=tree[neib[curr][i]];
        }else{
            sum+=update(neib[curr][i]);
        }
    }
    tree[curr]=sum+1;
    updated[curr]=true;
    return tree[curr];
}

int main(){
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);
    ll n,q,a,b,i,x,k,tip;
    cin >> n;
    for(i=0;i<n-1;i++){
        cin >> a >> b;
        neib[a].push_back(b);
    }
    for(i=1;i<=n;i++){
        cin >> knows[i];
    }
    build(1);
    cin >> q;
    for(i=0;i<q;i++){
        cin >> tip >> x >> k;
        if(tip==1){
            update(x);
        }else{
            cout << tree[x] << endl;
        }
    }
return 0;
}

