#include <iostream>
#include <vector>
#define endl "\n"
#define ll long long
using namespace std;

const int maxn=2*(1e5)+10;
vector<long long> neib[maxn];
bool knows[maxn];
bool updated[maxn];
ll tree[maxn],parent[maxn];

long long build(ll curr){
    if(neib[curr].size()==0){
        tree[curr]=knows[curr];
        return tree[curr];
    }
    ll sum=0;
    for(ll i=0;i<neib[curr].size();i++){
        sum+=build(neib[curr][i]);
    }
    sum+=knows[curr];
    tree[curr]=sum;
    return tree[curr];
}

void upd_prnt(ll curr, ll diff){
    tree[curr]+=diff;
    if(curr!=1){
        upd_prnt(parent[curr],diff);
    }
}

long long update(ll curr){
    if(updated[curr]){
        return tree[curr];
    }
    if(neib[curr].size()==0){
        if(tree[curr]==0){
            tree[curr]=1;
            upd_prnt(parent[curr],1);
            updated[curr]=true;
            return 1;
        }
    }
    ll sum=0;
    for(ll i=0;i<neib[curr].size();i++){
        if(updated[neib[curr][i]]){
            sum+=tree[neib[curr][i]];
        }else{
            sum+=update(neib[curr][i]);
        }
    }
    ll diff=sum+1-tree[curr];
    tree[curr]=sum+1;
    updated[curr]=true;
    if(curr!=1){
        upd_prnt(parent[curr],diff);
    }
    return tree[curr];
}

ll currsum;

void sumdep(ll curr, ll depth, ll currdepth){
    if(currdepth==depth){
        currsum+=tree[curr];
    }else{
        for(ll i=0;i<neib[curr].size();i++){
            sumdep(neib[curr][i],depth,currdepth+1);
        }
    }
}

long long sumto(ll curr, ll depth){
    ll ans=tree[curr];
    currsum=0;
    sumdep(curr,depth+1,0);
    ans-=currsum;
    return ans;
}


int main(){
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);
    ll n,q,a,b,i,x,k,tip;
    cin >> n;
    for(i=0;i<n-1;i++){
        cin >> a >> b;
        neib[a].push_back(b);
        parent[b]=a;
    }
    for(i=1;i<=n;i++){
        cin >> knows[i];
    }
    build(1);
    cin >> q;
    for(i=0;i<q;i++){
        cin >> tip >> x >> k;
        if(tip==1){
            update(x);
        }else{
            cout << sumto(x,k) << endl;
        }
    }
return 0;
}

