#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
const int MAXN=2e5+10;
vector <int> v[MAXN];
int ind[MAXN], maxi[MAXN], br;
int tree[4*MAXN], lazy[4*MAXN];
bool fl[MAXN];
void dfs(int x) {
    ind[x]=br;
    maxi[ind[x]]=br;
    br++;
    for (auto i:v[x]) {
        dfs(i);
        maxi[ind[x]]=max(maxi[ind[x]],maxi[ind[i]]);
    }
}
void build_tree(int node, int l, int r) {
    if (l==r) {
        tree[node]=fl[l];
        lazy[node]=0;
        return;
    }
    int mid=(l+r)/2;
    build_tree(node*2,l,mid);
    build_tree(node*2+1,mid+1,r);
    tree[node]=tree[node*2]+tree[node*2+1];
}
void push_lazy(int node, int l, int r) {
    if (lazy[node]!=0 && l!=r) {
        int mid=(l+r)/2;
        lazy[node*2]=tree[node*2]=(mid-l+1);
        lazy[node*2+1]=tree[node*2+1]=(r-mid);
        lazy[node]=0;
    }
}
void update(int node, int l, int r, int ql, int qr) {
    if (ql>r || qr<l) return;
    push_lazy(node,l,r);
    if (l>=ql && r<=qr) {
        lazy[node]=tree[node]=(r-l+1);
        return;
    }
    int mid=(l+r)/2;
    update(node*2,l,mid,ql,qr);
    update(node*2+1,mid+1,r,ql,qr);
    tree[node]=tree[node*2]+tree[node*2+1];
}
int query(int node, int l, int r, int ql, int qr) {
    if (ql>r || qr<l) return 0;
    push_lazy(node,l,r);
    if (l>=ql && r<=qr) return tree[node];
    int mid=(l+r)/2;
    return query(node*2,l,mid,ql,qr)+query(node*2+1,mid+1,r,ql,qr);
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, a, b;
    cin >> n;
    for (int i=0;i<n-1;i++) {
        cin >> a >> b;
        v[a].push_back(b);
    }
    br=1;
    dfs(1);
    for (int i=1;i<=n;i++) cin >> fl[ind[i]];
    build_tree(1,1,n);
    int q, type, x, k;
    cin >> q;
    for (int i=0;i<q;i++) {
        cin >> type >> x >> k;
        x=ind[x];
        if (type==1) update(1,1,n,x,maxi[x]);
        else cout << query(1,1,n,x,maxi[x]) << endl;
    }
    return 0;
}
/**
9
1 3
3 6
3 7
6 8
6 9
1 2
2 4
2 5
0 1 0 0 1 1 0 0 0
7
2 1 9
2 2 9
1 4 9
2 2 9
1 3 9
2 1 9
2 6 9
**/
