#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
#define int long long
#define MAXN 200005
int br, q;
vector<int> graph[MAXN];
int parent[MAXN];
int news[MAXN];
int tree[4 * MAXN], lazy[4 * MAXN];
vector<int> tr;
int start[MAXN], stop[MAXN];
void dfs(int v){
    tr.push_back(v); start[v] = tr.size() - 1;
    for(int i : graph[v]){
        dfs(i);
    }
    stop[v] = tr.size() - 1;
}
void fix(int idx, int from, int to){
    if(lazy[idx] == 0) return;
    tree[idx] = to - from + 1;
    lazy[2 * idx] = 1; lazy[2 * idx + 1] = 1;
    lazy[idx] = 0;
}
void update(int idx, int from, int to, int l, int r){
    if(from > to) return;
    if(l > to || r < from) return;
    fix(idx, from, to);
    if(from >= l && to <= r){
        tree[idx] = (to - from + 1); lazy[idx] = 1; return;
    }
    int mid = (from + to) / 2;
    update(2 * idx, from, mid, l, r); update(2 * idx + 1, mid + 1, to, l, r);
    fix(2 * idx, from, mid); fix(2 * idx + 1, mid + 1, to);
    tree[idx] = tree[2 * idx] + tree[2 * idx + 1];
}
int query(int idx, int from, int to, int l, int r){
    if(from > to) return 0;
    if(l > to || r < from) return 0;
    fix(idx, from, to);
    if(from >= l && to <= r){
        //cout << "A " << from << ' ' << to << ' ' << tree[idx] << endl;
        return tree[idx];
    }
    int mid = (from + to) / 2;
    int res = query(2 * idx, from, mid, l, r) + query(2 * idx + 1, mid + 1, to, l, r);
    fix(2 * idx, from, mid); fix(2 * idx + 1, mid + 1, to);
    tree[idx] = tree[2 * idx] + tree[2 * idx + 1];
    //cout << "B " << from << ' ' << to << ' ' << res << endl;
    return res;
}
void build(int idx, int from, int to){
    if(from > to) return;
    if(from == to){
        tree[idx] = news[tr[from]]; return;
    }
    int mid = (from + to) / 2;
    build(2 * idx, from, mid); build(2 * idx + 1, mid + 1, to);
    tree[idx] = tree[2 * idx] + tree[2 * idx + 1];
}
signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> br;
    for(int i = 0; i < br - 1; ++i){
        int from, to; cin >> from >> to;
        graph[from].push_back(to);
        parent[to] = from;
    }
    for(int i = 1; i <= br; ++i){
        cin >> news[i];
    }
    dfs(1);
    build(1, 0, br - 1);
    // for(int i : tr){
    //     cout << i << ' ';
    // }
    // cout << endl;
    cin >> q;
    for(int i = 0; i < q; ++i){
        int type, x, k; cin >> type >> x >> k;
        if(type == 1){
            update(1, 0, br - 1, start[x], stop[x]);
        }
        else{
            cout << query(1, 0, br - 1, start[x], stop[x]) << endl;
        }
    }
    return 0;
}